#############################
#### One click buildings ####
#############################


##############################
##############################
### Code to create house   ###
##############################
##############################

def create_house
  
  selection = Sketchup.active_model.selection
  entities = Sketchup.active_model.active_entities
  items = selection.count
  entity_count = entities.count
  main_entity_id = 0
  
  face_connection = []
  connections = []
  connection_number = 0

  if items != 1
    echo "Please select only one item."
  elsif selection[0].typename != "Face"
    echo "Please select a face."
  else
    for step in 0..entity_count - 1
      if entities[step] == selection[0]
        main_entity_id = step
      end
    end
    
  end
  
  for step in 0..entity_count - 1
    if entities[step].typename == "Face" and step != main_entity_id
      x_position = entities[step].vertices[0].position[0]
      y_position = entities[step].vertices[0].position[1]
      x_min_position = entities[step].vertices[0].position[0]
      y_min_position = entities[step].vertices[0].position[1]
      for step2 in 1..entities[step].vertices.count - 1
        if entities[step].vertices[step2].position[0] > x_position
          x_position = entities[step].vertices[step2].position[0]
        end
        if entities[step].vertices[step2].position[1] > y_position
          y_position = entities[step].vertices[step2].position[1]
        end
        if entities[step].vertices[step2].position[0] < x_min_position
          x_min_position = entities[step].vertices[step2].position[0]
        end
        if entities[step].vertices[step2].position[1] < y_min_position
          y_min_position = entities[step].vertices[step2].position[1]
        end
      end
     
      eye = [x_position + 200 / $inch, y_position + 200 / $inch, entities[step].vertices[0].position[2] + 600 / $inch]
      target = [(x_min_position + x_position) / 2, (y_min_position + y_position) / 2, 0]
      up = [0,0,1]
      my_camera = Sketchup::Camera.new eye, target, up

      # Get a handle to the current view and change its camera.
      view = Sketchup.active_model.active_view
      view.camera = my_camera
     
      #### Find connections ####
      face_connection[step] = 0
      for step2 in 0..selection.count - 1
        if step2 != step
          if selection[step2].typename == "Face"
            connection_count = 0
            for step3 in 0..entities[step].vertices.count - 1
              for step4 in 0..selection[step2].vertices.count - 1
                if entities[step].vertices[step3].position == selection[step2].vertices[step4].position
                  connection_count += 1
                  face_connection[step] += 1
                end
              end
            end
            if connection_count >= 2
              connections[connection_number] = [step, step2]
              connection_number += 1
            end
          end
        end
      end
    end
  end
  

  #### Check connections ####

  face_group = []
  face_group_count = []
  face_groups = 0
  
  for step in 0..entity_count - 1
    if entities[step].typename == "Face"
      face_group[face_groups] = []
      face_group_count[face_groups] = 0
      face_registered = 0
      
      ### Check if face is already in a group ###
      
      for step2 in 0..face_groups - 1
        for step3 in 0..face_group_count[step2] - 1
          if face_group[step2][step3] == step
            face_registered = 1
          end
        end
      end

      if face_registered == 0
        face_group[face_groups][0] = step
        face_group_count[face_groups] = 1
        
        #### Find direct connections ####
        
        for step2 in 0..connections.count - 1
          connection_registered = 0
        
          if connections[step2][0] == step
            for step3 in 0..face_group_count[face_groups] - 1
              if face_group[face_groups][step3] == connections[step2][1]
                connection_registered = 1
              end
            end
            if connection_registered == 0
              face_group[face_groups][face_group_count[face_groups]] = connections[step2][1]
              face_group_count[face_groups] += 1
            end
          elsif connections[step2][1] == step
            for step3 in 0..face_group_count[face_groups] - 1
              if face_group[face_groups][step3] == connections[step2][0]
                connection_registered = 1
              end
            end
            if connection_registered == 0
              face_group[face_groups][face_group_count[face_groups]] = connections[step2][0]
              face_group_count[face_groups] += 1
            end
          end
        end

        #### Find indirect connections ####

        if face_group_count[face_groups] > 1
              

          begin
            new_connection_found = 0
            for step2 in 1..face_group_count[face_groups] - 1
              for step3 in 0..connections.count - 1
                connection_registered = 0
                if connections[step3][0] == face_group[face_groups][step2]
                  for step4 in 0..face_group_count[face_groups] - 1
                    if face_group[face_groups][step4] == connections[step3][1]
                      connection_registered = 1
                    end
                  end
                  if connection_registered == 0
                    face_group[face_groups][face_group_count[face_groups]] = connections[step3][1]
                    face_group_count[face_groups] += 1
                    new_connection_found = 1
               #     UI.messagebox "New connection" + connections[step3].to_s
                  end
                elsif connections[step3][1] == face_group[face_groups][step2]
                  for step4 in 0..face_group_count[face_groups] - 1
                    if face_group[face_groups][step4] == connections[step3][0]
                      connection_registered = 1
                    end
                  end
                  if connection_registered == 0
                    face_group[face_groups][face_group_count[face_groups]] = connections[step3][0]
                    face_group_count[face_groups] += 1
                    new_connection_found = 1
            #        UI.messagebox "New connection" + connections[step3].to_s
                  end
                end
              end
            end
   #         UI.messagebox new_connection_found
          end while new_connection_found > 0
        end
        face_groups += 1
      end
    end
  end



  #### List groups ####
  
  for step in 0..face_groups - 1
    echo face_group[step]
  end

end


  
##############################
##############################
### Code for house ###
##############################
##############################

def house
  
  group = Sketchup.active_model.entities.add_group
  group_ents = group.entities
  group.description = "House"
  materials = Sketchup.active_model.materials
  
  prompts = ["House type", "House width", "House depth", "House height", "Roof type", "Roof height", "Land at front", "Land at rear", "Land at sides", "External border type", "Internal border type", "Angle", "X-pos", "Y-pos", "Extensions"]
  defaults = ["Semi-detached", "1200", "700", "500", "Gable", "240", "500", "2000", "300", "Fence", "Fence", "0", "0", "0", ""]
  list = ["Semi-detached|Terraced|Detached", "", "", "", "Flat|Gable|Hipped|Mansard", "", "", "", "", "Fence|Hedge|Wall", "Fence|Hedge|Wall", "", "", "", ""]
  input = UI.inputbox prompts, defaults, list, "House info"

  house_type = input[0]
  
  if house_type == "Semi-detached"
    house_units = 2
  elsif house_type == "Terraced"
    prompts = ["Number of units"]
    defaults = ["4"]
    list = [""]
    input_house_units = UI.inputbox prompts, defaults, list, "Terraced house info"
    house_units = input_house_units[0].to_i
    if house_units < 3
      house_units = 3
    end
  else
    house_units = 1
  end
  house_width = input[1].to_f / $inch
  house_depth = input[2].to_f / $inch
  house_middle_depth = house_depth / 2
  house_height = input[3].to_f / $inch
  roof_type = input[4]
  roof_height = input[5].to_f / $inch + house_height
  land_at_front = input[6].to_f / $inch
  land_at_rear = input[7].to_f / $inch
  land_at_side_left = input[8].to_f / $inch
  land_at_side_right = input[8].to_f / $inch
  external_border_type = input[9]
  internal_border_type = input[10]
  building_angle = input[11].to_f / $inch
  building_x_pos = input[12].to_f / $inch
  building_y_pos = input[13].to_f / $inch
  extension_text = input[14]
  
  
  
  ##### Draw house #####
  
  pts = []
  pts[0] = [0, 0, house_height]
  pts[1] = [0, 0, 0]
  pts[2] = [house_width, 0, house_height]
  pts[3] = [house_width, 0, 0]
  pts[4] = [house_width, house_depth, house_height]
  pts[5] = [house_width, house_depth, 0]
  pts[6] = [0, house_depth, house_height]
  pts[7] = [0, house_depth, 0]
  
  for step in 0..3
    face = group_ents.add_face pts[step * 2], pts[(step * 2) + 1], pts[(((step + 1) * 2) + 1).modulo(8)], pts[((step + 1) * 2).modulo(8)]
  end  
  
  ##### Draw roof #####
  
  if roof_type == "Flat"
    face = group_ents.add_face pts[0], pts[2], pts[4], pts[6]
  elsif roof_type == "Gable"
    pts[8] = [0, house_middle_depth, roof_height]
    pts[9] = [house_width, house_middle_depth, roof_height]
    face = group_ents.add_face pts[0], pts[6], pts[8]
    face = group_ents.add_face pts[2], pts[4], pts[9]
    face = group_ents.add_face pts[8], pts[9], pts[2], pts[0]
    face = group_ents.add_face pts[8], pts[9], pts[4], pts[6]
  elsif roof_type == "Hipped"
    pts[8] = [house_middle_depth, house_middle_depth, roof_height]
    pts[9] = [house_width - house_middle_depth, house_middle_depth, roof_height]
    face = group_ents.add_face pts[0], pts[6], pts[8]
    face = group_ents.add_face pts[2], pts[4], pts[9]
    face = group_ents.add_face pts[8], pts[9], pts[2], pts[0]
    face = group_ents.add_face pts[8], pts[9], pts[4], pts[6]
  elsif roof_type == "Mansard"
    mansard_border = (roof_height - house_height) / 4
    mansard_height = roof_height - mansard_border
    pts[8] = [house_middle_depth, house_middle_depth, roof_height]
    pts[9] = [house_width - house_middle_depth, house_middle_depth, roof_height]
    pts[10] = [mansard_border, mansard_border, mansard_height]
    pts[11] = [house_width - mansard_border, mansard_border, mansard_height]
    pts[12] = [house_width - mansard_border, house_depth - mansard_border, mansard_height]
    pts[13] = [mansard_border, house_depth - mansard_border, mansard_height]
    
    for step in 0..3
      face = group_ents.add_face pts[step * 2], pts[((step * 2) + 2).modulo(8)], pts[10 + (1 + step).modulo(4)], pts[10 + step]
    end
    face = group_ents.add_face pts[10], pts[13], pts[8]
    face = group_ents.add_face pts[11], pts[12], pts[9]
    face = group_ents.add_face pts[8], pts[9], pts[11], pts[10]
    face = group_ents.add_face pts[8], pts[9], pts[12], pts[13]
  end
  
  ##### Draw land #####
  
  pts = []
  pts[0] = [0 - land_at_side_left, 0 - land_at_front, 0]
  pts[1] = [house_width + land_at_side_right, 0 - land_at_front, 0]
  pts[2] = [house_width + land_at_side_right, house_depth + land_at_rear, 0]
  pts[3] = [0 - land_at_side_left, house_depth + land_at_rear, 0]
  
  face = group_ents.add_face pts
  status = face.reverse!
  
  ##### Draw borders #####
  
  fence_height = 180 / $inch
  wall_height = 100 / $inch
  wall_thickness = 30 / $inch
  hedge_height = 180 / $inch
  hedge_width = 80 / $inch

  if external_border_type == "Fence"
    pts = []
    pts[0] = [house_width + land_at_side_right, 0 - land_at_front, 0]
    pts[1] = [house_width + land_at_side_right, house_depth + land_at_rear, 0]
    pts[2] = [0 - land_at_side_left, house_depth + land_at_rear, 0]
    pts[3] = [0 - land_at_side_left, 0 - land_at_front, 0]
    pts[4] = [house_width + land_at_side_right, 0 - land_at_front, fence_height]
    pts[5] = [house_width + land_at_side_right, house_depth + land_at_rear, fence_height]
    pts[6] = [0 - land_at_side_left, house_depth + land_at_rear, fence_height]
    pts[7] = [0 - land_at_side_left, 0 - land_at_front, fence_height]
    
    for step in 0..2
      face = group_ents.add_face pts[step], pts[step + 1], pts[step + 5], pts[step + 4]
    end
    internal_border_end = house_depth + land_at_rear
  elsif external_border_type == "Wall"
    pts = []
    pts[0] = [house_width + land_at_side_right, 0 - land_at_front, 0]
    pts[1] = [house_width + land_at_side_right, house_depth + land_at_rear, 0]
    pts[2] = [0 - land_at_side_left, house_depth + land_at_rear, 0]
    pts[3] = [0 - land_at_side_left, 0 - land_at_front, 0]
    pts[4] = [house_width + land_at_side_right, 0 - land_at_front, wall_height]
    pts[5] = [house_width + land_at_side_right, house_depth + land_at_rear, wall_height]
    pts[6] = [0 - land_at_side_left, house_depth + land_at_rear, wall_height]
    pts[7] = [0 - land_at_side_left, 0 - land_at_front, wall_height]
    pts[8] = [house_width + land_at_side_right - wall_thickness, 0 - land_at_front, 0]
    pts[9] = [house_width + land_at_side_right - wall_thickness, house_depth + land_at_rear - wall_thickness, 0]
    pts[10] = [0 - land_at_side_left + wall_thickness, house_depth + land_at_rear - wall_thickness, 0]
    pts[11] = [0 - land_at_side_left + wall_thickness, 0 - land_at_front, 0]
    pts[12] = [house_width + land_at_side_right - wall_thickness, 0 - land_at_front, wall_height]
    pts[13] = [house_width + land_at_side_right - wall_thickness, house_depth + land_at_rear - wall_thickness, wall_height]
    pts[14] = [0 - land_at_side_left + wall_thickness, house_depth + land_at_rear - wall_thickness, wall_height]
    pts[15] = [0 - land_at_side_left + wall_thickness, 0 - land_at_front, wall_height]
    
    for step in 0..2
      face = group_ents.add_face pts[step], pts[step + 1], pts[step + 5], pts[step + 4]
      status = face.reverse!
    end
    for step in 8..10
      face = group_ents.add_face pts[step], pts[step + 1], pts[step + 5], pts[step + 4]
      if step == 8
        status = face.reverse!
      end
    end
    face = group_ents.add_face pts[0], pts[4], pts[12], pts[8]
    face = group_ents.add_face pts[3], pts[7], pts[15], pts[11]
    face = group_ents.add_face pts[4], pts[5], pts[6], pts[7], pts[15], pts[14], pts[13], pts[12]
    
    internal_border_end = house_depth + land_at_rear - wall_thickness
  elsif external_border_type == "Hedge"
    pts = []
    pts[0] = [house_width + land_at_side_right, 0 - land_at_front, 0]
    pts[1] = [house_width + land_at_side_right, house_depth + land_at_rear, 0]
    pts[2] = [0 - land_at_side_left, house_depth + land_at_rear, 0]
    pts[3] = [0 - land_at_side_left, 0 - land_at_front, 0]
    pts[4] = [house_width + land_at_side_right, 0 - land_at_front, hedge_height]
    pts[5] = [house_width + land_at_side_right, house_depth + land_at_rear, hedge_height]
    pts[6] = [0 - land_at_side_left, house_depth + land_at_rear, hedge_height]
    pts[7] = [0 - land_at_side_left, 0 - land_at_front, hedge_height]
    pts[8] = [house_width + land_at_side_right - hedge_width, 0 - land_at_front, 0]
    pts[9] = [house_width + land_at_side_right - hedge_width, house_depth + land_at_rear - hedge_width, 0]
    pts[10] = [0 - land_at_side_left + hedge_width, house_depth + land_at_rear - hedge_width, 0]
    pts[11] = [0 - land_at_side_left + hedge_width, 0 - land_at_front, 0]
    pts[12] = [house_width + land_at_side_right - hedge_width, 0 - land_at_front, hedge_height]
    pts[13] = [house_width + land_at_side_right - hedge_width, house_depth + land_at_rear - hedge_width, hedge_height]
    pts[14] = [0 - land_at_side_left + hedge_width, house_depth + land_at_rear - hedge_width, hedge_height]
    pts[15] = [0 - land_at_side_left + hedge_width, 0 - land_at_front, hedge_height]
    
    for step in 0..2
      face = group_ents.add_face pts[step], pts[step + 1], pts[step + 5], pts[step + 4]
      status = face.reverse!
    end
    for step in 8..10
      face = group_ents.add_face pts[step], pts[step + 1], pts[step + 5], pts[step + 4]
      if step == 8
        status = face.reverse!
      end
    end
    face = group_ents.add_face pts[0], pts[4], pts[12], pts[8]
    face = group_ents.add_face pts[3], pts[7], pts[15], pts[11]
    face = group_ents.add_face pts[4], pts[5], pts[6], pts[7], pts[15], pts[14], pts[13], pts[12]
    
    internal_border_end = house_depth + land_at_rear - hedge_width
  end
  
  if internal_border_type == "Fence"
    pts = []
    pts[0] = [house_width / 2, house_depth, 0]
    pts[1] = [house_width / 2, internal_border_end, 0]
    pts[2] = [house_width / 2, internal_border_end, fence_height]
    pts[3] = [house_width / 2, house_depth, fence_height]
    face = group_ents.add_face pts
  elsif internal_border_type == "Wall"
    pts = []
    pts[0] = [house_width / 2 - wall_thickness / 2, house_depth, 0]
    pts[1] = [house_width / 2 - wall_thickness / 2, internal_border_end, 0]
    pts[2] = [house_width / 2 - wall_thickness / 2, internal_border_end, wall_height]
    pts[3] = [house_width / 2 - wall_thickness / 2, house_depth, wall_height]
    pts[4] = [house_width / 2 + wall_thickness / 2, house_depth, 0]
    pts[5] = [house_width / 2 + wall_thickness / 2, internal_border_end, 0]
    pts[6] = [house_width / 2 + wall_thickness / 2, internal_border_end, wall_height]
    pts[7] = [house_width / 2 + wall_thickness / 2, house_depth, wall_height]
    face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
    status = face.reverse!
    face = group_ents.add_face pts[7], pts[6], pts[2], pts[3]
    face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
    face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
  elsif internal_border_type == "Hedge"
    pts = []
    pts[0] = [house_width / 2 - hedge_width / 2, house_depth, 0]
    pts[1] = [house_width / 2 - hedge_width / 2, internal_border_end, 0]
    pts[2] = [house_width / 2 - hedge_width / 2, internal_border_end, hedge_height]
    pts[3] = [house_width / 2 - hedge_width / 2, house_depth, hedge_height]
    pts[4] = [house_width / 2 + hedge_width / 2, house_depth, 0]
    pts[5] = [house_width / 2 + hedge_width / 2, internal_border_end, 0]
    pts[6] = [house_width / 2 + hedge_width / 2, internal_border_end, hedge_height]
    pts[7] = [house_width / 2 + hedge_width / 2, house_depth, hedge_height]
    face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
    status = face.reverse!
    face = group_ents.add_face pts[7], pts[6], pts[2], pts[3]
    face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
    face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
  end
  
  ##### Draw extensions #####
    
end