###############################################################
### One click furniture
### Create random furniture for use with One Click Hangar
###############################################################
  
##### Code to create office #####

def create_office
  
  prompts = ["Office length", "Office width", "Desk info", "Cabinet info"]
  defaults = ["800", "400", "4", "3"]
  list = ["", "", "", ""]
  input = UI.inputbox prompts, defaults, list, "Create office"
  
  office_length = input[0].to_f / $inch
  office_width = input[1].to_f / $inch
  
  desk_info = input[2].to_i
  cabinent_info = input[3].to_i
  
  
  for step in 0..desk_info - 1
    
  end
  
end
    

##### Code for computer desk #####

def computer_desk

  group = Sketchup.active_model.entities.add_group
  group_ents = group.entities
  materials = Sketchup.active_model.materials

  desk_height = 80 / $inch
  desk_depth = 70 / $inch
  desk_width = 140 / $inch
  desk_thickness = 2 / $inch
  leg_thickness = 3 / $inch
  back_plate = 30 / $inch
  side_plate = 20 / $inch
  
  # Draw legs # 
  pts = []
  for step in 0..7
    pts[step] = []
  end
  pts[0][0] = [0, 0, 0]
  pts[1][0] = [0, leg_thickness, 0]
  pts[2][0] = [leg_thickness, leg_thickness, 0]
  pts[3][0] = [leg_thickness, 0, 0]
  pts[4][0] = [0, 0, desk_height - desk_thickness]
  pts[5][0] = [0, leg_thickness, desk_height - desk_thickness]
  pts[6][0] = [leg_thickness, leg_thickness, desk_height - desk_thickness]
  pts[7][0] = [leg_thickness, 0, desk_height - desk_thickness]
  pts[0][1] = [desk_width, 0, 0]
  pts[1][1] = [desk_width, leg_thickness, 0]
  pts[2][1] = [desk_width - leg_thickness, leg_thickness, 0]
  pts[3][1] = [desk_width - leg_thickness, 0, 0]
  pts[4][1] = [desk_width, 0, desk_height - desk_thickness]
  pts[5][1] = [desk_width, leg_thickness, desk_height - desk_thickness]
  pts[6][1] = [desk_width - leg_thickness, leg_thickness, desk_height - desk_thickness]
  pts[7][1] = [desk_width - leg_thickness, 0, desk_height - desk_thickness]
  pts[0][2] = [desk_width, desk_depth, 0]
  pts[1][2] = [desk_width, desk_depth - leg_thickness, 0]
  pts[2][2] = [desk_width - leg_thickness, desk_depth - leg_thickness, 0]
  pts[3][2] = [desk_width - leg_thickness, desk_depth, 0]
  pts[4][2] = [desk_width, desk_depth, desk_height - desk_thickness]
  pts[5][2] = [desk_width, desk_depth - leg_thickness, desk_height - desk_thickness]
  pts[6][2] = [desk_width - leg_thickness, desk_depth - leg_thickness, desk_height - desk_thickness]
  pts[7][2] = [desk_width - leg_thickness, desk_depth, desk_height - desk_thickness]
  pts[0][3] = [0, desk_depth, 0]
  pts[1][3] = [0, desk_depth - leg_thickness, 0]
  pts[2][3] = [leg_thickness, desk_depth - leg_thickness, 0]
  pts[3][3] = [leg_thickness, desk_depth, 0]
  pts[4][3] = [0, desk_depth, desk_height - desk_thickness]
  pts[5][3] = [0, desk_depth - leg_thickness, desk_height - desk_thickness]
  pts[6][3] = [leg_thickness, desk_depth - leg_thickness, desk_height - desk_thickness]
  pts[7][3] = [leg_thickness, desk_depth, desk_height - desk_thickness]
  
  for step_leg in 0..3
    for step in 0..3
        face = group_ents.add_face pts[step.modulo(4)][step_leg], pts[(step + 1).modulo(4)][step_leg], pts[(step + 1).modulo(4) + 4][step_leg], pts[step.modulo(4) + 4][step_leg]
        if step == 0 and (step_leg == 0 or step_leg == 2)
          status = face.reverse!
        end
    end
  end
  
  # Draw desk top #
  pts = []
  pts[0] = [0, 0, desk_height - desk_thickness]
  pts[1] = [desk_width, 0, desk_height - desk_thickness]
  pts[2] = [desk_width, desk_depth, desk_height - desk_thickness]
  pts[3] = [0, desk_depth, desk_height - desk_thickness]
  pts[4] = [0, 0, desk_height]
  pts[5] = [desk_width, 0, desk_height]
  pts[6] = [desk_width, desk_depth, desk_height]
  pts[7] = [0, desk_depth, desk_height]
  for step in 0..3
    face = group_ents.add_face pts[step.modulo(4)], pts[(step + 1).modulo(4)], pts[(step + 1).modulo(4) + 4], pts[step.modulo(4) + 4]
 end
 face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
 face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]

  # Draw back plate #
  pts = []
  pts[0] = [leg_thickness, desk_depth, desk_height - desk_thickness]
  pts[1] = [desk_width - leg_thickness, desk_depth, desk_height - desk_thickness]
  pts[2] = [desk_width - leg_thickness, desk_depth, desk_height - desk_thickness - back_plate]
  pts[3] = [leg_thickness, desk_depth, desk_height - desk_thickness - back_plate]
  pts[4] = [leg_thickness, desk_depth - desk_thickness, desk_height - desk_thickness - back_plate]
  pts[5] = [desk_width - leg_thickness, desk_depth - desk_thickness, desk_height - desk_thickness - back_plate]
  pts[6] = [desk_width - leg_thickness, desk_depth - desk_thickness, desk_height - desk_thickness]
  pts[7] = [leg_thickness, desk_depth - desk_thickness, desk_height - desk_thickness]

  for step in 0..2
   face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 2], pts[step * 2 + 3]
  end
  
  # Draw side plates #
  pts = []
  pts[0] = [0, desk_depth - leg_thickness, desk_height - desk_thickness]
  pts[1] = [0, leg_thickness, desk_height - desk_thickness]
  pts[2] = [0, leg_thickness, desk_height - desk_thickness - side_plate]
  pts[3] = [0, desk_depth - leg_thickness, desk_height - desk_thickness - side_plate]
  pts[4] = [desk_thickness, desk_depth - leg_thickness, desk_height - desk_thickness - side_plate]
  pts[5] = [desk_thickness, leg_thickness, desk_height - desk_thickness - side_plate]
  pts[6] = [desk_thickness, leg_thickness, desk_height - desk_thickness]
  pts[7] = [desk_thickness, desk_depth - leg_thickness, desk_height - desk_thickness]

  for step in 0..2
   face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 2], pts[step * 2 + 3]
  end

  pts = []
  pts[0] = [desk_width, desk_depth - leg_thickness, desk_height - desk_thickness]
  pts[1] = [desk_width, leg_thickness, desk_height - desk_thickness]
  pts[2] = [desk_width, leg_thickness, desk_height - desk_thickness - side_plate]
  pts[3] = [desk_width, desk_depth - leg_thickness, desk_height - desk_thickness - side_plate]
  pts[4] = [desk_width - desk_thickness, desk_depth - leg_thickness, desk_height - desk_thickness - side_plate]
  pts[5] = [desk_width - desk_thickness, leg_thickness, desk_height - desk_thickness - side_plate]
  pts[6] = [desk_width - desk_thickness, leg_thickness, desk_height - desk_thickness]
  pts[7] = [desk_width - desk_thickness, desk_depth - leg_thickness, desk_height - desk_thickness]

  for step in 0..2
   face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 2], pts[step * 2 + 3]
  end

end

##### Code for cabinet #####

def cabinet
 
  group = Sketchup.active_model.entities.add_group
  group_ents = group.entities
  materials = Sketchup.active_model.materials
  
  cabinet_height = 170 / $inch
  cabinet_width = 80 / $inch
  cabinet_depth = 40 / $inch
  cabinet_thickness = 1 / $inch
  cabinet_shelves = 4
  cabinet_shelf_thickness = 2 / $inch
  cabinet_shelf_levels = [40 / $inch, 70 / $inch, 100 / $inch, 130 / $inch]  ### Shelf level starts at the bottom of the shelf
  cabinet_floor_offset = 7 / $inch
  
  # Draw outer walls
  
  pts = []
  pts[0] = [0, 0, 0]
  pts[1] = [0, 0, cabinet_height]
  pts[2] = [0, cabinet_depth, cabinet_height]
  pts[3] = [0, cabinet_depth, 0]
  pts[4] = [cabinet_width, cabinet_depth, 0]
  pts[5] = [cabinet_width, cabinet_depth, cabinet_height]
  pts[6] = [cabinet_width, 0, cabinet_height]
  pts[7] = [cabinet_width, 0, 0]
  for step in 0..3
   face = group_ents.add_face pts[(step * 2).modulo(8)], pts[(step * 2 + 1).modulo(8)], pts[(step * 2 + 2).modulo(8)], pts[(step * 2 + 3).modulo(8)]
  end
  face = group_ents.add_face pts[1], pts[2], pts[5], pts[6]  
  
  # Cutout front and draw internal walls
  pts = []
  pts[0] = [cabinet_thickness, 0, cabinet_floor_offset]
  pts[1] = [cabinet_width - cabinet_thickness, 0, cabinet_floor_offset]
  pts[2] = [cabinet_width - cabinet_thickness, 0, cabinet_height - cabinet_thickness]
  pts[3] = [cabinet_thickness, 0, cabinet_height - cabinet_thickness]
  face = group_ents.add_face pts
  status = face.erase!

  pts[7] = [cabinet_thickness, cabinet_depth - cabinet_thickness, cabinet_floor_offset]
  pts[6] = [cabinet_width - cabinet_thickness, cabinet_depth - cabinet_thickness, cabinet_floor_offset]
  pts[5] = [cabinet_width - cabinet_thickness, cabinet_depth - cabinet_thickness, cabinet_height - cabinet_thickness]
  pts[4] = [cabinet_thickness, cabinet_depth - cabinet_thickness, cabinet_height - cabinet_thickness]
  for step in 1..3
   face = group_ents.add_face pts[(step * 2).modulo(8)], pts[(step * 2 + 1).modulo(8)], pts[(step * 2 + 2).modulo(8)], pts[(step * 2 + 3).modulo(8)]
  end
  face = group_ents.add_face pts[0], pts[3], pts[4], pts[7]
  face = group_ents.add_face pts[1], pts[2], pts[5], pts[6]
  
  # Draw shelves
  
  for step in 0..cabinet_shelves - 1
    pts = []
    pts[0] = [cabinet_width - cabinet_thickness, cabinet_depth - cabinet_thickness, cabinet_shelf_levels[step]]
    pts[1] = [cabinet_thickness, cabinet_depth - cabinet_thickness, cabinet_shelf_levels[step]]
    pts[2] = [cabinet_thickness, cabinet_shelf_thickness, cabinet_shelf_levels[step]]
    pts[3] = [cabinet_width - cabinet_thickness, cabinet_shelf_thickness, cabinet_shelf_levels[step]]
    pts[4] = [cabinet_width - cabinet_thickness, cabinet_shelf_thickness, cabinet_shelf_levels[step] + cabinet_shelf_thickness]
    pts[5] = [cabinet_thickness, cabinet_shelf_thickness, cabinet_shelf_levels[step] + cabinet_shelf_thickness]
    pts[6] = [cabinet_thickness, cabinet_depth - cabinet_thickness, cabinet_shelf_levels[step] + cabinet_shelf_thickness]
    pts[7] = [cabinet_width - cabinet_thickness, cabinet_depth - cabinet_thickness, cabinet_shelf_levels[step] + cabinet_shelf_thickness]
    for step2 in 0..2
      face = group_ents.add_face pts[step2 * 2], pts[step2 * 2 + 1], pts[step2 * 2 + 2], pts[step2 * 2 + 3]
      if step2 == 0
        status = face.reverse!
      end
    end

  end
end

