####################
### Hangar doors ###
####################


###################################################
###################################################
###### Below is the code for to insert doors ######
###################################################
###################################################

def insert_door(door_type = "", door_height = 0.0, door_folding_level = 0.0, door_sections = 0, door_width = 0.0, door_middle = [], full_length = 0.0, wall_thickness = 0.0, door_frame_thickness = 0.0, door_skin_thickness = 0.0, outside_height = 0.0, arc = 0.0, door_frame_texture = "", door_texture = "", wall_texture = "", roof_texture = "", beam_texture = "", floor_texture = "", direction = "", hangar_type = "", left_offset = 0.0, door_extensions = "")
  
  
  door_height = door_height.to_f
  door_folding_level = door_folding_level.to_i
  door_sections = door_sections.to_i
  door_width = door_width.to_f
  multiple_doors = 0
  begin
    door_middle = door_middle.to_f
  rescue
    multiple_doors = door_middle.length
    door_middle_array = door_middle
    door_middle = door_middle_array[0]
  end
  
  full_length = full_length.to_f
  wall_thickness = wall_thickness.to_f
  door_frame_thickness = door_frame_thickness.to_f
  door_skin_thickness = door_skin_thickness.to_f
  outside_height = outside_height.to_f
  arc = arc.to_f
  left_offset = left_offset.to_f
  door_extension = []
  
  if door_extensions == nil
    door_extensions = ""
  end
  
  if door_extensions != ""
#   UI.messagebox "X1"  
    if door_extensions.count("|") > 0
      door_extension = door_extensions.split("|")
    else
      door_extension[0] = door_extensions
    end
#   UI.messagebox "Y1"  
  end
  
  if door_folding_level < 0
    close_door = rand(2)
    if close_door == 0
      door_folding_level = door_folding_level.abs
    else
      door_folding_level = 90
    end
  
  end
  

  # Extensions for doors
  
  door_extension_type = []
  entrance_door_override = 0
  door_no_frame = 0
  entrance_door_x_position = 0
  entrance_door_y_position = 0
  entrance_door_x_size = 80 / $inch
  entrance_door_y_size = 190 / $inch


  if door_extension.length > 0
    for step in 0..door_extension.length - 1
#   UI.messagebox "X2"  
      if door_extension[step].count(":") > 0
        door_extension_info = door_extension[step].split(":")
        door_extension_type[step] = door_extension_info[0]
  
        if door_extension_type[step] == "Override"
          entrance_door_override = door_extension_info[1] 
        end
        if door_extension_type[step] == "Entrance door"
          entrance_door_x_position = door_extension_info[1].to_f / $inch
          entrance_door_y_position = door_extension_info[2].to_f / $inch
          entrance_door_x_size = door_extension_info[3].to_f / $inch
          entrance_door_y_size = door_extension_info[4].to_f / $inch
        end
      end
#   UI.messagebox "Y2"  
    end
  end
  
  if hangar_type == "T-Hangar"
    door_no_frame = 1
  end
  
  # Create separate group for door entities
  group = Sketchup.active_model.entities.add_group
  group_ents = group.entities
  group.description = door_type + ":" + door_height.to_s + ":" + door_folding_level.to_s + ":" + door_sections.to_s + ":" + door_width.to_s + ":" + door_middle.to_s + ":" + full_length.to_s + ":" + wall_thickness.to_s + ":" + door_frame_thickness.to_s + ":" + door_skin_thickness.to_s + ":" + outside_height.to_s + ":" + arc.to_s + ":" + door_frame_texture + ":" + door_texture + ":" + wall_texture + ":" + roof_texture + ":" + beam_texture + ":" + floor_texture + ":" + direction + ":" + hangar_type + ":" + left_offset.to_s + ":" + door_extensions
  materials = Sketchup.active_model.materials

  for step in 0..$texture_name.length
    if door_texture == $texture_name[step] or door_frame_texture == $texture_name[step] or beam_texture == $texture_name[step]
      texture = materials.add $texture_name[step]
      texture.texture = $texture_files + $texture_filename[step]
      texture.texture.size = [$texture_x_size[step] / $inch, $texture_y_size[step] / $inch]
    end 
    if door_texture == "Untextured" or door_frame_texture == "Untextured" or beam_texture == "Untextured"
      texture = materials.add "Untextured"
      texture.color = "White"
    end
  end 
  
  if door_type == "Hydraulic door - Vertical piston"
  
    # Draw side beams
    
    beam_width = door_height / 6
    beam_thickness = door_frame_thickness * 4
    
    
    pts = []
    pts[0] = [0, 0, 0]
    pts[1] = [beam_width, 0, 0]
    pts[2] = [beam_width, 0, door_height]
    pts[3] = [0, 0, door_height]
    pts[4] = [0, beam_thickness, 0]
    pts[5] = [0, beam_thickness, door_height]
    pts[6] = [beam_width, beam_thickness, 0]
    pts[7] = [beam_width, beam_thickness, door_height]
    pts[8] = [beam_width - door_frame_thickness, beam_thickness, door_height]
    pts[9] = [beam_width - door_frame_thickness, door_frame_thickness, door_height]
    pts[10] = [beam_width - beam_thickness, door_frame_thickness, door_height]
    pts[11] = [beam_width - beam_thickness, beam_thickness, door_height]
    
    face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
    status = face.material = beam_texture
    face = group_ents.add_face pts[0], pts[3], pts[5], pts[4]
    status = face.material = beam_texture
    face = group_ents.add_face pts[1], pts[2], pts[7], pts[6]
    status = face.material = beam_texture
    face = group_ents.add_face pts[8], pts[9], pts[10], pts[11]
    status = face.material = beam_texture
  
  
  ##############################
  #### Hydraulic swing door ####
  ##############################
  
  elsif door_type == "Detailed door" or door_type == "Hydraulic swing door"
    group_support = Sketchup.active_model.entities.add_group
    group_support_ents = group_support.entities

    
    beam_width = door_frame_thickness * 2
    beam_thickness = door_frame_thickness
    beam_top = door_height - beam_thickness * 3
    door_beam_position = full_length
    # draw support frame for doors
    
    if door_no_frame == 0
      for step in 0..1
        step_index = 1 - step * 2
        if step == 0
          door_beam_side_position = door_middle - door_width / 2 - door_frame_thickness
        else
          door_beam_side_position = door_middle + door_width / 2 + door_frame_thickness
        end
        pts = []
        pts[0] = [door_beam_position, door_beam_side_position, 0]
        pts[1] = [door_beam_position - beam_thickness, door_beam_side_position, 0]
        pts[2] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * step_index, 0]
        pts[3] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * step_index, 0]
        pts[4] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position, 0]
        pts[5] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position, 0]
        pts[6] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position - beam_thickness * 3 * step_index, 0]
        pts[7] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 3 * step_index, 0]
        pts[8] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 2 * step_index, 0]
        pts[9] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 2 * step_index, 0]
        pts[10] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 3 * step_index, 0]
        pts[11] = [door_beam_position, door_beam_side_position - beam_thickness * 3 * step_index, 0]
        pts[12] = [door_beam_position, door_beam_side_position, beam_top]
        pts[13] = [door_beam_position - beam_thickness, door_beam_side_position, beam_top]
        pts[14] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * step_index, beam_top]
        pts[15] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * step_index, beam_top]
        pts[16] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position, beam_top]
        pts[17] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position, beam_top]
        pts[18] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position - beam_thickness * 3 * step_index, beam_top]
        pts[19] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 3 * step_index, beam_top]
        pts[20] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 2 * step_index, beam_top]
        pts[21] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 2 * step_index, beam_top]
        pts[22] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 3 * step_index, beam_top]
        pts[23] = [door_beam_position, door_beam_side_position - beam_thickness * 3 * step_index, beam_top]
      
        for beam_step in 0..10
          face = group_support_ents.add_face pts[beam_step], pts[beam_step + 1], pts[beam_step + 13], pts[beam_step + 12]
          if beam_step == 0 and face.normal[1] != step_index
            status = face.reverse!
          end
          status = face.material = beam_texture
        end
        face = group_support_ents.add_face pts[11], pts[0], pts[12], pts[23]
        status = face.material = beam_texture
        face = group_support_ents.add_face pts[12], pts[13], pts[14], pts[15], pts[16], pts[17], pts[18], pts[19], pts[20], pts[21], pts[22], pts[23]
        status = face.material = beam_texture
      end
  
      door_beam_side_position = door_middle - door_width / 2
      door_beam_side_end_position = door_middle + door_width / 2
      pts = []
      pts[0] = [door_beam_position, door_beam_side_position - beam_thickness * 4, beam_top]
      pts[1] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 4, beam_top]
      pts[2] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 4, beam_top + beam_thickness]
      pts[3] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 4, beam_top + beam_thickness]
      pts[4] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 4, beam_top]
      pts[5] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position - beam_thickness * 4, beam_top]
      pts[6] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position - beam_thickness * 4, beam_top + beam_thickness * 3]
      pts[7] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 4, beam_top + beam_thickness * 3]
      pts[8] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 4, beam_top + beam_thickness * 2]
      pts[9] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 4, beam_top + beam_thickness * 2]
      pts[10] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 4, beam_top + beam_thickness * 3]
      pts[11] = [door_beam_position, door_beam_side_position - beam_thickness * 4, beam_top + beam_thickness * 3]
      pts[12] = [door_beam_position, door_beam_side_end_position + beam_thickness * 4, beam_top]
      pts[13] = [door_beam_position - beam_thickness, door_beam_side_end_position + beam_thickness * 4, beam_top]
      pts[14] = [door_beam_position - beam_thickness, door_beam_side_end_position + beam_thickness * 4, beam_top + beam_thickness]
      pts[15] = [door_beam_position - beam_thickness - beam_width, door_beam_side_end_position + beam_thickness * 4, beam_top + beam_thickness]
      pts[16] = [door_beam_position - beam_thickness - beam_width, door_beam_side_end_position + beam_thickness * 4, beam_top]
      pts[17] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_end_position + beam_thickness * 4, beam_top]
      pts[18] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_end_position + beam_thickness * 4, beam_top + beam_thickness * 3]
      pts[19] = [door_beam_position - beam_thickness - beam_width, door_beam_side_end_position + beam_thickness * 4, beam_top + beam_thickness * 3]
      pts[20] = [door_beam_position - beam_thickness - beam_width, door_beam_side_end_position + beam_thickness * 4, beam_top + beam_thickness * 2]
      pts[21] = [door_beam_position - beam_thickness, door_beam_side_end_position + beam_thickness * 4, beam_top + beam_thickness * 2]
      pts[22] = [door_beam_position - beam_thickness, door_beam_side_end_position + beam_thickness * 4, beam_top + beam_thickness * 3]
      pts[23] = [door_beam_position, door_beam_side_end_position + beam_thickness * 4, beam_top + beam_thickness * 3]
      for beam_step in 0..10
        face = group_support_ents.add_face pts[beam_step], pts[beam_step + 1], pts[beam_step + 13], pts[beam_step + 12]
        if beam_step == 0 or beam_step == 4
          status = face.reverse!
        end
        status = face.material = beam_texture
      end
      face = group_support_ents.add_face pts[11], pts[0], pts[12], pts[23]
      status = face.material = beam_texture
      face = group_support_ents.add_face pts[0], pts[1], pts[2], pts[3], pts[4], pts[5], pts[6], pts[7], pts[8], pts[9], pts[10], pts[11]
      status = face.material = beam_texture
      face = group_support_ents.add_face pts[12], pts[13], pts[14], pts[15], pts[16], pts[17], pts[18], pts[19], pts[20], pts[21], pts[22], pts[23]
      status = face.material = beam_texture
    end
    
    #Add textures
    texture = materials.add "Shiny metal"
    texture.texture = $texture_files + "suht_shiny_metal.jpg"
    texture.texture.size = 100 / $inch
    texture = materials.add "Black texture"
    texture.texture = $texture_files + "suht_black_texture.jpg"
    texture.texture.size = 10 / $inch


    # Create door frame
    vertical_door_frame =(door_width /(170 / $inch)).to_i
    door_frame_position = full_length + wall_thickness - door_frame_thickness
    door_frame_distance =(door_width - door_frame_thickness) / vertical_door_frame
    door_skirt_distance =(door_width - door_frame_thickness) /(vertical_door_frame * 2)
    door_skirt_length = 15 / $inch
    for step in 0..vertical_door_frame
      pts = []
      pts[0] = [door_frame_position,(step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_thickness]
      pts[1] = [door_frame_position,(step * door_frame_distance) +(door_middle -(door_width / 2)), door_height - door_frame_thickness]
      pts[2] = [door_frame_position,(step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_height - door_frame_thickness]
      pts[3] = [door_frame_position,(step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_thickness]
      face = group_ents.add_face pts
      status = face.material = door_frame_texture
    
      pts[4] = [door_frame_position + door_frame_thickness,(step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_thickness]
      pts[5] = [door_frame_position + door_frame_thickness,(step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_height - door_frame_thickness]
      pts[6] = [door_frame_position + door_frame_thickness,(step * door_frame_distance) +(door_middle -(door_width / 2)), door_height - door_frame_thickness]
      pts[7] = [door_frame_position + door_frame_thickness,(step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_thickness]
      face = group_ents.add_face pts[0], pts[1], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = door_frame_texture
    end
    
    for step in 0..1
      pts = []
      pts[0] = [door_frame_position, door_middle -(door_width / 2),((door_height - door_frame_thickness) * step)]
      pts[1] = [door_frame_position, door_middle -(door_width / 2),((door_height - door_frame_thickness) * step) + door_frame_thickness]
      pts[2] = [door_frame_position, door_middle +(door_width / 2),((door_height - door_frame_thickness) * step) + door_frame_thickness]
      pts[3] = [door_frame_position, door_middle +(door_width / 2),((door_height - door_frame_thickness) * step)]
      face = group_ents.add_face pts
      status = face.material = door_frame_texture
      pts[4] = [door_frame_position + door_frame_thickness, door_middle +(door_width / 2),((door_height - door_frame_thickness) * step)]
      pts[5] = [door_frame_position + door_frame_thickness, door_middle +(door_width / 2),((door_height - door_frame_thickness) * step) + door_frame_thickness]
      pts[6] = [door_frame_position + door_frame_thickness, door_middle -(door_width / 2),((door_height - door_frame_thickness) * step) + door_frame_thickness]
      pts[7] = [door_frame_position + door_frame_thickness, door_middle -(door_width / 2),((door_height - door_frame_thickness) * step)]
      face = group_ents.add_face pts[1], pts[2], pts[5], pts[6]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[0], pts[3], pts[4], pts[7]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[0], pts[1], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = door_frame_texture
      if step == 0
        face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
        status = face.material = door_frame_texture
      end
    
    end
  
    pts = []
    pts[0] = [door_frame_position + door_frame_thickness, door_middle -(door_width / 2) + door_frame_thickness, 0]
    pts[1] = [door_frame_position + door_frame_thickness +(door_skirt_length / 2), door_middle -(door_width / 2) + door_frame_thickness, 0]
    pts[2] = [door_frame_position + door_frame_thickness + door_skirt_length, door_middle -(door_width / 2) + door_frame_thickness +(door_skirt_length * 2), 0]
    pts[3] = [door_frame_position + door_frame_thickness + door_skirt_length, door_middle +(door_width / 2) -(door_frame_thickness +(door_skirt_length * 2)), 0]
    pts[4] = [door_frame_position + door_frame_thickness +(door_skirt_length / 2), door_middle +((door_width / 2) - door_frame_thickness), 0]
    pts[5] = [door_frame_position + door_frame_thickness, door_middle +(door_width / 2) - door_frame_thickness, 0]
    edge = group_ents.add_edges pts
    
    pts = []
    pts[0] = [door_frame_position + door_frame_thickness, door_middle -(door_width / 2) + door_frame_thickness, 0]
    pts[1] = [door_frame_position + door_frame_thickness, door_middle -(door_width / 2) + door_frame_thickness, door_frame_thickness]
    pts[2] = [door_frame_position + door_frame_thickness, door_middle -(door_width / 2), door_frame_thickness]
    pts[3] = [door_frame_position + door_frame_thickness, door_middle -(door_width / 2), 0]
    face = group_ents.add_face pts
    status = face.material = door_frame_texture
    status = face.followme edge 
    
    for step in 1..(vertical_door_frame * 2) - 1
      pts = []
      pts[0] = [door_frame_position + door_frame_thickness,(step * door_skirt_distance) +(door_middle -(door_width / 2)), 0]
      pts[1] = [door_frame_position + door_frame_thickness,(step * door_skirt_distance) +(door_middle -(door_width / 2)), door_frame_thickness]
      pts[2] = [door_frame_position + door_frame_thickness,(step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_thickness]
      pts[3] = [door_frame_position + door_frame_thickness,(step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), 0]
      pts[4] = [door_frame_position + door_frame_thickness + door_skirt_length,(step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), 0]
      pts[5] = [door_frame_position + door_frame_thickness + door_skirt_length,(step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_thickness]
      pts[6] = [door_frame_position + door_frame_thickness + door_skirt_length,(step * door_skirt_distance) +(door_middle -(door_width / 2)), door_frame_thickness]
      pts[7] = [door_frame_position + door_frame_thickness + door_skirt_length,(step * door_skirt_distance) +(door_middle -(door_width / 2)), 0]
      face = group_ents.add_face pts[0], pts[3], pts[4], pts[7]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[0], pts[1], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[1], pts[2], pts[5], pts[6]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = door_frame_texture
    end
  
    # Add brackets for pistons
    
    piston_support_group = Sketchup.active_model.entities.add_group
    piston_support_group_ents = piston_support_group.entities

    pts = []
    pts[0] = [door_frame_position, door_middle -(door_width / 2), 0]
    pts[1] = [door_frame_position, door_middle -(door_width / 2), door_height +(door_frame_thickness * 2) + door_skirt_length]
    face = piston_support_group_ents.add_edges pts
    top_support_edge =(door_height * 0.8) +(20 / $inch)
    bottom_support_edge =(door_height * 0.8) -(20 / $inch)


    #Calculate piston angle and dimensions
    door_angle = 90 - door_folding_level
    angle_sin = Math.sin(door_angle.degrees)
    angle_cos = Math.cos(door_angle.degrees)
    adjacent = angle_sin * door_height * 2 / 3
    opposite = angle_cos * door_height * 2 / 3
    door_adjacent = angle_sin * door_frame_thickness * 1.75
    door_opposite = angle_cos * door_frame_thickness * 1.75
    door_adjacent2 = angle_sin * door_frame_thickness * 0.5
    door_opposite2 = angle_cos * door_frame_thickness * 0.5
    piston_length =(Math.sqrt(((door_height * 0.2) *(door_height * 0.2)) +((door_height * 2 / 3) *(door_height * 2 / 3))) / 2) +(wall_thickness * 2)
    piston_end_x_pos = full_length + wall_thickness + adjacent - door_opposite + door_adjacent2
    piston_end_z_pos = door_height - opposite - door_adjacent - door_opposite2
    full_piston_length = Math.sqrt((piston_end_x_pos -(full_length -(wall_thickness * 2))) *(piston_end_x_pos -(full_length -(wall_thickness * 2))) +((piston_end_z_pos -(door_height * 0.8)) *(piston_end_z_pos -(door_height * 0.8))))
    door_height_difference =(door_height * 0.8) - piston_end_z_pos

    
    bracket_location = door_height / 3
    bracket_size = door_frame_thickness

    for step in 0..1
      step_index = 1 -(step * 2)
      pts = []
      pts[0] = [door_frame_position, door_middle -((door_width / 2) * step_index), bracket_location]
      pts[1] = [door_frame_position, door_middle -((door_width / 2) * step_index), bracket_location - bracket_size]
      pts[2] = [door_frame_position - bracket_size, door_middle -((door_width / 2) * step_index), bracket_location - bracket_size]
      pts[3] = [door_frame_position - bracket_size, door_middle -((door_width / 2) * step_index), bracket_location]
      face = group_ents.add_face pts
      status = face.material = door_frame_texture

      pts[4] = [door_frame_position - bracket_size, door_middle -((door_width / 2) * step_index) +(door_frame_thickness * step_index), bracket_location]
      pts[5] = [door_frame_position - bracket_size, door_middle -((door_width / 2) * step_index) +(door_frame_thickness * step_index), bracket_location - bracket_size]
      pts[6] = [door_frame_position, door_middle -((door_width / 2) * step_index) +(door_frame_thickness * step_index), bracket_location - bracket_size]
      pts[7] = [door_frame_position, door_middle -((door_width / 2) * step_index) +(door_frame_thickness * step_index), bracket_location]
      face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[1], pts[2], pts[5], pts[6]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[0], pts[3], pts[4], pts[7]
      status = face.material = door_frame_texture

      pts[8] = [door_frame_position, door_middle -((door_width / 2) * step_index) +((door_frame_thickness + bracket_size) * step_index), bracket_location - bracket_size]
      pts[9] = [door_frame_position, door_middle -((door_width / 2) * step_index) +((door_frame_thickness + bracket_size) * step_index), bracket_location]
      pts[10] = [door_frame_position - bracket_size, door_middle -((door_width / 2) * step_index) +((door_frame_thickness + bracket_size) * step_index), bracket_location]
      pts[11] = [door_frame_position - bracket_size, door_middle -((door_width / 2) * step_index) +((door_frame_thickness + bracket_size) * step_index), bracket_location - bracket_size]
      pts[12] = [door_frame_position - bracket_size, door_middle -((door_width / 2) * step_index) +(((door_frame_thickness * 2) + bracket_size) * step_index), bracket_location - bracket_size]
      pts[13] = [door_frame_position - bracket_size, door_middle -((door_width / 2) * step_index) +(((door_frame_thickness * 2) + bracket_size) * step_index), bracket_location]
      pts[14] = [door_frame_position + door_frame_thickness, door_middle -((door_width / 2) * step_index) +(((door_frame_thickness * 2) + bracket_size) * step_index), bracket_location]
      pts[15] = [door_frame_position + door_frame_thickness, door_middle -((door_width / 2) * step_index) +(((door_frame_thickness * 2) + bracket_size) * step_index), bracket_location - bracket_size]
      pts[16] = [door_frame_position + door_frame_thickness, door_middle -((door_width / 2) * step_index) +(door_frame_thickness * step_index), bracket_location - bracket_size]
      pts[17] = [door_frame_position + door_frame_thickness, door_middle -((door_width / 2) * step_index) +(door_frame_thickness * step_index), bracket_location]
      face = group_ents.add_face pts[7], pts[6], pts[8], pts[9]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[8], pts[9], pts[10], pts[11]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[10], pts[11], pts[12], pts[13]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[12], pts[13], pts[14], pts[15]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[16], pts[6], pts[8], pts[11], pts[12], pts[15]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[7], pts[9], pts[10], pts[13], pts[14], pts[17]
      status = face.material = door_frame_texture

      # Add support for pistons
      pts = []
      pts[0] = [full_length - beam_width - beam_thickness * 2, door_middle -((door_width / 2) * step_index), bottom_support_edge]
      pts[1] = [full_length - beam_width - beam_thickness * 2, door_middle -((door_width / 2) * step_index) -(door_frame_thickness * step_index), bottom_support_edge]
      pts[2] = [full_length - beam_width - beam_thickness * 2, door_middle -((door_width / 2) * step_index) -(door_frame_thickness * step_index), top_support_edge]
      pts[3] = [full_length - beam_width - beam_thickness * 2, door_middle -((door_width / 2) * step_index), top_support_edge]
      face = piston_support_group_ents.add_face pts
      if step == 1
        status = face.reverse!
      end
      status = face.material = door_frame_texture
      pts[4] = [full_length, door_middle -((door_width / 2) * step_index), bottom_support_edge]
      pts[5] = [full_length, door_middle -((door_width / 2) * step_index) -(door_frame_thickness * step_index), bottom_support_edge]
      pts[6] = [full_length, door_middle -((door_width / 2) * step_index) -(door_frame_thickness * step_index), top_support_edge]
      pts[7] = [full_length, door_middle -((door_width / 2) * step_index), top_support_edge]
      face = piston_support_group_ents.add_face pts[0], pts[1], pts[5], pts[4]
      status = face.material = door_frame_texture
      face = piston_support_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
      status = face.material = door_frame_texture
      face = piston_support_group_ents.add_face pts[2], pts[3], pts[7], pts[6]
      status = face.material = door_frame_texture
      face = piston_support_group_ents.add_face pts[1], pts[2], pts[6], pts[5]
      status = face.material = door_frame_texture
      face = piston_support_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_frame_texture

      pt1 = [full_length - (wall_thickness * 2), door_middle -((door_width / 2) * step_index) +((door_frame_thickness * 3) * step_index), door_height * 0.8]
      vector = Geom::Vector3d.new 0,-1 * step_index,0
      vector2 = vector.normalize!       
      circle = piston_support_group_ents.add_circle pt1, vector2, door_frame_thickness / 2
      face = piston_support_group_ents.add_face circle
      status = face.material = door_frame_texture
      status = face.pushpull door_frame_thickness * 3

      if step == 0
        piston_group = Sketchup.active_model.entities.add_group
        piston_group_ents = piston_group.entities
      end
      #Create piston
      pt1 = [full_length -(wall_thickness * 2), door_middle -((door_width / 2) * step_index) +((door_frame_thickness * 2) * step_index), door_height * 0.8]
      vector = Geom::Vector3d.new 0,-1 * step_index,0
      vector2 = vector.normalize!       
      circle = piston_group_ents.add_circle pt1, vector2, door_frame_thickness
      face = piston_group_ents.add_face circle
      status = face.material = door_frame_texture
      status = face.pushpull door_frame_thickness

      pts = []
      pts[0] = [full_length - (wall_thickness * 2), door_middle - ((door_width / 2) * step_index) + (door_frame_thickness * step_index), (door_height * 0.8) + (door_frame_thickness / 2)]
      pts[1] = [full_length - (wall_thickness * 2), door_middle - ((door_width / 2) * step_index) + (door_frame_thickness * step_index), (door_height * 0.8) - (door_frame_thickness / 2)]
      pts[2] = [full_length - (wall_thickness * 2) + (door_frame_thickness * 2), door_middle - ((door_width / 2) * step_index) + (door_frame_thickness * step_index), (door_height * 0.8) -(door_frame_thickness / 2)]
      pts[3] = [full_length - (wall_thickness * 2) + (door_frame_thickness * 2), door_middle - ((door_width / 2) * step_index) + (door_frame_thickness * step_index), (door_height * 0.8) +(door_frame_thickness / 2)]
      face = piston_group_ents.add_face pts
      if step == 1
        status = face.reverse!
      end
      status = face.material = door_frame_texture
      pts[4] = [full_length -(wall_thickness * 2) +(door_frame_thickness * 2), door_middle -((door_width / 2) * step_index) +((door_frame_thickness * 2) * step_index),(door_height * 0.8) +(door_frame_thickness / 2)]
      pts[5] = [full_length -(wall_thickness * 2) +(door_frame_thickness * 2), door_middle -((door_width / 2) * step_index) +((door_frame_thickness * 2) * step_index),(door_height * 0.8) -(door_frame_thickness / 2)]
      pts[6] = [full_length -(wall_thickness * 2), door_middle -((door_width / 2) * step_index) +((door_frame_thickness * 2) * step_index),(door_height * 0.8) -(door_frame_thickness / 2)]
      pts[7] = [full_length -(wall_thickness * 2), door_middle -((door_width / 2) * step_index) +((door_frame_thickness * 2) * step_index),(door_height * 0.8) +(door_frame_thickness / 2)]
      face = piston_group_ents.add_face pts[1], pts[2], pts[5], pts[6]
      status = face.material = door_frame_texture
      face = piston_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = piston_group_ents.add_face pts[0], pts[3], pts[4], pts[7]
      status = face.material = door_frame_texture

      pt2 = [full_length - (wall_thickness * 2) +(door_frame_thickness * 2), door_middle -((door_width / 2) * step_index) +((door_frame_thickness * 1.5) * step_index), door_height * 0.8]
      vector = Geom::Vector3d.new 1,0,0
      vector2 = vector.normalize!       
      circle = piston_group_ents.add_circle pt2, vector2, door_frame_thickness
      face = piston_group_ents.add_face circle
      status = face.material = "Black texture"
      status = face.pushpull piston_length
  
      pt3 = [full_length - (wall_thickness * 2) + full_piston_length, door_middle -((door_width / 2) * step_index) +((door_frame_thickness * 1.5) * step_index), door_height * 0.8]
      vector = Geom::Vector3d.new -1,0,0
      vector2 = vector.normalize!       
      circle = piston_group_ents.add_circle pt3, vector2, door_frame_thickness / 2
      face = piston_group_ents.add_face circle
      status = face.material = "Shiny metal"
      status = face.pushpull(full_piston_length -((door_frame_thickness * 2) + piston_length))

    end

    if door_height_difference < 0
      door_t = Geom::Transformation.rotation pt1, Y_AXIS,(90 - Math.acos(door_height_difference / full_piston_length).radians).degrees
      piston_group.transform! door_t
    elsif door_height_difference > 0
      door_t = Geom::Transformation.rotation pt1, Y_AXIS, Math.asin(door_height_difference / full_piston_length)
      piston_group.transform! door_t
    end

    # Create door skin
    pts = []
    pts[0] = [door_frame_position + door_frame_thickness, door_middle -(door_width / 2), door_frame_thickness]
    pts[1] = [door_frame_position + door_frame_thickness, door_middle -(door_width / 2), door_height]
    pts[2] = [door_frame_position + door_frame_thickness, door_middle +(door_width / 2), door_height]
    pts[3] = [door_frame_position + door_frame_thickness, door_middle +(door_width / 2), door_frame_thickness]
    face = group_ents.add_face pts
    status = face.reverse!
    status = face.material = door_texture

    pts[4] = [door_frame_position + door_frame_thickness + door_skin_thickness, door_middle + (door_width / 2), door_frame_thickness]
    pts[5] = [door_frame_position + door_frame_thickness + door_skin_thickness, door_middle + (door_width / 2), door_height]
    pts[6] = [door_frame_position + door_frame_thickness + door_skin_thickness, door_middle - (door_width / 2), door_height]
    pts[7] = [door_frame_position + door_frame_thickness + door_skin_thickness, door_middle - (door_width / 2), door_frame_thickness]
    face = group_ents.add_face pts[1], pts[2], pts[5], pts[6]
    status = face.material = door_texture
    face = group_ents.add_face pts[0], pts[3], pts[4], pts[7]
    status = face.reverse!
    status = face.material = door_texture
    face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
    status = face.material = door_texture
    face = group_ents.add_face pts[0], pts[1], pts[6], pts[7]
    status = face.material = door_texture
    face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
    status = face.material = door_texture
    
    
    ############ Door cutout ###########
    
    if entrance_door_override == 0
      entrance_door_x_offset = door_middle - (door_width / 2) + door_frame_thickness * 5
      entrance_door_y_offset = door_frame_thickness * 2
      pts = []
      pts[0] = [door_frame_position + door_frame_thickness + door_skin_thickness, entrance_door_x_offset + entrance_door_x_position, entrance_door_y_offset + entrance_door_y_position]
      pts[1] = [door_frame_position + door_frame_thickness + door_skin_thickness, entrance_door_x_offset + entrance_door_x_position + entrance_door_x_size, entrance_door_y_offset + entrance_door_y_position]
      pts[2] = [door_frame_position + door_frame_thickness + door_skin_thickness, entrance_door_x_offset + entrance_door_x_position + entrance_door_x_size, entrance_door_y_offset + entrance_door_y_position + entrance_door_y_size]
      pts[3] = [door_frame_position + door_frame_thickness + door_skin_thickness, entrance_door_x_offset + entrance_door_x_position, entrance_door_y_offset + entrance_door_y_position + entrance_door_y_size]
      pts[4] = [door_frame_position + door_frame_thickness, entrance_door_x_offset + entrance_door_x_position, entrance_door_y_offset + entrance_door_y_position]
      pts[5] = [door_frame_position + door_frame_thickness, entrance_door_x_offset + entrance_door_x_position + entrance_door_x_size, entrance_door_y_offset + entrance_door_y_position]
      pts[6] = [door_frame_position + door_frame_thickness, entrance_door_x_offset + entrance_door_x_position + entrance_door_x_size, entrance_door_y_offset + entrance_door_y_position + entrance_door_y_size]
      pts[7] = [door_frame_position + door_frame_thickness, entrance_door_x_offset + entrance_door_x_position, entrance_door_y_offset + entrance_door_y_position + entrance_door_y_size]

      face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
      status = face.erase!
      face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.erase!

      entrance_door_group = Sketchup.active_model.entities.add_group
      entrance_door_group_ents = entrance_door_group.entities
      face = entrance_door_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
      status = face.material = door_frame_texture
      face = entrance_door_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.reverse!
      status = face.material = door_frame_texture
      group = group.parent.entities.add_group([group, entrance_door_group])
    end
    
    if door_folding_level.to_i < 0
      door_folding_level = 0.0
    elsif door_folding_level.to_i > 90
      door_folding_level = 90.0
    end

    door_radians = (-90 + door_folding_level.to_i).degrees
    
    door_t = Geom::Transformation.rotation [full_length + wall_thickness, door_middle - (door_width / 2), door_height], Y_AXIS, door_radians
    group.transform! door_t

    pts = []
    pts[0] = [0, 0, 0]
    pts[1] = [full_length, 0, 0]
    edge = piston_support_group_ents.add_edges pts
    
    

    if multiple_doors > 0
      multi_door_group = []
      if door_no_frame == 0
        multi_door_group[0] = group.parent.entities.add_group([group, piston_support_group, piston_group, group_support])
      else
        multi_door_group[0] = group.parent.entities.add_group([group, piston_support_group, piston_group])
      end
      trans = multi_door_group[0].transformation
      
      for step in 1..multiple_doors - 1
        multi_door_group[step] = multi_door_group[0].copy
        point = Geom::Point3d.new(trans.origin[0], door_middle_array[step] - door_middle + trans.origin[1], trans.origin[2])
        t = Geom::Transformation.new point
        multi_door_group[step].move! t
      end
      
      group = multi_door_group[0].parent.entities.add_group(multi_door_group)
    else
      if door_no_frame == 0
        group = group.parent.entities.add_group([group, piston_support_group, piston_group, group_support])
      else
        group = group.parent.entities.add_group([group, piston_support_group, piston_group])
      end
      group.description = door_type + ":" + door_height.to_s + ":" + door_folding_level.to_s + ":" + door_sections.to_s + ":" + door_width.to_s + ":" + door_middle.to_s + ":" + full_length.to_s + ":" + wall_thickness.to_s + ":" + door_frame_thickness.to_s + ":" + door_skin_thickness.to_s + ":" + outside_height.to_s + ":" + arc.to_s + ":" + door_frame_texture + ":" + door_texture + ":" + wall_texture + ":" + roof_texture + ":" + beam_texture + ":" + floor_texture + ":" + direction + ":" + hangar_type + ":" + left_offset.to_s + ":" + door_extensions
    end



    
    if direction == "X"
      door_radians = 270.degrees
      door_t = Geom::Transformation.rotation [0, 0, door_height], Z_AXIS, door_radians
      group.transform! door_t
    elsif direction == "-X"
      door_radians = 270.degrees
      door_t = Geom::Transformation.rotation [0, 0, door_height], Z_AXIS, door_radians
      group.transform! door_t
        point = Geom::Point3d.new(0, 0, 0)
      t = Geom::Transformation.scaling(point, 1, -1, 1)
      group.transform! t
    end

    return group
    
  elsif door_type == "Sliding doors"

    # draw sliding door frame
    door_support_frame_thickness = (door_frame_thickness + door_skin_thickness) * door_sections
    door_support_frame_start = full_length + wall_thickness #+ door_skin_thickness
    door_section_width = (door_width / 2) / door_sections
    left_rail_start = door_middle - door_width / 2 - door_section_width - (100 / $inch)
    right_rail_start = door_middle + door_width / 2 + door_section_width + (100 / $inch)
    
    pts = []
    pts[0] = [full_length + wall_thickness, door_middle - (door_width/2), door_height + door_frame_thickness]
    pts[1] = [door_support_frame_start, door_middle - (door_width/2), door_height + door_frame_thickness]
    pts[2] = [door_support_frame_start, door_middle - (door_width/2), door_height + door_frame_thickness * 3]
    pts[3] = [full_length + wall_thickness, door_middle - (door_width/2), door_height + door_frame_thickness * 3]
  #  face = group_ents.add_face pts
  #  status = face.material = door_frame_texture

    pts[4] = [door_support_frame_start, left_rail_start - door_support_frame_thickness, door_height+ door_frame_thickness * 3]
    pts[5] = [door_support_frame_start, left_rail_start - door_support_frame_thickness, 0]
    pts[6] = [door_support_frame_start, left_rail_start, 0]
    pts[7] = [door_support_frame_start, left_rail_start, door_height + door_frame_thickness]
    face = group_ents.add_face pts[4], pts[5], pts[6], pts[7], pts[1], pts[2]
    status = face.reverse!
    status = face.material = door_frame_texture
      
    pts[8] = [door_support_frame_start + door_support_frame_thickness, left_rail_start - door_support_frame_thickness, door_height+ door_frame_thickness * 3]
    pts[9] = [door_support_frame_start + door_support_frame_thickness, left_rail_start - door_support_frame_thickness, 0]
    pts[10] = [door_support_frame_start + door_support_frame_thickness, left_rail_start, 0]
    pts[11] = [door_support_frame_start + door_support_frame_thickness, left_rail_start, door_height + door_frame_thickness]
      
    face = group_ents.add_face pts[8], pts[9], pts[5], pts[4]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[10], pts[11], pts[7], pts[6]
    status = face.material = door_frame_texture
      
    pts[12] = [full_length + wall_thickness, door_middle -(door_width/2) +(5 / $inch), door_height + door_frame_thickness]
    pts[13] = [door_support_frame_start, door_middle -(door_width/2) +(5 / $inch), door_height + door_frame_thickness]
    pts[14] = [door_support_frame_start, door_middle -(door_width/2) +(5 / $inch), door_height+ door_frame_thickness * 3]
    pts[15] = [full_length + wall_thickness, door_middle -(door_width/2) +(5 / $inch), door_height+ door_frame_thickness * 3]
      
  #  face = group_ents.add_face pts[12], pts[13], pts[14], pts[15]
  #  status = face.reverse!
  #  status = face.material = door_frame_texture
      
    ptsx = []
    ptsx[0] = [full_length + wall_thickness, door_middle +(door_width/2), door_height + door_frame_thickness]
    ptsx[1] = [door_support_frame_start, door_middle +(door_width/2), door_height + door_frame_thickness]
    ptsx[2] = [door_support_frame_start, door_middle +(door_width/2), door_height+ door_frame_thickness * 3]
    ptsx[3] = [full_length + wall_thickness, door_middle +(door_width/2), door_height+ door_frame_thickness * 3]
  #  face = group_ents.add_face ptsx
  #  status = face.reverse!
  #  status = face.material = door_frame_texture
      
    ptsx[4] = [door_support_frame_start, right_rail_start + door_support_frame_thickness, door_height + door_frame_thickness * 3]
    ptsx[5] = [door_support_frame_start, right_rail_start + door_support_frame_thickness, 0]
    ptsx[6] = [door_support_frame_start, right_rail_start, 0]
    ptsx[7] = [door_support_frame_start, right_rail_start, door_height + door_frame_thickness]
    face = group_ents.add_face ptsx[4], ptsx[5], ptsx[6], ptsx[7], ptsx[1], ptsx[2]
    status = face.material = door_frame_texture
      
    ptsx[8] = [door_support_frame_start + door_support_frame_thickness, right_rail_start + door_support_frame_thickness, door_height + door_frame_thickness * 3]
    ptsx[9] = [door_support_frame_start + door_support_frame_thickness, right_rail_start + door_support_frame_thickness, 0]
    ptsx[10] = [door_support_frame_start + door_support_frame_thickness, right_rail_start, 0]
    ptsx[11] = [door_support_frame_start + door_support_frame_thickness, right_rail_start, door_height + door_frame_thickness]

    face = group_ents.add_face ptsx[8], ptsx[9], ptsx[5], ptsx[4]
    status = face.material = door_frame_texture
    face = group_ents.add_face ptsx[10], ptsx[11], ptsx[7], ptsx[6]
    status = face.material = door_frame_texture
  
    ptsx[12] = [full_length + wall_thickness, door_middle + (door_width/2) - (5 / $inch), door_height + door_frame_thickness]
    ptsx[13] = [door_support_frame_start, door_middle + (door_width/2) - (5 / $inch), door_height + door_frame_thickness]
    ptsx[14] = [door_support_frame_start, door_middle + (door_width/2) - (5 / $inch), door_height + door_frame_thickness * 3]
    ptsx[15] = [full_length + wall_thickness, door_middle + (door_width/2) - (5 / $inch), door_height + door_frame_thickness * 3]
 #   face = group_ents.add_face ptsx[12], ptsx[13], ptsx[14], ptsx[15]
 #   status = face.material = door_frame_texture
 #   face = group_ents.add_face ptsx[13], ptsx[14], pts[14], pts[13]
 #   status = face.material = door_frame_texture
    
 #   face = group_ents.add_face ptsx[8], ptsx[4], ptsx[2], ptsx[3], ptsx[15], ptsx[14], pts[14], pts[15], pts[3], pts[2], pts[4], pts[8]
 #   status = face.material = door_frame_texture
 #   face = group_ents.add_face ptsx[11], ptsx[7], ptsx[1], ptsx[0], ptsx[12], ptsx[13], pts[13], pts[12], pts[0], pts[1], pts[7], pts[11]
 #   status = face.material = door_frame_texture
    face = group_ents.add_face ptsx[8], ptsx[4], pts[4], pts[8]
    status = face.material = door_frame_texture
    face = group_ents.add_face ptsx[11], ptsx[7], pts[7], pts[11]
    status = face.material = door_frame_texture
    face = group_ents.add_face ptsx[8], ptsx[9], ptsx[10], ptsx[11], pts[11], pts[10], pts[9], pts[8]
    status = face.material = door_frame_texture
    
    # Draw rails
    
    reverse_doors = 1
    
    for step in 0..door_sections - 1
    
      for side_step in 0..1
        if side_step == 0
          rail_start = left_rail_start
        else
          rail_start = right_rail_start
        end
        side_step_index = 1 - side_step * 2
  #      rail_section_start = door_support_frame_start + (door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 3
        rail_section_start = door_support_frame_start + (door_frame_thickness + door_skin_thickness) * (door_sections - 1 - step) + door_frame_thickness / 3
        rail_end = door_middle - door_section_width * step * side_step_index
        
        # Top rails
        pts = []
        pts[0] = [rail_section_start, rail_start, door_height + door_frame_thickness]
        pts[1] = [rail_section_start, rail_end, door_height + door_frame_thickness]
        pts[2] = [rail_section_start, rail_end, door_height]
        pts[3] = [rail_section_start, rail_start, door_height]
        pts[4] = [rail_section_start + door_frame_thickness / 3, rail_start, door_height + door_frame_thickness]
        pts[5] = [rail_section_start + door_frame_thickness / 3, rail_end, door_height + door_frame_thickness]
        pts[6] = [rail_section_start + door_frame_thickness / 3, rail_end, door_height]
        pts[7] = [rail_section_start + door_frame_thickness / 3, rail_start, door_height]
        
        face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
        if face.normal[0] > 0
          status = face.reverse!
        end
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
        status = face.material = door_frame_texture
        if step > 0
          face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
          status = face.material = door_frame_texture
        end 

        # Bottom rails
        pts = []
        pts[0] = [rail_section_start, rail_start, 0 - door_frame_thickness]
        pts[1] = [rail_section_start, rail_end, 0 - door_frame_thickness]
        pts[2] = [rail_section_start, rail_end, 0]
        pts[3] = [rail_section_start, rail_start, 0]
        pts[4] = [rail_section_start + door_frame_thickness / 3, rail_start, 0 - door_frame_thickness]
        pts[5] = [rail_section_start + door_frame_thickness / 3, rail_end, 0 - door_frame_thickness]
        pts[6] = [rail_section_start + door_frame_thickness / 3, rail_end, 0]
        pts[7] = [rail_section_start + door_frame_thickness / 3, rail_start, 0]
        
        face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
        if face.normal[0] < 0
          status = face.reverse!
        end
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[0], pts[3], pts[7], pts[4]
        status = face.material = door_frame_texture
        if step > 0
          face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
          status = face.material = door_frame_texture
        end 

        # Draw door frame
        
#        door_section_start = door_support_frame_start + (door_frame_thickness + door_skin_thickness * 2) * (door_sections - 1 - step)
        door_section_start = door_support_frame_start + (door_frame_thickness + door_skin_thickness) * (door_sections - 1 - step)
        door_start_position = door_middle - door_width / 2 * side_step_index + door_section_width * door_folding_level / 90 * (door_sections - step) * side_step_index
        pts = []
        pts[0] = [door_section_start, door_start_position, door_height]
        pts[1] = [door_section_start, door_start_position, door_height - door_frame_thickness]
        pts[2] = [door_section_start, door_start_position - door_section_width * side_step_index, door_height - door_frame_thickness]
        pts[3] = [door_section_start, door_start_position - door_section_width * side_step_index, door_height]
        pts[4] = [door_section_start + door_frame_thickness, door_start_position, door_height]
        pts[5] = [door_section_start + door_frame_thickness, door_start_position, door_height - door_frame_thickness]
        pts[6] = [door_section_start + door_frame_thickness, door_start_position - door_section_width * side_step_index, door_height - door_frame_thickness]
        pts[7] = [door_section_start + door_frame_thickness, door_start_position - door_section_width * side_step_index, door_height]
        
        face = group_ents.add_face pts[0], pts[3], pts[7], pts[4]
        if face.normal[2] < 0
          status = face.reverse!
        end
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
        status = face.material = door_frame_texture

        pts = []
        pts[0] = [door_section_start, door_start_position, 0]
        pts[1] = [door_section_start, door_start_position, door_frame_thickness]
        pts[2] = [door_section_start, door_start_position - door_section_width * side_step_index, door_frame_thickness]
        pts[3] = [door_section_start, door_start_position - door_section_width * side_step_index, 0]
        pts[4] = [door_section_start + door_frame_thickness, door_start_position, 0]
        pts[5] = [door_section_start + door_frame_thickness, door_start_position, door_frame_thickness]
        pts[6] = [door_section_start + door_frame_thickness, door_start_position - door_section_width * side_step_index, door_frame_thickness]
        pts[7] = [door_section_start + door_frame_thickness, door_start_position - door_section_width * side_step_index, 0]
        
        face = group_ents.add_face pts[0], pts[3], pts[7], pts[4]
        if face.normal[2] > 0
          status = face.reverse!
        end
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
        status = face.material = door_frame_texture

        # Vertical beams
        vertical_door_frame =(door_section_width /(80 / $inch)).to_i
        door_frame_distance =(door_section_width - door_frame_thickness) / vertical_door_frame
        
        for beam_step in 0..vertical_door_frame
          pts = []
          pts[0] = [door_section_start, door_start_position - beam_step * door_frame_distance * side_step_index, door_frame_thickness]
          pts[1] = [door_section_start, door_start_position - beam_step * door_frame_distance * side_step_index, door_height - door_frame_thickness]
          pts[2] = [door_section_start, door_start_position - (beam_step * door_frame_distance + door_frame_thickness) * side_step_index, door_height - door_frame_thickness]
          pts[3] = [door_section_start, door_start_position - (beam_step * door_frame_distance + door_frame_thickness) * side_step_index, door_frame_thickness]
          face = group_ents.add_face pts
          status = face.material = door_frame_texture
          pts[4] = [door_section_start + door_frame_thickness, door_start_position - (beam_step * door_frame_distance + door_frame_thickness) * side_step_index, door_frame_thickness]
          pts[5] = [door_section_start + door_frame_thickness, door_start_position - (beam_step * door_frame_distance + door_frame_thickness) * side_step_index, door_height - door_frame_thickness]
          pts[6] = [door_section_start + door_frame_thickness, door_start_position - beam_step * door_frame_distance * side_step_index, door_height - door_frame_thickness]
          pts[7] = [door_section_start + door_frame_thickness, door_start_position - beam_step * door_frame_distance * side_step_index, door_frame_thickness]
          face = group_ents.add_face pts[0], pts[1], pts[6], pts[7]
          status = face.material = door_frame_texture
          face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
          status = face.material = door_frame_texture
        end
        
        #Door skin
        pts = []
        pts[0] = [door_section_start + door_frame_thickness, door_start_position, door_height]
        pts[1] = [door_section_start + door_frame_thickness, door_start_position, 0]
        pts[2] = [door_section_start + door_frame_thickness, door_start_position - door_section_width * side_step_index, 0]
        pts[3] = [door_section_start + door_frame_thickness, door_start_position - door_section_width * side_step_index, door_height]
        pts[4] = [door_section_start + door_frame_thickness + door_skin_thickness, door_start_position, door_height]
        pts[5] = [door_section_start + door_frame_thickness + door_skin_thickness, door_start_position, 0]
        pts[6] = [door_section_start + door_frame_thickness + door_skin_thickness, door_start_position - door_section_width * side_step_index, 0]
        pts[7] = [door_section_start + door_frame_thickness + door_skin_thickness, door_start_position - door_section_width * side_step_index, door_height]

        face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
        if face.normal[0] > 0
          status = face.reverse!
        end
        status = face.material = door_texture
        face = group_ents.add_face pts[0], pts[3], pts[7], pts[4]
        status = face.material = door_texture
        face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
        status = face.material = door_texture
        face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
        status = face.material = door_texture
        face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
        status = face.material = door_texture
      end
      
      
    end

    if direction == "Y"
      pts = []
      pts[0] = [0, 0, 0]
      pts[1] = [full_length, 0, 0]
      edge = group_ents.add_edges pts
    end

    return group

  elsif door_type == "Encased sliding doors"
      door_thickness = door_skin_thickness
      door_section_width = door_width.to_f / door_folding_level.to_i
      door_sections = door_folding_level.to_i
      full_width = door_middle.to_f * 2
      
      pts = []
      pts[0] = [full_length, 0, outside_height]
      pts[1] = [full_length, 0, 0]
      pts[2] = [full_length, 0 - wall_thickness - door_section_width, 0]
      pts[3] = [full_length, 0 - wall_thickness - door_section_width, outside_height]
      face = group_ents.add_face pts
      status = face.material = wall_texture
      pts[4] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), 0 - wall_thickness - door_section_width, outside_height]
      pts[5] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), 0 - wall_thickness - door_section_width, 0]
      face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = wall_texture

      pts[6] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), door_middle -(door_width / 2), 0]
      pts[7] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), door_middle -(door_width / 2), door_height]
      pts[8] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), door_middle +(door_width / 2), door_height]
      pts[9] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), door_middle +(door_width / 2), 0]
      pts[10] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), full_width + wall_thickness + door_section_width, 0]
      pts[11] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), full_width + wall_thickness + door_section_width, outside_height]
      pts[12] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), full_width, outside_height]
      pts[13] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), door_middle, outside_height + arc]
      pts[14] = [full_length +(wall_thickness * 2) +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), 0, outside_height]
      face = group_ents.add_face pts[4], pts[5], pts[6], pts[7], pts[8], pts[9], pts[10], pts[11], pts[12], pts[13], pts[14]
      status = face.material = wall_texture

      pts[15] = [full_length, full_width + wall_thickness + door_section_width, outside_height]
      pts[16] = [full_length, full_width + wall_thickness + door_section_width, 0]
      face = group_ents.add_face pts[10], pts[11], pts[15], pts[16]
      status = face.material = wall_texture

      pts[17] = [full_length, full_width, 0]
      pts[18] = [full_length, full_width, outside_height]
      face = group_ents.add_face pts[15], pts[16], pts[17], pts[18]
      status = face.material = wall_texture

        pts[19] = [full_length + wall_thickness +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), door_middle -(door_width / 2), door_height]
        pts[20] = [full_length + wall_thickness +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), door_middle -(door_width / 2), 0]
        face = group_ents.add_face pts[6], pts[7], pts[19], pts[20]
        status = face.material = wall_texture

        pts[21] = [full_length + wall_thickness +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), 0 - door_section_width, 0]
        pts[22] = [full_length + wall_thickness +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), 0 - door_section_width, door_height]
        face = group_ents.add_face pts[19], pts[20], pts[21], pts[22]
        status = face.material = wall_texture
      
        pts[23] = [full_length + wall_thickness, 0 - door_section_width, door_height]
        pts[24] = [full_length + wall_thickness, 0 - door_section_width, 0]
        face = group_ents.add_face pts[21], pts[22], pts[23], pts[24]
        status = face.material = wall_texture
      
        pts[25] = [full_length + wall_thickness, 0, 0]
        pts[26] = [full_length + wall_thickness, 0, door_height]
        face = group_ents.add_face pts[23], pts[24], pts[25], pts[26]
        status = face.material = wall_texture
      
        pts[27] = [full_length + wall_thickness +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), door_middle +(door_width / 2), 0]
        pts[28] = [full_length + wall_thickness +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), door_middle +(door_width / 2), door_height]
        face = group_ents.add_face pts[8], pts[9], pts[27], pts[28]
        status = face.material = wall_texture
      
        pts[29] = [full_length + wall_thickness +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), full_width + door_section_width, door_height]
        pts[30] = [full_length + wall_thickness +(door_thickness * door_sections) +((1 / $inch) *(door_sections + 1)), full_width + door_section_width, 0]
        face = group_ents.add_face pts[27], pts[28], pts[29], pts[30]
        status = face.material = wall_texture

        pts[31] = [full_length + wall_thickness, full_width + door_section_width, 0]
        pts[32] = [full_length + wall_thickness, full_width + door_section_width, door_height]
        face = group_ents.add_face pts[29], pts[30], pts[31], pts[32]
        status = face.material = wall_texture

        pts[33] = [full_length + wall_thickness, full_width, door_height]
        pts[34] = [full_length + wall_thickness, full_width, 0]
        pts[35] = [full_length + wall_thickness, door_middle, outside_height + arc]
        pts[36] = [full_length + wall_thickness, 0, outside_height]
        pts[37] = [full_length + wall_thickness, full_width, outside_height]
        pts[38] = [full_length + wall_thickness, door_middle -(door_width / 2), door_height]
        pts[39] = [full_length + wall_thickness, door_middle -(door_width / 2), 0]
        pts[40] = [full_length + wall_thickness, door_middle +(door_width / 2), 0]
        pts[41] = [full_length + wall_thickness, door_middle +(door_width / 2), door_height]
        face = group_ents.add_face pts[31], pts[32], pts[33], pts[34]
        status = face.material = wall_texture

        face = group_ents.add_face pts[23], pts[22], pts[19], pts[7], pts[8], pts[28], pts[29], pts[32]
        status = face.material = wall_texture
        face = group_ents.add_face pts[0], pts[1], pts[25], pts[36]
        status = face.material = wall_texture
        face = group_ents.add_face pts[25], pts[36], pts[35], pts[37], pts[34], pts[40], pts[41], pts[38], pts[39]
        status = face.material = wall_texture
        face = group_ents.add_face pts[34], pts[37], pts[18], pts[17]
        status = face.material = wall_texture


        face = group_ents.add_face pts[0], pts[3], pts[4], pts[14]
        status = face.material = roof_texture
        face = group_ents.add_face pts[15], pts[18], pts[12], pts[11]
        status = face.material = roof_texture


        face = group_ents.add_face pts[36], pts[14], pts[13], pts[35]
        status = face.material = roof_texture
        face = group_ents.add_face pts[37], pts[12], pts[13], pts[35]
        status = face.material = roof_texture

        for step in 0..door_sections - 1
        
          pts = []
          pts[0] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))), door_middle -(door_width / 2) - door_thickness, 0]
          pts[1] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))), door_middle -(door_width / 2) - door_thickness, door_height]
          pts[2] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))) + door_thickness, door_middle -(door_width / 2) - door_thickness, door_height]
          pts[3] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))) + door_thickness, door_middle -(door_width / 2) - door_thickness, 0]
          face = group_ents.add_face pts
          status = face.material = door_texture
        
          
          pts[4] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))) + door_thickness, door_middle -(door_width / 2) - door_thickness - door_section_width, 0]
          pts[5] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))) + door_thickness, door_middle -(door_width / 2) - door_thickness - door_section_width, door_height]
          face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
          status = face.material = door_texture
        
          pts[6] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))), door_middle -(door_width / 2) - door_thickness - door_section_width, door_height]
          pts[7] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))), door_middle -(door_width / 2) - door_thickness - door_section_width, 0]
          face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
          status = face.material = door_texture
          face = group_ents.add_face pts[6], pts[7], pts[0], pts[1]
          status = face.material = door_texture
        
          pts = []
          pts[0] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))), door_middle +(door_width / 2) + door_thickness, 0]
          pts[1] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))), door_middle +(door_width / 2) + door_thickness, door_height]
          pts[2] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))) + door_thickness, door_middle +(door_width / 2) + door_thickness, door_height]
          pts[3] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))) + door_thickness, door_middle +(door_width / 2) + door_thickness, 0]
          face = group_ents.add_face pts
          status = face.reverse!
          status = face.material = door_texture
        
          pts[4] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))) + door_thickness, door_middle +(door_width / 2) + door_thickness + door_section_width, 0]
          pts[5] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))) + door_thickness, door_middle +(door_width / 2) + door_thickness + door_section_width, door_height]
          face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
          status = face.material = door_texture
        
          
          pts[6] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))), door_middle +(door_width / 2) + door_thickness + door_section_width, door_height]
          pts[7] = [full_length + wall_thickness +(1 / $inch) +(step *(door_thickness +(1 /$inch))), door_middle +(door_width / 2) + door_thickness + door_section_width, 0]
          face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
          status = face.material = door_texture
          face = group_ents.add_face pts[6], pts[7], pts[0], pts[1]
          status = face.material = door_texture
        
        end

    left_offset = 0 - wall_thickness - door_section_width
    group.description = door_type + ":" + door_height.to_s + ":" + door_folding_level.to_s + ":" + door_sections.to_s + ":" + door_width.to_s + ":" + door_middle.to_s + ":" + full_length.to_s + ":" + wall_thickness.to_s + ":" + door_frame_thickness.to_s + ":" + door_skin_thickness.to_s + ":" + outside_height.to_s + ":" + arc.to_s + ":" + door_frame_texture + ":" + door_texture + ":" + wall_texture + ":" + roof_texture + ":" + beam_texture + ":" + floor_texture + ":" + direction + ":" + hangar_type + ":" + left_offset.to_s + ":" + door_extensions
    if direction == "Y"
      pts = []
      pts[0] = [0, 0, 0]
      pts[1] = [full_length, 0, 0]
      edge = group_ents.add_edges pts
    end
    return group
  
  elsif door_type == "Detailed bi-folding doors" or door_type == "Bi-folding doors"
    group_support = Sketchup.active_model.entities.add_group
    group_support_ents = group_support.entities

    
    vertical_door_frame = (door_width / (170 / $inch)).to_i
    if hangar_type == "T-Hangar Row"
      door_width = door_width - vertical_door_frame
      door_frame_position = full_length + wall_thickness # + door_frame_thickness
    else
      door_frame_position = full_length + wall_thickness - door_frame_thickness
    end
    door_frame_distance = (door_width - door_frame_thickness) / vertical_door_frame
    door_skirt_distance = (door_width - door_frame_thickness) /(vertical_door_frame * 2)
    door_skirt_length = 15 / $inch
    if door_height / 2 > 180 / $inch
      draw_door = 1
    else
      draw_door = 0
    end
    
    beam_width = door_frame_thickness * 2
    beam_thickness = door_frame_thickness
    beam_top = door_height - beam_thickness * 3
    door_beam_position = full_length

    # Draw vertical beam support
    for step in 0..1
      step_index = 1 - step * 2
      if step == 0
        door_beam_side_position = door_middle - door_width / 2
      else
        door_beam_side_position = door_middle + door_width / 2
      end
      pts = []
      pts[0] = [door_beam_position, door_beam_side_position, 0]
      pts[1] = [door_beam_position - beam_thickness, door_beam_side_position, 0]
      pts[2] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * step_index, 0]
      pts[3] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * step_index, 0]
      pts[4] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position, 0]
      pts[5] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position, 0]
      pts[6] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position - beam_thickness * 3 * step_index, 0]
      pts[7] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 3 * step_index, 0]
      pts[8] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 2 * step_index, 0]
      pts[9] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 2 * step_index, 0]
      pts[10] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 3 * step_index, 0]
      pts[11] = [door_beam_position, door_beam_side_position - beam_thickness * 3 * step_index, 0]
      pts[12] = [door_beam_position, door_beam_side_position, beam_top]
      pts[13] = [door_beam_position - beam_thickness, door_beam_side_position, beam_top]
      pts[14] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * step_index, beam_top]
      pts[15] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * step_index, beam_top]
      pts[16] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position, beam_top]
      pts[17] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position, beam_top]
      pts[18] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position - beam_thickness * 3 * step_index, beam_top]
      pts[19] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 3 * step_index, beam_top]
      pts[20] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 2 * step_index, beam_top]
      pts[21] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 2 * step_index, beam_top]
      pts[22] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 3 * step_index, beam_top]
      pts[23] = [door_beam_position, door_beam_side_position - beam_thickness * 3 * step_index, beam_top]
    
      for beam_step in 0..10
        face = group_support_ents.add_face pts[beam_step], pts[beam_step + 1], pts[beam_step + 13], pts[beam_step + 12]
        if beam_step == 0 and face.normal[1] != step_index
          status = face.reverse!
        end
        status = face.material = beam_texture
      end
      face = group_support_ents.add_face pts[11], pts[0], pts[12], pts[23]
      status = face.material = beam_texture
      face = group_support_ents.add_face pts[12], pts[13], pts[14], pts[15], pts[16], pts[17], pts[18], pts[19], pts[20], pts[21], pts[22], pts[23]
      status = face.material = beam_texture
    end

    door_beam_side_position = door_middle - door_width / 2
    door_beam_side_end_position = door_middle + door_width / 2
    pts = []
    pts[0] = [door_beam_position, door_beam_side_position - beam_thickness * 3, beam_top]
    pts[1] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 3, beam_top]
    pts[2] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 3, beam_top + beam_thickness]
    pts[3] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 3, beam_top + beam_thickness]
    pts[4] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 3, beam_top]
    pts[5] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position - beam_thickness * 3, beam_top]
    pts[6] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_position - beam_thickness * 3, beam_top + beam_thickness * 3]
    pts[7] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 3, beam_top + beam_thickness * 3]
    pts[8] = [door_beam_position - beam_thickness - beam_width, door_beam_side_position - beam_thickness * 3, beam_top + beam_thickness * 2]
    pts[9] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 3, beam_top + beam_thickness * 2]
    pts[10] = [door_beam_position - beam_thickness, door_beam_side_position - beam_thickness * 3, beam_top + beam_thickness * 3]
    pts[11] = [door_beam_position, door_beam_side_position - beam_thickness * 3, beam_top + beam_thickness * 3]
    pts[12] = [door_beam_position, door_beam_side_end_position + beam_thickness * 3, beam_top]
    pts[13] = [door_beam_position - beam_thickness, door_beam_side_end_position + beam_thickness * 3, beam_top]
    pts[14] = [door_beam_position - beam_thickness, door_beam_side_end_position + beam_thickness * 3, beam_top + beam_thickness]
    pts[15] = [door_beam_position - beam_thickness - beam_width, door_beam_side_end_position + beam_thickness * 3, beam_top + beam_thickness]
    pts[16] = [door_beam_position - beam_thickness - beam_width, door_beam_side_end_position + beam_thickness * 3, beam_top]
    pts[17] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_end_position + beam_thickness * 3, beam_top]
    pts[18] = [door_beam_position - beam_thickness * 2 - beam_width, door_beam_side_end_position + beam_thickness * 3, beam_top + beam_thickness * 3]
    pts[19] = [door_beam_position - beam_thickness - beam_width, door_beam_side_end_position + beam_thickness * 3, beam_top + beam_thickness * 3]
    pts[20] = [door_beam_position - beam_thickness - beam_width, door_beam_side_end_position + beam_thickness * 3, beam_top + beam_thickness * 2]
    pts[21] = [door_beam_position - beam_thickness, door_beam_side_end_position + beam_thickness * 3, beam_top + beam_thickness * 2]
    pts[22] = [door_beam_position - beam_thickness, door_beam_side_end_position + beam_thickness * 3, beam_top + beam_thickness * 3]
    pts[23] = [door_beam_position, door_beam_side_end_position + beam_thickness * 3, beam_top + beam_thickness * 3]
    for beam_step in 0..10
      face = group_support_ents.add_face pts[beam_step], pts[beam_step + 1], pts[beam_step + 13], pts[beam_step + 12]
      if beam_step == 0 or beam_step == 4
        status = face.reverse!
      end
      status = face.material = beam_texture
    end
    face = group_support_ents.add_face pts[11], pts[0], pts[12], pts[23]
    status = face.material = beam_texture
    face = group_support_ents.add_face pts[0], pts[1], pts[2], pts[3], pts[4], pts[5], pts[6], pts[7], pts[8], pts[9], pts[10], pts[11]
    status = face.material = beam_texture
    face = group_support_ents.add_face pts[12], pts[13], pts[14], pts[15], pts[16], pts[17], pts[18], pts[19], pts[20], pts[21], pts[22], pts[23]
    status = face.material = beam_texture
    
    # Draw hinges
    door_hinge_offset = 30 / $inch
    door_hinges =((door_width - door_hinge_offset * 2) /(100 / $inch)).to_i
    door_hinge_width = door_frame_thickness * 4
    door_hinge_thickness = door_frame_thickness / 2
    door_hinge_distance =(door_width - door_hinge_offset * 2 - door_hinge_width) /(door_hinges - 1)
    
    for step in 0..door_hinges - 1
      pts = []
      pts[0] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, beam_top]
      pts[1] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, beam_top + beam_thickness * 2]
      pts[2] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, beam_top + beam_thickness * 2]
      pts[3] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, beam_top]
      pts[4] = [door_beam_position + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, beam_top]
      pts[5] = [door_beam_position + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, beam_top + beam_thickness * 2]
      pts[6] = [door_beam_position + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, beam_top + beam_thickness * 2]
      pts[7] = [door_beam_position + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, beam_top]
      face = group_support_ents.add_face pts[0], pts[1], pts[5], pts[4]
      status = face.reverse!
      status = face.material = door_frame_texture
      face = group_support_ents.add_face pts[1], pts[2], pts[6], pts[5]
      status = face.material = door_frame_texture
      face = group_support_ents.add_face pts[2], pts[3], pts[7], pts[6]
      status = face.material = door_frame_texture
      face = group_support_ents.add_face pts[3], pts[0], pts[4], pts[7]
      status = face.material = door_frame_texture
      face = group_support_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_frame_texture
      
      for hinge_step in 0..1
            center_point = Geom::Point3d.new(door_beam_position + door_hinge_thickness / 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + hinge_step * beam_thickness * 3, beam_top - door_hinge_thickness / 2)
            normal_vector = Geom::Vector3d.new(0,1,0)
            zvector = Geom::Vector3d.new(1,0,0)
        start_angle = 0.degrees
        end_angle = 180.degrees
        radius = door_hinge_thickness / 2
        curve_detail = 30
            ptsx = group_support_ents.add_arc center_point, zvector, normal_vector, radius, start_angle, end_angle, curve_detail
        pts = []
        for curve_step in 0..29
          pts[curve_step] = ptsx[curve_step].end.position
        end
        pts[30] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + hinge_step * beam_thickness * 3, beam_top]
        pts[31] = [door_beam_position + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + hinge_step * beam_thickness * 3, beam_top]
        face = group_support_ents.add_face pts
        if hinge_step == 0
          status = face.reverse!
        end
        status = face.material = door_frame_texture
        status = face.pushpull door_frame_thickness
      end

      # Draw door hinge
      if step == 0
        group_top_frame = Sketchup.active_model.entities.add_group
        group_top_frame_ents = group_top_frame.entities
      end
          center_point = Geom::Point3d.new(door_beam_position + door_hinge_thickness / 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + hinge_step * beam_thickness * 3, beam_top - door_hinge_thickness / 2)
          normal_vector = Geom::Vector3d.new(0,1,0)
          zvector = Geom::Vector3d.new(-1,0,0)
      start_angle = 90.degrees
      end_angle = 270.degrees
      radius = door_hinge_thickness / 2
      curve_detail = 30
          ptsx = group_top_frame_ents.add_arc center_point, zvector, normal_vector, radius, start_angle, end_angle, curve_detail
      pts = []
      for curve_step in 0..29
        pts[curve_step] = ptsx[curve_step].end.position
      end
      pts[30] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + beam_thickness * 3, beam_top - door_hinge_thickness]
      pts[31] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + beam_thickness * 3, beam_top]
      face = group_top_frame_ents.add_face pts
      status = face.reverse!
      status = face.material = door_frame_texture
      status = face.pushpull door_frame_thickness * 2
      
      pts = []
      pts[0] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, beam_top]
      pts[1] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, beam_top - door_hinge_thickness]
      pts[2] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, beam_top - door_hinge_thickness]
      pts[3] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, beam_top]
      pts[4] = [door_beam_position - door_frame_thickness * 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, beam_top]
      pts[5] = [door_beam_position - door_frame_thickness * 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, beam_top - door_hinge_thickness]
      pts[6] = [door_beam_position - door_frame_thickness * 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, beam_top - door_hinge_thickness]
      pts[7] = [door_beam_position - door_frame_thickness * 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, beam_top]
      face = group_top_frame_ents.add_face pts[0], pts[1], pts[2], pts[3]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[2], pts[3], pts[7], pts[6]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[0], pts[1], pts[5], pts[4]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[3], pts[0], pts[4], pts[7]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_frame_texture
      


    end

    # Draw new door frame
    door_frame_top_position = beam_top - door_hinge_thickness
    door_frame_bottom_position = door_frame_top_position / 2 + door_hinge_thickness
    door_frame_top_back_position = door_beam_position - door_frame_thickness * 2
    door_frame_back_position = door_frame_top_back_position + door_frame_thickness
    door_frame_front_position = door_frame_top_back_position + door_frame_thickness * 2

    pts = []
    pts[0] = [door_frame_top_back_position, door_beam_side_position, door_frame_top_position]
    pts[1] = [door_frame_top_back_position, door_beam_side_end_position, door_frame_top_position]
    pts[2] = [door_frame_top_back_position, door_beam_side_end_position, door_frame_top_position - door_frame_thickness]
    pts[3] = [door_frame_top_back_position, door_beam_side_position, door_frame_top_position - door_frame_thickness]
    pts[4] = [door_frame_front_position, door_beam_side_position, door_frame_top_position]
    pts[5] = [door_frame_front_position, door_beam_side_end_position, door_frame_top_position]
    pts[6] = [door_frame_front_position, door_beam_side_end_position, door_frame_top_position - door_frame_thickness]
    pts[7] = [door_frame_front_position, door_beam_side_position, door_frame_top_position - door_frame_thickness]
    face = group_top_frame_ents.add_face pts[0], pts[1], pts[5], pts[4]
    status = face.reverse!
    status = face.material = door_frame_texture
    face = group_top_frame_ents.add_face pts[0], pts[1], pts[2], pts[3]
    status = face.material = door_frame_texture
    face = group_top_frame_ents.add_face pts[2], pts[3], pts[7], pts[6]
    status = face.material = door_frame_texture
    face = group_top_frame_ents.add_face pts[0], pts[3], pts[7], pts[4]
    status = face.material = door_frame_texture
    face = group_top_frame_ents.add_face pts[1], pts[2], pts[6], pts[5]
    status = face.material = door_frame_texture

    for vertical_step in 0..vertical_door_frame
      pts = []
      pts[0] = [door_frame_back_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_top_position - door_frame_thickness]
      pts[1] = [door_frame_back_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position + door_frame_thickness]
      pts[2] = [door_frame_back_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position + door_frame_thickness]
      pts[3] = [door_frame_back_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_top_position - door_frame_thickness]
      face = group_top_frame_ents.add_face pts
      stauts = face.reverse!
      status = face.material = door_frame_texture
      pts[4] = [door_frame_front_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_top_position - door_frame_thickness]
      pts[5] = [door_frame_front_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position + door_frame_thickness]
      pts[6] = [door_frame_front_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position + door_frame_thickness]
      pts[7] = [door_frame_front_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_top_position - door_frame_thickness]
      face = group_top_frame_ents.add_face pts[0], pts[1], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = door_frame_texture
    end

    pts = []
    pts[0] = [door_frame_top_back_position, door_beam_side_position, door_frame_bottom_position]
    pts[1] = [door_frame_top_back_position, door_beam_side_end_position, door_frame_bottom_position]
    pts[2] = [door_frame_top_back_position, door_beam_side_end_position, door_frame_bottom_position + door_frame_thickness]
    pts[3] = [door_frame_top_back_position, door_beam_side_position, door_frame_bottom_position + door_frame_thickness]
    pts[4] = [door_frame_front_position, door_beam_side_position, door_frame_bottom_position]
    pts[5] = [door_frame_front_position, door_beam_side_end_position, door_frame_bottom_position]
    pts[6] = [door_frame_front_position, door_beam_side_end_position, door_frame_bottom_position + door_frame_thickness]
    pts[7] = [door_frame_front_position, door_beam_side_position, door_frame_bottom_position + door_frame_thickness]
    face = group_top_frame_ents.add_face pts[0], pts[1], pts[5], pts[4]
    status = face.material = door_frame_texture
    face = group_top_frame_ents.add_face pts[0], pts[1], pts[2], pts[3]
    status = face.material = door_frame_texture
    face = group_top_frame_ents.add_face pts[2], pts[3], pts[7], pts[6]
    status = face.material = door_frame_texture
    face = group_top_frame_ents.add_face pts[0], pts[3], pts[7], pts[4]
    status = face.material = door_frame_texture
    face = group_top_frame_ents.add_face pts[1], pts[2], pts[6], pts[5]
    status = face.material = door_frame_texture
    face = group_top_frame_ents.add_face pts[4], pts[5], pts[6], pts[7]
    status = face.material = door_frame_texture

    pts = []
    pts[0] = [door_frame_front_position, door_middle -(door_width / 2) + door_frame_thickness, door_frame_bottom_position]
    pts[1] = [door_frame_front_position +(door_skirt_length / 2), door_middle -(door_width / 2) + door_frame_thickness, door_frame_bottom_position]
    pts[2] = [door_frame_front_position + door_skirt_length, door_middle -(door_width / 2) + door_frame_thickness +(door_skirt_length * 2), door_frame_bottom_position]
    pts[3] = [door_frame_front_position + door_skirt_length, door_middle +(door_width / 2) -(door_frame_thickness +(door_skirt_length * 2)), door_frame_bottom_position]
    pts[4] = [door_frame_front_position +(door_skirt_length / 2), door_middle +((door_width / 2) - door_frame_thickness), door_frame_bottom_position]
    pts[5] = [door_frame_front_position, door_middle +(door_width / 2) - door_frame_thickness, door_frame_bottom_position]
    edge = group_top_frame_ents.add_edges pts
        
    pts = []
    pts[0] = [door_frame_front_position, door_middle -(door_width / 2) + door_frame_thickness, door_frame_bottom_position]
    pts[1] = [door_frame_front_position, door_middle -(door_width / 2) + door_frame_thickness, door_frame_bottom_position + door_frame_thickness]
    pts[2] = [door_frame_front_position, door_middle -(door_width / 2), door_frame_bottom_position + door_frame_thickness]
    pts[3] = [door_frame_front_position, door_middle -(door_width / 2), door_frame_bottom_position]
    face = group_top_frame_ents.add_face pts
    status = face.material = door_frame_texture
    status = face.followme edge 
    
    for skirt_step in 1..(vertical_door_frame * 2) - 1
      pts = []
      pts[0] = [door_frame_front_position,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position]
      pts[1] = [door_frame_front_position,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position + door_frame_thickness]
      pts[2] = [door_frame_front_position,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position + door_frame_thickness]
      pts[3] = [door_frame_front_position,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position]
      pts[4] = [door_frame_front_position + door_skirt_length,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position]
      pts[5] = [door_frame_front_position + door_skirt_length,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position + door_frame_thickness]
      pts[6] = [door_frame_front_position + door_skirt_length,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position + door_frame_thickness]
      pts[7] = [door_frame_front_position + door_skirt_length,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position]
      face = group_top_frame_ents.add_face pts[0], pts[3], pts[4], pts[7]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[0], pts[1], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[1], pts[2], pts[5], pts[6]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = door_frame_texture
    end

    for step in 0..door_hinges - 1
      pts = []
      pts[0] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, door_frame_bottom_position]
      pts[1] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, door_frame_bottom_position - door_hinge_thickness]
      pts[2] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, door_frame_bottom_position - door_hinge_thickness]
      pts[3] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, door_frame_bottom_position]
      pts[4] = [door_beam_position - door_frame_thickness * 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, door_frame_bottom_position]
      pts[5] = [door_beam_position - door_frame_thickness * 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, door_frame_bottom_position - door_hinge_thickness]
      pts[6] = [door_beam_position - door_frame_thickness * 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, door_frame_bottom_position - door_hinge_thickness]
      pts[7] = [door_beam_position - door_frame_thickness * 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, door_frame_bottom_position]
      face = group_top_frame_ents.add_face pts[0], pts[1], pts[2], pts[3]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[2], pts[3], pts[7], pts[6]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[0], pts[1], pts[5], pts[4]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[1], pts[2], pts[6], pts[5]
      status = face.material = door_frame_texture
      face = group_top_frame_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_frame_texture

          center_point = Geom::Point3d.new(door_beam_position - door_frame_thickness * 2 + door_hinge_thickness / 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + hinge_step * beam_thickness * 3, door_frame_bottom_position - door_hinge_thickness * 1.5)
          normal_vector = Geom::Vector3d.new(0,1,0)
          zvector = Geom::Vector3d.new(1,0,0)
      start_angle = 0.degrees
      end_angle = 180.degrees
      radius = door_hinge_thickness / 2
      curve_detail = 30
          ptsx = group_top_frame_ents.add_arc center_point, zvector, normal_vector, radius, start_angle, end_angle, curve_detail
      pts = []
      for curve_step in 0..29
        pts[curve_step] = ptsx[curve_step].end.position
      end
      pts[30] = [door_beam_position - door_frame_thickness * 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + beam_thickness * 3, door_frame_bottom_position - door_hinge_thickness]
      pts[31] = [door_beam_position - door_frame_thickness * 2 + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + beam_thickness * 3, door_frame_bottom_position - door_hinge_thickness]
      face = group_top_frame_ents.add_face pts
      status = face.reverse!
      status = face.material = door_frame_texture
      status = face.pushpull door_frame_thickness * 2
    end

    pts = []
    pts[0] = [door_frame_front_position, door_beam_side_position, door_frame_top_position]
    pts[1] = [door_frame_front_position, door_beam_side_position, door_frame_bottom_position + door_frame_thickness]
    pts[2] = [door_frame_front_position, door_beam_side_end_position, door_frame_bottom_position + door_frame_thickness]
    pts[3] = [door_frame_front_position, door_beam_side_end_position, door_frame_top_position]
    face = group_top_frame_ents.add_face pts
    status = face.reverse!
    status = face.material = door_texture

    pts[4] = [door_frame_front_position + door_skin_thickness, door_beam_side_end_position, door_frame_top_position]
    pts[5] = [door_frame_front_position + door_skin_thickness, door_beam_side_end_position, door_frame_bottom_position + door_frame_thickness]
    pts[6] = [door_frame_front_position + door_skin_thickness, door_beam_side_position, door_frame_bottom_position + door_frame_thickness]
    pts[7] = [door_frame_front_position + door_skin_thickness, door_beam_side_position, door_frame_top_position]

    face = group_top_frame_ents.add_face pts[2], pts[3], pts[4], pts[5]
    status = face.material = door_texture
    face = group_top_frame_ents.add_face pts[4], pts[5], pts[6], pts[7]
    status = face.material = door_texture
    face = group_top_frame_ents.add_face pts[6], pts[7], pts[0], pts[1]
    status = face.material = door_texture
    face = group_top_frame_ents.add_face pts[1], pts[2], pts[5], pts[6]
    status = face.reverse!
    status = face.material = door_texture
    face = group_top_frame_ents.add_face pts[0], pts[3], pts[4], pts[7]
    status = face.material = door_texture

    group_bottom_frame = Sketchup.active_model.entities.add_group
    group_bottom_frame_ents = group_bottom_frame.entities

    door_frame_top_position = door_frame_top_position / 2 - door_hinge_thickness
    door_frame_bottom_position = 0

    for step in 0..door_hinges - 1
      pts = []
      pts[0] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, door_frame_top_position]
      pts[1] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, door_frame_top_position + door_hinge_thickness]
      pts[2] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, door_frame_top_position + door_hinge_thickness]
      pts[3] = [door_beam_position, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, door_frame_top_position]
      pts[4] = [door_beam_position - door_frame_thickness * 2 + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, door_frame_top_position]
      pts[5] = [door_beam_position - door_frame_thickness * 2 + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step, door_frame_top_position + door_hinge_thickness]
      pts[6] = [door_beam_position - door_frame_thickness * 2 + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, door_frame_top_position + door_hinge_thickness]
      pts[7] = [door_beam_position - door_frame_thickness * 2 + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + door_hinge_width, door_frame_top_position]
      face = group_bottom_frame_ents.add_face pts[0], pts[1], pts[2], pts[3]
      status = face.reverse!
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[2], pts[3], pts[7], pts[6]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[0], pts[1], pts[5], pts[4]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[1], pts[2], pts[6], pts[5]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[0], pts[3], pts[7], pts[4]
      status = face.material = door_frame_texture

      for hinge_step in 0..1
            center_point = Geom::Point3d.new(door_beam_position - door_frame_thickness * 2 + door_hinge_thickness / 2, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + hinge_step * beam_thickness * 3 * hinge_step, door_frame_top_position + door_hinge_thickness / 2)
            normal_vector = Geom::Vector3d.new(0,1,0)
            zvector = Geom::Vector3d.new(1,0,0)
        start_angle = 90.degrees
        end_angle = 270.degrees
        radius = door_hinge_thickness / 2
        curve_detail = 30
            ptsx = group_bottom_frame_ents.add_arc center_point, zvector, normal_vector, radius, start_angle, end_angle, curve_detail
        pts = []
        for curve_step in 0..29
          pts[curve_step] = ptsx[curve_step].end.position
        end
        pts[31] = [door_beam_position - door_frame_thickness * 2 + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + beam_thickness * 3 * hinge_step, door_frame_top_position]
        pts[30] = [door_beam_position - door_frame_thickness * 2 + door_hinge_thickness, door_beam_side_position + door_hinge_offset + door_hinge_distance * step + beam_thickness * 3 * hinge_step, door_frame_top_position + door_hinge_thickness]
        face = group_bottom_frame_ents.add_face pts
        if hinge_step == 0
          status = face.reverse!
        end
        status = face.material = door_frame_texture
        status = face.pushpull door_frame_thickness
      end
    end


    pts = []
    pts[0] = [door_frame_back_position, door_beam_side_position, door_frame_top_position]
    pts[1] = [door_frame_back_position, door_beam_side_end_position, door_frame_top_position]
    pts[2] = [door_frame_back_position, door_beam_side_end_position, door_frame_top_position - door_frame_thickness]
    pts[3] = [door_frame_back_position, door_beam_side_position, door_frame_top_position - door_frame_thickness]
    pts[4] = [door_frame_front_position, door_beam_side_position, door_frame_top_position]
    pts[5] = [door_frame_front_position, door_beam_side_end_position, door_frame_top_position]
    pts[6] = [door_frame_front_position, door_beam_side_end_position, door_frame_top_position - door_frame_thickness]
    pts[7] = [door_frame_front_position, door_beam_side_position, door_frame_top_position - door_frame_thickness]
    face = group_bottom_frame_ents.add_face pts[0], pts[1], pts[5], pts[4]
    status = face.reverse!
    status = face.material = door_frame_texture
    face = group_bottom_frame_ents.add_face pts[0], pts[1], pts[2], pts[3]
    status = face.material = door_frame_texture
    face = group_bottom_frame_ents.add_face pts[2], pts[3], pts[7], pts[6]
    status = face.material = door_frame_texture
    face = group_bottom_frame_ents.add_face pts[0], pts[3], pts[7], pts[4]
    status = face.material = door_frame_texture
    face = group_bottom_frame_ents.add_face pts[1], pts[2], pts[6], pts[5]
    status = face.material = door_frame_texture

    for vertical_step in 0..vertical_door_frame
      pts = []
      pts[0] = [door_frame_back_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_top_position - door_frame_thickness]
      pts[1] = [door_frame_back_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position + door_frame_thickness]
      pts[2] = [door_frame_back_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position + door_frame_thickness]
      pts[3] = [door_frame_back_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_top_position - door_frame_thickness]
      face = group_bottom_frame_ents.add_face pts
      #status = face.reverse!
      status = face.material = door_frame_texture
      pts[4] = [door_frame_front_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_top_position - door_frame_thickness]
      pts[5] = [door_frame_front_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position + door_frame_thickness]
      pts[6] = [door_frame_front_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position + door_frame_thickness]
      pts[7] = [door_frame_front_position,(vertical_step * door_frame_distance) +(door_middle -(door_width / 2)), door_frame_top_position - door_frame_thickness]
      face = group_bottom_frame_ents.add_face pts[0], pts[1], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = door_frame_texture
    end

    pts = []
    pts[0] = [door_frame_top_back_position, door_beam_side_position, door_frame_bottom_position]
    pts[1] = [door_frame_top_back_position, door_beam_side_end_position, door_frame_bottom_position]
    pts[2] = [door_frame_top_back_position, door_beam_side_end_position, door_frame_bottom_position + door_frame_thickness]
    pts[3] = [door_frame_top_back_position, door_beam_side_position, door_frame_bottom_position + door_frame_thickness]
    pts[4] = [door_frame_front_position, door_beam_side_position, door_frame_bottom_position]
    pts[5] = [door_frame_front_position, door_beam_side_end_position, door_frame_bottom_position]
    pts[6] = [door_frame_front_position, door_beam_side_end_position, door_frame_bottom_position + door_frame_thickness]
    pts[7] = [door_frame_front_position, door_beam_side_position, door_frame_bottom_position + door_frame_thickness]
    face = group_bottom_frame_ents.add_face pts[0], pts[1], pts[5], pts[4]
    status = face.material = door_frame_texture
    face = group_bottom_frame_ents.add_face pts[0], pts[1], pts[2], pts[3]
    status = face.material = door_frame_texture
    face = group_bottom_frame_ents.add_face pts[2], pts[3], pts[7], pts[6]
    status = face.material = door_frame_texture
    face = group_bottom_frame_ents.add_face pts[0], pts[3], pts[7], pts[4]
    status = face.material = door_frame_texture
    face = group_bottom_frame_ents.add_face pts[1], pts[2], pts[6], pts[5]
    status = face.material = door_frame_texture
    face = group_bottom_frame_ents.add_face pts[4], pts[5], pts[6], pts[7]
    status = face.material = door_frame_texture

    pts = []
    pts[0] = [door_frame_top_back_position, door_middle -(door_width / 2) + door_frame_thickness, door_frame_bottom_position]
    pts[1] = [door_frame_top_back_position - (door_skirt_length / 2), door_middle -(door_width / 2) + door_frame_thickness, door_frame_bottom_position]
    pts[2] = [door_frame_top_back_position - door_skirt_length, door_middle -(door_width / 2) + door_frame_thickness +(door_skirt_length * 2), door_frame_bottom_position]
    pts[3] = [door_frame_top_back_position - door_skirt_length, door_middle +(door_width / 2) -(door_frame_thickness +(door_skirt_length * 2)), door_frame_bottom_position]
    pts[4] = [door_frame_top_back_position - (door_skirt_length / 2), door_middle +((door_width / 2) - door_frame_thickness), door_frame_bottom_position]
    pts[5] = [door_frame_top_back_position, door_middle +(door_width / 2) - door_frame_thickness, door_frame_bottom_position]
    edge = group_bottom_frame_ents.add_edges pts
        
    pts = []
    pts[0] = [door_frame_top_back_position, door_middle -(door_width / 2) + door_frame_thickness, door_frame_bottom_position]
    pts[1] = [door_frame_top_back_position, door_middle -(door_width / 2) + door_frame_thickness, door_frame_bottom_position + door_frame_thickness]
    pts[2] = [door_frame_top_back_position, door_middle -(door_width / 2), door_frame_bottom_position + door_frame_thickness]
    pts[3] = [door_frame_top_back_position, door_middle -(door_width / 2), door_frame_bottom_position]
    face = group_bottom_frame_ents.add_face pts
    status = face.material = door_frame_texture
    status = face.followme edge 
    
    for skirt_step in 1..(vertical_door_frame * 2) - 1
      pts = []
      pts[0] = [door_frame_top_back_position, (skirt_step * door_skirt_distance) + (door_middle -(door_width / 2)), door_frame_bottom_position]
      pts[1] = [door_frame_top_back_position, (skirt_step * door_skirt_distance) + (door_middle -(door_width / 2)), door_frame_bottom_position + door_frame_thickness]
      pts[2] = [door_frame_top_back_position, (skirt_step * door_skirt_distance) + (door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position + door_frame_thickness]
      pts[3] = [door_frame_top_back_position, (skirt_step * door_skirt_distance) + (door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position]
      pts[4] = [door_frame_top_back_position - door_skirt_length,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position]
      pts[5] = [door_frame_top_back_position - door_skirt_length,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2) + door_frame_thickness), door_frame_bottom_position + door_frame_thickness]
      pts[6] = [door_frame_top_back_position - door_skirt_length,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position + door_frame_thickness]
      pts[7] = [door_frame_top_back_position - door_skirt_length,(skirt_step * door_skirt_distance) +(door_middle -(door_width / 2)), door_frame_bottom_position]
      face = group_bottom_frame_ents.add_face pts[0], pts[3], pts[4], pts[7]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[0], pts[1], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[1], pts[2], pts[5], pts[6]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = door_frame_texture
    end

    pts = []
    pts[0] = [door_frame_front_position, door_beam_side_position, door_frame_top_position + door_hinge_thickness * 2]
    pts[1] = [door_frame_front_position, door_beam_side_position, door_frame_bottom_position]
    pts[2] = [door_frame_front_position, door_beam_side_end_position, door_frame_bottom_position]
    pts[3] = [door_frame_front_position, door_beam_side_end_position, door_frame_top_position + door_hinge_thickness * 2]
    face = group_bottom_frame_ents.add_face pts
    status = face.reverse!
    status = face.material = door_texture

    pts[4] = [door_frame_front_position + door_skin_thickness, door_beam_side_end_position, door_frame_top_position + door_hinge_thickness * 2]
    pts[5] = [door_frame_front_position + door_skin_thickness, door_beam_side_end_position, door_frame_bottom_position]
    pts[6] = [door_frame_front_position + door_skin_thickness, door_beam_side_position, door_frame_bottom_position]
    pts[7] = [door_frame_front_position + door_skin_thickness, door_beam_side_position, door_frame_top_position + door_hinge_thickness * 2]

    face = group_bottom_frame_ents.add_face pts[2], pts[3], pts[4], pts[5]
    status = face.material = door_texture
    face = group_bottom_frame_ents.add_face pts[4], pts[5], pts[6], pts[7]
    status = face.material = door_texture
    face = group_bottom_frame_ents.add_face pts[6], pts[7], pts[0], pts[1]
    status = face.material = door_texture
    face = group_bottom_frame_ents.add_face pts[1], pts[2], pts[5], pts[6]
    status = face.material = door_texture
    face = group_bottom_frame_ents.add_face pts[0], pts[3], pts[4], pts[7]
    status = face.material = door_texture


    if door_frame_top_position - door_frame_thickness * 3 - door_hinge_thickness > entrance_door_y_size + 5 / $inch and entrance_door_override == 0
    
      if entrance_door_x_position == 0
        door_x_position = door_beam_side_position + door_frame_distance + door_frame_thickness * 5
      else
        door_x_position = entrance_door_x_position
      end
      if entrance_door_y_position < door_frame_thickness + door_hinge_thickness
        door_y_position = door_frame_thickness + door_hinge_thickness
      else
        door_y_position = entrance_door_y_position
      end
      door_x_size = entrance_door_x_size
      door_y_size = entrance_door_y_size
      
      pts = []
      pts[0] = [door_frame_front_position + door_skin_thickness, door_x_position, door_y_position]
      pts[1] = [door_frame_front_position + door_skin_thickness, door_x_position + door_x_size, door_y_position]
      pts[2] = [door_frame_front_position + door_skin_thickness, door_x_position + door_x_size, door_y_position + door_y_size]
      pts[3] = [door_frame_front_position + door_skin_thickness, door_x_position, door_y_position + door_y_size]
      pts[4] = [door_frame_front_position, door_x_position, door_y_position]
      pts[5] = [door_frame_front_position, door_x_position + door_x_size, door_y_position]
      pts[6] = [door_frame_front_position, door_x_position + door_x_size, door_y_position + door_y_size]
      pts[7] = [door_frame_front_position, door_x_position, door_y_position + door_y_size]
      pts[8] = [door_frame_front_position, door_x_position, door_y_position - door_hinge_thickness]
      pts[9] = [door_frame_front_position, door_x_position + door_x_size, door_y_position - door_hinge_thickness]
      pts[10] = [door_frame_front_position - door_skirt_length - door_frame_thickness * 3, door_x_position, door_y_position - door_hinge_thickness]
      pts[11] = [door_frame_front_position - door_skirt_length - door_frame_thickness * 3, door_x_position + door_x_size, door_y_position - door_hinge_thickness]
      pts[12] = [door_frame_front_position - door_skirt_length - door_frame_thickness * 3, door_x_position, door_y_position]
      pts[13] = [door_frame_front_position - door_skirt_length - door_frame_thickness * 3, door_x_position + door_x_size, door_y_position]
      pts[14] = [door_frame_front_position, door_x_position, door_y_position - door_hinge_thickness]
      pts[15] = [door_frame_front_position - door_frame_thickness, door_x_position, door_y_position - door_hinge_thickness]
      pts[16] = [door_frame_front_position - door_frame_thickness, door_x_position - door_frame_thickness, door_y_position - door_hinge_thickness]
      pts[17] = [door_frame_front_position, door_x_position - door_frame_thickness, door_y_position - door_hinge_thickness]
      pts[18] = [door_frame_front_position, door_x_position, door_frame_top_position - door_frame_thickness]
      pts[19] = [door_frame_front_position - door_frame_thickness, door_x_position, door_frame_top_position - door_frame_thickness]
      pts[20] = [door_frame_front_position - door_frame_thickness, door_x_position - door_frame_thickness, door_frame_top_position - door_frame_thickness]
      pts[21] = [door_frame_front_position, door_x_position - door_frame_thickness, door_frame_top_position - door_frame_thickness]
      pts[22] = [door_frame_front_position, door_x_position + door_x_size, door_y_position - door_hinge_thickness]
      pts[23] = [door_frame_front_position - door_frame_thickness, door_x_position + door_x_size, door_y_position - door_hinge_thickness]
      pts[24] = [door_frame_front_position - door_frame_thickness, door_x_position + door_x_size + door_frame_thickness, door_y_position - door_hinge_thickness]
      pts[25] = [door_frame_front_position, door_x_position + door_x_size + door_frame_thickness, door_y_position - door_hinge_thickness]
      pts[26] = [door_frame_front_position, door_x_position + door_x_size, door_frame_top_position - door_frame_thickness]
      pts[27] = [door_frame_front_position - door_frame_thickness, door_x_position + door_x_size, door_frame_top_position - door_frame_thickness]
      pts[28] = [door_frame_front_position - door_frame_thickness, door_x_position + door_x_size + door_frame_thickness, door_frame_top_position - door_frame_thickness]
      pts[29] = [door_frame_front_position, door_x_position + door_x_size + door_frame_thickness, door_frame_top_position - door_frame_thickness]
      pts[30] = [door_frame_front_position - door_frame_thickness, door_x_position + door_x_size, door_y_position + door_y_size]
      pts[31] = [door_frame_front_position - door_frame_thickness, door_x_position, door_y_position + door_y_size]
      pts[32] = [door_frame_front_position - door_frame_thickness, door_x_position + door_x_size, door_y_position + door_y_size + door_frame_thickness]
      pts[33] = [door_frame_front_position - door_frame_thickness, door_x_position, door_y_position + door_y_size + door_frame_thickness]
      pts[34] = [door_frame_front_position, door_x_position + door_x_size, door_y_position + door_y_size + door_frame_thickness]
      pts[35] = [door_frame_front_position, door_x_position, door_y_position + door_y_size + door_frame_thickness]

      #Cutout
      face = group_bottom_frame_ents.add_face pts[0], pts[1], pts[2], pts[3]
      status = face.erase!
      face = group_bottom_frame_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.erase!

      #Step plate
      face = group_bottom_frame_ents.add_face pts[4], pts[5], pts[13], pts[12]
      status = face.reverse!
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[10], pts[11], pts[13], pts[12]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[4], pts[5], pts[13], pts[12]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[8], pts[9], pts[11], pts[10]
      status = face.reverse!
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[8], pts[10], pts[12], pts[4]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[9], pts[11], pts[13], pts[5]
      status = face.material = door_frame_texture

      #Door frame
      face = group_bottom_frame_ents.add_face pts[14], pts[15], pts[19], pts[18]
      status = face.reverse!
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[15], pts[16], pts[20], pts[19]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[16], pts[17], pts[21], pts[20]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[22], pts[23], pts[27], pts[26]
      status = face.reverse!
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[23], pts[24], pts[28], pts[27]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[24], pts[25], pts[29], pts[28]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[6], pts[7], pts[31], pts[30]
      status = face.reverse!
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[30], pts[31], pts[33], pts[32]
      status = face.material = door_frame_texture
      face = group_bottom_frame_ents.add_face pts[32], pts[33], pts[35], pts[34]
      status = face.material = door_frame_texture

      group_bottom_temp_frame = Sketchup.active_model.entities.add_group
      group_bottom_temp_frame_ents = group_bottom_temp_frame.entities
      face = group_bottom_temp_frame_ents.add_face pts[0], pts[1], pts[2], pts[3]
      status = face.material = door_frame_texture
      face = group_bottom_temp_frame_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.reverse!
      status = face.material = door_frame_texture
      group_bottom_frame = group_bottom_frame.parent.entities.add_group([group_bottom_frame, group_bottom_temp_frame])

    end


    if door_folding_level.to_i < 1
      door_folding_level = 1.0
    elsif door_folding_level.to_i > 90
      door_folding_level = 90.0
    end
    
    door_radians = (180 - door_folding_level.to_i * 2).degrees
    door_t = Geom::Transformation.rotation [door_beam_position - door_frame_thickness * 2 + door_hinge_thickness / 2, door_beam_side_position, door_frame_top_position + door_hinge_thickness / 2], Y_AXIS, door_radians
    group_bottom_frame.transform! door_t
    
    full_group = group_top_frame.parent.entities.add_group([group_top_frame, group_bottom_frame])

    door_radians = (-90 + door_folding_level.to_i).degrees
    door_t = Geom::Transformation.rotation [door_beam_position + door_hinge_thickness / 2, door_beam_side_position, beam_top - door_hinge_thickness / 2], Y_AXIS, door_radians
    full_group.transform! door_t

    group_frame = Sketchup.active_model.entities.add_group
    group_frame_ents = group_frame.entities
    pts = []
    pts[0] = [0, 0, 0]
    pts[1] = [full_length, 0, 0]
    edge = group_frame_ents.add_edges pts

    if multiple_doors > 0
      multi_door_group = []
      multi_door_group[0] = full_group.parent.entities.add_group([full_group, group_support, group_frame])
      trans = multi_door_group[0].transformation
      
      for step in 1..multiple_doors - 1
        multi_door_group[step] = multi_door_group[0].copy
        point = Geom::Point3d.new(trans.origin[0], door_middle_array[step] - door_middle + trans.origin[1], trans.origin[2])
        t = Geom::Transformation.new point
        multi_door_group[step].move! t
      end
      
      group = multi_door_group[0].parent.entities.add_group(multi_door_group)
    else
      group = full_group.parent.entities.add_group([full_group, group_support, group_frame])
      group.description = door_type + ":" + door_height.to_s + ":" + door_folding_level.to_s + ":" + door_sections.to_s + ":" + door_width.to_s + ":" + door_middle.to_s + ":" + full_length.to_s + ":" + wall_thickness.to_s + ":" + door_frame_thickness.to_s + ":" + door_skin_thickness.to_s + ":" + outside_height.to_s + ":" + arc.to_s + ":" + door_frame_texture + ":" + door_texture + ":" + wall_texture + ":" + roof_texture + ":" + beam_texture + ":" + floor_texture + ":" + direction + ":" + hangar_type + ":" + left_offset.to_s + ":" + door_extensions

    end

      if direction == "X"
        door_radians = 270.degrees
        door_t = Geom::Transformation.rotation [0, 0, door_height], Z_AXIS, door_radians
        group.transform! door_t
      elsif direction == "-X"
        door_radians = 270.degrees
        door_t = Geom::Transformation.rotation [0, 0, door_height], Z_AXIS, door_radians
        group.transform! door_t
          point = Geom::Point3d.new(0, 0, 0)
        t = Geom::Transformation.scaling(point, 1, -1, 1)
        group.transform! t
      end

    return group


  
  elsif door_type == "Sliding doors - row"
    actual_door_width = hangar_type.to_f
    
    pts = []
    pts[0] = [full_length + wall_thickness, door_middle - (door_frame_thickness/2), door_height +(door_frame_thickness * 2)]
    pts[1] = [full_length + wall_thickness, door_middle - (door_frame_thickness/2), door_height + door_frame_thickness]
    pts[2] = [full_length + wall_thickness + door_frame_thickness, door_middle -(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[3] = [full_length + wall_thickness + door_frame_thickness, door_middle -(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]
    face = group_ents.add_face pts
    status = face.material = door_frame_texture

    pts[4] = [full_length + wall_thickness + door_frame_thickness, door_middle -(door_width / 2) +(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]
    pts[5] = [full_length + wall_thickness + door_frame_thickness, door_middle -(door_width / 2) +(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[6] = [full_length + wall_thickness, door_middle - (door_width / 2) + (door_frame_thickness/2), door_height + door_frame_thickness]
    pts[7] = [full_length + wall_thickness, door_middle - (door_width / 2) + (door_frame_thickness/2), door_height +(door_frame_thickness * 2)]

    pts[8] = [full_length + wall_thickness, door_middle - (door_width / 2) - (door_frame_thickness/2), door_height + (door_frame_thickness * 2)]
    pts[9] = [full_length + wall_thickness, door_middle - (door_width / 2) - (door_frame_thickness/2), door_height + door_frame_thickness]
    pts[10] = [full_length + wall_thickness + door_frame_thickness, door_middle -(door_width / 2) -(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[11] = [full_length + wall_thickness + door_frame_thickness, door_middle -(door_width / 2) -(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]

    pts[12] = [full_length + wall_thickness + door_frame_thickness, door_middle - door_width, door_height +(door_frame_thickness * 2)]
    pts[13] = [full_length + wall_thickness + door_frame_thickness, door_middle - door_width + door_frame_thickness, door_height + door_frame_thickness]
    pts[14] = [full_length + wall_thickness + door_frame_thickness, door_middle - door_width + door_frame_thickness, 0]
    pts[15] = [full_length + wall_thickness + door_frame_thickness, door_middle - door_width, 0]
    pts[16] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle - door_width, 0]
    pts[17] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle - door_width + door_frame_thickness, 0]
    pts[18] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle - door_width + door_frame_thickness, door_height + door_frame_thickness]
    pts[19] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle - door_width, door_height +(door_frame_thickness * 2)]
    pts[20] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle -(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]
    pts[21] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle -(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[22] = [full_length + wall_thickness +(door_frame_thickness * 3), door_middle -(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[23] = [full_length + wall_thickness +(door_frame_thickness * 3), door_middle -(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]
    pts[24] = [full_length + wall_thickness +(door_frame_thickness * 3), door_middle + door_width, door_height +(door_frame_thickness * 2)]
    pts[25] = [full_length + wall_thickness +(door_frame_thickness * 3), door_middle + door_width - door_frame_thickness, door_height + door_frame_thickness]
    pts[26] = [full_length + wall_thickness +(door_frame_thickness * 3), door_middle + door_width - door_frame_thickness, 0]
    pts[27] = [full_length + wall_thickness +(door_frame_thickness * 3), door_middle + door_width, 0]
    pts[28] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle + door_width, 0]
    pts[29] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle + door_width - door_frame_thickness, 0]
    pts[30] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle + door_width - door_frame_thickness, door_height + door_frame_thickness]
    pts[31] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle + door_width, door_height +(door_frame_thickness * 2)]

    pts[32] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle +(door_width / 2) +(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]
    pts[33] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle +(door_width / 2) +(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[34] = [full_length + wall_thickness, door_middle +(door_width / 2) +(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[35] = [full_length + wall_thickness, door_middle +(door_width / 2) +(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]

    pts[36] = [full_length + wall_thickness, door_middle +(door_width / 2) -(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]
    pts[37] = [full_length + wall_thickness, door_middle +(door_width / 2) -(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[38] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle +(door_width / 2) -(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[39] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle +(door_width / 2) -(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]

    pts[40] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle +(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]
    pts[41] = [full_length + wall_thickness +(door_frame_thickness * 2), door_middle +(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[42] = [full_length + wall_thickness, door_middle +(door_frame_thickness/2), door_height + door_frame_thickness]
    pts[43] = [full_length + wall_thickness, door_middle +(door_frame_thickness/2), door_height +(door_frame_thickness * 2)]



    face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[8], pts[9], pts[10], pts[11]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[10], pts[11], pts[12], pts[15], pts[14], pts[13]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[13], pts[14], pts[17], pts[18]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[16], pts[17], pts[18], pts[21], pts[20], pts[19]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[15], pts[16], pts[19], pts[12]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[20], pts[21], pts[22], pts[23]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[22], pts[23], pts[24], pts[27], pts[26], pts[25]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[20], pts[21], pts[22], pts[23]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[25], pts[26], pts[29], pts[30]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[24], pts[27], pts[28], pts[31]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[28], pts[29], pts[30], pts[33], pts[32], pts[31]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[32], pts[33], pts[34], pts[35]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[36], pts[37], pts[38], pts[39]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[38], pts[39], pts[40], pts[41]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[40], pts[41], pts[42], pts[43]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[0], pts[3], pts[4], pts[7], pts[8], pts[11], pts[12], pts[19], pts[20], pts[23], pts[24], pts[31], pts[32], pts[35], pts[36], pts[39], pts[40], pts[43]
    status = face.material = door_frame_texture
    face = group_ents.add_face pts[1], pts[2], pts[5], pts[6], pts[9], pts[10], pts[13], pts[18], pts[21], pts[22], pts[25], pts[30], pts[33], pts[34], pts[37], pts[38], pts[41], pts[42]
    status = face.material = door_frame_texture

    
    #Draw doors
    for step in 0..1
      step_direction = 1 - (step * 2)
      
      pts = []
      pts[0] = [full_length + wall_thickness + (door_frame_thickness * (2 - step)) + (door_skin_thickness / 2), door_middle + (step_direction * (door_width - actual_door_width / 2)) - (step_direction * door_width * door_folding_level / 90), door_height + door_frame_thickness]
      pts[1] = [full_length + wall_thickness + (door_frame_thickness * (2 - step)) + (door_skin_thickness / 2), door_middle + (step_direction * (door_width - actual_door_width / 2)) - (step_direction * door_width * door_folding_level / 90), 0]
      pts[2] = [full_length + wall_thickness + (door_frame_thickness * (2 - step)) + (door_skin_thickness / 2), door_middle + (step_direction * door_width) - (step_direction * door_width * door_folding_level / 90), 0]
      pts[3] = [full_length + wall_thickness + (door_frame_thickness * (2 - step)) + (door_skin_thickness / 2), door_middle + (step_direction * door_width) - (step_direction * door_width * door_folding_level / 90), door_height + door_frame_thickness]
      face = group_ents.add_face pts
      if step == 1
        status = face.reverse!
      end
      status = face.material = door_texture

      pts[4] = [full_length + wall_thickness + (door_frame_thickness * (2 - step)) - (door_skin_thickness / 2), door_middle + (step_direction * door_width) - (step_direction * door_width * door_folding_level / 90), door_height + door_frame_thickness]
      pts[5] = [full_length + wall_thickness + (door_frame_thickness * (2 - step)) - (door_skin_thickness / 2), door_middle + (step_direction * door_width) - (step_direction * door_width * door_folding_level / 90), 0]
      pts[6] = [full_length + wall_thickness + (door_frame_thickness * (2 - step)) - (door_skin_thickness / 2), door_middle + (step_direction * (door_width - actual_door_width / 2)) - (step_direction * door_width * door_folding_level / 90), 0]
      pts[7] = [full_length + wall_thickness + (door_frame_thickness * (2 - step)) - (door_skin_thickness / 2), door_middle + (step_direction * (door_width - actual_door_width / 2)) - (step_direction * door_width * door_folding_level / 90), door_height + door_frame_thickness]
      face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
      status = face.material = door_texture
      face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_texture
      face = group_ents.add_face pts[0], pts[1], pts[6], pts[7]
      status = face.material = door_texture

    end

    pts = []
    pts[0] = [0, 0, 0]
    pts[1] = [full_length, 0, 0]
    edge = group_ents.add_edges pts


    if direction == "X"
      door_radians = 270.degrees
      door_t = Geom::Transformation.rotation [0, 0, door_height], Z_AXIS, door_radians
      group.transform! door_t
    elsif direction == "-X"
      door_radians = 270.degrees
      door_t = Geom::Transformation.rotation [0, 0, door_height], Z_AXIS, door_radians
      group.transform! door_t
        point = Geom::Point3d.new(0, 0, 0)
      t = Geom::Transformation.scaling(point, 1, -1, 1)
      group.transform! t
    end
    return group
    
  elsif door_type == "Encased sliding doors - single sided"
    internal_encasing_width =(door_frame_thickness + door_skin_thickness) * door_sections +(door_skin_thickness *(door_sections + 1))
    encasing_start = door_middle - door_width / 2 + door_width / (door_sections + 1)
    full_width = door_middle.to_f * 2
    
    
    # Draw outer wall
    
    pts = []
    pts[0] = [full_length + wall_thickness, 0, 0]
    pts[1] = [full_length + wall_thickness, 0, outside_height]
    pts[2] = [full_length + wall_thickness * 2 + internal_encasing_width, 0, outside_height]
    pts[3] = [full_length + wall_thickness * 2 + internal_encasing_width, 0, 0]
    face = group_ents.add_face pts
    status = face.reverse!
    status = face.material = wall_texture
    
    pts[4] = [full_length + wall_thickness * 2 + internal_encasing_width, encasing_start, 0]
    pts[5] = [full_length + wall_thickness * 2 + internal_encasing_width, encasing_start, door_height]
    pts[6] = [full_length + wall_thickness * 2 + internal_encasing_width, door_middle + door_width / 2, door_height]
    pts[7] = [full_length + wall_thickness * 2 + internal_encasing_width, door_middle + door_width / 2, 0]
    pts[8] = [full_length + wall_thickness * 2 + internal_encasing_width, full_width, 0]
    pts[9] = [full_length + wall_thickness * 2 + internal_encasing_width, full_width, outside_height]
    pts[10] = [full_length + wall_thickness * 2 + internal_encasing_width, door_middle, outside_height + arc]
    pts[11] = [full_length + wall_thickness, full_width, outside_height]
    pts[12] = [full_length + wall_thickness, full_width, 0]
    pts[13] = [full_length + wall_thickness, door_middle, outside_height + arc]

    pts[14] = [full_length + wall_thickness + internal_encasing_width, encasing_start, 0]
    pts[15] = [full_length + wall_thickness + internal_encasing_width, encasing_start, door_height]
    pts[16] = [full_length + wall_thickness + internal_encasing_width, door_middle + door_width / 2, door_height]
    pts[17] = [full_length + wall_thickness + internal_encasing_width, door_middle + door_width / 2, 0]
    pts[18] = [full_length + wall_thickness + internal_encasing_width, full_width - wall_thickness, door_height + door_frame_thickness]
    pts[19] = [full_length + wall_thickness + internal_encasing_width, full_width - wall_thickness, 0]
    pts[20] = [full_length + wall_thickness + internal_encasing_width, wall_thickness, 0]
    pts[21] = [full_length + wall_thickness + internal_encasing_width, wall_thickness, door_height + door_frame_thickness]
    pts[22] = [full_length + wall_thickness, wall_thickness, 0]
    pts[23] = [full_length + wall_thickness, wall_thickness, door_height + door_frame_thickness]
    pts[24] = [full_length + wall_thickness, full_width - wall_thickness, door_height + door_frame_thickness]
    pts[25] = [full_length + wall_thickness, full_width - wall_thickness, 0]
    
    face = group_ents.add_face pts[2], pts[3], pts[4], pts[5], pts[6], pts[7], pts[8], pts[9], pts[10]
    status = face.material = wall_texture
    face = group_ents.add_face pts[8], pts[9], pts[11], pts[12]
    status = face.material = wall_texture
    face = group_ents.add_face pts[9], pts[11], pts[13], pts[10]
    status = face.material = roof_texture
    face = group_ents.add_face pts[1], pts[2], pts[10], pts[13]
    status = face.material = roof_texture
    face = group_ents.add_face pts[4], pts[5], pts[15], pts[14]
    status = face.material = wall_texture
    face = group_ents.add_face pts[5], pts[6], pts[16], pts[15]
    status = face.material = wall_texture
    face = group_ents.add_face pts[6], pts[7], pts[17], pts[16]
    status = face.material = wall_texture
    face = group_ents.add_face pts[14], pts[15], pts[16], pts[17], pts[19], pts[18], pts[21], pts[20]
    status = face.material = wall_texture
    face = group_ents.add_face pts[22], pts[23], pts[21], pts[20]
    status = face.material = wall_texture
    face = group_ents.add_face pts[24], pts[25], pts[19], pts[18]
    status = face.material = wall_texture
    face = group_ents.add_face pts[23], pts[24], pts[18], pts[21]
    status = face.material = wall_texture

    
    pts = []
    pts[0] = [full_length, door_middle - door_width / 2, 0]
    pts[1] = [full_length, door_middle - door_width / 2, door_height]
    pts[2] = [full_length, encasing_start, door_height]
    pts[3] = [full_length, encasing_start, 0]
    face = group_ents.add_face pts
    status = face.material = wall_texture

    pts[4] = [full_length + wall_thickness, door_middle - door_width / 2, 0]
    pts[5] = [full_length + wall_thickness, door_middle - door_width / 2, door_height]
    pts[6] = [full_length + wall_thickness, encasing_start, door_height]
    pts[7] = [full_length + wall_thickness, encasing_start, 0]
    face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
    status = face.material = wall_texture
    face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
    status = face.material = wall_texture
    
    # Draw rails
    ptsx = []
    for step in 0..door_sections - 1
      rail_end = door_middle + door_width / 2 -((door_width -(door_width /(door_sections + 1))) / door_sections * step)
      
      pts = []
      pts[0] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 3, wall_thickness, door_height + door_frame_thickness]
      pts[1] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 3, wall_thickness, door_height]
      pts[2] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 3, rail_end, door_height]
      pts[3] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 3, rail_end, door_height + door_frame_thickness]
      face = group_ents.add_face pts
      status = face.reverse!
      status = face.material = door_frame_texture
    
      pts[4] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness * 2 / 3, wall_thickness, door_height + door_frame_thickness]
      pts[5] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness * 2 / 3, wall_thickness, door_height]
      pts[6] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness * 2 / 3, rail_end, door_height]
      pts[7] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness * 2 / 3, rail_end, door_height + door_frame_thickness]
      face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
      status = face.material = door_frame_texture

      pts = []
      pts[0] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 2, wall_thickness, 0 - door_frame_thickness]
      pts[1] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 2, wall_thickness, 0]
      pts[2] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 2, rail_end, 0]
      pts[3] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 2, rail_end, 0 - door_frame_thickness]
    
      pts[4] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness, wall_thickness, 0 - door_frame_thickness]
      pts[5] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness, wall_thickness, 0]
      pts[6] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness, rail_end, 0]
      pts[7] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness, rail_end, 0 - door_frame_thickness]
      face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
      status = face.erase!
      face = group_ents.add_face pts[0], pts[1], pts[2], pts[3]
      status = face.reverse!
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[0], pts[3], pts[7], pts[4]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
      status = face.material = door_frame_texture
      
      ptsx[step * 4] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 2, wall_thickness, 0]
      ptsx[step * 4 + 1] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 2, rail_end, 0]
      ptsx[step * 4 + 2] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness, rail_end, 0]
      ptsx[step * 4 + 3] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness, wall_thickness, 0]
      
    end


    # Draw floor
    ptsx[step * 4 + 4] = [full_length + wall_thickness + internal_encasing_width, wall_thickness, 0]
    ptsx[step * 4 + 5] = [full_length + wall_thickness + internal_encasing_width, full_width - wall_thickness, 0]
    ptsx[step * 4 + 6] = [full_length + wall_thickness, full_width - wall_thickness, 0]
    ptsx[step * 4 + 7] = [full_length + wall_thickness, wall_thickness, 0]

    face = group_ents.add_face ptsx
    status = face.material = floor_texture




    # Draw door frame and skin
    
    for step in 0..door_sections - 1
    
      door_start_point =(door_middle - door_width / 2) +((door_width / (door_sections + 1)) * (door_sections - step)) * (door_folding_level.to_f / 90)
      door_section_width = door_width / (door_sections + 1)
      vertical_frame_support_count =(door_section_width /(100 / $inch)).to_i
      vertical_frame_distance =(door_section_width - door_frame_thickness) / vertical_frame_support_count
      pts = []
      pts[0] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point, 0]
      pts[1] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point, door_height + door_frame_thickness / 2]
      pts[2] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, door_height + door_frame_thickness / 2]
      pts[3] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, 0]
      face = group_ents.add_face pts
      status = face.material = door_texture
      pts[4] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step + door_skin_thickness, door_start_point, 0]
      pts[5] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step + door_skin_thickness, door_start_point, door_height + door_frame_thickness / 2]
      pts[6] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step + door_skin_thickness, door_start_point + door_section_width, door_height + door_frame_thickness / 2]
      pts[7] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step + door_skin_thickness, door_start_point + door_section_width, 0]
      face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
      status = face.material = door_texture
      face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
      status = face.material = door_texture
      face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
      status = face.material = door_texture
      face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
      status = face.material = door_texture

      for door_frame_step in 0..vertical_frame_support_count
        pts = []
        pts[0] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + vertical_frame_distance * door_frame_step, door_frame_thickness]
        pts[1] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + vertical_frame_distance * door_frame_step, door_height - door_frame_thickness / 2]
        pts[2] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + vertical_frame_distance * door_frame_step + door_frame_thickness, door_height - door_frame_thickness / 2]
        pts[3] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + vertical_frame_distance * door_frame_step + door_frame_thickness, door_frame_thickness]
        face = group_ents.add_face pts
        status = face.material = door_frame_texture

        pts[4] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + vertical_frame_distance * door_frame_step, door_frame_thickness]
        pts[5] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + vertical_frame_distance * door_frame_step, door_height - door_frame_thickness / 2]
        pts[6] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + vertical_frame_distance * door_frame_step + door_frame_thickness, door_height - door_frame_thickness / 2]
        pts[7] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + vertical_frame_distance * door_frame_step + door_frame_thickness, door_frame_thickness]
        face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
        status = face.material = door_frame_texture
        face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
        status = face.material = door_frame_texture
      end
      pts = []
      pts[0] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point, 0]
      pts[1] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point,  door_frame_thickness]
      pts[2] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, door_frame_thickness]
      pts[3] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, 0]
      face = group_ents.add_face pts
      status = face.material = door_frame_texture
      pts[4] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point, 0]
      pts[5] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point, door_frame_thickness]
      pts[6] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, door_frame_thickness]
      pts[7] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, 0]
      face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[0], pts[3], pts[7], pts[4]
      status = face.reverse!
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
      status = face.material = door_frame_texture


      pts = []
      pts[0] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point, door_height - door_frame_thickness / 2]
      pts[1] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point, door_height + door_frame_thickness / 2]
      pts[2] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, door_height + door_frame_thickness / 2]
      pts[3] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, door_height - door_frame_thickness / 2]
      face = group_ents.add_face pts
      status = face.material = door_frame_texture
      pts[4] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 3, door_start_point, door_height + door_frame_thickness / 2]
      pts[5] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 3, door_start_point + door_section_width, door_height + door_frame_thickness / 2]
      pts[6] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 3, door_start_point + door_section_width, door_height]
      pts[7] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness / 3, door_start_point, door_height]
      pts[8] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness * 2 / 3, door_start_point, door_height]
      pts[9] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness * 2 / 3, door_start_point + door_section_width, door_height]
      pts[10] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness * 2 / 3, door_start_point + door_section_width, door_height + door_frame_thickness / 2]
      pts[11] = [full_length + wall_thickness + door_frame_thickness +(door_frame_thickness + door_skin_thickness * 2) * step + door_frame_thickness * 2 / 3, door_start_point, door_height + door_frame_thickness / 2]
      pts[12] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point, door_height - door_frame_thickness / 2]
      pts[13] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point, door_height + door_frame_thickness / 2]
      pts[14] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, door_height + door_frame_thickness / 2]
      pts[15] = [full_length + wall_thickness + door_frame_thickness * 2 +(door_frame_thickness + door_skin_thickness * 2) * step, door_start_point + door_section_width, door_height - door_frame_thickness / 2]
      face = group_ents.add_face pts[1], pts[2], pts[5], pts[4]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[3], pts[2], pts[5], pts[6], pts[9], pts[10], pts[14], pts[15]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[0], pts[1], pts[4], pts[7], pts[8], pts[11], pts[13], pts[12]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[0], pts[3], pts[15], pts[12]
      status = face.material = door_frame_texture
      face = group_ents.add_face pts[10], pts[11], pts[13], pts[14]
      status = face.material = door_frame_texture


    end
    
    return group 
  elsif door_type == "Roller shutter"
    roller_frame_thickness = 1 / $inch
    support_frame_location = full_length - door_frame_thickness * 2
    pts = []
    pts[0] = [support_frame_location, door_middle -(door_width / 2), 0]
    pts[1] = [support_frame_location, door_middle -(door_width / 2), door_height]
    pts[2] = [support_frame_location - roller_frame_thickness, door_middle -(door_width / 2), door_height]
    pts[3] = [support_frame_location - roller_frame_thickness, door_middle -(door_width / 2), 0]
  # face = group_ents.add_face pts
  # if face.normal[1] < 0
  #   status = face.reverse!
  # end
    pts[4] = [support_frame_location - roller_frame_thickness, door_middle -(door_width / 2) - door_frame_thickness + roller_frame_thickness, 0]
    pts[5] = [support_frame_location - roller_frame_thickness, door_middle -(door_width / 2) - door_frame_thickness + roller_frame_thickness, door_height]
    pts[6] = [support_frame_location - door_frame_thickness + roller_frame_thickness, door_middle -(door_width / 2) - door_frame_thickness + roller_frame_thickness, door_height]
    pts[7] = [support_frame_location - door_frame_thickness + roller_frame_thickness, door_middle -(door_width / 2) - door_frame_thickness + roller_frame_thickness, 0]
    pts[8] = [support_frame_location - door_frame_thickness + roller_frame_thickness, door_middle -(door_width / 2), 0]
    pts[9] = [support_frame_location - door_frame_thickness + roller_frame_thickness, door_middle -(door_width / 2), door_height]
    pts[10] = [support_frame_location - door_frame_thickness, door_middle -(door_width / 2), door_height]
    pts[11] = [support_frame_location - door_frame_thickness, door_middle -(door_width / 2), 0]
    pts[12] = [support_frame_location - door_frame_thickness, door_middle -(door_width / 2) - door_frame_thickness, 0]
    pts[13] = [support_frame_location - door_frame_thickness, door_middle -(door_width / 2) - door_frame_thickness, door_height]
    pts[14] = [support_frame_location, door_middle -(door_width / 2) - door_frame_thickness, door_height]
    pts[15] = [support_frame_location, door_middle -(door_width / 2) - door_frame_thickness, 0]
    
  # for step in 1..6
  #   face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 2], pts[step * 2 + 3]
  # end
  # face = group_ents.add_face pts[14], pts[15], pts[0], pts[1]
    
    
    if outside_height - door_height > 40 / $inch
    # support_frame_inner_radius = 30 / $inch
      support_frame_outer_radius = 35 / $inch
      support_frame_middle_radius = support_frame_outer_radius - door_frame_thickness / 2
        else
     #      support_frame_inner_radius = outside_height - door_height - 10 / $inch
      support_frame_outer_radius = outside_height - door_height - 5 / $inch
      support_frame_middle_radius = support_frame_outer_radius - door_frame_thickness / 2
    end
      
    support_frame_height = door_height + support_frame_outer_radius
    support_frame_start = support_frame_location - support_frame_outer_radius
    support_frame_end = support_frame_location - support_frame_outer_radius - door_height

    center_point = Geom::Point3d.new(support_frame_location - support_frame_outer_radius, door_middle -(door_width / 2), door_height)
    middle_center_point = Geom::Point3d.new(support_frame_location - support_frame_outer_radius, door_middle -(door_width / 2) - door_frame_thickness, door_height)
        normal_vector = Geom::Vector3d.new(0,1,0)
        zvector = Geom::Vector3d.new(1,0,0)
        start_angle = 270.degrees
        end_angle = 360.degrees
  # inner_arc = group_ents.add_arc center_point, zvector, normal_vector, support_frame_inner_radius, end_angle, start_angle, 30
        outer_arc = group_ents.add_arc center_point, zvector, normal_vector, support_frame_outer_radius, end_angle, start_angle, 30
        middle_arc = group_ents.add_arc middle_center_point, zvector, normal_vector, support_frame_middle_radius, end_angle, start_angle, 30
      
      arc_pts = []
      middle_pts = []
      arc_pts[0] = [support_frame_location, door_middle -(door_width / 2), 0]
      middle_pts[0] = [support_frame_location - door_frame_thickness / 2, door_middle -(door_width / 2) - door_frame_thickness, 0]
      for step in 0..outer_arc.length - 1
        arc_pts[step + 1] = [outer_arc[step].start.position[0], outer_arc[step].start.position[1], outer_arc[step].start.position[2]]
        middle_pts[step + 1] = [middle_arc[step].start.position[0], middle_arc[step].start.position[1], middle_arc[step].start.position[2]]
      end
      
      
      arc_pts[step + 1] = [outer_arc[step].end.position[0], outer_arc[step].end.position[1], outer_arc[step].end.position[2]]
      middle_pts[step + 1] = [middle_arc[step].end.position[0], middle_arc[step].end.position[1], middle_arc[step].end.position[2]]
    arc_pts[step + 2] = [support_frame_end, door_middle -(door_width / 2), support_frame_height]
    middle_pts[step + 2] = [support_frame_end, door_middle -(door_width / 2) - door_frame_thickness, support_frame_height - door_frame_thickness / 2]
      arc_edge = group_ents.add_edges arc_pts
      face = group_ents.add_face pts[0], pts[3], pts[4], pts[7], pts[8], pts[11], pts[12], pts[15]
      status = face.followme arc_edge
      middle_edge = group_ents.add_edges middle_pts
      
      # Door panels
      
      middle_arc_segment_length = Math.sqrt((middle_arc[step].start.position[0] - middle_arc[step].end.position[0]) *(middle_arc[step].start.position[0] - middle_arc[step].end.position[0]) +(middle_arc[step].start.position[2] - middle_arc[step].end.position[2]) *(middle_arc[step].start.position[2] - middle_arc[step].end.position[2]))
      middle_arc_total_length = middle_arc_segment_length * 30
      support_frame_total_length = door_height + middle_arc_total_length / 2
      support_frame_start_height = support_frame_total_length -(support_frame_total_length * door_folding_level.to_i / 90)
      support_frame_top_start = door_height + middle_arc_total_length
      door_panels =(door_height /(40 / $inch)).to_i
      door_panel_height = door_height / door_panels
      door_wheel_radius =(door_frame_thickness -(2 / $inch)) / 2
      
      centre_points = []
      for step in 0..door_panels - 1
        if step == 0
          if door_wheel_radius + support_frame_start_height <= door_height
            centre_point = [support_frame_location - door_frame_thickness / 2, door_middle -(door_width / 2) - door_frame_thickness + 1 / $inch, door_wheel_radius + support_frame_start_height]
          else
            for curve_step in 0..29
              if support_frame_start_height > door_height + middle_arc_segment_length * curve_step and support_frame_start_height <= door_height + middle_arc_segment_length *(curve_step + 1)
                curve_segment = curve_step
              end
            end
            remaining_length = support_frame_start_height - door_height - curve_segment * middle_arc_segment_length
            remaining_length_ratio = remaining_length / middle_arc_segment_length
            height_difference = middle_pts[curve_segment + 1][2] - middle_pts[curve_segment][2]
            length_difference = middle_pts[curve_segment][0] - middle_pts[curve_segment + 1][0]
            centre_point = [middle_pts[curve_segment][0] - length_difference * remaining_length_ratio, door_middle -(door_width / 2) - door_frame_thickness + 1 / $inch, middle_pts[curve_segment][2] + height_difference * remaining_length_ratio]
        end
          vector = Geom::Vector3d.new 0,1,0
        vector2 = vector.normalize!
        group_support = Sketchup.active_model.entities.add_group
        group_support_ents = group_support.entities
        edges = group_support_ents.add_circle centre_point, vector2, door_wheel_radius
      
          centre_point3 = [middle_pts[curve_segment][0] - length_difference * remaining_length_ratio, door_middle -(door_width / 2) - door_frame_thickness, middle_pts[curve_segment][2] + height_difference * remaining_length_ratio]
        test_edges = group_ents.add_circle centre_point3, vector2,(door_panel_height - door_wheel_radius * 2), 360
        
        for edge_step in 0..middle_pts.length - 2
          start_distance = Math.sqrt((((middle_pts[curve_segment][0] - length_difference * remaining_length_ratio) - middle_pts[edge_step][0]) *((middle_pts[curve_segment][0] - length_difference * remaining_length_ratio) - middle_pts[edge_step][0])) +(((middle_pts[curve_segment][2] - height_difference * remaining_length_ratio) - middle_pts[edge_step][2]) *((middle_pts[curve_segment][2] - height_difference * remaining_length_ratio) - middle_pts[edge_step][2])))
          end_distance = Math.sqrt((((middle_pts[curve_segment][0] - length_difference * remaining_length_ratio) - middle_pts[edge_step + 1][0]) *((middle_pts[curve_segment][0] - length_difference * remaining_length_ratio) - middle_pts[edge_step + 1][0])) +(((middle_pts[curve_segment][2] - height_difference * remaining_length_ratio) - middle_pts[edge_step + 1][2]) *((middle_pts[curve_segment][2] - height_difference * remaining_length_ratio) - middle_pts[edge_step + 1][2])))
          if start_distance < door_panel_height - door_wheel_radius * 2 and end_distance > door_panel_height - door_wheel_radius * 2
        #   UI.messagebox start_distance
        #   UI.messagebox end_distance
        #   UI.messagebox(door_panel_height - door_wheel_radius * 2).to_s
        #   UI.messagebox edge_step
            correct_segment = edge_step + 1
            x_pts = [middle_pts[edge_step][0], middle_pts[edge_step][1] - 10, middle_pts[edge_step][2]]
            y_pts = [middle_pts[edge_step + 1][0], middle_pts[edge_step + 1][1] - 10, middle_pts[edge_step + 1][2]]
            edge = group_ents.add_edges middle_pts[edge_step], x_pts
            edge = group_ents.add_edges middle_pts[edge_step + 1], y_pts
          end
          
        end
        
        for circle_step in 0..359
          line1 = [Geom::Point3d.new(test_edges[circle_step].start.position[0],test_edges[circle_step].start.position[1],test_edges[circle_step].start.position[2]), Geom::Point3d.new(test_edges[circle_step].end.position[0],test_edges[circle_step].end.position[1],test_edges[circle_step].end.position[2])]
          line2 = [Geom::Point3d.new(middle_pts[correct_segment][0],middle_pts[correct_segment][1],middle_pts[correct_segment][2]), Geom::Point3d.new(middle_pts[correct_segment + 1][0],middle_pts[correct_segment + 1][1],middle_pts[correct_segment + 1][2])]
          intersection = Geom.intersect_line_line(line1, line2)
          #41
          if intersection != nil
            point_length_diff =(middle_pts[curve_segment][0] - length_difference * remaining_length_ratio) - intersection[0]
            point_height_diff =(middle_pts[curve_segment][2] + height_difference * remaining_length_ratio) - intersection[2]
            #testpt = group_ents.add_cpoint intersection
            #UI.messagebox circle_step
            intersection_distance = Math.sqrt((point_length_diff * point_length_diff) +(point_height_diff * point_height_diff))
            #if intersection_distance == door_panel_height - door_wheel_radius * 2
            if circle_step == 41
              line = group_ents.add_line intersection, centre_point3
              UI.messagebox line.length.to_f
            end
            UI.messagebox intersection_distance.to_s + " XX " +(door_panel_height - door_wheel_radius * 2).to_s
          end
        end
        face = group_support_ents.add_face edges
        status = face.pushpull door_frame_thickness * 2
          centre_point2 = [middle_pts[curve_segment][0] - length_difference * remaining_length_ratio, door_middle -(door_width / 2) - door_frame_thickness + 1 / $inch, middle_pts[curve_segment][2] + height_difference * remaining_length_ratio + door_panel_height - door_wheel_radius * 2]
          edges = group_support_ents.add_circle centre_point2, vector2, door_wheel_radius
        face = group_support_ents.add_face edges
        status = face.pushpull door_frame_thickness * 2
        

        end
        current_frame_location =(step + 1) * door_panel_height - door_wheel_radius + support_frame_start_height
        if current_frame_location <= door_height
          centre_point = [support_frame_location - door_frame_thickness / 2, door_middle -(door_width / 2) - door_frame_thickness + 1 / $inch,(step + 1) * door_panel_height - door_wheel_radius]
        elsif current_frame_location > support_frame_top_start
          centre_point = [support_frame_start -(current_frame_location - support_frame_top_start), door_middle -(door_width / 2) - door_frame_thickness + 1 / $inch, support_frame_height - door_frame_thickness / 2]
        else
          for curve_step in 0..29
            if current_frame_location > door_height + middle_arc_segment_length * curve_step and current_frame_location <= door_height + middle_arc_segment_length *(curve_step + 1)
              curve_segment = curve_step
            end
          end
          remaining_length = current_frame_location - door_height - curve_segment * middle_arc_segment_length
          remaining_length_ratio = remaining_length / middle_arc_segment_length
          height_difference = middle_pts[curve_segment + 1][2] - middle_pts[curve_segment][2]
          length_difference = middle_pts[curve_segment][0] - middle_pts[curve_segment + 1][0]
          centre_point = [middle_pts[curve_segment][0] - length_difference * remaining_length_ratio, door_middle -(door_width / 2) - door_frame_thickness + 1 / $inch, middle_pts[curve_segment][2] + height_difference * remaining_length_ratio]
        end

        edges = group_ents.add_circle centre_point, vector2, door_wheel_radius
      face = group_ents.add_face edges
      status = face.pushpull door_frame_thickness * 2
        
      end
      
      
      
      
      
      
    group = group.parent.entities.add_group([group, group_support])
  
      
  
    if direction == "X"
      door_radians = 270.degrees
      door_t = Geom::Transformation.rotation [0, 0, door_height], Z_AXIS, door_radians
      group.transform! door_t
    elsif direction == "-X"
      door_radians = 270.degrees
      door_t = Geom::Transformation.rotation [0, 0, door_height], Z_AXIS, door_radians
      group.transform! door_t
        point = Geom::Point3d.new(0, 0, 0)
      t = Geom::Transformation.scaling(point, 1, -1, 1)
      group.transform! t
    end
    return group
  end

end





########################################################
########################################################
###### Below is the code to draw standalone doors ######
########################################################
########################################################

def draw_door

  prompts = ["Door width?", "Door height?", "Door type?", "Door folding level?", "Door sections?", "Door frame thickness?", "Door skin thickness?", "Extensions?"]
    defaults = ["1400", "370", "Sliding doors", "5", "1", "5", "3", ""]
  list = ["", "", "Sliding doors|Bi-folding doors|Encased sliding doors|Encased sliding doors - single sided|Hydraulic swing door|Hydraulic door - Vertical piston", "", "", "", "", ""]
  input = UI.inputbox prompts, defaults, list, "Door info"

  texture_defaults = ["Untextured", "Untextured", "Untextured"]
  texture_list = [$metal_list, $door_list, $metal_list]
  texture_prompts = ["Beam texture?", "Door texture?", "Door frame texture?"]
  texture_input = UI.inputbox texture_prompts, texture_defaults, texture_list, "Texture info"
    
  beam_texture = texture_input[0]
  door_texture = texture_input[1]
  door_frame_texture = texture_input[2]
  wall_texture = door_texture
  roof_texture = wall_texture
  floor_texture = wall_texture
  
  door_width = input[0].to_f / $inch
  door_middle = door_width / 2
  door_height = input[1].to_f / $inch
  door_type = input[2]
  
  door_folding_level = input[3].to_i
  door_sections = input[4].to_i
  door_frame_thickness = input[5].to_f / $inch
  door_skin_thickness = input[6].to_f / $inch
  extensions = input[7]

  door_group = insert_door(door_type, door_height, door_folding_level.to_i, door_sections, door_width, door_middle, 0, 0, door_frame_thickness, door_skin_thickness, 0, 0, door_frame_texture, door_texture, wall_texture, roof_texture, beam_texture, floor_texture, "Y", "Door", 0, extensions)

end



