##################################
####    Core functions for    ####
#### One Click Software Suite ####
####  ©2014 Morten Blindheim  ####
##################################

#################################################################
###### Below is the code to show information about plugin  ######
#################################################################

def about_plugin
  about_text = "You are running version " + $version_number + " of the hangar tool.\nThe " + $file_name + " file is located in " + $local_folder + "\n\nWould you like to check for update?"
  logstring("Displaying version box", 1)
  result = UI.messagebox about_text, MB_YESNO
  if result == 6
    logstring("Checking for updates", 1)
    status = UI.openURL "http://www.fsdeveloper.com/forum/showthread.php?t=424466"
  end
end


#########################################################
###### Below is the code to import custom textures ######
#########################################################

def import_textures

  #texture_file = File.dirname(__FILE__).gsub("/", "\\"). + "\\textures.och"
  texture_file = $och_folder + "/textures.och"
  logstring("Reading textures.och", 1)
  imported_texture_list = IO.readlines(texture_file)
  
  texture_item = []
  
  logstring(imported_texture_list.length.to_s + " textures found in textures.och", 1)
  for step in 0..imported_texture_list.length - 1
    logstring("Reading texture #" + (step + 1).to_s, 2)
    texture_item[step] = imported_texture_list[step].split(";")
    texture_types = []
    if texture_item[step][2].count("|") > 0
      texture_types = texture_item[step][2].split("|")
    else
      texture_types[0] = texture_item[step][2].gsub("\\", "/")
    end
    
    allow_texture = 1
    for texture_step in 0..$texture_name.length - 1
      if $texture_name[texture_step] == texture_item[step][0]
        logstring("Skipping texture #" + (step + 1).to_s + ". Duplicate texture '" + $texture_name[texture_step] + "' found.", 1)
        allow_texture = 0
      end
    end
    
    ### Check if file exists ###
    if texture_item[step][3].count(":") === 0
      texture_filename = $texture_files + texture_item[step][3]
    else
      texture_filename = texture_item[step][3]
    end
    if !File.exist?(texture_filename)
      logstring("Skipping texture #" + (step + 1).to_s + ". File '" + texture_filename + "' not found.", 1)
      allow_texture = 0
    end
    
    if allow_texture == 1
      logstring("Loading texture #" + (step + 1).to_s + ". '" + texture_item[step][0] + "'", 2)
      for texture_step in 0..texture_types.length - 1
        if texture_types[texture_step] == "All"
          $internal_wall_list = $internal_wall_list + "|" + texture_item[step][0]
          $wall_list = $wall_list + "|" + texture_item[step][0]
          $roof_list = $roof_list + "|" + texture_item[step][0]
          $door_list = $door_list + "|" + texture_item[step][0]
          $floor_list = $floor_list + "|" + texture_item[step][0]
          $metal_list = $metal_list + "|" + texture_item[step][0]
          $extension_list = $extension_list + "|" + texture_item[step][0]
          $wood_list = $wood_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to all categories.", 2)
        elsif texture_types[texture_step] == "Internal"
          $internal_wall_list = $internal_wall_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to Internal Wall category.", 2)
        elsif texture_types[texture_step] == "Wall"
          $wall_list = $wall_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to Wall category.", 2)
        elsif texture_types[texture_step] == "Roof"
          $roof_list = $roof_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to Roof category.", 2)
        elsif texture_types[texture_step] == "Door"
          $door_list = $door_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to Door category.", 2)
        elsif texture_types[texture_step] == "Floor"
          $floor_list = $floor_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to Floor category.", 2)
        elsif texture_types[texture_step] == "Metal"
          $metal_list = $metal_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to Metal category.", 2)
        elsif texture_types[texture_step] == "Extension"
          $extension_list = $extension_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to Extension category.", 2)
        elsif texture_types[texture_step] == "Wood"
          $wood_list = $wood_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to Wood category.", 2)
        elsif texture_types[texture_step] == "Fence"
          $fence_list = $fence_list + "|" + texture_item[step][0]
          logstring("Texture #" + (step + 1).to_s + " added to Fence category.", 2)
        end
      end
      texture_array = $texture_name.length
      $texture_filename[texture_array] = texture_item[step][3]
      $texture_name[texture_array] = texture_item[step][0]
      if texture_item[step][1].count("x") > 0
        texture_sizes = texture_item[step][1].split("x")
        $texture_x_size[texture_array] = texture_sizes[0].to_i
        $texture_y_size[texture_array] = texture_sizes[1].to_i
      else
        $texture_x_size[texture_array] = texture_item[step][1].to_i
        $texture_y_size[texture_array] = texture_item[step][1].to_i
      end
      logstring("Texture #" + (step + 1).to_s + ". Filename '" + $texture_filename[texture_array] + "", 2)
      logstring("Texture #" + (step + 1).to_s + ". Width (cm) " + $texture_x_size[texture_array].to_s + "", 2)
      logstring("Texture #" + (step + 1).to_s + ". Heigh (cm) " + $texture_y_size[texture_array].to_s + "", 2)
    end
  end
  $textures_imported = 1
end


##################################################
###### Below is the code to geolocate model ######
##################################################

def geolocate_model (latitude=0.0, longitude=0.0, location="", country="")

  logstring("Geo-locating model to latitude " + latitude.to_s + ", longitude " + longitude.to_s, 1)
  model = Sketchup.active_model
  shadow_info = Sketchup.active_model.shadow_info
  shadow_info["Latitude"] = latitude
  shadow_info["Longitude"] = longitude
  shadow_info["City"] = location
  shadow_info["Country"] = country
  
  key = "GeoReference"
  model.set_attribute key, "GeoReferenceNorthAngle", 358.646700673226
  model.set_attribute key, "UsesGeoReferencing", true
  model.set_attribute key, "Longitude" , longitude
  model.set_attribute key, "Latitude" , latitude
  model.set_attribute key, "ModelTranslationX" ,  -12901579.2256146
  model.set_attribute key, "ModelTranslationY" , -214086056.635273
  model.set_attribute key, "ModelTranslationZ" , 0.0
  model.set_attribute key, "LocationSource" , "Google Earth"
  model.set_attribute key, "ZValueCentered" ,  0.0
  model.set_attribute key, "TimeStamp", 1296598526
  model.set_attribute key, "ModelHereState", ""
  model.set_attribute key, "ModelHereZoom", 19
end


########################################################################
###### Below is the code to calculate distance between geo points ######
########################################################################

def calculate_distance (start_latitude=0.0, start_longitude=0.0, end_latitude=0.0, end_longitude=0.0)

  earth_radius = 6371
  dlat = (end_latitude - start_latitude).degrees
  dlong = (end_longitude - start_longitude).degrees
  r_start_latitude = start_latitude.degrees
  r_end_latitude = end_latitude.degrees
  logstring("Calculating distance between two geo points", 1)
   
  calc_a = Math.sin(dlat/2) * Math.sin(dlat/2) + Math.sin(dlong/2) * Math.sin(dlong/2) * Math.cos(r_start_latitude) * Math.cos(r_end_latitude)
  calc_c = 2 * Math.atan2(Math.sqrt(calc_a), Math.sqrt(1-calc_a))
  distance = (earth_radius * calc_c * 100000)
  logstring("Start coordinates, latitude " + start_latitude.to_s + ", longitude " + start_longitude.to_s, 1)
  logstring("End coordinates, latitude " + end_latitude.to_s + ", longitude " + end_longitude.to_s, 1)
  logstring("Total distance " + distance.to_s, 1)
  
  return distance
end


#####################################################################
###### Below is the code to use echo as a display message code ######
#####################################################################

def echo (string = "")
  UI.messagebox string
  logstring("Message shown: " + string, 2)
end


################################################
###### Below is the code to append to log ######
################################################

def logstring (string = "", level = 0)
  if $log_level > 0
    if !File.exist?($log_file)
      out_file = File.new($log_file, "w")
    else
      out_file = File.open($log_file, "a")
    end
    if level <= $log_level
      t = Time.now
      t.to_s
      t.strftime "%Y-%m-%d %H:%M:%S %z"
      out_string = (t.to_s + $log_separator.to_s + string.to_s).gsub("\\t", "\t")
      out_file.puts(out_string)
    end
    out_file.close
  end
end


#################################################
###### Below is the code to show item info ######
#################################################

def show_item_info
  
  selection = Sketchup.active_model.selection
  items = selection.count

  if items == 1
    if selection[0].typename == "Group"
      if selection[0].description == "AFCAD Tower"
        create_tower = UI.messagebox "Tower location for " + $airport_icao + ". Do you wish to create tower?", MB_YESNO
        if create_tower == IDYES
          atc_tower("", $airport_tower_x_pos * $inch, $airport_tower_y_pos * $inch)
          selection[0].erase!
        end
      elsif selection[0].description[0,6] == "Runway"
        runway_info = selection[0].description.to_s.split("|")
        create_runway = UI.messagebox runway_info[0].to_s + " " + runway_info[1].to_s + ". Do you wish to texture the runway?", MB_YESNO
        if create_runway == IDYES
          texture_runway(runway_info[0].to_s + " " + runway_info[1].to_s, runway_info[2], runway_info[3], runway_info[4], runway_info[5], runway_info[6])
          selection[0].erase!
        end
      elsif selection[0].description[0,7] == "Parking"
        parking_info = selection[0].description.to_s.split("|")
        create_parking = UI.messagebox parking_info[0].to_s + " " + parking_info[1].to_s + ". Do you wish to create a hangar?", MB_YESNO
        if create_parking == IDYES
          standalone_hangar(selection[0].description, 999, 999)
  #        selection[0].erase!
        end
      elsif selection[0].description[0,5] == "Apron"
        apron_info = selection[0].description.to_s
        create_apron = UI.messagebox "Do you wish to texture the apron (" + apron_info + ")? Note: This will erase all non-grouped entities.", MB_YESNO
        if create_apron == IDYES
          texture_apron(selection[0])
          selection[0].erase!
        end
      end
    else
      echo selection[0]
    end
  elsif items > 1
    echo "Item info cannot be displayed for multiple items."
  else
    echo "Please select a valid object."
  end
end


##################################################################
###### Code to calculate decimal to imperial fraction units ######
##################################################################

def convert_imperial(value = 0.0)

  value = value.to_f
  value_int = value.to_i
  value_dec =(value - value.to_i).to_f
  
  value_feet =(value_int / 12).to_i
  value_inches = value_int - (value_feet * 12)
  value_fraction = ""
  fraction_found = 0
  
  if value_dec > 0
    for step in 2..16
      if fraction_found == 0
        if value_dec * step ==(value_dec * step).to_i
          value_fraction =(value_dec * step).to_i.to_s + "/" + step.to_s
          fraction_found = 1
        end
      end
    end
  end
  
  if value_dec == 0
    return value_feet.to_s + "\" " + value_inches.to_s + "'"
  else
    if fraction_found == 1
      return value_feet.to_s + "\" " + value_inches.to_s + " " + value_fraction + "'"
    else
      return "approx. " + value_feet.to_s + "\" " + value_inches.to_s + "'"
    end
  end 

end


###################################################################
####### Code to calculate imperial fraction units to decimal ######
###################################################################

def calculate_units(unit_string = "")

  unit_feet = 0
  unit_inch = 0
  if unit_string.count(" ") == 1 and unit_string.count("'") == 0 and unit_string.count("/") == 1
  
    unit_items = unit_string.split(" ")
    
    if unit_string.count("\"") == 1
      unit_fraction = unit_items[1][0..unit_items[1].index("\"")-1].split("/")
      unit_inch = unit_items[0].to_i + unit_fraction[0].to_f / unit_fraction[1].to_f
    else
      unit_fraction = unit_items[1].split("/")
      unit_inch = unit_items[0].to_i + unit_fraction[0].to_f / unit_fraction[1].to_f
    end
    
  elsif unit_string.count(" ") == 2
    unit_items = unit_string.split(" ")
    
    if unit_items[0].count("'") == 1
      unit_feet = unit_items[0][0..unit_items[0].index("'")-1].to_i
    else
      unit_feet = unit_items[0].to_i
    end
    if unit_items[2].count("\"") == 1
      unit_fraction = unit_items[2][0..unit_items[2].index("\"")-1].split("/")
      unit_inch = unit_items[1].to_i + unit_fraction[0].to_f / unit_fraction[1].to_f
    else
      unit_fraction = unit_items[2].split("/")
      unit_inch = unit_items[1].to_i + unit_fraction[0].to_f / unit_fraction[1].to_f
    end

  elsif unit_string.count(" ") == 1
    unit_items = unit_string.split(" ")
    
    if unit_items[0].count("'") == 1
      unit_feet = unit_items[0][0..unit_items[0].index("'")-1].to_i
    else
      unit_feet = unit_items[0].to_i
    end

    if unit_items[1].count("/") == 1
      if unit_items[1].count("\"") == 1
        unit_fraction = unit_items[1][0..unit_items[1].index("\"")-1].split("/")
        unit_inch = unit_fraction[0].to_f / unit_fraction[1].to_f
      else
        unit_fraction = unit_items[1].split("/")
        unit_inch = unit_fraction[0].to_f / unit_fraction[1].to_f
      end
    else
      if unit_string.count("\"") == 1
        unit_inch = unit_items[1][0..unit_items[1].index("\"")-1].to_f
      else
        unit_inch = unit_items[1].to_f
      end
    end
  else
    if unit_string.count("'") == 1
      unit_feet = unit_string[0..unit_string.index("'")-1].to_i
    elsif unit_string.count("\"") == 1
      if unit_string.count("/") == 1
        unit_fraction = unit_string.split("/")
        unit_inch = unit_fraction[0].to_f / unit_fraction[1].to_f
      else
        unit_inch = unit_string[0..unit_string.index("\"")-1].to_i
      end
    elsif unit_string.count("/") == 1
      
      unit_fraction = unit_string.split("/")
      unit_inch = unit_fraction[0].to_f / unit_fraction[1].to_f
    else
      unit_feet = unit_string.to_f
    end
  end
  
  unit_total = unit_feet * 12 + unit_inch
  
  return unit_total

end


###############################################
####### Code to import custom extensions ######
###############################################

def extension_import(extension_id = "")
  
  extension_file = $och_folder + "/extensions.och"
  imported_extension_list = IO.readlines(extension_file)
  extension_found = 0
  extension_count = 0
  extensions = []
  
  for step in 0..imported_extension_list.length - 1
    if imported_extension_list[step][0..4] == "[ext."
      if imported_extension_list[step].count("//") > 0
        extension_split = imported_extension_list[step].split("//")
        extension_details = extension_split[0].strip.split(".")
      else
        extension_details = imported_extension_list[step].split(".")
      end
      if extension_details[1].strip == extension_id.to_s + "]"
        extension_found = 1
      else
        if extension_found == 1
          extension_found = 2
        end
      end
    elsif extension_found == 1 and imported_extension_list[step].strip.length > 0
      if imported_extension_list[step].count("//") > 0
        extension_split = imported_extension_list[step].split("//")
        extensions[extension_count] = extension_split[0].strip
      else
        extensions[extension_count] = imported_extension_list[step].strip
      end
      extension_count += 1
    end
  end
  return extensions
end


####################################################
###### Below is the code to set default units ######
####################################################

def change_units
  prompts = ["Please select unit: "]
  defaults = [$unit_type]
  list = ["Centimetres|Feet and Inches|Millimetres|Feet|Inches|Metres"]
  input = UI.inputbox prompts, defaults, list, "Select units"
  
  if input[0] == "Centimetres"
    $inch = 2.54
    $unit_multiplier = 1
  elsif input[0] == "Millimetres"
    $inch = 25.4
    $unit_multiplier = 10
  elsif input[0] == "Feet"
    $inch = 1 / 12
    $unit_multiplier = 1 / (2.54 * 12)
  elsif input[0] == "Inches" or input[0] == "Feet and Inches"
    $inch = 1
    $unit_multiplier = 1 / 2.54
  elsif input[0] == "Metres"
    $inch = 0.0254
    $unit_multiplier = 0.01
  end
  $unit_type = input[0]

  settings_file = $och_folder + "/settings.och"
  imported_settings_list = IO.readlines(settings_file)
  
  settings_item = []
  
  for step in 0..imported_settings_list.length - 1
    settings_item = imported_settings_list[step].split("=")
    if settings_item[0] == "units"
      imported_settings_list[step] = "units=" + $unit_type
    end
  end
  
  new_settings_file = File.new(settings_file,"w")
  
  new_settings_file.write(imported_settings_list)
  new_settings_file.close
end


##########################################
### Code to extract entrance door info ### 
##########################################

def entrance_door_info(extension_string = "")
  
  entrance_door_string = extension_string[extension_string.index("(") + 1..extension_string.index(")") - 1]
  entrance_door = []
  if entrance_door_string.count(";") == 4 or entrance_door_string.count(";") == 5
    entrance_door_failed = 0
    entrance_door_details = entrance_door_string.split(";")
    entrance_door[0] = entrance_door_details[2] #### Side ####
    if entrance_door_details[0].count("x") == 1
      entrance_door_temp_string = entrance_door_details[0].split("x")
      entrance_door[1] = entrance_door_temp_string[0].to_f / $inch #### X pos ####
      entrance_door[2] = entrance_door_temp_string[1].to_f / $inch #### Y pos ####
    else
      entrance_door_failed = 1
    end
    if entrance_door_details[1].count("x") == 1
      entrance_door_temp_string = entrance_door_details[1].split("x")
      entrance_door[3] = entrance_door_temp_string[0].to_f / $inch #### X size ####
      entrance_door[4] = entrance_door_temp_string[1].to_f / $inch #### Y size ####
    else
      entrance_door_failed = 1
    end
    entrance_door[5] = entrance_door_details[4] #### Texture ####
    entrance_door[6] = entrance_door_details[3] #### Type ####
          
    if entrance_door_string.count(";") == 5
      entrance_door[7] = entrance_door_details[5] #### Top texture ####
      entrance_door[8] = entrance_door_details[5] #### Top texture ####
    else
      entrance_door[7] = entrance_door[5] #### Top texture ####
      entrance_door[8] = entrance_door[5] #### Top texture ####
    end
          
    if entrance_door_failed == 0
      entrance_door[9] = entrance_door[0] #### Cross beam exclusion side ####
      entrance_door[10] = [entrance_door[1], entrance_door[2], entrance_door[1] + entrance_door[3], entrance_door[2] + entrance_door[4]] #### Cross beam exclusion positions ####
      return entrance_door
    else
      return false
    end
  else
    return false 
  end
end


#################################################
###### Below is the code to show help file ######
#################################################

def help_file
  
  if $help_file_imported == 0
  # help_file = File.dirname(__FILE__).gsub("/", "\\"). + "\\HangarForms\\help.txt"
    help_file = $och_folder + "/HangarForms/help.txt"
    imported_help_list = IO.readlines(help_file)
    
    $help_item = []
    for step in 0..imported_help_list.length - 1
      $help_item[step] = imported_help_list[step].split(";")
    end
    $help_file_imported = 1
  end

  dlg = UI::WebDialog.new("One Click Hangar - help", true, "HangarInfo", 720, 400, 150, 150, true)
  dlg.set_url $html_files + "help.html"
  name = $help_item[0]
  js_script = "dataFromSketchup(#{name.inspect})"
  
  dlg.add_action_callback("help_link") do |web_dialog,action_name|
    help_number = 0
    for step in 0..$help_item.length - 1
      if $help_item[step][0] == action_name
        help_number = step
      end
    end
    name = $help_item[help_number]
    js_script = "dataFromSketchup(#{name.inspect})"
    dlg.execute_script(js_script) 
  
  end

  dlg.add_action_callback("view_image") do |web_dialog,action_name|
    dlg_image = UI::WebDialog.new("One Click Hangar - screenshot", true, "HangarInfo", 720, 400, 150, 150, true)
    dlg_image.set_url $html_files + "view_image.html"
    js_script = "dataFromSketchup(#{action_name.inspect})"
    dlg_image.show {
      dlg_image.execute_script(js_script) 
    }
    
  end

  dlg.show {
    dlg.execute_script(js_script) 
  }
  
end


#############################
###### Import settings ######
#############################

def import_settings

  settings_file = $och_folder + "/settings.och"
  imported_settings_list = IO.readlines(settings_file)
  
  settings_item = []
  
  for step in 0..imported_settings_list.length - 1
    settings_item = imported_settings_list[step].split("=")
    
    if settings_item[0] == "units"
      if settings_item[1] == "Centimetres"
        $inch = 2.54
        $unit_multiplier = 1
      elsif settings_item[1] == "Millimetres"
        $inch = 25.4
        $unit_multiplier = 10
      elsif settings_item[1] == "Feet"
        $inch = 1 / 12
        $unit_multiplier = 1 /(2.54 * 12)
      elsif settings_item[1] == "Inches" or settings_item[1] == "Feet and Inches"
        $inch = 1
        $unit_multiplier = 1 / 2.54
      elsif settings_item[1] == "Metres"
        $inch = 0.0254
        $unit_multiplier = 0.01
      end
      $unit_type = settings_item[1].to_s.gsub("\n", "")
    elsif settings_item[0] == "debug"
      $debug_on = settings_item[1].to_i
    elsif settings_item[0] == "loglevel"
      $log_level = settings_item[1].to_i
    elsif settings_item[0] == "logseparator"
      $log_separator = settings_item[1].to_s.gsub("\n", "")
    elsif settings_item[0] == "shortcuts"
      $shortcuts_enabled = settings_item[1].to_i
    elsif settings_item[0] == "development"
      $development_enabled = settings_item[1].to_i
    end
    
  end
end


##############################################################
###### Below is the code to display the texture manager ######
##############################################################

def texture_manager
  
  dlg = UI::WebDialog.new("One Click Hangar - Texture Manager", true, "HangarInfo", 720, 400, 150, 150, true)
  dlg.set_url $ochtml_folder + "texture_manager.html"
  texture_file = File.dirname(__FILE__) + "/textures.och"
  imported_texture_list = IO.readlines(texture_file)
  js_script = "loadPage(#{imported_texture_list.inspect})"
  
  dlg.add_action_callback("reload_texture") do |web_dialog,action_name|
    
    logstring("Closing Texture Manager", 1)
    dlg.close
 #   js_script = "dataFromSketchup(#{name.inspect})"
 #   dlg.execute_script(js_script) 
 
 
    $metal_list = "Untextured"
    $wall_list = "Untextured"
    $roof_list = "Untextured"
    $door_list = "Untextured"
    $floor_list = "No floor|Untextured"
    $internal_wall_list = "Same as external|Untextured"
    $wood_list = "Untextured"
    $fence_list = "Untextured"
    $extension_list = ""
  end

  dlg.show {
    logstring("Displaying Texture Manager", 1)
    dlg.execute_script(js_script) 
  }
      
end