##########################################################
##########################################################
###### Below is the code for the standalone hangar	######
##########################################################
##########################################################

def standalone_hangar(hangar_codes = "", midlat = 0.0, midlong = 0.0)

	group = Sketchup.active_model.entities.add_group
	group_ents = group.entities
	materials = Sketchup.active_model.materials
	logstring("Standalone hangar initiated", 1)
	afcad_read = 0

	if hangar_codes != "" and hangar_codes != "Box" and midlat != 999
		
		afcad_read = 1

		hangar_info = hangar_codes.split(":")
		
		#hangar_dimensions = hangar_info[0][hangar_info[0].index("(") + 1..hangar_info[0].index(")") - 1].split("x")
		
		
		#Set texture info to default
		beam_texture = hangar_info[22]
		wall_texture = hangar_info[23]
		internal_wall_texture = hangar_info[24]
		if internal_wall_texture == "Same as external"
			internal_wall_texture = wall_texture
		end
		roof_texture = hangar_info[25]
		ceiling_texture = hangar_info[26]
		door_texture = hangar_info[27]
		door_frame_texture = hangar_info[28]
		floor_texture = hangar_info[29]
		cross_beam_texture = beam_texture
		
		beam_type = hangar_info[1]
		beams = hangar_info[2].to_i
		beam_width = hangar_info[4].to_f / $inch
		beam_thickness = hangar_info[5].to_f / $inch
		start_beam_size = beam_width + beam_thickness
		wall_thickness = hangar_info[6].to_f / $inch
		eaves_overhang = hangar_info[7].to_f / $inch
		wall_type = "Flat"
		internal_height = hangar_info[8].to_f / $inch
		full_width = (hangar_info[9].to_f / $inch) - (wall_thickness * 2)
		arc = hangar_info[10].to_f / $inch

		#Calculate internal structure sizes
		if beam_type == "T" or beam_type == "New T"
			total_beam_size =((beam_width + beam_thickness) * 2) +(((beam_width * 2) + beam_thickness) *(beams - 2))
		elsif beam_type == "U"
			total_beam_size =((beam_width + beam_thickness) * 2) * beams
		elsif beam_type == "H"
			total_beam_size =(beam_width + beam_thickness) * beams
		elsif beam_type == "New H"
			total_beam_size =(beam_width +(beam_thickness * 3)) * beams
		elsif beam_type == "Wood"
			total_beam_size = beam_thickness * beams
		end

		if beam_type != "New H" and beam_type != "Wood"
			spacing_total = (hangar_info[3].to_f / $inch) - total_beam_size - (wall_thickness * 2) - (beam_thickness * 2)
		else
			spacing_total = (hangar_info[3].to_f / $inch) - total_beam_size - (wall_thickness * 2)
		end
		spacing = spacing_total / (beams - 1)

		if beam_type == "New T"
			fullbeam_size =(beam_width * 2) + beam_thickness
			halfbeam_size = beam_width + beam_thickness
			beam_depth = beam_width + beam_thickness
			full_length =(spacing *(beams - 1)) +((beams - 2) * fullbeam_size) +(halfbeam_size * 2)
			start_beam_size = beam_width + beam_thickness
		elsif beam_type == "U"
			fullbeam_size =(beam_width + beam_thickness) * 2
			full_length =(spacing *(beams - 1)) +(beams * fullbeam_size)
			beam_depth = beam_width + beam_thickness
			start_beam_size = fullbeam_size
		elsif beam_type == "H"
			fullbeam_size = beam_width + beam_thickness
			full_length =(spacing *(beams - 1)) +(beams * fullbeam_size)
			beam_depth = beam_width +(beam_thickness * 2)
			start_beam_size = fullbeam_size
		elsif beam_type == "New H"
			fullbeam_size = beam_width +(beam_thickness * 3)
			full_length =(spacing *(beams - 1)) +(beams * fullbeam_size)
			beam_depth = beam_width +(beam_thickness * 2)
			start_beam_size = fullbeam_size - beam_thickness
		elsif beam_type == "Wood"
			fullbeam_size = beam_thickness
			beam_depth = beam_width
			start_beam_size = fullbeam_size
		end

		door_width = hangar_info[11].to_f / $inch
		door_height= hangar_info[12].to_f / $inch
		door_type = hangar_info[13]
		door_folding_level = hangar_info[14].to_i
		door_sections = hangar_info[15].to_i
		parking_radius = hangar_info[30].to_f * 100 / $inch
		
		
		
		if door_width > full_width
			door_width = full_width
		end

		door_section_width = door_width / door_sections
		#door_thickness = wall_thickness / 2
		door_middle =(wall_thickness + full_width) / 2
		door_frame_thickness = hangar_info[16].to_f / $inch
		door_skin_thickness = hangar_info[17].to_f / $inch
		extension_text = hangar_info[21]
		
		#Calculate hangar's distance from midpoint
		earth_radius = 6371
		lat1 = midlat
		lat2 = hangar_info[31].to_f
		long1 = midlong
		long2 = hangar_info[32].to_f
		dlaty =(lat2-lat1).degrees
		dlongy =(0).degrees
		dlatx =(0).degrees
		dlongx =(long2-long1).degrees
		rlat1 = lat1.degrees
		rlat2 = lat2.degrees
		
		calc_a = Math.sin(dlaty/2) * Math.sin(dlaty/2) + Math.sin(dlongy/2) * Math.sin(dlongy/2) * Math.cos(rlat1) * Math.cos(rlat2)
		calc_c = 2 * Math.atan2(Math.sqrt(calc_a), Math.sqrt(1-calc_a))
		y_distance =(earth_radius * calc_c * 100000)
		calc_a = Math.sin(dlatx/2) * Math.sin(dlatx/2) + Math.sin(dlongx/2) * Math.sin(dlongx/2) * Math.cos(rlat1) * Math.cos(rlat1)
		calc_c = 2 * Math.atan2(Math.sqrt(calc_a), Math.sqrt(1-calc_a))
		x_distance =(earth_radius * calc_c * 100000)
		calc_a = Math.sin(dlaty/2) * Math.sin(dlaty/2) + Math.sin(dlongx/2) * Math.sin(dlongx/2) * Math.cos(rlat1) * Math.cos(rlat1)
		calc_c = 2 * Math.atan2(Math.sqrt(calc_a), Math.sqrt(1-calc_a))
		a_distance =(earth_radius * calc_c * 100000)

		if long1 > long2
			x_distance = 0 - x_distance
		end
		
		if lat1 > lat2
			y_distance = 0 - y_distance
		end

# Test calculations of distance
test_distance = Math.sqrt((x_distance * x_distance) +(y_distance * y_distance))

#		UI.messagebox x_distance
#		UI.messagebox y_distance
		
		hangar_angle = 270 - hangar_info[33].to_f
		hangar_x = x_distance / $inch
		hangar_y = y_distance / $inch
		radians = hangar_angle.degrees
	else
    if midlat != 0 and midlong != 0 and hangar_codes != "Box"
      afcad_codes = hangar_codes.split("|")
      echo "Import from AFCAD"
      angle = []
      angle[0] = (270 - afcad_codes[4].to_f).modulo(360)
      angle[1] = afcad_codes[2].to_f
      angle[2] = afcad_codes[3].to_f
      angle[3] = afcad_codes[1].to_f * 200 / $inch + 200 / $inch ### Radius * 2, converted to cm, 200 cm added ###
      angle[4] = angle[3]
      door_width = afcad_codes[1].to_f * 200 + 100 
    else
      angle = find_endpoints
      door_width = 1400 
    end
		prompts = ["Hangar length?", "Wall thickness?", "Eaves overhang?", "Internal height?", "Internal width?", "Arc height?", "Door width?", "Door height?", "Door type?", "Door folding level?", "Door sections?", "Door frame thickness?", "Door skin thickness?", "Angle?", "X-pos?", "Y-pos?", "Extensions?"]
		if $unit_type == "Feet and Inches"
			if angle[3] == 0
				internal_width_default = "60' 6\""
			else
				internal_width_default = convert_imperial(angle[3])
			end
			if angle[4] == 0
				full_length_default = "50'"
			else
				full_length_default = convert_imperial(angle[4])
			end
			defaults = [full_length_default, "2\"", "0\"", "13' 5 3/4\"", internal_width_default, "4' 4 7/16\"", "42'", "13' 6\"", "Sliding doors", "5", "1", "2\"", "1\"", angle[0].to_f, angle[1] * $inch, angle[2] * $inch, ""]
		else
      if angle[3] == 0
        angle[3] = 1620 / $inch
      else
        door_width = (angle[3] * $inch * 0.8 / 10).floor * 10
      end
      if angle[4] == 0
        full_length_default = 1620 / $inch
      else
        full_length_default = angle[4]
      end
      
      if hangar_codes == "Box"
        hangar_height_default = midlat * $inch
        hangar_arc_height_default = midlong * $inch
      else
        hangar_height_default = (((full_length_default * $inch) - 20) / 40).floor * 10
        hangar_arc_height_default = 150
      end
      door_height_default = (hangar_height_default * 0.9 / 10).floor * 10
			defaults = [(full_length_default * $inch) - 20, "5", "0", hangar_height_default, (angle[3] * $inch) - 20, hangar_arc_height_default, door_width, door_height_default, "Sliding doors", "5", "1", "5", "3", angle[0].to_f, angle[1] * $inch, angle[2] * $inch, ""]
		end
		list = ["", "", "", "", "", "", "", "", "Sliding doors|Bi-folding doors|Encased sliding doors|Encased sliding doors - single sided|Hydraulic swing door|Do not draw door", "", "", "", "", "", "", "", ""]
		input = UI.inputbox prompts, defaults, list, "Hangar info"
    if (input === false)
      logstring("Cancel button clicked - Exiting", 1)
      return nil
    end
    	
	  beam_defaults = ["New H", "30", "10", "2", "6", "14"]
    beam_prompts = ["Beam type:", "Beam width:", "Beam depth:", "Beam thickness:", "Beam rows:", "Diagonal beams:"]
    beam_list = ["T|New T|U|H|New H|Wood|Duo Pitch Truss", "", "", "", "", ""]
	  beam_input = UI.inputbox beam_prompts, beam_defaults, beam_list, "Beam info"
    if (beam_input === false)
      logstring("Cancel button clicked - Exiting", 1)
      return nil
    end
    	
		if beam_input[0] != "Wood"
		 	texture_defaults = ["Blue metal", "Vertical corrugated iron", "Same as external", "Vertical square iron", "Vertical square iron", "Horizontal square iron", "Silver metal", "Concrete"]
		 	texture_list = [$metal_list, $wall_list, $internal_wall_list, $roof_list, $roof_list, $door_list, $metal_list, $floor_list]
		else
		 	texture_defaults = ["Wooden planks", "Vertical corrugated iron", "Same as external", "Wooden planks", "Wooden planks", "Horizontal square iron", "Silver metal", "Concrete"]
		 	texture_list = [$wood_list, $wall_list, $internal_wall_list, $wood_list + "|" + $roof_list, $wood_list + "|" + $roof_list, $door_list, $metal_list, $floor_list]
		end
	 	texture_prompts = ["Beam texture?", "Wall texture?", "Internal wall texture?", "Roof texture?", "Ceiling texture?", "Door texture?", "Door frame texture?", "Floor texture?"]
	 	texture_input = UI.inputbox texture_prompts, texture_defaults, texture_list, "Texture info"
    if (texture_input === false)
      logstring("Cancel button clicked - Exiting", 1)
      return nil
    end
    		
		#Get texture info
		beam_texture = texture_input[0]
		wall_texture = texture_input[1]
		internal_wall_texture = texture_input[2]
		roof_texture = texture_input[3]
		ceiling_texture = texture_input[4]
		door_texture = texture_input[5]
		door_frame_texture = texture_input[6]
		floor_texture = texture_input[7]
		if internal_wall_texture == "Same as external"
			internal_wall_texture = wall_texture
		end
		
		beam_type = beam_input[0]
		beams = beam_input[4].to_i
		
		if $unit_type == "Feet and Inches"
			if angle[4] == 0
				angle[4] = calculate_units(input[0]).to_f / $inch
			end
      beam_width = calculate_units(beam_input[1]).to_f / $inch
      beam_depth = calculate_units(beam_input[2]).to_f / $inch
			beam_thickness = calculate_units(beam_input[3]).to_f / $inch
			wall_thickness = calculate_units(input[1]).to_f / $inch	
			eaves_overhang = calculate_units(input[2]).to_f / $inch
			internal_height = calculate_units(input[3]).to_f / $inch
			if angle[3] == 0
				full_width = calculate_units(input[4]).to_f / $inch
			else
				full_width = angle[3] / $inch
			end
			
			arc = calculate_units(input[5]).to_f / $inch
			door_width = calculate_units(input[6]).to_f / $inch
			door_height = calculate_units(input[7]).to_f / $inch	
			door_frame_thickness = calculate_units(input[11]).to_f / $inch
			door_skin_thickness = calculate_units(input[12]).to_f / $inch
	
		else
		
			if angle[4] == 0
				angle[4] = input[0].to_f / $inch
			end
      beam_width = beam_input[1].to_f / $inch
      beam_depth = beam_input[2].to_f / $inch
			beam_thickness = beam_input[3].to_f / $inch
			diagonal_beams = beam_input[4].to_i
			wall_thickness = input[1].to_f / $inch	
			eaves_overhang = input[2].to_f / $inch
			internal_height = input[3].to_f / $inch
			full_width = input[4].to_f / $inch
			arc = input[5].to_f / $inch
			door_width = input[6].to_f / $inch
			door_height = input[7].to_f / $inch	
			door_frame_thickness = input[11].to_f / $inch
			door_skin_thickness = input[12].to_f / $inch
			
		end
		
		full_length = angle[4] - wall_thickness * 2
		if beam_type == "T" or beam_type == "New T"
			total_beam_size =((beam_width + beam_thickness) * 2) + (((beam_width * 2) + beam_thickness) * (beams - 2))
		elsif beam_type == "U"
			total_beam_size =((beam_width + beam_thickness) * 2) * beams
		elsif beam_type == "H"
			total_beam_size =(beam_width + beam_thickness) * beams
		elsif beam_type == "New H"
			total_beam_size =(beam_width + (beam_thickness * 3)) * beams
		elsif beam_type == "Wood"
			total_beam_size = beam_thickness * beams
	  else
	    total_beam_size = 0
		end
		if beam_type != "New H" and beam_type != "Wood"
			spacing_total = full_length - total_beam_size - (beam_thickness * 2)
		else
			spacing_total = full_length - total_beam_size
		end
		spacing = spacing_total / (beams - 1)

		if beam_type == "New T"
			fullbeam_size =(beam_width * 2) + beam_thickness
			halfbeam_size = beam_width + beam_thickness
			beam_depth = beam_width + beam_thickness
			start_beam_size = beam_width + beam_thickness
		elsif beam_type == "U"
			fullbeam_size = (beam_width + beam_thickness) * 2
			beam_depth = beam_width + beam_thickness
			start_beam_size = fullbeam_size
		elsif beam_type == "H"
			fullbeam_size = beam_width + beam_thickness
			beam_depth = beam_width + (beam_thickness * 2)
			start_beam_size = fullbeam_size
		elsif beam_type == "New H"
			fullbeam_size = beam_width + (beam_thickness * 3)
			beam_depth = beam_width + (beam_thickness * 2)
			start_beam_size = fullbeam_size - beam_thickness
		elsif beam_type == "Wood"
			fullbeam_size = beam_thickness
			beam_depth = beam_width
			start_beam_size = fullbeam_size
	  else
      fullbeam_size = beam_thickness
      start_beam_size = fullbeam_size
		end


		door_type = input[8]
		door_folding_level = input[9].to_i
		door_sections = input[10].to_i
	
		if door_width > full_width - (beam_depth * 2)
			door_width = full_width - (beam_depth * 2)
		end

		if door_width == full_width - (beam_depth * 2) and door_height > internal_height - beam_width * 2
			door_height = internal_height - beam_width * 2
		end
		
		door_section_width = door_width / door_sections
		door_middle = wall_thickness + (full_width / 2)

	
		hangar_angle = input[13].to_f
#		if midlat == 999 and midlong == 999
#      hangar_x = input[18].to_f / $inch - full_length / 2
#      hangar_y = input[19].to_f / $inch - full_width / 2
#		else
  		hangar_x = input[14].to_f / $inch
  		hangar_y = input[15].to_f / $inch
#		end
		radians = hangar_angle.degrees

		extension_text = input[16]

		group.description = "Standard:" + hangar_x.to_s + ":" + hangar_y.to_s + ":" + hangar_angle.to_s

	end

	height = internal_height # Temporary



#############################
####	Get extension info ####
#############################
	
	extensions = []
	extension_types = []
	door_offset = 0
	door_tail_height = 0
	door_tail_width = 0
	back_door_tail_height = []
	back_door_tail_width = []
	back_door_width = []
	back_door_height = []
	back_door_position = []
  back_door_type = []
	back_door_extension = []
	back_door_allowed = []
	back_door_count = 0
	cross_beam_thickness = 0
	cross_beam_width = 0
	cross_beam_texture = ""
	cross_beam_set = 0
	cross_beam_exclusions = []
	cross_beam_exclusion_side = []
	cross_beam_exclusion_count = 0
	cross_beam_extras_drawn = []
	window_count = 0
	window_x_pos = []
	window_y_pos = []
	window_x_size = []
	window_y_size = []
	window_texture = []
	window_back_texture = []
	window_transparency = []
	window_wall = []
	window_repeat = []
	window_gap = []
	entrance_door_count = 0
	entrance_doors = []
	roof_window_count = 0
	roof_window_x_pos = []
	roof_window_y_pos = []
	roof_window_x_size = []
	roof_window_y_size = []
	roof_window_texture = []
	roof_window_back_texture = []
	roof_window_transparency = []
	roof_window_side = []
	roof_window_repeat = []
	roof_window_gap = []
	uv_map_count = 0
	uv_map_x_pos = []
	uv_map_y_pos = []
	uv_map_x_size = []
	uv_map_y_size = []
	uv_map_texture = []
	uv_map_wall = []
	uv_map_rotation = []
	multiple_doors = 0
	multiple_door_folding_level = []
	
	sign_count = 0
	sign_x_pos = []			# Position on wall from front or left
	sign_y_pos = []			# Position on wall from ground
	sign_x_size = []		# Sign width
	sign_y_size = []		# Sign height
	sign_thickness = []		# Sign thickness
	sign_double_sided = []		# 0 for logo on front only(only valid for textured signs), 1 for logo on both sides
	sign_wall = []			# Wall to put sign on, F, B, L, R
	sign_texture = []		# Sign texture name
	sign_type = []			# Sign type; L(logo), T(text)
	sign_filled = []		# 0 to not adjust texture size, 1 to adjust texture size.
	hangar_left_extension = 0 / $inch
	hangar_right_extension = 0 / $inch
	left_beam_follow_extension = 0
	right_beam_follow_extension = 0
	super_detailed = 0

	hangar_door_extension = []
	hangar_door_extension_length = []
	
	foundation_wall_height = 0
	foundation_wall_thickness = 0
	foundation_wall_texture = ""
	
	if extension_text.length > 0
		if extension_text[0..1] == "X("
		  extension_name = extension_text[extension_text.index("(") + 1..extension_text.index(")") - 1]
		  extensions = extension_import(extension_name)
    elsif extension_text.count('|') > 0
      extensions = extension_text.split("|")
		else
			extensions[0] = extension_text
		end
		
		
		door_set = 0
		for step in 0..extensions.length - 1
			door_found = 0
			if extensions[step].count('(') > 0 and extensions[step].count(')') > 0 
				extension_types[step] = extensions[step][0..extensions[step].index("(") - 1]
			else
				extension_types[step] = "ERR"
			end
			
			# Multiple Doors
			if extension_types[step] == "MD" and multiple_doors == 0 and (door_type == "Bi-folding doors" or door_type == "Hydraulic swing door")
				multiple_doors_text = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1]
				if multiple_doors_text.count(";") > 0
					multiple_door_folding_level = multiple_doors_text.split(";")
				end
				multiple_doors = multiple_doors_text.to_i
				
				total_door_width = door_width * multiple_doors
				door_distance = ((wall_thickness * 2) + full_width  - total_door_width) / (multiple_doors + 1)

				if multiple_doors < 2 or (door_width * multiple_doors + wall_thickness * (multiple_doors + 1)) > full_width
					multiple_doors = 0
				end
			##	UI.messagebox multiple_door_folding_level.count
			end



			# Door
			if extension_types[step] == "D" and door_offset == 0 and door_set == 0 and multiple_doors == 0
				door_offset = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1].to_f
				door_middle = door_middle + (door_offset / $inch)
				if door_middle + door_width / 2 > full_width and door_offset > 0
					door_middle = full_width - (door_width / 2)
				elsif door_middle - door_width / 2 < wall_thickness and door_offset < 0
					door_middle = wall_thickness + (door_width / 2)
				end
				door_found = 1
			end
			
			# Back door
			if extension_types[step] == "DB" or extension_types[step] == "BD"
        back_door_string = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1]
				if back_door_string.count(";") >= 2
					back_door_items = back_door_string.split(";")
          back_door_position[back_door_count] = back_door_items[0].to_f / $inch
          back_door_width[back_door_count] = back_door_items[1].to_f / $inch
          back_door_height[back_door_count] = back_door_items[2].to_f / $inch
          if back_door_string.count(";") >= 3
  					if back_door_items[3] == "Sliding"
	   					back_door_type[back_door_count] = "Sliding doors"
			 		  elsif back_door_items[3] == "Bi-fold"
				  		back_door_type[back_door_count] = "Bi-folding doors"
            elsif back_door_items[3] == "Hydraulic"
						  back_door_type[back_door_count] = "Hydraulic swing door"
            elsif back_door_items[3] == "Encased"
						  back_door_type[back_door_count] = "Encased sliding doors"
            else
						  back_door_type[back_door_count] = door_type
				    end
				    if back_door_string.count(";") == 4
              back_door_extension[back_door_count] = back_door_items[4]
            end
					end
					back_door_folding_level = door_folding_level
					back_door_allowed[back_door_count] = 1
          if back_door_position[back_door_count] + back_door_width[back_door_count] > full_width
            back_door_allowed[back_door_count] = 0
          end
					for step in 0..back_door_count - 1
					  if back_door_allowed[step] == 1
              if back_door_position[step] > back_door_position[back_door_count] and back_door_position[step] < back_door_position[back_door_count] + back_door_width[back_door_count]
                back_door_allowed[back_door_count] = 0
              end
              if back_door_position[step] + back_door_width[step] > back_door_position[back_door_count] and back_door_position[step] + back_door_width[step] < back_door_position[back_door_count] + back_door_width[back_door_count]
                back_door_allowed[back_door_count] = 0
              end
            end
					end
					back_door_count += 1
				end
			end
			
			# Cross beams
			if extension_types[step] == "CB" and cross_beam_set == 0
				cross_beam_string = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1]
				if cross_beam_string.count(";") == 2
					cross_beam_items = cross_beam_string.split(";")
					cross_beam_thickness = cross_beam_items[0].to_f / $inch
					cross_beam_width = cross_beam_items[1].to_f / $inch
					cross_beam_texture = cross_beam_items[2]
					cross_beam_set = 1
				end
			end
			
			# Windows
			if extension_types[step] == "W"
				window_string = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1]
				if window_string.count(";") >= 4
					window_failed = 0
					window_items = window_string.split(";")
					if window_items[0].count("x") == 1
						window_details = window_items[0].split("x")
						window_x_pos[window_count] = window_details[0].to_f / $inch
						window_y_pos[window_count] = window_details[1].to_f / $inch
						if window_y_pos[window_count] >= internal_height
							window_failed = 1
						end
					else
						window_failed = 1
					end
					if window_items[1].count("x") == 1
						window_details = window_items[1].split("x")
						window_x_size[window_count] = window_details[0].to_f / $inch
						window_y_size[window_count] = window_details[1].to_f / $inch
						if window_y_size[window_count] + window_y_pos[window_count] > internal_height and window_failed == 0
							window_y_size[window_count] = internal_height - window_y_pos[window_count]
						end
					else
						window_failed = 1
					end
					if window_items[3].count("/") > 0
						window_details = window_items[3].split("/")
						window_texture[window_count] = window_details[0]
						window_back_texture[window_count] = window_details[1]
					else
						window_texture[window_count] = window_items[3]
						window_back_texture[window_count] = window_items[3]
					end	
					window_transparency[window_count] = window_items[4].to_i
					if window_transparency[window_count] < 0
						window_transparency[window_count] = 0
					elsif window_transparency[window_count] > 100
						window_transparency[window_count] = 100
					end
					
					window_wall[window_count] = window_items[2]
					if window_wall[window_count] != "F" and window_wall[window_count] != "B" and window_wall[window_count] != "R" and window_wall[window_count] != "L" and window_wall[window_count][0..0] != "T"
						window_failed = 1
					end
					if window_string.count(";") == 6
						window_repeat[window_count] = window_items[5].to_i
						window_gap[window_count] = window_items[6].to_f / $inch
					else
						window_repeat[window_count] = 1
						window_gap[window_count] = 0
					end
					if window_failed == 0
						cross_beam_exclusion_side[cross_beam_exclusion_count] = window_wall[window_count]
						cross_beam_exclusions[cross_beam_exclusion_count] = [window_x_pos[window_count], window_y_pos[window_count], window_x_pos[window_count] + window_x_size[window_count], window_y_pos[window_count] + window_y_size[window_count]]
						cross_beam_extras_drawn[cross_beam_exclusion_count] = 0
						cross_beam_exclusion_count = cross_beam_exclusion_count + 1
						window_count = window_count + 1
						
					end
				end
			end
			
			# Roof windows
			if extension_types[step] == "RW"
				roof_window_string = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1]
				if roof_window_string.count(";") >= 4
					roof_window_failed = 0
					roof_window_items = roof_window_string.split(";")
					if roof_window_items[0].count("x") == 1
						roof_window_details = roof_window_items[0].split("x")
						roof_window_x_pos[roof_window_count] = roof_window_details[0].to_f / $inch
						roof_window_y_pos[roof_window_count] = roof_window_details[1].to_f / $inch
						if roof_window_y_pos[roof_window_count] >= full_width / 2 - wall_thickness
							roof_window_failed = 1
						end
					else
						roof_window_failed = 1
					end
					if roof_window_items[1].count("x") == 1
						roof_window_details = roof_window_items[1].split("x")
						roof_window_x_size[roof_window_count] = roof_window_details[0].to_f / $inch
						roof_window_y_size[roof_window_count] = roof_window_details[1].to_f / $inch
						if roof_window_y_size[roof_window_count] + roof_window_y_pos[roof_window_count] > full_width / 2 - wall_thickness and roof_window_failed == 0
							roof_window_y_size[roof_window_count] = full_width / 2 - roof_window_y_pos[roof_window_count] - wall_thickness
						end
					else
						roof_window_failed = 1
					end
					if roof_window_items[3].count("/") > 0
						roof_window_details = roof_window_items[3].split("/")
						roof_window_texture[roof_window_count] = roof_window_details[0]
						roof_window_back_texture[roof_window_count] = roof_window_details[1]
					else
						roof_window_texture[roof_window_count] = roof_window_items[3]
						roof_window_back_texture[roof_window_count] = roof_window_items[3]
					end	
					roof_window_transparency[roof_window_count] = roof_window_items[4].to_i
					if roof_window_transparency[roof_window_count] < 0
						roof_window_transparency[roof_window_count] = 0
					elsif roof_window_transparency[roof_window_count] > 100
						roof_window_transparency[roof_window_count] = 100
					end
					
					roof_window_side[roof_window_count] = roof_window_items[2]
					if roof_window_side[roof_window_count] != "R" and roof_window_side[roof_window_count] != "L"
						roof_window_failed = 1
					end
					if roof_window_string.count(";") == 6
						roof_window_repeat[roof_window_count] = roof_window_items[5].to_i
						roof_window_gap[roof_window_count] = roof_window_items[6].to_f / $inch
					else
						roof_window_repeat[roof_window_count] = 1
						roof_window_gap[roof_window_count] = 0
					end
					if roof_window_failed == 0
						roof_window_count = roof_window_count + 1
					end
				end
			end
		
			# Signage
			if extension_types[step] == "S"
				sign_string = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1]
				if sign_string.count(";") >= 3
					sign_failed = 0
					sign_details = sign_string.split(";")
					sign_type[sign_count] = sign_details[0]
					if sign_details[1].count("x") == 1
						sign_temp_string = sign_details[1].split("x")
						sign_x_pos[sign_count] = sign_temp_string[0].to_f / $inch
						sign_y_pos[sign_count] = sign_temp_string[1].to_f / $inch
					else
						sign_failed = 1
					end
					if sign_details[2].count("x") == 2
						sign_temp_string = sign_details[2].split("x")
						sign_x_size[sign_count] = sign_temp_string[0].to_f / $inch
						sign_y_size[sign_count] = sign_temp_string[1].to_f / $inch
						sign_thickness[sign_count] = sign_temp_string[2].to_f / $inch
					else
						sign_failed = 1
					end
					sign_wall[sign_count] = sign_details[3]
					if sign_type[sign_count] == "L" and sign_string.count(";") == 6
						sign_texture[sign_count] = sign_details[4]
						sign_filled[sign_count] = sign_details[5].to_i
						sign_double_sided[sign_count] = sign_details[6].to_i
					
					else
						sign_failed = 1
					end
					
					if sign_failed == 0
						sign_count = sign_count + 1
					end
				end
			end
			
			# Entrance doors
			if extension_types[step] == "ED"
			  entrance_doors[entrance_door_count] = entrance_door_info(extensions[step])
			  if entrance_doors[entrance_door_count] != false
          cross_beam_exclusion_side[cross_beam_exclusion_count] = entrance_doors[entrance_door_count][9]
          cross_beam_exclusions[cross_beam_exclusion_count] = entrance_doors[entrance_door_count][10]
          cross_beam_extras_drawn[cross_beam_exclusion_count] = 0
          cross_beam_exclusion_count = cross_beam_exclusion_count + 1
          entrance_door_count = entrance_door_count + 1
 				end
			end

			# Hangar door extensions
			if extension_types[step] == "HD"
				hangar_door_string = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1]
				if hangar_door_string.count(";") == 1
					hangar_door_info = hangar_door_string.split(";")
					hangar_door_id = hangar_door_info[0].to_i
					if hangar_door_extension[hangar_door_id].to_s == ""
						hangar_door_extension[hangar_door_id] = hangar_door_info[1]
					else
						hangar_door_extension[hangar_door_id] = hangar_door_extension[hangar_door_id].to_s + "|" + hangar_door_info[1].to_s
					end
				
				end
			end
			
			# Foundation wall
			if extension_types[step] == "FW"
				foundation_wall_string = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1]
				if foundation_wall_string.count(";") == 2
					foundation_wall_info = foundation_wall_string.split(";")
					foundation_wall_height = foundation_wall_info[0].to_f / $inch
					foundation_wall_thickness = foundation_wall_info[1].to_f / $inch
					foundation_wall_texture = foundation_wall_info[2]
					
					if foundation_wall_thickness < wall_thickness
						foundation_wall_thickness = wall_thickness
					end
				end
			end
			
			# UV Mapping
			if extension_types[step] == "UV"
				uv_map_string = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1]
				if uv_map_string.count(";") == 6
					uv_map_info = uv_map_string.split(";")
					uv_map_x_pos[uv_map_count] = uv_map_info[0].to_f / $inch
					uv_map_y_pos[uv_map_count] = uv_map_info[1].to_f / $inch
					uv_map_x_size[uv_map_count] = uv_map_info[2].to_f / $inch
					uv_map_y_size[uv_map_count] = uv_map_info[3].to_f / $inch
					uv_map_texture[uv_map_count] = uv_map_info[4]
					uv_map_wall[uv_map_count] = uv_map_info[5]
					uv_map_rotation[uv_map_count] = uv_map_info[6].to_f
					uv_map_count = uv_map_count + 1
				end
			end

			if extension_types[step] == "LH"
				hangar_left_extension = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1].to_f / $inch
			end
			if extension_types[step] == "RH"
				hangar_right_extension = extensions[step][extensions[step].index("(") + 1..extensions[step].index(")") - 1].to_f / $inch
			end
			if extension_types[step] == "X"
				super_detailed = 1
				beam_type = "New H"
				total_beam_size = (beam_width + (beam_thickness * 3)) * beams
				spacing_total = angle[4] - total_beam_size - (wall_thickness * 2)
				spacing = spacing_total / (beams - 1)
				fullbeam_size = beam_width + (beam_thickness * 3)
				full_length = (spacing *(beams - 1)) +(beams * fullbeam_size)
				beam_depth = beam_width + (beam_thickness * 2)
				start_beam_size = fullbeam_size - beam_thickness
			end

			if door_found == 1 and door_set == 0
			
				current_extension = []
				current_extension_step = []
				if extensions[step].count(',') > 0
					current_extension = extensions[step].split(",")
					
					for ext_step in 0..current_extension.length - 1
						if current_extension[ext_step].count('(') > 0 and current_extension[ext_step].count(')') > 0
							current_extension_step[ext_step] = current_extension[ext_step][0..current_extension[ext_step].index("(") - 1]
						end
						if current_extension_step[ext_step] == "C"
							if current_extension[ext_step].count('x') > 0
								door_tail_height =(current_extension[ext_step][current_extension[ext_step].index("x") + 1..current_extension[ext_step].index(")") - 1].to_f) / $inch
								door_tail_width =(current_extension[ext_step][current_extension[ext_step].index("(") + 1..current_extension[ext_step].index("x") - 1].to_f) / $inch
								door_set = 1
							
							end
						end
					end
				end
				door_found = 0			
			end
		end
	end

	

######################
#### Add textures ####
######################

## echo "Add textures"

if cross_beam_texture == ""
	cross_beam_texture = beam_texture
end
if foundation_wall_texture == ""
	foundation_wall_texture = wall_texture
end
	
material_added = []

for step in 0..$texture_name.length - 1
	material_added[step] = 0
end

for step in 0..$texture_name.length - 1
	if wall_texture == $texture_name[step] or roof_texture == $texture_name[step] or door_texture == $texture_name[step] or floor_texture == $texture_name[step] or beam_texture == $texture_name[step] or door_frame_texture == $texture_name[step] or internal_wall_texture == $texture_name[step] or cross_beam_texture == $texture_name[step] or ceiling_texture == $texture_name[step] or foundation_wall_texture == $texture_name[step]
		texture = materials.add $texture_name[step]
    if $texture_filename[step].count(":") === 0
      texture.texture = $texture_files + $texture_filename[step]
    else
      texture.texture = $texture_filename[step]
    end
	  texture.texture.size = [$texture_x_size[step] / $inch * $unit_multiplier, $texture_y_size[step] / $inch * $unit_multiplier]
		material_added[step] = 1
	end
end

if wall_texture == "Untextured" or ceiling_texture == "Untextured" or roof_texture == "Untextured" or door_texture == "Untextured" or floor_texture == "Untextured" or beam_texture == "Untextured" or door_frame_texture == "Untextured" or internal_wall_texture == "Untextured" or cross_beam_texture == "Untextured"
		texture = materials.add "Untextured"
		texture.color = "White"
end
	
width = beam_width
thickness = beam_thickness
	
##########################################
#### Set internal and external bounds ####
##########################################

roof_slope = arc / (full_width / 2)
beam_slope = roof_slope
roof_left_offset = hangar_left_extension * roof_slope
roof_right_offset = hangar_right_extension * roof_slope

internal_back_position = wall_thickness
internal_front_position = full_length + wall_thickness
internal_right_position = wall_thickness + full_width + hangar_right_extension
internal_left_position = wall_thickness - hangar_left_extension
internal_arc_position = wall_thickness + (full_width / 2)

internal_right_beam_position = wall_thickness + full_width #- beam_thickness * super_detailed
internal_left_beam_position = wall_thickness #+ beam_thickness * super_detailed

external_back_position = 0
external_front_position = full_length + (wall_thickness * 2)
external_right_position = (wall_thickness * 2) + full_width + hangar_right_extension
external_left_position = 0 - hangar_left_extension

door_left_position = door_middle - (door_width / 2)
door_right_position = door_left_position + door_width

if cross_beam_set == 0
	cross_beam_width = beam_width / 2
	cross_beam_thickness = beam_thickness
end

if foundation_wall_height > 0
	internal_foundation_wall_back_position = foundation_wall_thickness
	internal_foundation_wall_front_position = external_front_position - foundation_wall_thickness
	internal_foundation_wall_left_position = external_left_position + foundation_wall_thickness
	internal_foundation_wall_right_position = external_right_position - foundation_wall_thickness
end
if foundation_wall_thickness > wall_thickness
	beam_wall_ground_offset = foundation_wall_height
	if hangar_left_extension == 0
		beam_left_ground_offset = foundation_wall_height
	else
		beam_left_ground_offset = 0
	end
	if hangar_right_extension == 0
		beam_right_ground_offset = foundation_wall_height
	else
		beam_right_ground_offset = 0
	end
else
	beam_left_ground_offset = 0
	beam_right_ground_offset = 0
	beam_wall_ground_offset = 0
end


outside_height = height + wall_thickness - wall_thickness * roof_slope
full_roof_length = full_length + wall_thickness

if beam_type != "New H"
	internal_right_beam_position = internal_right_beam_position - beam_thickness
	internal_left_beam_position = internal_left_beam_position + beam_thickness
end


if beam_type == "Duo Pitch Truss"
  beam_group = duo_pitch_truss("Standard", "Pitched", beam_texture, wall_thickness.to_f, wall_thickness.to_f, beam_width.to_f, beam_depth.to_f, door_height.to_f, (internal_height - door_height - beam_depth).to_f, full_width.to_f, (full_length - wall_thickness).to_f, arc.to_f, beam_depth.to_f, beams.to_i, diagonal_beams.to_f)
elsif beam_type == "T"
  beam_group = t_beam("Standard", "Pitched", beam_texture, wall_thickness.to_f, wall_thickness.to_f, beam_width.to_f, beam_depth.to_f, beam_thickness.to_f, internal_height.to_f, arc.to_f, full_length.to_f, full_width.to_f, beams.to_i)
else


	beam_group = Sketchup.active_model.entities.add_group
	beam_group_ents = beam_group.entities


	# Loop beams
	for step in 1..beams

		# Draw beam profile
    if beam_type == "U"
			if step == 1 or step == beams
				pt1 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_left_beam_position, beam_wall_ground_offset]
			else
				pt1 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_left_beam_position, beam_left_ground_offset]
			end
			pt2 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_left_beam_position, height - cross_beam_width + beam_thickness * beam_slope]
			pt3 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_arc_position, height + arc - cross_beam_width]
			pt4 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_right_beam_position, height - cross_beam_width + beam_thickness * beam_slope]
			if step == 1 or step == beams
				pt5 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_right_beam_position, beam_wall_ground_offset]
			else
				pt5 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_right_beam_position, beam_right_ground_offset]
			end
			edges = beam_group_ents.add_edges pt1, pt2, pt3, pt4, pt5

			pt1 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)), internal_left_beam_position, beam_left_ground_offset]
			pt2 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) + fullbeam_size, internal_left_beam_position, beam_left_ground_offset]
			pt3 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) +((thickness + beam_width) * 2), internal_left_beam_position + thickness + beam_width, beam_left_ground_offset]
			pt4 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) +((beam_width * 2) + thickness), internal_left_beam_position + thickness + beam_width, beam_left_ground_offset]
			pt5 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) +((beam_width * 2) + thickness), internal_left_beam_position + thickness, beam_left_ground_offset]
			pt6 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) + thickness, internal_left_beam_position + thickness, beam_left_ground_offset]
			pt7 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) + thickness, internal_left_beam_position + thickness + beam_width, beam_left_ground_offset]
			pt8 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)), internal_left_beam_position + thickness + beam_width, beam_left_ground_offset]
			face = beam_group_ents.add_face pt1, pt2, pt3, pt4, pt5, pt6, pt7, pt8
			if face.normal[2] > 0
				status = face.reverse!
			end
			status = face.material = beam_texture
			# Draw beam
			fullbeam = face.followme edges
		elsif beam_type == "H"
			if step == 1 or step == beams
				pt1 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_left_beam_position, beam_wall_ground_offset]
			else
				pt1 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_left_beam_position, beam_left_ground_offset]
			end
			pt2 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_left_beam_position, height - cross_beam_width + beam_thickness * beam_slope]
			pt3 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_arc_position, height + arc - cross_beam_width]
			pt4 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_right_beam_position, height - cross_beam_width + beam_thickness * beam_slope]
			if step == 1 or step == beams
				pt5 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_right_beam_position, beam_wall_ground_offset]
			else
				pt5 = [internal_back_position + beam_thickness +(spacing + fullbeam_size) *(step - 1), internal_right_beam_position, beam_right_ground_offset]
			end
			edges = beam_group_ents.add_edges pt1, pt2, pt3, pt4, pt5

			pt1 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)), internal_left_beam_position, beam_left_ground_offset]
			pt2 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) + beam_width + thickness, internal_left_beam_position, beam_left_ground_offset]
			pt3 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) + beam_width + thickness, internal_left_beam_position + thickness, beam_left_ground_offset]
			pt4 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) +(beam_width/2) + thickness, internal_left_beam_position + thickness, beam_left_ground_offset]
			pt5 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) +(beam_width/2) + thickness, internal_left_beam_position + beam_width + thickness, beam_left_ground_offset]
			pt6 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) + beam_width + thickness, internal_left_beam_position + beam_width + thickness, beam_left_ground_offset]
			pt7 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) + beam_width + thickness, internal_left_beam_position + beam_width +(thickness * 2), beam_left_ground_offset]
			pt8 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)), internal_left_beam_position + beam_width +(thickness * 2), beam_left_ground_offset]
			pt9 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)), internal_left_beam_position + beam_width + thickness, beam_left_ground_offset]
			pt10 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) +(beam_width/2), internal_left_beam_position + beam_width + thickness, beam_left_ground_offset]
			pt11 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)) +(beam_width/2), internal_left_beam_position + thickness, beam_left_ground_offset]
			pt12 = [internal_back_position + beam_thickness +((spacing + fullbeam_size) *(step - 1)), internal_left_beam_position + thickness, beam_left_ground_offset]

			face = beam_group_ents.add_face pt1, pt2, pt3, pt4, pt5, pt6, pt7, pt8, pt9, pt10, pt11, pt12
			if face.normal[2] > 0
				status = face.reverse!
			end
			status = face.material = beam_texture
			# Draw beam
			fullbeam = face.followme edges
		elsif beam_type == "New T"
			if step == 1
				pts = []
				pts[0] = [internal_back_position + beam_width + beam_thickness * 2, internal_left_beam_position, beam_wall_ground_offset]
				pts[1] = [internal_back_position + beam_width + beam_thickness * 2, internal_left_beam_position + beam_thickness, beam_wall_ground_offset]
				pts[2] = [internal_back_position + beam_thickness * 2, internal_left_beam_position + beam_thickness, beam_wall_ground_offset]
				pts[3] = [internal_back_position + beam_thickness * 2, internal_left_beam_position + beam_width + beam_thickness, beam_wall_ground_offset]
				pts[4] = [internal_back_position + beam_thickness, internal_left_beam_position + beam_width + beam_thickness, beam_wall_ground_offset]
				pts[5] = [internal_back_position + beam_thickness, internal_left_beam_position, beam_wall_ground_offset]
				
				pts[6] = [internal_back_position + beam_width + beam_thickness * 2, internal_left_beam_position, internal_height - cross_beam_width]
				pts[7] = [internal_back_position + beam_width + beam_thickness * 2, internal_left_beam_position + beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[8] = [internal_back_position + beam_thickness * 2, internal_left_beam_position + beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[9] = [internal_back_position + beam_thickness * 2, internal_left_beam_position +(beam_width * 2) + beam_thickness, internal_height - cross_beam_width - beam_width]
				pts[10] = [internal_back_position + beam_thickness, internal_left_beam_position +(beam_width * 2) + beam_thickness, internal_height - cross_beam_width - beam_width]
				pts[11] = [internal_back_position + beam_thickness, internal_left_beam_position, internal_height - cross_beam_width]

				pts[12] = [internal_back_position + beam_width + beam_thickness * 2, internal_arc_position, internal_height + arc - cross_beam_width]
				pts[13] = [internal_back_position + beam_width + beam_thickness * 2, internal_arc_position, internal_height + arc - cross_beam_width - beam_thickness]
				pts[14] = [internal_back_position + beam_thickness * 2, internal_arc_position, internal_height + arc - cross_beam_width - beam_thickness]
				pts[15] = [internal_back_position + beam_thickness * 2, internal_arc_position, internal_height + arc - cross_beam_width - beam_thickness - beam_width]
				pts[16] = [internal_back_position + beam_thickness, internal_arc_position, internal_height + arc - cross_beam_width - beam_thickness - beam_width]
				pts[17] = [internal_back_position + beam_thickness, internal_arc_position, internal_height + arc - cross_beam_width]

				pts[18] = [internal_back_position + beam_width + beam_thickness * 2, internal_right_beam_position, internal_height - cross_beam_width]
				pts[19] = [internal_back_position + beam_width + beam_thickness * 2, internal_right_beam_position - beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[20] = [internal_back_position + beam_thickness * 2, internal_right_beam_position - beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[21] = [internal_back_position + beam_thickness * 2, internal_right_beam_position -(beam_width * 2) - beam_thickness, internal_height - cross_beam_width - beam_width]
				pts[22] = [internal_back_position + beam_thickness, internal_right_beam_position -(beam_width * 2) - beam_thickness, internal_height - cross_beam_width - beam_width]
				pts[23] = [internal_back_position + beam_thickness, internal_right_beam_position, internal_height - cross_beam_width]
				
				pts[24] = [internal_back_position + beam_width + beam_thickness * 2, internal_right_beam_position, beam_wall_ground_offset]
				pts[25] = [internal_back_position + beam_width + beam_thickness * 2, internal_right_beam_position - beam_thickness, beam_wall_ground_offset]
				pts[26] = [internal_back_position + beam_thickness * 2, internal_right_beam_position - beam_thickness, beam_wall_ground_offset]
				pts[27] = [internal_back_position + beam_thickness * 2, internal_right_beam_position - beam_width - beam_thickness, beam_wall_ground_offset]
				pts[28] = [internal_back_position + beam_thickness, internal_right_beam_position - beam_width - beam_thickness, beam_wall_ground_offset]
				pts[29] = [internal_back_position + beam_thickness, internal_right_beam_position, beam_wall_ground_offset]
				
				for beam_section_step in 0..3
					for face_step in 0..4
						face = beam_group_ents.add_face pts[face_step + beam_section_step * 6], pts[face_step + beam_section_step * 6 + 1], pts[face_step + beam_section_step * 6 + 7], pts[face_step + beam_section_step * 6 + 6]
						status = face.material = beam_texture
					end
						face = beam_group_ents.add_face pts[beam_section_step * 6], pts[beam_section_step * 6 + 5], pts[beam_section_step * 6 + 11], pts[beam_section_step * 6 + 6]
						status = face.material = beam_texture
				end
				
			elsif step == beams
				pts = []
				pts[0] = [internal_front_position - beam_width - beam_thickness * 2, internal_left_beam_position, beam_wall_ground_offset]
				pts[1] = [internal_front_position - beam_width - beam_thickness * 2, internal_left_beam_position + beam_thickness, beam_wall_ground_offset]
				pts[2] = [internal_front_position - beam_thickness * 2, internal_left_beam_position + beam_thickness, beam_wall_ground_offset]
				pts[3] = [internal_front_position - beam_thickness * 2, internal_left_beam_position + beam_width + beam_thickness, beam_wall_ground_offset]
				pts[4] = [internal_front_position - beam_thickness, internal_left_beam_position + beam_width + beam_thickness, beam_wall_ground_offset]
				pts[5] = [internal_front_position - beam_thickness, internal_left_beam_position, beam_wall_ground_offset]
				
				pts[6] = [internal_front_position - beam_width - beam_thickness * 2, internal_left_beam_position, internal_height - cross_beam_width]
				pts[7] = [internal_front_position - beam_width - beam_thickness * 2, internal_left_beam_position + beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[8] = [internal_front_position - beam_thickness * 2, internal_left_beam_position + beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[9] = [internal_front_position - beam_thickness * 2, internal_left_beam_position +(beam_width * 2) + beam_thickness, internal_height - cross_beam_width - beam_width]
				pts[10] = [internal_front_position - beam_thickness, internal_left_beam_position +(beam_width * 2) + beam_thickness, internal_height - cross_beam_width - beam_width]
				pts[11] = [internal_front_position - beam_thickness, internal_left_beam_position, internal_height - cross_beam_width]

				pts[12] = [internal_front_position - beam_width - beam_thickness * 2, internal_arc_position, internal_height + arc - cross_beam_width]
				pts[13] = [internal_front_position - beam_width - beam_thickness * 2, internal_arc_position, internal_height + arc - cross_beam_width - beam_thickness]
				pts[14] = [internal_front_position - beam_thickness * 2, internal_arc_position, internal_height + arc - cross_beam_width - beam_thickness]
				pts[15] = [internal_front_position - beam_thickness * 2, internal_arc_position, internal_height + arc - cross_beam_width - beam_thickness - beam_width]
				pts[16] = [internal_front_position - beam_thickness, internal_arc_position, internal_height + arc - cross_beam_width - beam_thickness - beam_width]
				pts[17] = [internal_front_position - beam_thickness, internal_arc_position, internal_height + arc - cross_beam_width]

				pts[18] = [internal_front_position - beam_width - beam_thickness * 2, internal_right_beam_position, internal_height - cross_beam_width]
				pts[19] = [internal_front_position - beam_width - beam_thickness * 2, internal_right_beam_position - beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[20] = [internal_front_position - beam_thickness * 2, internal_right_beam_position - beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[21] = [internal_front_position - beam_thickness * 2, internal_right_beam_position -(beam_width * 2) - beam_thickness, internal_height - cross_beam_width - beam_width]
				pts[22] = [internal_front_position - beam_thickness, internal_right_beam_position -(beam_width * 2) - beam_thickness, internal_height - cross_beam_width - beam_width]
				pts[23] = [internal_front_position - beam_thickness, internal_right_beam_position, internal_height - cross_beam_width]

				pts[24] = [internal_front_position - beam_width - beam_thickness * 2, internal_right_beam_position, beam_wall_ground_offset]
				pts[25] = [internal_front_position - beam_width - beam_thickness * 2, internal_right_beam_position - beam_thickness, beam_wall_ground_offset]
				pts[26] = [internal_front_position - beam_thickness * 2, internal_right_beam_position - beam_thickness, beam_wall_ground_offset]
				pts[27] = [internal_front_position - beam_thickness * 2, internal_right_beam_position - beam_width - beam_thickness, beam_wall_ground_offset]
				pts[28] = [internal_front_position - beam_thickness, internal_right_beam_position - beam_width - beam_thickness, beam_wall_ground_offset]
				pts[29] = [internal_front_position - beam_thickness, internal_right_beam_position, beam_wall_ground_offset]

				for beam_section_step in 0..3
					for face_step in 0..4
						face = beam_group_ents.add_face pts[face_step + beam_section_step * 6], pts[face_step + beam_section_step * 6 + 1], pts[face_step + beam_section_step * 6 + 7], pts[face_step + beam_section_step * 6 + 6]
						if face_step == 0 and beam_section_step == 0
							status = face.reverse!
						end
						status = face.material = beam_texture
					end
					face = beam_group_ents.add_face pts[beam_section_step * 6], pts[beam_section_step * 6 + 5], pts[beam_section_step * 6 + 11], pts[beam_section_step * 6 + 6]
					status = face.material = beam_texture
				end

			else
				pts = []
				pts[0] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_left_beam_position, beam_left_ground_offset]
				pts[1] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_left_beam_position, beam_left_ground_offset]
				pts[2] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_left_beam_position + beam_thickness, beam_left_ground_offset]
				pts[3] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_left_beam_position + beam_thickness, beam_left_ground_offset]
				pts[4] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_left_beam_position + beam_width + beam_thickness, beam_left_ground_offset]
				pts[5] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_left_beam_position + beam_width + beam_thickness, beam_left_ground_offset]
				pts[6] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_left_beam_position + beam_thickness, beam_left_ground_offset]
				pts[7] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_left_beam_position + beam_thickness, beam_left_ground_offset]

				pts[8] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_left_beam_position, internal_height - cross_beam_width]
				pts[9] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_left_beam_position, internal_height - cross_beam_width]
				pts[10] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_left_beam_position + beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[11] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_left_beam_position + beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[12] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_left_beam_position +(beam_width * 2) + beam_thickness, internal_height - beam_width - cross_beam_width]
				pts[13] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_left_beam_position +(beam_width * 2) + beam_thickness, internal_height - beam_width - cross_beam_width]
				pts[14] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_left_beam_position + beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[15] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_left_beam_position + beam_thickness, internal_height - beam_thickness - cross_beam_width]

				pts[16] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_arc_position, height + arc - cross_beam_width]
				pts[17] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_arc_position, height + arc - cross_beam_width]
				pts[18] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_arc_position, height + arc - cross_beam_width - beam_thickness]
				pts[19] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_arc_position, height + arc - cross_beam_width - beam_thickness]
				pts[20] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_arc_position, height + arc - cross_beam_width - beam_thickness - beam_width]
				pts[21] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_arc_position, height + arc - cross_beam_width - beam_thickness - beam_width]
				pts[22] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_arc_position, height + arc - cross_beam_width - beam_thickness]
				pts[23] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_arc_position, height + arc - cross_beam_width - beam_thickness]

				pts[24] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_right_beam_position, internal_height - cross_beam_width]
				pts[25] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_right_beam_position, internal_height - cross_beam_width]
				pts[26] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_right_beam_position - beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[27] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_right_beam_position - beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[28] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_right_beam_position -(beam_width * 2) - beam_thickness, internal_height - beam_width - cross_beam_width]
				pts[29] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_right_beam_position -(beam_width * 2) - beam_thickness, internal_height - beam_width - cross_beam_width]
				pts[30] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_right_beam_position - beam_thickness, internal_height - beam_thickness - cross_beam_width]
				pts[31] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_right_beam_position - beam_thickness, internal_height - beam_thickness - cross_beam_width]

				pts[32] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_right_beam_position, beam_right_ground_offset]
				pts[33] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_right_beam_position, beam_right_ground_offset]
				pts[34] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width +(beam_width * 2) + beam_thickness, internal_right_beam_position - beam_thickness, beam_right_ground_offset]
				pts[35] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_right_beam_position - beam_thickness, beam_right_ground_offset]
				pts[36] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width + beam_thickness, internal_right_beam_position - beam_width - beam_thickness, beam_right_ground_offset]
				pts[37] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_right_beam_position - beam_width - beam_thickness, beam_right_ground_offset]
				pts[38] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width + beam_width, internal_right_beam_position - beam_thickness, beam_right_ground_offset]
				pts[39] = [internal_back_position + beam_thickness +((spacing +((beam_width * 2) + beam_thickness)) *(step - 1)) - beam_width, internal_right_beam_position - beam_thickness, beam_right_ground_offset]

				for beam_section_step in 0..3
					for face_step in 0..6
						face = beam_group_ents.add_face pts[face_step + beam_section_step * 8], pts[face_step + beam_section_step * 8 + 1], pts[face_step + beam_section_step * 8 + 9], pts[face_step + beam_section_step * 8 + 8]
						status = face.material = beam_texture
					end
					face = beam_group_ents.add_face pts[beam_section_step * 8], pts[beam_section_step * 8 + 7], pts[beam_section_step * 8 + 15], pts[beam_section_step * 8 + 8]
					status = face.material = beam_texture
				end

			end			
		elsif beam_type == "New H"
			for side_step in 0..1
				side_step_index = 1 - side_step * 2
				
				if side_step == 0
					beam_start = internal_left_beam_position + beam_thickness
					beam_base_start = internal_left_beam_position
					beam_extension_start = internal_left_position
					beam_extension_offset = hangar_left_extension
					beam_extension_hor_height = internal_height - cross_beam_width -(hangar_left_extension - beam_thickness * 2) * beam_slope
					beam_extension_top = internal_height - cross_beam_width - beam_thickness -(hangar_left_extension - beam_thickness) * beam_slope
					beam_extension_top_plate = internal_height - cross_beam_width -(hangar_left_extension - beam_thickness) * beam_slope
					extension_roof_offset = roof_left_offset
				else
					beam_start = internal_right_beam_position - beam_thickness
					beam_base_start = internal_right_beam_position
					beam_extension_start = internal_right_position
					beam_extension_offset = hangar_right_extension
					beam_extension_top = internal_height - cross_beam_width - beam_thickness -(hangar_right_extension - beam_thickness) * beam_slope
					beam_extension_top_plate = internal_height - cross_beam_width -(hangar_right_extension - beam_thickness) * beam_slope
					beam_extension_hor_height = internal_height - cross_beam_width -(hangar_right_extension - beam_thickness * 2) * beam_slope
					extension_roof_offset = roof_right_offset
				end
				if beam_extension_offset > 150 / $inch
					beam_side_count = 1
				else
					beam_side_count = 0
				end
				
				#Base
				beam_base_width = fullbeam_size + beam_thickness
				for beam_side_step in 0..beam_side_count
					if step == 1 or step == beams or beam_side_step == 1
						beam_base_ground_offset = beam_wall_ground_offset
					else
						if side_step == 0
							beam_base_ground_offset = beam_left_ground_offset
						else
							beam_base_ground_offset = beam_right_ground_offset
						end
					end
					beam_base_start_pos = beam_base_start -(((beam_extension_offset * beam_side_step) * side_step_index))
					pts = []
					pts[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_base_start_pos, beam_base_ground_offset]
					pts[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_base_start_pos +(beam_base_width * side_step_index), beam_base_ground_offset]
					pts[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size, beam_base_start_pos +(beam_base_width * side_step_index), beam_base_ground_offset]
					pts[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size, beam_base_start_pos, beam_base_ground_offset]
					pts[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_base_start_pos, beam_base_ground_offset + beam_thickness]
					pts[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_base_start_pos +(beam_base_width * side_step_index), beam_base_ground_offset + beam_thickness]
					pts[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size, beam_base_start_pos +(beam_base_width * side_step_index), beam_base_ground_offset + beam_thickness]
					pts[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size, beam_base_start_pos, beam_base_ground_offset + beam_thickness]
				
					face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
					if side_step == 0
						status = face.reverse!
					end
					status = face.material = beam_texture
					face = beam_group_ents.add_face pts[1], pts[2], pts[6], pts[5]
					status = face.material = beam_texture
					if step != 1
						face = beam_group_ents.add_face pts[0], pts[1], pts[5], pts[4]
						status = face.material = beam_texture
					end
					if step != beams
						face = beam_group_ents.add_face pts[2], pts[3], pts[7], pts[6]
						status = face.material = beam_texture
					end
				
					if(side_step == 0 and hangar_left_extension > 0) or(side_step == 1 and hangar_right_extension > 0)
						face = beam_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
						status = face.material = beam_texture
					end
				
				end

				if step == 1 or step == beams
						beam_base_ground_offset = beam_wall_ground_offset
				else
					if side_step == 0
						beam_base_ground_offset = beam_left_ground_offset
					else
						beam_base_ground_offset = beam_right_ground_offset
					end
				end
				
				#Upright
				pts = []
				pts[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start, beam_base_ground_offset + beam_thickness]
				pts[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +(beam_thickness * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +(beam_thickness * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +((beam_thickness + beam_width) * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness + beam_width) * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness * 2 + beam_width) * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness * 2 + beam_width) * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness + beam_width) * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[8] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +((beam_thickness + beam_width) * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[9] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +(beam_thickness * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[10] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +(beam_thickness * side_step_index), beam_base_ground_offset + beam_thickness]
				pts[11] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start, beam_base_ground_offset + beam_thickness]

				beam_top = internal_height - beam_thickness - cross_beam_width - fullbeam_size

				pts[12] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start, beam_top]
				pts[13] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +(beam_thickness * side_step_index), beam_top]
				pts[14] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +(beam_thickness * side_step_index), beam_top]
				pts[15] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +((beam_thickness + beam_width * 2) * side_step_index), beam_top]
				pts[16] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness + beam_width * 2) * side_step_index), beam_top]
				pts[17] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top]
				pts[18] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top]
				pts[19] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness + beam_width * 2) * side_step_index), beam_top]
				pts[20] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +((beam_thickness + beam_width * 2) * side_step_index), beam_top]
				pts[21] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +(beam_thickness * side_step_index), beam_top]
				pts[22] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +(beam_thickness * side_step_index), beam_top]
				pts[23] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start, beam_top]

				for beam_step in 0..10
					face = beam_group_ents.add_face pts[beam_step], pts[beam_step + 1], pts[beam_step + 13], pts[beam_step + 12]
					if side_step == 0 and beam_step == 0
						status = face.reverse!
					end
					status = face.material = beam_texture
				end 
						
				pts[24] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start, beam_top + beam_thickness]
				pts[25] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top + beam_thickness]
				pts[26] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top + beam_thickness]
				pts[27] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start, beam_top + beam_thickness]

				face = beam_group_ents.add_face pts[12], pts[17], pts[18], pts[23]
				status = face.reverse!
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[17], pts[18], pts[26], pts[25]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[12], pts[17], pts[25], pts[24]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[18], pts[23], pts[27], pts[26]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[24], pts[25], pts[26], pts[27]
				status = face.material = beam_texture

				face = beam_group_ents.add_face pts[0], pts[11], pts[23], pts[12]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[24], pts[27], pts[23], pts[12]
				status = face.material = beam_texture

				#Horizontal
				pts = []
				pts[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start, beam_top + beam_thickness]
				pts[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top + beam_thickness]
				pts[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc -(beam_thickness * 2) - beam_width - cross_beam_width]
				pts[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - beam_thickness - beam_width - cross_beam_width]
				pts[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top + beam_thickness * 2]
				pts[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +(beam_thickness * side_step_index), beam_top + beam_thickness * 2]
				pts[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +(beam_thickness * side_step_index), internal_height - beam_thickness - cross_beam_width + beam_thickness * beam_slope * 2]
				pts[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - beam_thickness - cross_beam_width - beam_thickness * beam_slope]
				pts[8] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - cross_beam_width - beam_thickness * beam_slope]
                                pts[9] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start, internal_height - cross_beam_width + beam_thickness * beam_slope]
				face = beam_group_ents.add_face pts
				status = face.material = beam_texture
				pts[10] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness + beam_width * 2) * side_step_index), beam_top + beam_thickness * 2]
				pts[11] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness + beam_width * 2) * side_step_index), internal_height - beam_thickness - cross_beam_width +(beam_thickness * 2 + beam_width * 2) * beam_slope]
				pts[12] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), internal_height - beam_thickness - cross_beam_width +(beam_thickness * 3 + beam_width * 2) * beam_slope]

				pts[13] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +((beam_thickness + beam_width * 2) * side_step_index), beam_top + beam_thickness * 2]
				pts[14] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +(beam_thickness * side_step_index), beam_top + beam_thickness * 2]
				pts[15] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +(beam_thickness * side_step_index), internal_height - beam_thickness - cross_beam_width + beam_thickness * beam_slope * 2]
				pts[16] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +((beam_thickness + beam_width * 2) * side_step_index), internal_height - beam_thickness - cross_beam_width +(beam_thickness * 2 + beam_width * 2) * beam_slope]

				pts[17] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top + beam_thickness * 2]
				pts[18] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), internal_height - beam_thickness - cross_beam_width +(beam_thickness * 3 + beam_width * 2) * beam_slope]
				pts[19] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - beam_thickness - cross_beam_width - beam_thickness * beam_slope]
				pts[20] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - beam_thickness - beam_width - cross_beam_width]

				face = beam_group_ents.add_face pts[4], pts[10], pts[11], pts[12]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[10], pts[5], pts[14], pts[13]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[5], pts[6], pts[15], pts[14]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[6], pts[11], pts[16], pts[15]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[11], pts[10], pts[13], pts[16]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[13], pts[14], pts[15], pts[16]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[3], pts[4], pts[17], pts[20]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[4], pts[12], pts[18], pts[17]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[12], pts[7], pts[19], pts[18]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[17], pts[18], pts[19], pts[20]
				status = face.material = beam_texture

				ptsx = []
				ptsx[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start, beam_top + beam_thickness]
				ptsx[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top + beam_thickness]
				ptsx[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc -(beam_thickness * 2) - beam_width - cross_beam_width]
				ptsx[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - beam_thickness - beam_width - cross_beam_width]
				ptsx[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top + beam_thickness * 2]
				ptsx[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +(beam_thickness * side_step_index), beam_top + beam_thickness * 2]
				ptsx[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +(beam_thickness * side_step_index), internal_height - beam_thickness - cross_beam_width + beam_thickness * beam_slope * 2]
				ptsx[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - beam_thickness - cross_beam_width - beam_thickness * beam_slope]
				ptsx[8] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - cross_beam_width - beam_thickness * beam_slope]
				ptsx[9] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start, internal_height - cross_beam_width + beam_thickness * beam_slope]
				face = beam_group_ents.add_face ptsx
				status = face.material = beam_texture
				ptsx[10] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness + beam_width * 2) * side_step_index), beam_top + beam_thickness * 2]
				ptsx[11] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness + beam_width * 2) * side_step_index), internal_height - beam_thickness - cross_beam_width +(beam_thickness * 2 + beam_width * 2) * beam_slope]
				ptsx[12] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), internal_height - beam_thickness - cross_beam_width +(beam_thickness * 3 + beam_width * 2) * beam_slope]

				ptsx[13] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +((beam_thickness + beam_width * 2) * side_step_index), beam_top + beam_thickness * 2]
				ptsx[14] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +(beam_thickness * side_step_index), beam_top + beam_thickness * 2]
				ptsx[15] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +(beam_thickness * side_step_index), internal_height - beam_thickness - cross_beam_width + beam_thickness * beam_slope * 2]
				ptsx[16] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +((beam_thickness + beam_width * 2) * side_step_index), internal_height - beam_thickness - cross_beam_width +(beam_thickness * 2 + beam_width * 2) * beam_slope]

				ptsx[17] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), beam_top + beam_thickness * 2]
				ptsx[18] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_start +((beam_thickness * 2 + beam_width * 2) * side_step_index), internal_height - beam_thickness - cross_beam_width +(beam_thickness * 3 + beam_width * 2) * beam_slope]
				ptsx[19] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - beam_thickness - cross_beam_width - beam_thickness * beam_slope]
				ptsx[20] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, internal_arc_position -(beam_thickness * side_step_index), internal_height + arc - beam_thickness - beam_width - cross_beam_width]

				face = beam_group_ents.add_face ptsx[4], ptsx[10], ptsx[11], ptsx[12]
				status = face.material = beam_texture
				face = beam_group_ents.add_face ptsx[10], ptsx[5], ptsx[14], ptsx[13]
				status = face.material = beam_texture
				face = beam_group_ents.add_face ptsx[5], ptsx[6], ptsx[15], ptsx[14]
				status = face.material = beam_texture
				face = beam_group_ents.add_face ptsx[6], ptsx[11], ptsx[16], ptsx[15]
				status = face.material = beam_texture
				face = beam_group_ents.add_face ptsx[11], ptsx[10], ptsx[13], ptsx[16]
				status = face.material = beam_texture
				face = beam_group_ents.add_face ptsx[13], ptsx[14], ptsx[15], ptsx[16]
				status = face.material = beam_texture
				face = beam_group_ents.add_face ptsx[3], ptsx[4], ptsx[17], ptsx[20]
				status = face.material = beam_texture
				face = beam_group_ents.add_face ptsx[4], ptsx[12], ptsx[18], ptsx[17]
				status = face.material = beam_texture
				face = beam_group_ents.add_face ptsx[12], ptsx[7], ptsx[19], ptsx[18]
				status = face.material = beam_texture
				face = beam_group_ents.add_face ptsx[17], ptsx[18], ptsx[19], ptsx[20]
				status = face.material = beam_texture

				face = beam_group_ents.add_face pts[1], pts[2], ptsx[2], ptsx[1]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[8], pts[9], ptsx[9], ptsx[8]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[0], pts[9], ptsx[9], ptsx[0]
				status = face.material = beam_texture

				if beam_side_count == 1
				
					#Upright
					beam_extension_start = beam_extension_start +(beam_thickness * side_step_index)
					pts = []
					pts[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start, beam_wall_ground_offset + beam_thickness]
					pts[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start +(beam_thickness * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_extension_start +(beam_thickness * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_extension_start +((beam_thickness + beam_width) * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start +((beam_thickness + beam_width) * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start +((beam_thickness * 2 + beam_width) * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start +((beam_thickness * 2 + beam_width) * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start +((beam_thickness + beam_width) * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[8] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_extension_start +((beam_thickness + beam_width) * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[9] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_extension_start +(beam_thickness * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[10] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start +(beam_thickness * side_step_index), beam_wall_ground_offset + beam_thickness]
					pts[11] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start, beam_wall_ground_offset + beam_thickness]
			
					pts[12] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start, beam_extension_top]
					pts[13] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start +(beam_thickness * side_step_index), beam_extension_top + beam_thickness * beam_slope]
					pts[14] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_extension_start +(beam_thickness * side_step_index), beam_extension_top + beam_thickness * beam_slope]
					pts[15] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness + beam_width / 2, beam_extension_start +((beam_thickness + beam_width) * side_step_index), beam_extension_top +(beam_thickness + beam_width) * beam_slope]
					pts[16] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start +((beam_thickness + beam_width) * side_step_index), beam_extension_top +(beam_thickness + beam_width) * beam_slope]
					pts[17] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start +((beam_thickness * 2 + beam_width) * side_step_index), beam_extension_top +(beam_thickness * 2 + beam_width) * beam_slope]
					pts[18] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start +((beam_thickness * 2 + beam_width) * side_step_index), beam_extension_top +(beam_thickness * 2 + beam_width) * beam_slope]
					pts[19] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start +((beam_thickness + beam_width) * side_step_index), beam_extension_top +(beam_thickness + beam_width) * beam_slope]
					pts[20] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_extension_start +((beam_thickness + beam_width) * side_step_index), beam_extension_top +(beam_thickness + beam_width) * beam_slope]
					pts[21] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width / 2, beam_extension_start +(beam_thickness * side_step_index), beam_extension_top + beam_thickness * beam_slope]
					pts[22] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start +(beam_thickness * side_step_index), beam_extension_top + beam_thickness * beam_slope]
					pts[23] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start, beam_extension_top]
			
					pts[24] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start, beam_extension_top_plate]
					pts[25] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_extension_start +((beam_thickness * 2 + beam_width) * side_step_index), beam_extension_top_plate +(beam_thickness * 2 + beam_width) * beam_slope]
					pts[26] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start +((beam_thickness * 2 + beam_width) * side_step_index), beam_extension_top_plate +(beam_thickness * 2 + beam_width) * beam_slope]
					pts[27] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 2 + beam_width, beam_extension_start, beam_extension_top_plate]
	
		
					face = beam_group_ents.add_face pts[24], pts[27], pts[23], pts[12]
					status = face.material = beam_texture
			
					for beam_step in 0..10
						face = beam_group_ents.add_face pts[beam_step], pts[beam_step + 1], pts[beam_step + 13], pts[beam_step + 12]
						if side_step == 0 and beam_step == 0
							status = face.reverse!
						end
						status = face.material = beam_texture
					end 
					face = beam_group_ents.add_face pts[0], pts[11], pts[27], pts[24]
					if side_step == 0
						status = face.reverse!
					end
					status = face.material = beam_texture
					face = beam_group_ents.add_face pts[12], pts[17], pts[18], pts[23]
					status = face.reverse!
					status = face.material = beam_texture
					face = beam_group_ents.add_face pts[17], pts[18], pts[26], pts[25]
					status = face.material = beam_texture
					face = beam_group_ents.add_face pts[12], pts[17], pts[25], pts[24]
					status = face.material = beam_texture
					face = beam_group_ents.add_face pts[18], pts[23], pts[27], pts[26]
					status = face.material = beam_texture
					face = beam_group_ents.add_face pts[24], pts[25], pts[26], pts[27]
					status = face.material = beam_texture
					
					
					#Horizontal
					beam_extension_start = beam_extension_start +(beam_thickness * side_step_index)
					pts = []
					for beam_side_step in 0..1
						beam_side_step_index = 1 - beam_side_step * 2
						pts[0 + beam_side_step * 4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size / 2 + beam_side_step_index * beam_thickness / 2, beam_extension_start, internal_height - extension_roof_offset + beam_thickness * 2 * roof_slope]
#						pts[1 + beam_side_step * 4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size / 2 + beam_side_step_index * beam_thickness / 2, beam_extension_start, beam_extension_top + beam_thickness + beam_thickness * beam_slope]
						pts[1 + beam_side_step * 4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size / 2 + beam_side_step_index * beam_thickness / 2, beam_extension_start, beam_extension_hor_height]
						pts[2 + beam_side_step * 4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size / 2 + beam_side_step_index * beam_thickness / 2, beam_base_start + beam_width * side_step_index, internal_height - cross_beam_width + beam_width * beam_slope]
						pts[3 + beam_side_step * 4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size / 2 + beam_side_step_index * beam_thickness / 2, beam_base_start + beam_width * side_step_index, internal_height + beam_width * roof_slope]
					end
					face = beam_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
					if side_step == 1
						status = face.reverse!
					end
					status = face.material = beam_texture
					face = beam_group_ents.add_face pts[1], pts[2], pts[6], pts[5]
					status = face.material = beam_texture
					face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
					status = face.material = beam_texture
					if roof_window_count > 0
						face = beam_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
						if face.normal[2] < 0
							status = face.reverse!
						end
						status = face.material = beam_texture
					end

					if step < beams
						pts[13] = [internal_back_position +(spacing + fullbeam_size) * step + fullbeam_size / 2 - beam_thickness * 1.5, beam_base_start + beam_width * side_step_index, internal_height - cross_beam_width + beam_width * beam_slope]
						pts[14] = [internal_back_position +(spacing + fullbeam_size) * step + fullbeam_size / 2 - beam_thickness * 1.5, beam_base_start + beam_width * side_step_index, internal_height + beam_width * roof_slope]
						pts[15] = [internal_back_position +(spacing + fullbeam_size) * step + fullbeam_size / 2 - beam_thickness / 2, beam_base_start + beam_width * side_step_index, internal_height - cross_beam_width + beam_width * beam_slope]
						pts[16] = [internal_back_position +(spacing + fullbeam_size) * step + fullbeam_size / 2 - beam_thickness / 2, beam_base_start + beam_width * side_step_index, internal_height + beam_width * roof_slope]
						pts[17] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size / 2 + beam_thickness * 1.5, beam_extension_start, internal_height - extension_roof_offset + beam_thickness * 2 * roof_slope]
						pts[18] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size / 2 + beam_thickness * 1.5, beam_extension_start, beam_extension_hor_height]
						
						pts[19] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size / 2 + beam_thickness * 1.5, beam_base_start + beam_width * side_step_index, internal_height - cross_beam_width + beam_width * beam_slope]
						pts[20] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + fullbeam_size / 2 + beam_thickness * 1.5, beam_base_start + beam_width * side_step_index, internal_height + beam_width * roof_slope]
						pts[21] = [internal_back_position +(spacing + fullbeam_size) * step + fullbeam_size / 2 - beam_thickness / 2, beam_extension_start, internal_height - extension_roof_offset + beam_thickness * 2 * roof_slope]
						pts[22] = [internal_back_position +(spacing + fullbeam_size) * step + fullbeam_size / 2 - beam_thickness / 2, beam_extension_start, beam_extension_hor_height]
						pts[23] = [internal_back_position +(spacing + fullbeam_size) * step + fullbeam_size / 2 - beam_thickness * 1.5, beam_extension_start, internal_height - extension_roof_offset + beam_thickness * 2 * roof_slope]
						pts[24] = [internal_back_position +(spacing + fullbeam_size) * step + fullbeam_size / 2 - beam_thickness * 1.5, beam_extension_start, beam_extension_hor_height]
 
						face = beam_group_ents.add_face pts[14], pts[13], pts[1], pts[0]
						status = face.material = beam_texture
						face = beam_group_ents.add_face pts[1], pts[13], pts[15], pts[18]
						status = face.material = beam_texture
						face = beam_group_ents.add_face pts[15], pts[16], pts[17], pts[18]
						status = face.material = beam_texture
					
						face = beam_group_ents.add_face pts[23], pts[24], pts[2], pts[3]
						status = face.material = beam_texture
						face = beam_group_ents.add_face pts[2], pts[24], pts[22], pts[19]
						status = face.material = beam_texture
						face = beam_group_ents.add_face pts[20], pts[19], pts[22], pts[21]
						status = face.material = beam_texture
						if roof_window_count > 0
							face = beam_group_ents.add_face pts[14], pts[0], pts[17], pts[16]
							if face.normal[2] < 0
								status = face.reverse!
							end
							status = face.material = beam_texture
							face = beam_group_ents.add_face pts[23], pts[3], pts[20], pts[21]
							if face.normal[2] < 0
								status = face.reverse!
							end
							status = face.material = beam_texture
						end
					end

				end

			end
			
			
			
			pts = []
			pts[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_arc_position - beam_thickness, internal_height + arc + beam_thickness * 2 - cross_beam_width]
			pts[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_arc_position - beam_thickness, internal_height + arc - beam_thickness * 4 - beam_width - cross_beam_width]
			pts[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 3 + beam_width, internal_arc_position - beam_thickness, internal_height + arc - beam_thickness * 4 - beam_width - cross_beam_width]
			pts[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 3 + beam_width, internal_arc_position - beam_thickness, internal_height + arc + beam_thickness * 2 - cross_beam_width]
			face = beam_group_ents.add_face pts
			status = face.material = beam_texture
			pts[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_arc_position + beam_thickness, internal_height + arc + beam_thickness * 2 - cross_beam_width]
			pts[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_arc_position + beam_thickness, internal_height + arc - beam_thickness * 4 - beam_width - cross_beam_width]
			pts[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 3 + beam_width, internal_arc_position + beam_thickness, internal_height + arc - beam_thickness * 4 - beam_width - cross_beam_width]
			pts[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness * 3 + beam_width, internal_arc_position + beam_thickness, internal_height + arc + beam_thickness * 2 - cross_beam_width]
			face = beam_group_ents.add_face pts[1], pts[2], pts[6], pts[5]
			status = face.material = beam_texture
			face = beam_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
			status = face.material = beam_texture
			face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
			status = face.material = beam_texture
			if step != 1 ## or (back_door == 1 and door_height > internal_height + arc - beam_thickness * 4 - beam_width - cross_beam_width)
				face = beam_group_ents.add_face pts[0], pts[1], pts[5], pts[4]
				status = face.material = beam_texture
			end
			if step != beams or door_height > internal_height + arc - beam_thickness * 4 - beam_width - cross_beam_width
				face = beam_group_ents.add_face pts[2], pts[3], pts[7], pts[6]
				status = face.material = beam_texture
			end

		elsif beam_type == "Wood"
			if beam_width >= beam_thickness * 2
				top_beam_start = internal_left_beam_position
				top_beam_end = internal_right_beam_position
			else
				top_beam_start = internal_left_beam_position - beam_thickness + beam_width / 2
				top_beam_end = internal_right_beam_position + beam_thickness - beam_width / 2
			end
			vertical_beam_top = internal_height - beam_width
			support_beam_top = internal_height / 4
			support_beam_bottom = support_beam_top -(Math.sqrt(beam_width * beam_width * 2))
			for side_step in 0..1
				side_step_index = 1 - side_step * 2
				if side_step == 0
					beam_start = internal_left_beam_position - beam_thickness
					beam_base_ground_offset = beam_left_ground_offset
				else
					beam_start = internal_right_beam_position + beam_thickness
					beam_base_ground_offset = beam_right_ground_offset
				end
				
				
				if step == 1
					start_face_step = 1
					end_face_step = 2
				elsif step == beams
					start_face_step = 0
					end_face_step = 1
				else
					start_face_step = 0
					end_face_step = 2
				end
				pts = []
				pts[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_start, beam_base_ground_offset]
				pts[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_start + beam_width * side_step_index, beam_base_ground_offset]
				pts[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start + beam_width * side_step_index, beam_base_ground_offset]
				pts[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start, beam_base_ground_offset]
				pts[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_start, vertical_beam_top]
				pts[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_start + beam_width * side_step_index, vertical_beam_top]
				pts[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start + beam_width * side_step_index, vertical_beam_top]
				pts[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start, vertical_beam_top]
				
				for face_step in start_face_step..end_face_step
					face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
					if face_step == 0 and face.normal[0] > 0 or face_step == 1 and face.normal[1] != side_step_index
						status = face.reverse!
					end
					status = face.material = beam_texture
				end
				
				if side_step == 0 and hangar_left_extension > 0 or side_step == 1 and hangar_right_extension > 0
					face = beam_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
					status = face.material = beam_texture
				end
				
				pts = []
				pts[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_start + beam_width * side_step_index, vertical_beam_top - support_beam_top]
				pts[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_start + beam_width * side_step_index, vertical_beam_top - support_beam_bottom]
				pts[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_start +(beam_width + support_beam_bottom) * side_step_index, vertical_beam_top]
				pts[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), beam_start +(beam_width + support_beam_top) * side_step_index, vertical_beam_top]
				pts[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start + beam_width * side_step_index, vertical_beam_top - support_beam_top]
				pts[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start + beam_width * side_step_index, vertical_beam_top - support_beam_bottom]
				pts[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +(beam_width + support_beam_bottom) * side_step_index, vertical_beam_top]
				pts[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, beam_start +(beam_width + support_beam_top) * side_step_index, vertical_beam_top]
				
				face = beam_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
				status = face.material = beam_texture
				
				if step != 1
					face = beam_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
					status = face.material = beam_texture
				end
				if step != beams
					face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
					status = face.material = beam_texture
				end
				face = beam_group_ents.add_face pts[1], pts[2], pts[6], pts[5]
				status = face.material = beam_texture
				
			end
			pts = []
			pts[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), top_beam_start, vertical_beam_top]
			pts[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), top_beam_end, vertical_beam_top]
			pts[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, top_beam_end, vertical_beam_top]
			pts[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, top_beam_start, vertical_beam_top]
			pts[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), top_beam_start, vertical_beam_top + beam_width]
			pts[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), top_beam_end, vertical_beam_top + beam_width]
			pts[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, top_beam_end, vertical_beam_top + beam_width]
			pts[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, top_beam_start, vertical_beam_top + beam_width]
			
			face = beam_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
			status = face.material = beam_texture
			if step != beams
				face = beam_group_ents.add_face pts[2], pts[3], pts[7], pts[6]
				status = face.material = beam_texture
			end
			if step != 1
				face = beam_group_ents.add_face pts[0], pts[1], pts[5], pts[4]
				status = face.material = beam_texture
			end
			face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
			status = face.material = beam_texture
			
			pts = []
			pts[0] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_left_beam_position - beam_thickness, internal_height]
			pts[1] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_arc_position, internal_height + arc]
			pts[2] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_right_beam_position + beam_thickness, internal_height]
			pts[3] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_right_beam_position + beam_thickness -(beam_width / arc * full_width / 2), internal_height]
			pts[4] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_arc_position, internal_height + arc - beam_width]
			pts[5] = [internal_back_position +(spacing + fullbeam_size) *(step - 1), internal_left_beam_position - beam_thickness +(beam_width / arc * full_width / 2), internal_height]
			pts[6] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_left_beam_position - beam_thickness, internal_height]
			pts[7] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_arc_position, internal_height + arc]
			pts[8] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_right_beam_position + beam_thickness, internal_height]
			pts[9] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_right_beam_position + beam_thickness -(beam_width / arc * full_width / 2), internal_height]
			pts[10] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_arc_position, internal_height + arc - beam_width]
			pts[11] = [internal_back_position +(spacing + fullbeam_size) *(step - 1) + beam_thickness, internal_left_beam_position - beam_thickness +(beam_width / arc * full_width / 2), internal_height]

			face = beam_group_ents.add_face pts[3], pts[4], pts[10], pts[9]
			status = face.reverse!
			status = face.material = beam_texture
			face = beam_group_ents.add_face pts[5], pts[4], pts[10], pts[11]
			status = face.material = beam_texture
			if step != beams
				face = beam_group_ents.add_face pts[6], pts[7], pts[8], pts[9], pts[10], pts[11]
				status = face.material = beam_texture
			end
			if step != 1
				face = beam_group_ents.add_face pts[0], pts[1], pts[2], pts[3], pts[4], pts[5]
				status = face.material = beam_texture
			end
			
		end
	end


	if beam_type == "New H" 
		spacing = spacing + beam_thickness * 2
		fullbeam_size = fullbeam_size - beam_thickness * 2
	end
	

	#Calculate support beam size
	
	if beam_type == "Wood"
		pts = []
		for side_step in 0..1
			side_step_index = 1 - side_step * 2
			if side_step == 0
				beam_start = internal_left_beam_position - beam_thickness
				beam_end = top_beam_start
			else
				beam_start = internal_right_beam_position + beam_thickness
				beam_end = top_beam_end
			end
		
			pts = []
			pts[0] = [internal_back_position, beam_start, internal_height - beam_width]
			pts[1] = [internal_front_position, beam_start, internal_height - beam_width]
			pts[2] = [internal_front_position, beam_end, internal_height - beam_width]
			pts[3] = [internal_back_position, beam_end, internal_height - beam_width]
			pts[4] = [internal_back_position, beam_end, internal_height]
			pts[5] = [internal_front_position, beam_end, internal_height]
			pts[6] = [internal_front_position, beam_start, internal_height]
			pts[7] = [internal_back_position, beam_start, internal_height]
			face = beam_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
			if face.normal[2] > 0
				status = face.reverse!
			end
			status = face.material = beam_texture
			face = beam_group_ents.add_face pts[2], pts[3], pts[4], pts[5]
			status = face.material = beam_texture
			face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
			status = face.material = beam_texture
			if side_step == 0 and hangar_left_extension > 0 or side_step == 1 and hangar_right_extension > 0
				face = beam_group_ents.add_face pts[0], pts[1], pts[6], pts[7]
				status = face.material = beam_texture
			end
		end
		
		rafter_offset = (beam_thickness / 2) * beam_slope
		pts = []
		pts[0] = [internal_back_position, internal_arc_position - beam_thickness / 2, internal_height + arc - rafter_offset]
		pts[1] = [internal_front_position, internal_arc_position - beam_thickness / 2, internal_height + arc - rafter_offset]
		pts[2] = [internal_front_position, internal_arc_position - beam_thickness / 2, internal_height + arc - beam_width - rafter_offset]
		pts[3] = [internal_back_position, internal_arc_position - beam_thickness / 2, internal_height + arc - beam_width - rafter_offset]
		pts[4] = [internal_back_position, internal_arc_position + beam_thickness / 2, internal_height + arc - beam_width - rafter_offset]
		pts[5] = [internal_front_position, internal_arc_position + beam_thickness / 2, internal_height + arc - beam_width - rafter_offset]
		pts[6] = [internal_front_position, internal_arc_position + beam_thickness / 2, internal_height + arc - rafter_offset]
		pts[7] = [internal_back_position, internal_arc_position + beam_thickness / 2, internal_height + arc - rafter_offset]
		face = beam_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
		status = face.reverse!
		status = face.material = beam_texture
		face = beam_group_ents.add_face pts[2], pts[3], pts[4], pts[5]
		status = face.material = beam_texture
		face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
		status = face.material = beam_texture
		
			
	else
		if beam_type != "New H"
			internal_right_beam_position = internal_right_beam_position + beam_thickness
			internal_left_beam_position = internal_left_beam_position - beam_thickness
		end
		length_support_beams =((full_width / 2) /(120 / $inch)).to_i
		length_support_beam_distance =((full_width / 2) -(15 / $inch) - beam_width) / length_support_beams
		side_step_start = [internal_left_beam_position, internal_right_beam_position]
		for side_step in 0..1
			side_step_index = 1 - side_step * 2
			for step in 0..length_support_beams
				starting_beam_z_pos = beam_width + length_support_beam_distance * step
				arc_pitch = arc /(full_width / 2)
				beam_pitch = arc_pitch
			
				x_beam_width = cross_beam_thickness
			#	x_beam_lip = cross_beam_width / 4
			#	x_beam_length = cross_beam_width
				
				pts = []
				pts[0] = [internal_back_position, side_step_start[side_step] + starting_beam_z_pos * side_step_index, height + arc_pitch * starting_beam_z_pos - cross_beam_width]
				pts[1] = [internal_back_position, side_step_start[side_step] + starting_beam_z_pos * side_step_index, height + arc_pitch * starting_beam_z_pos]
				pts[2] = [internal_back_position, side_step_start[side_step] +(starting_beam_z_pos + x_beam_width) * side_step_index, height + arc_pitch *(starting_beam_z_pos + x_beam_width)]
				pts[3] = [internal_back_position, side_step_start[side_step] +(starting_beam_z_pos + x_beam_width) * side_step_index, height + arc_pitch *(starting_beam_z_pos + x_beam_width) - cross_beam_width]
				pts[4] = [internal_front_position, side_step_start[side_step] +(starting_beam_z_pos + x_beam_width) * side_step_index, height + arc_pitch *(starting_beam_z_pos + x_beam_width) - cross_beam_width]
				pts[5] = [internal_front_position, side_step_start[side_step] +(starting_beam_z_pos + x_beam_width) * side_step_index, height + arc_pitch *(starting_beam_z_pos + x_beam_width)]
				pts[6] = [internal_front_position, side_step_start[side_step] + starting_beam_z_pos * side_step_index, height + arc_pitch * starting_beam_z_pos]
				pts[7] = [internal_front_position, side_step_start[side_step] + starting_beam_z_pos * side_step_index, height + arc_pitch * starting_beam_z_pos - cross_beam_width]
	
				face = beam_group_ents.add_face pts[2], pts[3], pts[4], pts[5]
				if face.normal[1] != side_step_index
					status = face.reverse!
				end
				status = face.material = cross_beam_texture
				face = beam_group_ents.add_face pts[3], pts[0], pts[7], pts[4]
				if face.normal[2] > 0
					status = face.reverse!
				end
				status = face.material = cross_beam_texture
				face = beam_group_ents.add_face pts[0], pts[1], pts[6], pts[7]
				if face.normal[1] == side_step_index
					status = face.reverse!
				end
				status = face.material = cross_beam_texture
				
				if roof_window_count > 0
					face = beam_group_ents.add_face pts[2], pts[1], pts[6], pts[5]
					if face.normal[2] < 0
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
				end
			end
		
			if(side_step == 0 and hangar_left_extension > 150 / $inch) or(side_step == 1 and hangar_right_extension > 150 / $inch)
				if side_step == 0
					beam_extension_start = internal_left_position +(beam_thickness * side_step_index)
					beam_extension_top = internal_height - roof_left_offset - beam_thickness - cross_beam_width
					beam_extension_hor_height = internal_height - cross_beam_width -(hangar_left_extension - beam_thickness * 2) * beam_slope
					extension_roof_offset = roof_left_offset
				else
					beam_extension_start = internal_right_position +(beam_thickness * side_step_index)
					beam_extension_top = internal_height - roof_right_offset - beam_thickness - cross_beam_width
					beam_extension_hor_height = internal_height - cross_beam_width -(hangar_right_extension - beam_thickness * 2) * beam_slope
					extension_roof_offset = roof_right_offset
				end
			
				pts = []
				pts[0] = [internal_back_position, beam_extension_start, internal_height - extension_roof_offset + beam_thickness * roof_slope]
				pts[1] = [internal_back_position, beam_extension_start, beam_extension_top + beam_thickness + beam_thickness * beam_slope]
				pts[2] = [internal_back_position, beam_extension_start +(beam_thickness * side_step_index), beam_extension_hor_height]
				pts[3] = [internal_back_position, beam_extension_start +(beam_thickness * side_step_index), internal_height - extension_roof_offset + beam_thickness * 2 * roof_slope]
				pts[4] = [internal_front_position, beam_extension_start, internal_height - extension_roof_offset + beam_thickness * roof_slope]
				pts[5] = [internal_front_position, beam_extension_start, beam_extension_top + beam_thickness + beam_thickness * beam_slope]
				pts[6] = [internal_front_position, beam_extension_start +(beam_thickness * side_step_index), beam_extension_hor_height]
				pts[7] = [internal_front_position, beam_extension_start +(beam_thickness * side_step_index), internal_height - extension_roof_offset + beam_thickness * 2 * roof_slope]
				face = beam_group_ents.add_face pts[0], pts[1], pts[5], pts[4]
				if side_step == 1
					status = face.reverse!
				end
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[1], pts[2], pts[6], pts[5]
				status = face.material = beam_texture
				face = beam_group_ents.add_face pts[2], pts[3], pts[7], pts[6]
				status = face.material = beam_texture
			end
		end
		
		#Draw cross beams in sidewalls
		
		wall_cb_height = 100 / $inch
		beam_spacing = spacing
		
		for side_step in 0..1
			side_step_index = 1 - side_step * 2
			if side_step == 0
				if beam_type == "New H"
					if hangar_left_extension > 150 / $inch
						beam_top = internal_height - roof_left_offset - beam_thickness - cross_beam_width
					end
					wall_cb_index =(beam_top /(100 / $inch)).to_i
					wall_cb_height = beam_top / wall_cb_index
				else
					beam_top = internal_height - roof_left_offset - beam_thickness - cross_beam_width
					wall_cb_index =(beam_top /(100 / $inch)).to_i
					wall_cb_height = beam_top / wall_cb_index
				end
				
				wall_start = internal_left_position
				beam_side_position = internal_left_beam_position
				wall_cb_count =((height - cross_beam_width - roof_left_offset) / wall_cb_height).to_i
			else
				if beam_type == "New H"
					if hangar_right_extension > 150 / $inch
						beam_top = internal_height - roof_right_offset - beam_thickness - cross_beam_width
					end
					wall_cb_index =(beam_top /(100 / $inch)).to_i
					wall_cb_height = beam_top / wall_cb_index
				else
					beam_top = internal_height - roof_left_offset - beam_thickness - cross_beam_width
					wall_cb_index =(beam_top /(100 / $inch)).to_i
					wall_cb_height = beam_top / wall_cb_index
				end
				wall_start = internal_right_position
				beam_side_position = internal_right_beam_position
				wall_cb_count =((height - cross_beam_width - roof_right_offset) / wall_cb_height).to_i
			end

			for height_step in 1..wall_cb_count
			
				beams_exclusion = 0
				if cross_beam_exclusion_count > 0
						
					for exclusion_step in 0..cross_beam_exclusion_count - 1
							
						if side_step == 0
							current_beam_side = "L"
						else
							current_beam_side = "R"
						end
						if(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step) or(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step + beam_thickness and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step + beam_thickness)
							
							if current_beam_side == "L"
								if cross_beam_exclusions[exclusion_step][3] >  internal_height - hangar_left_extension * roof_slope - beam_thickness
									cross_beam_exclusions[exclusion_step][3] = internal_height - hangar_left_extension * roof_slope - beam_thickness
								end
							else
								if cross_beam_exclusions[exclusion_step][3] >  internal_height - hangar_right_extension * roof_slope - beam_thickness
									cross_beam_exclusions[exclusion_step][3] = internal_height - hangar_right_extension * roof_slope - beam_thickness
								end
							end
							
							beams_exclusion = 1
									
							#Draw uprights
							if height_step == 1
								bottom_crossbeam_end = 0
							else
								bottom_crossbeam_end =(wall_cb_height *(height_step - 1)) + beam_thickness
							end
							if bottom_crossbeam_end < foundation_wall_height
								bottom_crossbeam_end = foundation_wall_height
							end
							if height_step == wall_cb_count
								top_crossbeam_end = cross_beam_exclusions[exclusion_step][3] + beam_thickness
							else
								if wall_cb_height *(height_step + 1) > cross_beam_exclusions[exclusion_step][3]
									top_crossbeam_end = wall_cb_height *(height_step + 1) 
								else
									top_crossbeam_end = cross_beam_exclusions[exclusion_step][3] + beam_thickness
								end
							end
	
							if cross_beam_extras_drawn[exclusion_step] == 0
								pts = []
								pts[0] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start, bottom_crossbeam_end]
								pts[1] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start + beam_thickness * side_step_index, bottom_crossbeam_end]
								pts[2] = [external_front_position - cross_beam_exclusions[exclusion_step][0] + beam_thickness, wall_start + beam_thickness * side_step_index, bottom_crossbeam_end]
								pts[3] = [external_front_position - cross_beam_exclusions[exclusion_step][0] + beam_thickness, wall_start, bottom_crossbeam_end]
								pts[4] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start, top_crossbeam_end]
								pts[5] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start + beam_thickness * side_step_index, top_crossbeam_end]
								pts[6] = [external_front_position - cross_beam_exclusions[exclusion_step][0] + beam_thickness, wall_start + beam_thickness * side_step_index, top_crossbeam_end]
								pts[7] = [external_front_position - cross_beam_exclusions[exclusion_step][0] + beam_thickness, wall_start, top_crossbeam_end]
								for face_step in 0..2
									face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
									if face_step == 0 and face.normal[0] > 0
										status = face.reverse!
									end
									status = face.material = cross_beam_texture
								end
								if height_step == wall_cb_count or top_crossbeam_end == cross_beam_exclusions[exclusion_step][3] + beam_thickness
									face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
									status = face.material = cross_beam_texture
								end
		
								pts = []
								pts[0] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start, bottom_crossbeam_end]
								pts[1] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start + beam_thickness * side_step_index, bottom_crossbeam_end]
								pts[2] = [external_front_position - cross_beam_exclusions[exclusion_step][2] - beam_thickness, wall_start + beam_thickness * side_step_index, bottom_crossbeam_end]
								pts[3] = [external_front_position - cross_beam_exclusions[exclusion_step][2] - beam_thickness, wall_start, bottom_crossbeam_end]
								pts[4] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start, top_crossbeam_end]
								pts[5] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start + beam_thickness * side_step_index, top_crossbeam_end]
								pts[6] = [external_front_position - cross_beam_exclusions[exclusion_step][2] - beam_thickness, wall_start + beam_thickness * side_step_index, top_crossbeam_end]
								pts[7] = [external_front_position - cross_beam_exclusions[exclusion_step][2] - beam_thickness, wall_start, top_crossbeam_end]
								for face_step in 0..2
									face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
									if face_step == 0 and face.normal[0] < 0
										status = face.reverse!
									end
									status = face.material = cross_beam_texture
								end
								if height_step == wall_cb_count or top_crossbeam_end == cross_beam_exclusions[exclusion_step][3] + beam_thickness
									face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
									status = face.material = cross_beam_texture
								end
								if cross_beam_exclusions[exclusion_step][1] >= beam_thickness
									pts = []
									pts[0] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start, cross_beam_exclusions[exclusion_step][1]]
									pts[1] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start + beam_thickness * side_step_index, cross_beam_exclusions[exclusion_step][1]]
									pts[2] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start + beam_thickness * side_step_index, cross_beam_exclusions[exclusion_step][1] - beam_thickness]
									pts[3] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start, cross_beam_exclusions[exclusion_step][1] - beam_thickness]
									pts[4] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start, cross_beam_exclusions[exclusion_step][1]]
									pts[5] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start + beam_thickness * side_step_index, cross_beam_exclusions[exclusion_step][1]]
									pts[6] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start + beam_thickness * side_step_index, cross_beam_exclusions[exclusion_step][1] - beam_thickness]
									pts[7] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start, cross_beam_exclusions[exclusion_step][1] - beam_thickness]
									for face_step in 0..2
										face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
										if face_step == 0 and face.normal[2] < 0
											status = face.reverse!
										end
										status = face.material = cross_beam_texture
									end
								end
								cross_beam_extras_drawn[exclusion_step] = 1
							end
							if height_step == wall_cb_count
								pts = []
								pts[0] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start, cross_beam_exclusions[exclusion_step][3]]
								pts[1] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start + beam_thickness * side_step_index, cross_beam_exclusions[exclusion_step][3]]
								pts[2] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start + beam_thickness * side_step_index, cross_beam_exclusions[exclusion_step][3] + beam_thickness]
								pts[3] = [external_front_position - cross_beam_exclusions[exclusion_step][0], wall_start, cross_beam_exclusions[exclusion_step][3] + beam_thickness]
								pts[4] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start, cross_beam_exclusions[exclusion_step][3]]
								pts[5] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start + beam_thickness * side_step_index, cross_beam_exclusions[exclusion_step][3]]
								pts[6] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start + beam_thickness * side_step_index, cross_beam_exclusions[exclusion_step][3] + beam_thickness]
								pts[7] = [external_front_position - cross_beam_exclusions[exclusion_step][2], wall_start, cross_beam_exclusions[exclusion_step][3] + beam_thickness]
								for face_step in 0..2
									face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
									if face_step == 0
										status = face.reverse!
									end
									status = face.material = cross_beam_texture
								end
							end
						end
					end
				end
				if beams_exclusion == 0
					pts = []
					pts[0] = [internal_back_position, wall_start,(wall_cb_height * height_step)]
					pts[1] = [internal_back_position, wall_start +(beam_thickness * side_step_index),(wall_cb_height * height_step)]
					pts[2] = [internal_back_position, wall_start +(beam_thickness * side_step_index),(wall_cb_height * height_step) + beam_thickness]
					pts[3] = [internal_back_position, wall_start,(wall_cb_height * height_step) + beam_thickness]
			
					pts[4] = [internal_front_position, wall_start,(wall_cb_height * height_step)]
					pts[5] = [internal_front_position, wall_start +(beam_thickness * side_step_index),(wall_cb_height * height_step)]
					pts[6] = [internal_front_position, wall_start +(beam_thickness * side_step_index),(wall_cb_height * height_step) + beam_thickness]
					pts[7] = [internal_front_position, wall_start,(wall_cb_height * height_step) + beam_thickness]
					face = beam_group_ents.add_face pts[0], pts[1], pts[5], pts[4]
					if face.normal[2] > 0
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
					face = beam_group_ents.add_face pts[1], pts[2], pts[6], pts[5]
					if face.normal[1] != side_step_index
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
					face = beam_group_ents.add_face pts[2], pts[3], pts[7], pts[6]
					if face.normal[2] < 0
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
					if window_count > 0
						face = beam_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
						status = face.material = cross_beam_texture
					end
				else
					cross_beam_start_array = []
					cross_beam_end_array = []
					cross_beam_array_count = 0
					for exclusion_step in 0..cross_beam_exclusion_count - 1
						if(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step) or(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step + beam_thickness and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step + beam_thickness)
							cross_beam_start_array[cross_beam_array_count] = external_front_position - cross_beam_exclusions[exclusion_step][2] - beam_thickness
							cross_beam_end_array[cross_beam_array_count] = external_front_position - cross_beam_exclusions[exclusion_step][0] + beam_thickness
							cross_beam_array_count = cross_beam_array_count + 1
						end
					end
					cross_beam_start_array[cross_beam_array_count] = internal_front_position
					cross_beam_end_array[cross_beam_array_count] = internal_back_position
					cross_beam_start_array.sort!
					cross_beam_end_array.sort!
					
					for part_beam_step in 0..cross_beam_array_count
						pts = []
						pts[0] = [cross_beam_start_array[part_beam_step], wall_start,(wall_cb_height * height_step)]
						pts[1] = [cross_beam_start_array[part_beam_step], wall_start + beam_thickness * side_step_index,(wall_cb_height * height_step)]
						pts[2] = [cross_beam_start_array[part_beam_step], wall_start + beam_thickness * side_step_index,(wall_cb_height * height_step) + beam_thickness]
						pts[3] = [cross_beam_start_array[part_beam_step], wall_start,(wall_cb_height * height_step) + beam_thickness]
						pts[4] = [cross_beam_end_array[part_beam_step], wall_start,(wall_cb_height * height_step)]
						pts[5] = [cross_beam_end_array[part_beam_step], wall_start + beam_thickness * side_step_index,(wall_cb_height * height_step)]
						pts[6] = [cross_beam_end_array[part_beam_step], wall_start + beam_thickness * side_step_index,(wall_cb_height * height_step) + beam_thickness]
						pts[7] = [cross_beam_end_array[part_beam_step], wall_start,(wall_cb_height * height_step) + beam_thickness]
						for face_step in 0..2
							face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
							if face_step == 0 and face.normal[2] > 0
								status = face.reverse!
							end
							status = face.material = cross_beam_texture
						end


					end
				end
		end	
	end
	
	#Crossbeams in back wall

	if back_door_count == 0
		if beam_type == "New H"
			beam_top = internal_height - beam_thickness - cross_beam_width - fullbeam_size - beam_thickness * 2
			wall_cb_index =(beam_top /(100 / $inch)).to_i
			wall_cb_height = beam_top / wall_cb_index
		end
		
		wall_cb_count =((height - cross_beam_width) / wall_cb_height).to_i
		for height_step in 1..wall_cb_count

			beams_exclusion = 0
			if cross_beam_exclusion_count > 0
				for exclusion_step in 0..cross_beam_exclusion_count - 1
					current_beam_side = "B"
					if(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step) or(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step + beam_thickness and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step + beam_thickness)
						beams_exclusion = 1

						if height_step == 1
							bottom_crossbeam_end = 0
						else
							bottom_crossbeam_end =(wall_cb_height *(height_step - 1)) + beam_thickness
						end
						if bottom_crossbeam_end < foundation_wall_height
							bottom_crossbeam_end = foundation_wall_height
							
						end
						if height_step == wall_cb_count
							top_crossbeam_end = cross_beam_exclusions[exclusion_step][3] + beam_thickness
						else
							if wall_cb_height *(height_step + 1) > cross_beam_exclusions[exclusion_step][3]
								top_crossbeam_end = wall_cb_height *(height_step + 1) 
							else
								top_crossbeam_end = cross_beam_exclusions[exclusion_step][3] + beam_thickness
							end
						end
						
					
						if cross_beam_extras_drawn[exclusion_step] == 0
							pts = []
							pts[0] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][0], bottom_crossbeam_end]
							pts[1] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][0], bottom_crossbeam_end]
							pts[2] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][0] - beam_thickness, bottom_crossbeam_end]
							pts[3] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][0] - beam_thickness, bottom_crossbeam_end]
							pts[4] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][0], top_crossbeam_end]
							pts[5] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][0], top_crossbeam_end]
							pts[6] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][0] - beam_thickness, top_crossbeam_end]
							pts[7] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][0] - beam_thickness, top_crossbeam_end]
							for face_step in 0..2
								face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
								if(face_step == 0 and face.normal[2] < 0) or(face_step == 1 and face.normal[0] < 0)
									status = face.reverse!
								end
								status = face.material = cross_beam_texture
							end
							if height_step == wall_cb_count or top_crossbeam_end == cross_beam_exclusions[exclusion_step][3] + beam_thickness
								face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
								status = face.material = cross_beam_texture
							end
							
							pts = []
							pts[0] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][2], bottom_crossbeam_end]
							pts[1] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][2], bottom_crossbeam_end]
							pts[2] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][2] + beam_thickness, bottom_crossbeam_end]
							pts[3] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][2] + beam_thickness, bottom_crossbeam_end]
							pts[4] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][2], top_crossbeam_end]
							pts[5] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][2], top_crossbeam_end]
							pts[6] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][2] + beam_thickness, top_crossbeam_end]
							pts[7] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][2] + beam_thickness, top_crossbeam_end]
							for face_step in 0..2
								face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
								if(face_step == 0 and face.normal[2] < 0) or(face_step == 1 and face.normal[0] < 0)
									status = face.reverse!
								end
								status = face.material = cross_beam_texture
							end
							if height_step == wall_cb_count or top_crossbeam_end == cross_beam_exclusions[exclusion_step][3] + beam_thickness
								face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
								status = face.material = cross_beam_texture
							end
							if cross_beam_exclusions[exclusion_step][1] >= beam_thickness
								pts = []
								pts[0] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][0], cross_beam_exclusions[exclusion_step][1]]
								pts[1] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][0], cross_beam_exclusions[exclusion_step][1]]
								pts[2] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][0], cross_beam_exclusions[exclusion_step][1] - beam_thickness]
								pts[3] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][0], cross_beam_exclusions[exclusion_step][1] - beam_thickness]
								pts[4] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][2], cross_beam_exclusions[exclusion_step][1]]
								pts[5] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][2], cross_beam_exclusions[exclusion_step][1]]
								pts[6] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][2], cross_beam_exclusions[exclusion_step][1] - beam_thickness]
								pts[7] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][2], cross_beam_exclusions[exclusion_step][1] - beam_thickness]
								for face_step in 0..2
									face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
									if(face_step == 0 and face.normal[2] < 0) or(face_step == 1 and face.normal[0] < 0)
										status = face.reverse!
									end
									status = face.material = cross_beam_texture
								end
							end
							cross_beam_extras_drawn[exclusion_step] = 1
						end
						
						if height_step == wall_cb_count
							pts = []
							pts[0] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][0], cross_beam_exclusions[exclusion_step][3]]
							pts[1] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][0], cross_beam_exclusions[exclusion_step][3]]
							pts[2] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][0], cross_beam_exclusions[exclusion_step][3] + beam_thickness]
							pts[3] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][0], cross_beam_exclusions[exclusion_step][3] + beam_thickness]
							pts[4] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][2], cross_beam_exclusions[exclusion_step][3]]
							pts[5] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][2], cross_beam_exclusions[exclusion_step][3]]
							pts[6] = [internal_back_position + beam_thickness, external_left_position + cross_beam_exclusions[exclusion_step][2], cross_beam_exclusions[exclusion_step][3] + beam_thickness]
							pts[7] = [internal_back_position, external_left_position + cross_beam_exclusions[exclusion_step][2], cross_beam_exclusions[exclusion_step][3] + beam_thickness]
							for face_step in 0..2
								face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
								if(face_step == 0 and face.normal[2] < 0) or(face_step == 1 and face.normal[0] < 0)
									status = face.reverse!
								end
								status = face.material = cross_beam_texture
							end
						end


							
					end
				end
			end

			if beams_exclusion == 0

				pts = []
				pts[0] = [internal_back_position, internal_left_beam_position,(wall_cb_height * height_step)]
				pts[1] = [internal_back_position + beam_thickness, internal_left_beam_position,(wall_cb_height * height_step)]
				pts[2] = [internal_back_position + beam_thickness, internal_left_beam_position,(wall_cb_height * height_step) + beam_thickness]
				pts[3] = [internal_back_position, internal_left_beam_position,(wall_cb_height * height_step) + beam_thickness]
				pts[4] = [internal_back_position, internal_right_beam_position,(wall_cb_height * height_step)]
				pts[5] = [internal_back_position + beam_thickness, internal_right_beam_position,(wall_cb_height * height_step)]
				pts[6] = [internal_back_position + beam_thickness, internal_right_beam_position,(wall_cb_height * height_step) + beam_thickness]
				pts[7] = [internal_back_position, internal_right_beam_position,(wall_cb_height * height_step) + beam_thickness]
				for face_step in 0..2
					face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
					if(face_step == 0 and face.normal[2] > 0) or(face_step == 1 and face.normal[0] < 0) or(face_step == 2 and face.normal[2] < 0)
						status = face.reverse!
						#UI.messagebox face_step
					end
					status = face.material = cross_beam_texture
				end
				if hangar_left_extension > 0
				face = beam_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
					status = face.material = cross_beam_texture
					end
				if hangar_right_extension > 0
					face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
				status = face.material = cross_beam_texture
				end
				if window_count > 0
					face = beam_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
					status = face.material = cross_beam_texture
				end
			else
			
				cross_beam_start_array = []
				cross_beam_end_array = []
				cross_beam_array_count = 0
				for exclusion_step in 0..cross_beam_exclusion_count - 1
					if(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step) or(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step + beam_thickness and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step + beam_thickness)
						cross_beam_start_array[cross_beam_array_count] = external_left_position + cross_beam_exclusions[exclusion_step][2] + beam_thickness
						cross_beam_end_array[cross_beam_array_count] = external_left_position + cross_beam_exclusions[exclusion_step][0] - beam_thickness
						cross_beam_array_count = cross_beam_array_count + 1
					end
				end
				cross_beam_start_array[cross_beam_array_count] = internal_left_beam_position
				cross_beam_end_array[cross_beam_array_count] = internal_right_beam_position
				cross_beam_start_array.sort!
				cross_beam_end_array.sort!
				
				for part_beam_step in 0..cross_beam_array_count
					pts = []
					pts[0] = [internal_back_position, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step)]
					pts[1] = [internal_back_position + beam_thickness, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step)]
					pts[2] = [internal_back_position + beam_thickness, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
					pts[3] = [internal_back_position, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
					pts[4] = [internal_back_position, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step)]
					pts[5] = [internal_back_position + beam_thickness, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step)]
					pts[6] = [internal_back_position + beam_thickness, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
					pts[7] = [internal_back_position, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
					
					if cross_beam_start_array[part_beam_step] < internal_left_beam_position or cross_beam_end_array[part_beam_step] < internal_left_beam_position  or cross_beam_start_array[part_beam_step] > internal_right_beam_position or cross_beam_end_array[part_beam_step] > internal_right_beam_position 
					
						for adjust_step in 0..7
							pts[adjust_step][2] = pts[adjust_step][2] + wall_cb_height
						end
						face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
						status = face.material = cross_beam_texture
					end
					for face_step in 0..2
						face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
						if face_step == 0 and face.normal[2] > 0
							status = face.reverse!
						end
						status = face.material = cross_beam_texture
					end
					if hangar_left_extension > 0
						face = beam_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
						status = face.material = cross_beam_texture
					end
					if hangar_right_extension > 0
						face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
						status = face.material = cross_beam_texture
					end

				end
			
			end
		end	
	end

	#Crossbeams in extension back and front walls
	
	if hangar_left_extension > 0
		if beam_type == "New H"
			if hangar_left_extension > 150 / $inch
				beam_top = internal_height - roof_left_offset - beam_thickness - cross_beam_width
			end
			wall_cb_index =(beam_top /(100 / $inch)).to_i
			wall_cb_height = beam_top / wall_cb_index
		end
		wall_start = internal_left_position
		beam_side_position = internal_left_beam_position + beam_width
		wall_cb_count =((height - cross_beam_width - roof_left_offset) / wall_cb_height).to_i
	
		for height_step in 1..wall_cb_count
			for side_step in 0..1
				if side_step == 0
					extension_beam_front_back_position = internal_back_position
					current_beam_side = "B"
				else
					extension_beam_front_back_position = internal_front_position
					current_beam_side = "F"
				end
				side_step_index = 1 - side_step * 2


				beams_exclusion = 0
				if cross_beam_exclusion_count > 0
					for exclusion_step in 0..cross_beam_exclusion_count - 1
						if(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step and(cross_beam_exclusions[exclusion_step][0] < hangar_left_extension or cross_beam_exclusions[exclusion_step][2] < hangar_left_extension)) or(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step + beam_thickness and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step + beam_thickness and(cross_beam_exclusions[exclusion_step][0] < hangar_left_extension or cross_beam_exclusions[exclusion_step][2] < hangar_left_extension))
							beams_exclusion = 1
						end
						
					end
				end


				if beams_exclusion == 0
					pts = []
					pts[0] = [extension_beam_front_back_position, wall_start,(wall_cb_height * height_step)]
					pts[1] = [extension_beam_front_back_position + beam_thickness * side_step_index, wall_start,(wall_cb_height * height_step)]
					pts[2] = [extension_beam_front_back_position + beam_thickness * side_step_index, wall_start,(wall_cb_height * height_step) + beam_thickness]
					pts[3] = [extension_beam_front_back_position, wall_start,(wall_cb_height * height_step) + beam_thickness]
					pts[4] = [extension_beam_front_back_position, beam_side_position,(wall_cb_height * height_step)]
					pts[5] = [extension_beam_front_back_position + beam_thickness * side_step_index, beam_side_position,(wall_cb_height * height_step)]
					pts[6] = [extension_beam_front_back_position + beam_thickness * side_step_index, beam_side_position,(wall_cb_height * height_step) + beam_thickness]
					pts[7] = [extension_beam_front_back_position, beam_side_position,(wall_cb_height * height_step) + beam_thickness]
					face = beam_group_ents.add_face pts[0], pts[1], pts[5], pts[4]
					if face.normal[2] > 0
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
					face = beam_group_ents.add_face pts[1], pts[2], pts[6], pts[5]
					if face.normal[0] != side_step_index
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
					face = beam_group_ents.add_face pts[2], pts[3], pts[7], pts[6]
					if face.normal[2] < 0
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
					face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
					status = face.material = cross_beam_texture
					if window_count > 0
						face = beam_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
						status = face.material = cross_beam_texture
					end
				else
					cross_beam_start_array = []
					cross_beam_end_array = []
					cross_beam_array_count = 0
					for exclusion_step in 0..cross_beam_exclusion_count - 1
						if((cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step) or(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step + beam_thickness and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step + beam_thickness)) and cross_beam_exclusions[exclusion_step][0] < hangar_left_extension
							cross_beam_end_array[cross_beam_array_count] = external_left_position + cross_beam_exclusions[exclusion_step][0] - beam_thickness
							cross_beam_start_array[cross_beam_array_count] = external_left_position + cross_beam_exclusions[exclusion_step][2] + beam_thickness
							cross_beam_array_count = cross_beam_array_count + 1
						end
					end
					cross_beam_start_array[cross_beam_array_count] = internal_left_position
					cross_beam_end_array[cross_beam_array_count] = beam_side_position
					cross_beam_start_array.sort!
					cross_beam_end_array.sort!
					
					for part_beam_step in 0..cross_beam_array_count
						
						do_not_draw = 0
						if cross_beam_start_array[part_beam_step] > beam_side_position or cross_beam_end_array[part_beam_step] > beam_side_position
							
							do_not_draw = 1
						end
						if do_not_draw == 0
							pts = []
							pts[0] = [extension_beam_front_back_position, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step)]
							pts[1] = [extension_beam_front_back_position + beam_thickness * side_step_index, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step)]
							pts[2] = [extension_beam_front_back_position + beam_thickness * side_step_index, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
							pts[3] = [extension_beam_front_back_position, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
							pts[4] = [extension_beam_front_back_position, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step)]
							pts[5] = [extension_beam_front_back_position + beam_thickness * side_step_index, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step)]
							pts[6] = [extension_beam_front_back_position + beam_thickness * side_step_index, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
							pts[7] = [extension_beam_front_back_position, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
						
							for face_step in 0..2
								face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
								if face_step == 0 and face.normal[2] > 0
									status = face.reverse!
								end
								status = face.material = cross_beam_texture
							end
							
							if cross_beam_end_array[part_beam_step] == beam_side_position
								face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
								status = face.material = cross_beam_texture
							end								
						end
					end
				end
			end
		end
	end	
	
	if hangar_right_extension > 0
		if beam_type == "New H"
			if hangar_left_extension > 150 / $inch
				beam_top = internal_height - roof_right_offset - beam_thickness - cross_beam_width
			end
			wall_cb_index =(beam_top /(100 / $inch)).to_i
			wall_cb_height = beam_top / wall_cb_index
		end
		wall_start = internal_right_position
		beam_side_position = internal_right_beam_position - beam_width
		wall_cb_count =((height - cross_beam_width - roof_right_offset) / wall_cb_height).to_i
	
		for height_step in 1..wall_cb_count
			for side_step in 0..1
				if side_step == 0
					extension_beam_front_back_position = internal_back_position
					current_beam_side = "B"
				else
					extension_beam_front_back_position = internal_front_position
					current_beam_side = "F"
				end
				side_step_index = 1 - side_step * 2
				
				beams_exclusion = 0
				if cross_beam_exclusion_count > 0
					for exclusion_step in 0..cross_beam_exclusion_count - 1
						if(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step and(cross_beam_exclusions[exclusion_step][0] > internal_right_beam_position or cross_beam_exclusions[exclusion_step][2] > internal_right_beam_position)) or(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step + beam_thickness and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step + beam_thickness and(cross_beam_exclusions[exclusion_step][0] > internal_right_beam_position or cross_beam_exclusions[exclusion_step][2] > internal_right_beam_position))
							beams_exclusion = 1
						end
					end
				end
				
				if beams_exclusion == 0
					pts = []
					pts[0] = [extension_beam_front_back_position, wall_start,(wall_cb_height * height_step)]
					pts[1] = [extension_beam_front_back_position + beam_thickness * side_step_index, wall_start,(wall_cb_height * height_step)]
					pts[2] = [extension_beam_front_back_position + beam_thickness * side_step_index, wall_start,(wall_cb_height * height_step) + beam_thickness]
					pts[3] = [extension_beam_front_back_position, wall_start,(wall_cb_height * height_step) + beam_thickness]
					pts[4] = [extension_beam_front_back_position, beam_side_position,(wall_cb_height * height_step)]
					pts[5] = [extension_beam_front_back_position + beam_thickness * side_step_index, beam_side_position,(wall_cb_height * height_step)]
					pts[6] = [extension_beam_front_back_position + beam_thickness * side_step_index, beam_side_position,(wall_cb_height * height_step) + beam_thickness]
					pts[7] = [extension_beam_front_back_position, beam_side_position,(wall_cb_height * height_step) + beam_thickness]
					face = beam_group_ents.add_face pts[0], pts[1], pts[5], pts[4]
					if face.normal[2] > 0
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
					face = beam_group_ents.add_face pts[1], pts[2], pts[6], pts[5]
					if face.normal[0] != side_step_index
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
					face = beam_group_ents.add_face pts[2], pts[3], pts[7], pts[6]
					if face.normal[2] < 0
						status = face.reverse!
					end
					status = face.material = cross_beam_texture
					face = beam_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
					status = face.material = cross_beam_texture
					if window_count > 0
						face = beam_group_ents.add_face pts[0], pts[3], pts[7], pts[4]
						status = face.material = cross_beam_texture
					end
				else
					cross_beam_start_array = []
					cross_beam_end_array = []
					cross_beam_array_count = 0
					for exclusion_step in 0..cross_beam_exclusion_count - 1
						if((cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step) or(cross_beam_exclusion_side[exclusion_step] == current_beam_side and cross_beam_exclusions[exclusion_step][1] < wall_cb_height * height_step + beam_thickness and cross_beam_exclusions[exclusion_step][3] > wall_cb_height * height_step + beam_thickness)) and cross_beam_exclusions[exclusion_step][0] > beam_side_position
							cross_beam_end_array[cross_beam_array_count] = external_left_position + cross_beam_exclusions[exclusion_step][0] - beam_thickness
							cross_beam_start_array[cross_beam_array_count] = external_left_position + cross_beam_exclusions[exclusion_step][2] + beam_thickness
							cross_beam_array_count = cross_beam_array_count + 1
						end
					end
					cross_beam_start_array[cross_beam_array_count] = beam_side_position
					cross_beam_end_array[cross_beam_array_count] = internal_right_position
					cross_beam_start_array.sort!
					cross_beam_end_array.sort!
					
					for part_beam_step in 0..cross_beam_array_count
						
						do_not_draw = 0
						if cross_beam_start_array[part_beam_step] < beam_side_position or cross_beam_end_array[part_beam_step] < beam_side_position
							do_not_draw = 1
						end
						if do_not_draw == 0
							pts = []
							pts[0] = [extension_beam_front_back_position, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step)]
							pts[1] = [extension_beam_front_back_position + beam_thickness * side_step_index, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step)]
							pts[2] = [extension_beam_front_back_position + beam_thickness * side_step_index, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
							pts[3] = [extension_beam_front_back_position, cross_beam_start_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
							pts[4] = [extension_beam_front_back_position, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step)]
							pts[5] = [extension_beam_front_back_position + beam_thickness * side_step_index, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step)]
							pts[6] = [extension_beam_front_back_position + beam_thickness * side_step_index, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
							pts[7] = [extension_beam_front_back_position, cross_beam_end_array[part_beam_step],(wall_cb_height * height_step) + beam_thickness]
						
							for face_step in 0..2
								face = beam_group_ents.add_face pts[face_step], pts[face_step + 1], pts[face_step + 5], pts[face_step + 4]
								if face_step == 0 and face.normal[2] > 0
									status = face.reverse!
								end
								status = face.material = cross_beam_texture
							end
							
							if cross_beam_start_array[part_beam_step] == beam_side_position
								face = beam_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
								status = face.material = cross_beam_texture
							end								
						end
					end
				
				end
			end
		end
	end	
		
end	
end
group_text = group.description
group = group.parent.entities.add_group([group, beam_group])
group.description = group_text


############################
####	Draw UV map walls	####
############################

	if eaves_overhang == 0
		external_left_height = outside_height - roof_left_offset
		external_right_height = outside_height - roof_right_offset
		external_arc_height = internal_height + arc + wall_thickness
	else
		external_left_height = outside_height - roof_left_offset - wall_thickness
		external_right_height = outside_height - roof_right_offset - wall_thickness
	#	external_right_height = outside_height - wall_thickness + internal_arc_position * roof_slope
#		external_arc_height = outside_height + arc - wall_thickness
		external_arc_height = internal_height + arc
	end

	uv_map_left_wall = 0
	uv_map_right_wall = 0
	uv_map_back_wall = 0
	uv_map_front_wall = 0
	uv_map_left_roof = 0
	uv_map_right_roof = 0
	uv_map_group = []
	uv_map_group_ents = []
	if uv_map_count > 0
		for step in 0..uv_map_count - 1
			uv_map_group[step] = Sketchup.active_model.entities.add_group
			uv_map_group_ents[step] = uv_map_group[step].entities
			texture_id = uv_map_group[step].to_s
			if uv_map_wall[step] == "L"
				texture_width = external_front_position
				texture_height = external_left_height
			elsif uv_map_wall[step] == "R"
				texture_width = external_front_position
				texture_height = external_right_height
			elsif uv_map_wall[step] == "LR"
				roof_height = external_arc_height - external_left_height
				roof_depth = internal_arc_position - external_left_position
				roof_length = Math.sqrt(roof_height * roof_height + roof_depth * roof_depth)
				roof_angle = Math.asin(roof_depth / roof_length).radians
				left_roof_length = roof_length
				left_roof_height = roof_height
				texture_width = external_front_position
				texture_height = roof_length
			elsif uv_map_wall[step] == "RR"
				roof_height = external_arc_height - external_right_height
				roof_depth = external_right_position - internal_arc_position
				roof_length = Math.sqrt(roof_height * roof_height + roof_depth * roof_depth)
				roof_angle = Math.asin(roof_depth / roof_length).radians
				right_roof_length = roof_length
				right_roof_height = roof_height
				texture_width = external_front_position
				texture_height = roof_length
			else
				texture_width = external_right_position - external_left_position
				texture_height = external_arc_height
			end
			for texture_step in 0..$texture_name.length - 1
				if uv_map_texture[step] == $texture_name[texture_step]
					texture = materials.add $texture_name[texture_step] + texture_id
          if $texture_filename[texture_step].count(":") === 0
            texture.texture = $texture_files + $texture_filename[texture_step]
          else
            texture.texture = $texture_filename[texture_step]
          end
					uv_x_scale =($texture_x_size[texture_step] / $inch) / uv_map_x_size[step]
					uv_y_scale =($texture_y_size[texture_step] / $inch) / uv_map_y_size[step]
					texture.texture.size = [uv_map_x_size[step] * uv_x_scale /(uv_map_x_size[step] / texture_width), uv_map_y_size[step] * uv_y_scale /(uv_map_y_size[step] / texture_height)]
				end
			end
			if uv_map_wall[step] == "L" and uv_map_left_wall == 0
				pts = []
				pts[0] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[1] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + external_front_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[2] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + external_front_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_left_height - foundation_wall_height]
				pts[3] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_left_height - foundation_wall_height]
				face = uv_map_group_ents[step].add_face pts
				status = face.material = uv_map_texture[step] + texture_id
				point = Geom::Point3d.new(0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step])
				t = Geom::Transformation.new point
				uv_map_group[step].move! t
				uv_map_left_wall = step + 1
				uv_map_left_offsets = [0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
			end

			if uv_map_wall[step] == "R" and uv_map_right_wall == 0
				pts = []
				pts[0] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_right_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[1] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + external_front_position, external_right_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[2] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + external_front_position, external_right_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_right_height - foundation_wall_height]
				pts[3] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_right_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_right_height - foundation_wall_height]
				face = uv_map_group_ents[step].add_face pts
				status = face.material = uv_map_texture[step] + texture_id
				point = Geom::Point3d.new(0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step])
				t = Geom::Transformation.new point
				uv_map_group[step].move! t
			   	point = Geom::Point3d.new((external_front_position - external_back_position) / 2, external_right_position, 0)
				t = Geom::Transformation.scaling(point, -1, -1, 1)
				uv_map_group[step].transform! t
				uv_map_right_wall = step + 1
				uv_map_right_offsets = [0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
			end
		
			if uv_map_wall[step] == "B" and uv_map_back_wall == 0
				pts = []
				pts[0] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[1] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + texture_width, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[2] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + texture_width, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_left_height - foundation_wall_height]
				pts[3] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + internal_arc_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_arc_height - foundation_wall_height]
				pts[4] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_right_height - foundation_wall_height]
				face = uv_map_group_ents[step].add_face pts
				status = face.material = uv_map_texture[step] + texture_id
				point = Geom::Point3d.new(0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step])
				t = Geom::Transformation.new point
				uv_map_group[step].move! t
				t = Geom::Transformation.rotation [external_back_position, external_left_position, 0], Z_AXIS, 90.degrees
				uv_map_group[step].transform! t
				
			   	point = Geom::Point3d.new(0,(external_right_position - external_left_position) / 2, 0)
				t = Geom::Transformation.scaling(point, -1, -1, 1)
				uv_map_group[step].transform! t
				uv_map_back_wall = step + 1
				uv_map_back_offsets = [0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
			end

			if uv_map_wall[step] == "F" and uv_map_front_wall == 0
				pts = []
				pts[0] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[1] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + texture_width - door_right_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[2] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + texture_width - door_right_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + door_height]
				pts[3] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + texture_width - door_left_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + door_height]
				pts[4] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + texture_width - door_left_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[5] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + texture_width, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[6] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + texture_width, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_right_height - foundation_wall_height]
				pts[7] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + texture_width - internal_arc_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_arc_height - foundation_wall_height]
				pts[8] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + external_left_height - foundation_wall_height]
				face = uv_map_group_ents[step].add_face pts
				status = face.material = uv_map_texture[step] + texture_id
				point = Geom::Point3d.new(external_front_position - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step])
				t = Geom::Transformation.new point
				uv_map_group[step].move! t
				t = Geom::Transformation.rotation [external_front_position, external_left_position, 0], Z_AXIS, 90.degrees
				uv_map_group[step].transform! t
				uv_map_front_wall = step + 1
				uv_map_front_offsets = [external_front_position - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
			end
			if uv_map_wall[step] == "LR" and uv_map_left_roof == 0
				pts = []

				pts[0] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[1] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + external_front_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[2] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + external_front_position, external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + roof_length]
				pts[3] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_left_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + roof_length]
				face = uv_map_group_ents[step].add_face pts
				status = face.material = uv_map_texture[step] + texture_id
				point = Geom::Point3d.new(0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, external_left_height - uv_map_y_pos[step] * texture_height / uv_map_y_size[step])
				t = Geom::Transformation.new point
				uv_map_group[step].move! t
				t = Geom::Transformation.rotation [external_front_position, external_left_position, external_left_height], X_AXIS, 0 - roof_angle.degrees
				uv_map_group[step].transform! t
				uv_map_left_roof = step + 1
				uv_map_left_roof_offsets = [0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
			end
			if uv_map_wall[step] == "RR" and uv_map_right_roof == 0
				pts = []

				pts[0] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_right_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[1] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + external_front_position, external_right_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
				pts[2] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step] + external_front_position, external_right_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + roof_length]
				pts[3] = [uv_map_x_pos[step] * texture_width / uv_map_x_size[step], external_right_position, uv_map_y_pos[step] * texture_height / uv_map_y_size[step] + roof_length]
				face = uv_map_group_ents[step].add_face pts
				status = face.material = uv_map_texture[step] + texture_id
				point = Geom::Point3d.new(0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, external_right_height - uv_map_y_pos[step] * texture_height / uv_map_y_size[step])
				t = Geom::Transformation.new point
				uv_map_group[step].move! t
			   	point = Geom::Point3d.new((external_front_position - external_back_position) / 2, external_right_position, 0)
				t = Geom::Transformation.scaling(point, -1, -1, 1)
				uv_map_group[step].transform! t
				t = Geom::Transformation.rotation [external_front_position, external_right_position, external_right_height], X_AXIS, roof_angle.degrees
				uv_map_group[step].transform! t
				uv_map_right_roof = step + 1
				uv_map_right_roof_offsets = [0 - uv_map_x_pos[step] * texture_width / uv_map_x_size[step], 0, 0 - uv_map_y_pos[step] * texture_height / uv_map_y_size[step]]
			end
		end
	end
	
	
#####################
####	Draw walls ####
#####################


  entrance_doors_left = 0
  entrance_doors_left_pos = []
  windows_left = 0
  windows_left_pos = []
  entrance_doors_right = 0
  entrance_doors_right_pos = []
  hangar_doors_back = 0
  entrance_doors_back = 0
  entrance_doors_back_pos = []
  hangar_doors_front = 0
  entrance_doors_front = 0
  entrance_doors_front_pos = []
  entrance_doors_allowed = []
  for step in 0..back_door_count - 1
    if back_door_allowed[step] == 1
      entrance_doors_back_pos[entrance_doors_back] = [back_door_position[step], back_door_width[step], back_door_height[step], 0]
      entrance_doors_back += 1
      hangar_doors_back += 1
    end
  end
  for step in 0..entrance_door_count - 1
    entrance_doors_allowed[step] = 1
    if entrance_doors[step][0] == "L" and entrance_doors[step][2] == 0
      entrance_doors_left_pos[entrance_doors_left] = [entrance_doors[step][1], entrance_doors[step][3], entrance_doors[step][4], entrance_doors[step][2]]
      entrance_doors_left += 1
    elsif entrance_doors[step][0] == "R" and entrance_doors[step][2] == 0
      entrance_doors_right_pos[entrance_doors_right] = [entrance_doors[step][1], entrance_doors[step][3], entrance_doors[step][4], entrance_doors[step][2]]
      entrance_doors_right += 1
    elsif entrance_doors[step][0] == "B" and entrance_doors[step][2] == 0
      for step2 in 0..back_door_count - 1
        if (entrance_doors[step][1] > back_door_position[step2] and entrance_doors[step][1] < back_door_position[step2] + back_door_width[step2]) or (entrance_doors[step][1] + entrance_doors[step][3] > back_door_position[step2] and entrance_doors[step][1] + entrance_doors[step][3] < back_door_position[step2] + back_door_width[step2])
          entrance_doors_allowed[step] = 0
        end
      end
      if entrance_doors_allowed[step] == 1
        entrance_doors_back_pos[entrance_doors_back] = [entrance_doors[step][1], entrance_doors[step][3], entrance_doors[step][4], entrance_doors[step][2]]
        entrance_doors_back += 1
      end
    end
  end


  for step in 0..window_count - 1
    if entrance_doors[step][0] == "L" and entrance_doors[step][2] == 0
      windows_left_pos[windows_left] = [entrance_doors[step][1], entrance_doors[step][3], entrance_doors[step][4], entrance_doors[step][2]]
      windows_left += 1
    end    
  end
  
  ####################### CODE START NEW WALL DRAWING METHOD ######################## 
  
  draw_new_walls = 0
  
  if draw_new_walls == 1
    cutout_left_count = 0
    cutout_right_count = 0
    cutout_back_count = 0
    cutout_front_count = 0
    cutout_left = []
    for step in 0..entrance_door_count - 1
      if entrance_doors[step][0] == "L"
        cutout_allowed = 1
        left_xy = entrance_doors[step][1].to_f
        top_z = entrance_doors[step][2].to_f + entrance_doors[step][4].to_f
        right_xy = entrance_doors[step][1].to_f + entrance_doors[step][3].to_f
        bottom_z = entrance_doors[step][2].to_f
        for step2 in 0..cutout_left_count - 1
          co_left_xy = cutout_left[step2][0].to_f
          co_top_z = cutout_left[step2][1].to_f
          co_right_xy = cutout_left[step2][2].to_f
          co_bottom_z = cutout_left[step2][3].to_f
          ### Check top left ###
          if co_left_xy <= right_xy and co_top_z >= bottom_z and co_left_xy >= left_xy and co_top_z <= top_z
            cutout_allowed = 0
          end
          ### Check top right ###
          if co_right_xy >= left_xy and co_top_z >= bottom_z and co_right_xy <= right_xy and co_top_z <= top_z
            cutout_allowed = 0
          end
          ### Check bottom left ###
          if co_left_xy <= right_xy and co_bottom_z <= top_z and co_left_xy >= left_xy and co_bottom_z >= bottom_z
            cutout_allowed = 0
          end
          ### Check bottom right ###
          if co_right_xy >= left_xy and co_bottom_z <= top_z and co_right_xy <= right_xy and co_bottom_z >= bottom_z
            cutout_allowed = 0
          end
        end
      
        if cutout_allowed == 1
          cutout_left[cutout_left_count] = [left_xy, top_z, right_xy, bottom_z]
          cutout_left_count += 1
        end
      end
    end
  
    wall_group = []
  
    pts = []
    pts[0] = [external_back_position, foundation_wall_height]
    pts[1] = [external_back_position, external_left_height]
    pts[2] = [external_front_position, external_left_height]
    pts[3] = [external_front_position, foundation_wall_height]
    wall_group[0] = draw_wall(4, "Y-", 0, pts, wall_texture, cutout_left)
  
    exit

  end

  ####################### CODE END NEW WALL DRAWING METHOD ######################## 

  
	pts = []
	pts[0] = [external_back_position, external_left_position, foundation_wall_height]
	pts[1] = [external_back_position, external_left_position, external_left_height]
	pts[2] = [external_back_position, internal_arc_position, external_arc_height]
	pts[3] = [external_back_position, external_right_position, external_right_height]
	pts[4] = [external_back_position, external_right_position, foundation_wall_height]
  for step in 0..entrance_doors_back - 1
    pts[5 + step * 4] = [external_back_position, external_left_position + entrance_doors_back_pos[step][0] + entrance_doors_back_pos[step][1], foundation_wall_height]
    pts[6 + step * 4] = [external_back_position, external_left_position + entrance_doors_back_pos[step][0] + entrance_doors_back_pos[step][1], entrance_doors_back_pos[step][2]]
    pts[7 + step * 4] = [external_back_position, external_left_position + entrance_doors_back_pos[step][0], entrance_doors_back_pos[step][2]]
    pts[8 + step * 4] = [external_back_position, external_left_position + entrance_doors_back_pos[step][0], foundation_wall_height]
  end
	if uv_map_back_wall == 0
		face = group_ents.add_face pts
		status = face.material = wall_texture
		if wall_thickness == 0
			status = face.back_material = internal_wall_texture
		end
	end
	pts = []
  pts[0] = [external_back_position, external_left_position, foundation_wall_height]
  pts[1] = [external_back_position, external_left_position, external_left_height]
	pts[2] = [external_front_position, external_left_position, external_left_height]
	pts[3] = [external_front_position, external_left_position, foundation_wall_height]
  for step in 0..entrance_doors_left - 1
    pts[4 + step * 4] = [external_front_position - entrance_doors_left_pos[step][0], external_left_position, foundation_wall_height]
    pts[5 + step * 4] = [external_front_position - entrance_doors_left_pos[step][0], external_left_position, entrance_doors_left_pos[step][2]]
    pts[6 + step * 4] = [external_front_position - (entrance_doors_left_pos[step][0] + entrance_doors_left_pos[step][1]), external_left_position, entrance_doors_left_pos[step][2]]
    pts[7 + step * 4] = [external_front_position - (entrance_doors_left_pos[step][0] + entrance_doors_left_pos[step][1]), external_left_position, foundation_wall_height]
	end
	if uv_map_left_wall == 0
		face = group_ents.add_face pts
		if face.normal[1] > 0
			status = face.reverse!
		end
		status = face.material = wall_texture
		if wall_thickness == 0
			status = face.back_material = internal_wall_texture
		end
	end

	pts = []		
	pts[0] = [external_back_position, external_right_position, foundation_wall_height]
	pts[1] = [external_back_position, external_right_position, external_right_height]
	pts[2] = [external_front_position, external_right_position, external_right_height]
	pts[3] = [external_front_position, external_right_position, foundation_wall_height]
  for step in 0..entrance_doors_right - 1
    pts[4 + step * 4] = [external_front_position - entrance_doors_right_pos[step][0], external_right_position, foundation_wall_height]
    pts[5 + step * 4] = [external_front_position - entrance_doors_right_pos[step][0], external_right_position, entrance_doors_right_pos[step][2]]
    pts[6 + step * 4] = [external_front_position - (entrance_doors_right_pos[step][0] + entrance_doors_right_pos[step][1]), external_right_position, entrance_doors_right_pos[step][2]]
    pts[7 + step * 4] = [external_front_position - (entrance_doors_right_pos[step][0] + entrance_doors_right_pos[step][1]), external_right_position, foundation_wall_height]
  end
	if uv_map_right_wall == 0
		face = group_ents.add_face pts
		status = face.material = wall_texture
		if wall_thickness == 0
			status = face.back_material = internal_wall_texture
		end
	end
	
	# Front walls
	
	if multiple_doors == 0
		pts = []
		pts[0] = [external_front_position, external_left_position, foundation_wall_height]
		pts[1] = [external_front_position, external_left_position, external_left_height]
		pts[2] = [external_front_position, internal_arc_position, external_arc_height]
		pts[3] = [external_front_position, external_right_position, external_right_height]
		pts[4] = [external_front_position, external_right_position, foundation_wall_height]
		pts[5] = [external_front_position, door_right_position, foundation_wall_height]
		pts[6] = [external_front_position, door_right_position, door_height]
		pts[7] = [external_front_position, door_left_position, door_height]
		pts[8] = [external_front_position, door_left_position, foundation_wall_height]
		if uv_map_front_wall == 0
			if door_tail_height == 0
				face = group_ents.add_face pts
				if wall_thickness == 0
					status = face.back_material = internal_wall_texture
				end
			else
				pts[9] = [external_front_position, door_right_position, door_height]
				pts[10] = [external_front_position, door_right_position, door_height + door_tail_height]
				pts[11] = [external_front_position, door_left_position, door_height + door_tail_height]
				pts[12] = [external_front_position, door_left_position, door_height]
				face = group_ents.add_face pts[0], pts[1], pts[2], pts[3], pts[4], pts[5], pts[6], pts[9], pts[10], pts[11], pts[12], pts[7], pts[8]
			end
			if face.normal[0] < 0
				status = face.reverse!
			end
			status = face.material = wall_texture
			if wall_thickness == 0
				status = face.back_material = internal_wall_texture
			end
		end
	else
		pts = []
		pts[0] = [external_front_position, external_left_position, foundation_wall_height]
		pts[1] = [external_front_position, external_left_position, external_left_height]
		pts[2] = [external_front_position, internal_arc_position, external_arc_height]
		pts[3] = [external_front_position, external_right_position, external_right_height]
		pts[4] = [external_front_position, external_right_position, foundation_wall_height]
		for step in 1..multiple_doors
			current_door_left_position = ((multiple_doors + 1 - step)  * door_distance) + ((multiple_doors - step) * door_width)
			current_door_right_position = current_door_left_position + door_width
			pts[step * 4 + 1] = [external_front_position, current_door_right_position, foundation_wall_height]
			pts[step * 4 + 2] = [external_front_position, current_door_right_position, door_height]
			pts[step * 4 + 3] = [external_front_position, current_door_left_position, door_height]
			pts[step * 4 + 4] = [external_front_position, current_door_left_position, foundation_wall_height]
		end
		face = group_ents.add_face pts
		if face.normal[0] < 0
			status = face.reverse!
		end
		status = face.material = wall_texture
		if wall_thickness == 0
			status = face.back_material = internal_wall_texture
		end
		
	end
	
	if wall_thickness > 0
		pts = []
		pts[0] = [internal_back_position, internal_left_position, foundation_wall_height]
		pts[1] = [internal_back_position, internal_left_position, height - roof_left_offset]
		pts[2] = [internal_back_position, internal_arc_position, height + arc]
		pts[3] = [internal_back_position, internal_right_position, height - roof_right_offset]
		pts[4] = [internal_back_position, internal_right_position, foundation_wall_height]
    for step in 0..entrance_doors_back - 1
      pts[5 + step * 4] = [internal_back_position, external_left_position + entrance_doors_back_pos[step][0] + entrance_doors_back_pos[step][1], foundation_wall_height]
      pts[6 + step * 4] = [internal_back_position, external_left_position + entrance_doors_back_pos[step][0] + entrance_doors_back_pos[step][1], entrance_doors_back_pos[step][2]]
      pts[7 + step * 4] = [internal_back_position, external_left_position + entrance_doors_back_pos[step][0], entrance_doors_back_pos[step][2]]
      pts[8 + step * 4] = [internal_back_position, external_left_position + entrance_doors_back_pos[step][0], foundation_wall_height]
      if step < hangar_doors_back
        ptsx = []
        ptsx[0] = [external_back_position, external_left_position + entrance_doors_back_pos[step][0] + entrance_doors_back_pos[step][1], foundation_wall_height]
        ptsx[1] = [external_back_position, external_left_position + entrance_doors_back_pos[step][0] + entrance_doors_back_pos[step][1], entrance_doors_back_pos[step][2]]
        ptsx[2] = [external_back_position, external_left_position + entrance_doors_back_pos[step][0], entrance_doors_back_pos[step][2]]
        ptsx[3] = [external_back_position, external_left_position + entrance_doors_back_pos[step][0], foundation_wall_height]
        for step2 in 0..2
          face = group_ents.add_face pts[5 + step * 4 + step2], ptsx[step2], ptsx[step2 + 1], pts[6 + step * 4 + step2]
          status = face.material = internal_wall_texture
        end
        
        
      end
    end
		face = group_ents.add_face pts
		if face.normal[0] == -1
		  status = face.reverse!
		end
		status = face.material = internal_wall_texture
		
		if multiple_doors == 0
			pts = []
			pts[0] = [internal_front_position, internal_left_position, foundation_wall_height]
			pts[1] = [internal_front_position, internal_left_position, height - roof_left_offset]
			pts[2] = [internal_front_position, internal_arc_position, height+arc]
			pts[3] = [internal_front_position, internal_right_position, height - roof_right_offset]
			pts[4] = [internal_front_position, internal_right_position, foundation_wall_height]
			pts[5] = [internal_front_position, door_right_position, foundation_wall_height]
			pts[6] = [internal_front_position, door_right_position, door_height]
			pts[7] = [internal_front_position, door_left_position, door_height]
			pts[8] = [internal_front_position, door_left_position, foundation_wall_height]
		
			if door_tail_height == 0
				face = group_ents.add_face pts
			else
				pts[19] = [internal_front_position, door_right_position, door_height]
				pts[20] = [internal_front_position, door_right_position, door_height + door_tail_height]
				pts[21] = [internal_front_position, door_left_position, door_height + door_tail_height]
				pts[22] = [internal_front_position, door_left_position, door_height]
				face = group_ents.add_face pts[0], pts[1], pts[2], pts[3], pts[4], pts[5], pts[6], pts[19], pts[20], pts[21], pts[22], pts[7], pts[8]
			end
			if face.normal[0] > 0
				status = face.reverse!
			end
			status = face.material = internal_wall_texture
				
			pts[14] = [external_front_position, door_right_position, foundation_wall_height]
			pts[15] = [external_front_position, door_right_position, door_height]
			pts[16] = [external_front_position, door_left_position, door_height]
			pts[17] = [external_front_position, door_left_position, foundation_wall_height]
		
			face = group_ents.add_face pts[5], pts[14], pts[15], pts[6]
			status = face.material = wall_texture
			if door_tail_height == 0
				face = group_ents.add_face pts[6], pts[15], pts[16], pts[7]
				status = face.material = wall_texture
			else
				pts[9] = [external_front_position, wall_thickness + door_middle + (door_tail_width / 2), door_height]
				pts[10] = [external_front_position, wall_thickness + door_middle + (door_tail_width / 2), door_height + door_tail_height]
				pts[11] = [external_front_position, door_left_position, door_height + door_tail_height]
				pts[12] = [external_front_position, door_left_position, door_height]
				face = group_ents.add_face pts[15], pts[9], pts[19], pts[6]
				status = face.material = wall_texture
				face = group_ents.add_face pts[9], pts[19], pts[20], pts[10]
				status = face.material = wall_texture
				face = group_ents.add_face pts[10], pts[11], pts[21], pts[20]
				status = face.material = wall_texture
				face = group_ents.add_face pts[11], pts[12], pts[22], pts[21]
				status = face.material = wall_texture
				face = group_ents.add_face pts[12], pts[22], pts[7], pts[16]
				status = face.material = wall_texture
			end
			face = group_ents.add_face pts[7], pts[16], pts[17], pts[8]
			status = face.material = wall_texture
		
		else
			pts = []
			ptsx = []
			pts[0] = [internal_front_position, internal_left_position, foundation_wall_height]
			pts[1] = [internal_front_position, internal_left_position, height - roof_left_offset]
			pts[2] = [internal_front_position, internal_arc_position, height+arc]
			pts[3] = [internal_front_position, internal_right_position, height - roof_right_offset]
			pts[4] = [internal_front_position, internal_right_position, foundation_wall_height]
			for step in 1..multiple_doors
				current_door_left_position = ((multiple_doors + 1 - step)  * door_distance) + ((multiple_doors - step) * door_width)
				current_door_right_position = current_door_left_position + door_width
				pts[step * 4 + 1] = [internal_front_position, current_door_right_position, foundation_wall_height]
				pts[step * 4 + 2] = [internal_front_position, current_door_right_position, door_height]
				pts[step * 4 + 3] = [internal_front_position, current_door_left_position, door_height]
				pts[step * 4 + 4] = [internal_front_position, current_door_left_position, foundation_wall_height]
				ptsx[step * 4 + 1] = [external_front_position, current_door_right_position, foundation_wall_height]
				ptsx[step * 4 + 2] = [external_front_position, current_door_right_position, door_height]
				ptsx[step * 4 + 3] = [external_front_position, current_door_left_position, door_height]
				ptsx[step * 4 + 4] = [external_front_position, current_door_left_position, foundation_wall_height]
			end
			face = group_ents.add_face pts
			if face.normal[0] > 0
				status = face.reverse!
			end
			status = face.material = internal_wall_texture
			for step in 1..multiple_doors
				face = group_ents.add_face ptsx[step * 4 + 1], ptsx[step * 4 + 2], pts[step * 4 + 2], pts[step * 4 + 1]
				status = face.material = wall_texture
				face = group_ents.add_face ptsx[step * 4 + 2], ptsx[step * 4 + 3], pts[step * 4 + 3], pts[step * 4 + 2]
				status = face.material = wall_texture
				face = group_ents.add_face ptsx[step * 4 + 3], ptsx[step * 4 + 4], pts[step * 4 + 4], pts[step * 4 + 3]
				status = face.material = wall_texture
			end
			
		
		end
		pts = []		
		pts[0] = [internal_back_position, internal_right_position, foundation_wall_height]
		pts[1] = [internal_back_position, internal_right_position, height - roof_right_offset]
		pts[2] = [internal_front_position, internal_right_position, height - roof_right_offset]
		pts[3] = [internal_front_position, internal_right_position, foundation_wall_height]
    for step in 0..entrance_doors_right - 1
      pts[4 + step * 4] = [external_front_position - entrance_doors_right_pos[step][0], internal_right_position, foundation_wall_height]
      pts[5 + step * 4] = [external_front_position - entrance_doors_right_pos[step][0], internal_right_position, entrance_doors_right_pos[step][2]]
      pts[6 + step * 4] = [external_front_position - (entrance_doors_right_pos[step][0] + entrance_doors_right_pos[step][1]), internal_right_position, entrance_doors_right_pos[step][2]]
      pts[7 + step * 4] = [external_front_position - (entrance_doors_right_pos[step][0] + entrance_doors_right_pos[step][1]), internal_right_position, foundation_wall_height]
    end
		face = group_ents.add_face pts
		status = face.material = internal_wall_texture
	
		pts = []		
		pts[0] = [internal_back_position, internal_left_position, foundation_wall_height]
		pts[1] = [internal_back_position, internal_left_position, height - roof_left_offset]
		pts[2] = [internal_front_position, internal_left_position, height - roof_left_offset]
		pts[3] = [internal_front_position, internal_left_position, foundation_wall_height]
    for step in 0..entrance_doors_left - 1
      pts[4 + step * 4] = [external_front_position - entrance_doors_left_pos[step][0], internal_left_position, foundation_wall_height]
      pts[5 + step * 4] = [external_front_position - entrance_doors_left_pos[step][0], internal_left_position, entrance_doors_left_pos[step][2]]
      pts[6 + step * 4] = [external_front_position - (entrance_doors_left_pos[step][0] + entrance_doors_left_pos[step][1]), internal_left_position, entrance_doors_left_pos[step][2]]
      pts[7 + step * 4] = [external_front_position - (entrance_doors_left_pos[step][0] + entrance_doors_left_pos[step][1]), internal_left_position, foundation_wall_height]
    end
		face = group_ents.add_face pts
		status = face.material = internal_wall_texture
	end


###############################
#### Draw foundation walls ####
###############################

  if foundation_wall_height > 0
    fw_entrance_doors_left_start = []
    fw_entrance_doors_left_end = []
    for step in 0..entrance_doors_left - 1
      pts = []
      pts[0] = [external_front_position - entrance_doors_left_pos[step][0], external_left_position, 0]
      pts[1] = [external_front_position - entrance_doors_left_pos[step][0], external_left_position, foundation_wall_height]
      pts[2] = [external_front_position - entrance_doors_left_pos[step][0], internal_foundation_wall_left_position, foundation_wall_height]
      pts[3] = [external_front_position - entrance_doors_left_pos[step][0], internal_foundation_wall_left_position, 0]
      face = group_ents.add_face pts
      status = face.material = foundation_wall_texture
      pts = []
      pts[0] = [external_front_position - (entrance_doors_left_pos[step][0] + entrance_doors_left_pos[step][1]), external_left_position, foundation_wall_height]
      pts[1] = [external_front_position - (entrance_doors_left_pos[step][0] + entrance_doors_left_pos[step][1]), external_left_position, 0]
      pts[2] = [external_front_position - (entrance_doors_left_pos[step][0] + entrance_doors_left_pos[step][1]), internal_foundation_wall_left_position, 0]
      pts[3] = [external_front_position - (entrance_doors_left_pos[step][0] + entrance_doors_left_pos[step][1]), internal_foundation_wall_left_position, foundation_wall_height]
      face = group_ents.add_face pts
      status = face.material = foundation_wall_texture
      fw_entrance_doors_left_start[step] = external_front_position - entrance_doors_left_pos[step][0]
      fw_entrance_doors_left_end[step] = external_front_position - (entrance_doors_left_pos[step][0] + entrance_doors_left_pos[step][1])
    end
    fw_entrance_doors_left_start.sort!
    fw_entrance_doors_left_end.sort!

    for step in 1..entrance_doors_left - 1
      pts = []
      pts[0] = [fw_entrance_doors_left_end[step], external_left_position, 0]
      pts[1] = [fw_entrance_doors_left_end[step], external_left_position, foundation_wall_height]
      pts[2] = [fw_entrance_doors_left_end[step], internal_foundation_wall_left_position, foundation_wall_height]
      pts[3] = [fw_entrance_doors_left_end[step], internal_foundation_wall_left_position, 0]
      pts[4] = [fw_entrance_doors_left_start[step - 1], external_left_position, foundation_wall_height]
      pts[5] = [fw_entrance_doors_left_start[step - 1], external_left_position, 0]
      pts[6] = [fw_entrance_doors_left_start[step - 1], internal_foundation_wall_left_position, 0]
      pts[7] = [fw_entrance_doors_left_start[step - 1], internal_foundation_wall_left_position, foundation_wall_height]
      face = group_ents.add_face pts[0], pts[1], pts[4], pts[5]
      status = face.material = foundation_wall_texture
      face = group_ents.add_face pts[1], pts[2], pts[7], pts[4]
      status = face.material = foundation_wall_texture
      face = group_ents.add_face pts[2], pts[3], pts[6], pts[7]
      status = face.material = foundation_wall_texture
    end

    if entrance_doors_left > 0
      pts = []
      pts[0] = [fw_entrance_doors_left_end[0], external_left_position, 0]
      pts[1] = [fw_entrance_doors_left_end[0], external_left_position, foundation_wall_height]
      pts[2] = [fw_entrance_doors_left_end[0], internal_foundation_wall_left_position, foundation_wall_height]
      pts[3] = [fw_entrance_doors_left_end[0], internal_foundation_wall_left_position, 0]
      pts[4] = [external_back_position, external_left_position, foundation_wall_height]
      pts[5] = [external_back_position, external_left_position, 0]
      pts[6] = [internal_foundation_wall_back_position, internal_foundation_wall_left_position, 0]
      pts[7] = [internal_foundation_wall_back_position, internal_foundation_wall_left_position, foundation_wall_height]
      face = group_ents.add_face pts[0], pts[1], pts[4], pts[5]
      status = face.material = foundation_wall_texture
      face = group_ents.add_face pts[1], pts[2], pts[7], pts[4]
      status = face.material = foundation_wall_texture
      face = group_ents.add_face pts[2], pts[3], pts[6], pts[7]
      status = face.material = foundation_wall_texture
      pts = []
      pts[0] = [fw_entrance_doors_left_start[entrance_doors_left - 1], external_left_position, 0]
      pts[1] = [fw_entrance_doors_left_start[entrance_doors_left - 1], external_left_position, foundation_wall_height]
      pts[2] = [fw_entrance_doors_left_start[entrance_doors_left - 1], internal_foundation_wall_left_position, foundation_wall_height]
      pts[3] = [fw_entrance_doors_left_start[entrance_doors_left - 1], internal_foundation_wall_left_position, 0]
      pts[4] = [external_front_position, external_left_position, foundation_wall_height]
      pts[5] = [external_front_position, external_left_position, 0]
      pts[6] = [internal_foundation_wall_front_position, internal_foundation_wall_left_position, 0]
      pts[7] = [internal_foundation_wall_front_position, internal_foundation_wall_left_position, foundation_wall_height]
      face = group_ents.add_face pts[0], pts[1], pts[4], pts[5]
      status = face.material = foundation_wall_texture
      face = group_ents.add_face pts[1], pts[2], pts[7], pts[4]
      status = face.material = foundation_wall_texture
      face = group_ents.add_face pts[2], pts[3], pts[6], pts[7]
      status = face.material = foundation_wall_texture
    else
      pts = []
      pts[0] = [external_back_position, external_left_position, 0]
      pts[1] = [external_back_position, external_left_position, foundation_wall_height]
      pts[2] = [internal_foundation_wall_back_position, internal_foundation_wall_left_position, foundation_wall_height]
      pts[3] = [internal_foundation_wall_back_position, internal_foundation_wall_left_position, 0]
      pts[4] = [external_front_position, external_left_position, foundation_wall_height]
      pts[5] = [external_front_position, external_left_position, 0]
      pts[6] = [internal_foundation_wall_front_position, internal_foundation_wall_left_position, 0]
      pts[7] = [internal_foundation_wall_front_position, internal_foundation_wall_left_position, foundation_wall_height]
      face = group_ents.add_face pts[0], pts[1], pts[4], pts[5]
      status = face.material = foundation_wall_texture
      face = group_ents.add_face pts[1], pts[2], pts[7], pts[4]
      status = face.reverse!
      status = face.material = foundation_wall_texture
      face = group_ents.add_face pts[2], pts[3], pts[6], pts[7]
      status = face.material = foundation_wall_texture
    end
else
	if foundation_wall_height > 0
		if multiple_doors > 0
			door_left_position = door_distance
			door_right_position = multiple_doors * (door_distance + door_width)
			
			for step in 1..multiple_doors - 1
				pts = []
				current_foundation_left_position = step * (door_distance + door_width)
				current_foundation_right_position = current_foundation_left_position + door_distance
				pts[0] = [internal_foundation_wall_front_position, current_foundation_left_position, 0]
				pts[1] = [external_front_position, current_foundation_left_position, 0]
				pts[2] = [external_front_position, current_foundation_left_position, foundation_wall_height]
				pts[3] = [internal_foundation_wall_front_position, current_foundation_left_position, foundation_wall_height]
				face = group_ents.add_face pts
				status = face.material = foundation_wall_texture
				pts[4] = [internal_foundation_wall_front_position, current_foundation_right_position, foundation_wall_height]
				pts[5] = [external_front_position, current_foundation_right_position, foundation_wall_height]
				pts[6] = [external_front_position, current_foundation_right_position, 0]
				pts[7] = [internal_foundation_wall_front_position, current_foundation_right_position, 0]
				face = group_ents.add_face pts[1], pts[2], pts[5], pts[6]
				status = face.material = foundation_wall_texture
				face = group_ents.add_face pts[2], pts[3], pts[4], pts[5]
				status = face.material = foundation_wall_texture
				face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
				status = face.material = foundation_wall_texture
				face = group_ents.add_face pts[0], pts[3], pts[4], pts[7]
				status = face.material = foundation_wall_texture
							
			end
			
		end
		pts = []
		pts[0] = [external_back_position, external_left_position, 0]
		pts[1] = [external_front_position, external_left_position, 0]
		pts[2] = [external_front_position, external_left_position, foundation_wall_height]
		pts[3] = [external_back_position, external_left_position, foundation_wall_height]
		face = group_ents.add_face pts
		status = face.material = foundation_wall_texture
		pts[4] = [external_front_position, door_left_position, 0]
		pts[5] = [external_front_position, door_left_position, foundation_wall_height]
		pts[6] = [internal_foundation_wall_front_position, door_left_position, 0]
		pts[7] = [internal_foundation_wall_front_position, door_left_position, foundation_wall_height]
		pts[8] = [internal_foundation_wall_front_position, internal_foundation_wall_left_position, 0]
		pts[9] = [internal_foundation_wall_front_position, internal_foundation_wall_left_position, foundation_wall_height]
		pts[10] = [internal_foundation_wall_back_position, internal_foundation_wall_left_position, 0]
		pts[11] = [internal_foundation_wall_back_position, internal_foundation_wall_left_position, foundation_wall_height]
		pts[12] = [internal_foundation_wall_back_position, internal_foundation_wall_right_position, 0]
		pts[13] = [internal_foundation_wall_back_position, internal_foundation_wall_right_position, foundation_wall_height]
		pts[14] = [internal_foundation_wall_front_position, internal_foundation_wall_right_position, 0]
		pts[15] = [internal_foundation_wall_front_position, internal_foundation_wall_right_position, foundation_wall_height]
		pts[16] = [internal_foundation_wall_front_position, door_right_position, 0]
		pts[17] = [internal_foundation_wall_front_position, door_right_position, foundation_wall_height]
		pts[18] = [external_front_position, door_right_position, 0]
		pts[19] = [external_front_position, door_right_position, foundation_wall_height]
		pts[20] = [external_front_position, external_right_position, 0]
		pts[21] = [external_front_position, external_right_position, foundation_wall_height]
		pts[22] = [external_back_position, external_right_position, 0]
		pts[23] = [external_back_position, external_right_position, foundation_wall_height]
		pts[24] = [internal_front_position, door_left_position, foundation_wall_height]
		pts[25] = [internal_front_position, internal_left_position, foundation_wall_height]
		pts[26] = [internal_back_position, internal_left_position, foundation_wall_height]
		pts[27] = [internal_back_position, internal_right_position, foundation_wall_height]
		pts[28] = [internal_front_position, internal_right_position, foundation_wall_height]
		pts[29] = [internal_front_position, door_right_position, foundation_wall_height]
		
		face = group_ents.add_face pts[1], pts[2], pts[5], pts[4]
		status = face.material = foundation_wall_texture
		for step in 0..8
			face = group_ents.add_face pts[step * 2 + 4], pts[step * 2 + 5], pts[step * 2 + 7], pts[step * 2 + 6]
			status = face.material = foundation_wall_texture
		end
		face = group_ents.add_face pts[22], pts[23], pts[3], pts[0]
		status = face.material = foundation_wall_texture

		if foundation_wall_thickness > wall_thickness
			face = group_ents.add_face pts[7], pts[9], pts[11], pts[13], pts[15], pts[17], pts[29], pts[28], pts[27], pts[26], pts[25], pts[24]
			status = face.material = foundation_wall_texture
			if beam_type == "T" or beam_type == "New T"
				if foundation_wall_thickness - wall_thickness < beam_thickness * 3
					pts = []
					pts[0] = [internal_foundation_wall_back_position, internal_left_position + beam_thickness * 3 + beam_width, 0]
					pts[1] = [internal_foundation_wall_back_position, internal_left_position + beam_thickness * 3 + beam_width, foundation_wall_height]
					pts[2] = [internal_back_position + beam_thickness * 3, internal_left_position + beam_thickness * 3 + beam_width, 0]
					pts[3] = [internal_back_position + beam_thickness * 3, internal_left_position + beam_thickness * 3 + beam_width, foundation_wall_height]
					pts[4] = [internal_back_position + beam_thickness * 3, internal_left_position + beam_thickness * 3, 0]
					pts[5] = [internal_back_position + beam_thickness * 3, internal_left_position + beam_thickness * 3, foundation_wall_height]
					pts[6] = [internal_back_position + beam_thickness * 3 + beam_width, internal_left_position + beam_thickness * 3, 0]
					pts[7] = [internal_back_position + beam_thickness * 3 + beam_width, internal_left_position + beam_thickness * 3, foundation_wall_height]
					pts[8] = [internal_back_position + beam_thickness * 3 + beam_width, internal_foundation_wall_left_position, 0]
					pts[9] = [internal_back_position + beam_thickness * 3 + beam_width, internal_foundation_wall_left_position, foundation_wall_height]
					pts[10] = [internal_foundation_wall_back_position, internal_foundation_wall_left_position, foundation_wall_height]
					for step in 0..3
						face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
						status = face.material = foundation_wall_texture
					end
					face = group_ents.add_face pts[1], pts[3], pts[5], pts[7], pts[9], pts[10]
					status = face.material = foundation_wall_texture
				
					pts = []
					pts[0] = [internal_foundation_wall_front_position, internal_left_position + beam_thickness * 3 + beam_width, 0]
					pts[1] = [internal_foundation_wall_front_position, internal_left_position + beam_thickness * 3 + beam_width, foundation_wall_height]
					pts[2] = [internal_front_position - beam_thickness * 3, internal_left_position + beam_thickness * 3 + beam_width, 0]
					pts[3] = [internal_front_position - beam_thickness * 3, internal_left_position + beam_thickness * 3 + beam_width, foundation_wall_height]
					pts[4] = [internal_front_position - beam_thickness * 3, internal_left_position + beam_thickness * 3, 0]
					pts[5] = [internal_front_position - beam_thickness * 3, internal_left_position + beam_thickness * 3, foundation_wall_height]
					pts[6] = [internal_front_position - beam_thickness * 3 - beam_width, internal_left_position + beam_thickness * 3, 0]
					pts[7] = [internal_front_position - beam_thickness * 3 - beam_width, internal_left_position + beam_thickness * 3, foundation_wall_height]
					pts[8] = [internal_front_position - beam_thickness * 3 - beam_width, internal_foundation_wall_left_position, 0]
					pts[9] = [internal_front_position - beam_thickness * 3 - beam_width, internal_foundation_wall_left_position, foundation_wall_height]
					pts[10] = [internal_foundation_wall_front_position, internal_foundation_wall_left_position, foundation_wall_height]
					for step in 0..3
						face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
						if step == 0
							status = face.reverse!
						end
						status = face.material = foundation_wall_texture
					end
					face = group_ents.add_face pts[1], pts[3], pts[5], pts[7], pts[9], pts[10]
					status = face.material = foundation_wall_texture

					pts = []
					pts[0] = [internal_foundation_wall_back_position, internal_right_position - beam_thickness * 3 - beam_width, 0]
					pts[1] = [internal_foundation_wall_back_position, internal_right_position - beam_thickness * 3 - beam_width, foundation_wall_height]
					pts[2] = [internal_back_position + beam_thickness * 3, internal_right_position - beam_thickness * 3 - beam_width, 0]
					pts[3] = [internal_back_position + beam_thickness * 3, internal_right_position - beam_thickness * 3 - beam_width, foundation_wall_height]
					pts[4] = [internal_back_position + beam_thickness * 3, internal_right_position - beam_thickness * 3, 0]
					pts[5] = [internal_back_position + beam_thickness * 3, internal_right_position - beam_thickness * 3, foundation_wall_height]
					pts[6] = [internal_back_position + beam_thickness * 3 + beam_width, internal_right_position - beam_thickness * 3, 0]
					pts[7] = [internal_back_position + beam_thickness * 3 + beam_width, internal_right_position - beam_thickness * 3, foundation_wall_height]
					pts[8] = [internal_back_position + beam_thickness * 3 + beam_width, internal_foundation_wall_right_position, 0]
					pts[9] = [internal_back_position + beam_thickness * 3 + beam_width, internal_foundation_wall_right_position, foundation_wall_height]
					pts[10] = [internal_foundation_wall_back_position, internal_foundation_wall_right_position, foundation_wall_height]
					for step in 0..3
						face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
						if step == 0
							status = face.reverse!
						end
						status = face.material = foundation_wall_texture
					end
					face = group_ents.add_face pts[1], pts[3], pts[5], pts[7], pts[9], pts[10]
					status = face.material = foundation_wall_texture
				
					pts = []
					pts[0] = [internal_foundation_wall_front_position, internal_right_position - beam_thickness * 3 - beam_width, 0]
					pts[1] = [internal_foundation_wall_front_position, internal_right_position - beam_thickness * 3 - beam_width, foundation_wall_height]
					pts[2] = [internal_front_position - beam_thickness * 3, internal_right_position - beam_thickness * 3 - beam_width, 0]
					pts[3] = [internal_front_position - beam_thickness * 3, internal_right_position - beam_thickness * 3 - beam_width, foundation_wall_height]
					pts[4] = [internal_front_position - beam_thickness * 3, internal_right_position - beam_thickness * 3, 0]
					pts[5] = [internal_front_position - beam_thickness * 3, internal_right_position - beam_thickness * 3, foundation_wall_height]
					pts[6] = [internal_front_position - beam_thickness * 3 - beam_width, internal_right_position - beam_thickness * 3, 0]
					pts[7] = [internal_front_position - beam_thickness * 3 - beam_width, internal_right_position - beam_thickness * 3, foundation_wall_height]
					pts[8] = [internal_front_position - beam_thickness * 3 - beam_width, internal_foundation_wall_right_position, 0]
					pts[9] = [internal_front_position - beam_thickness * 3 - beam_width, internal_foundation_wall_right_position, foundation_wall_height]
					pts[10] = [internal_foundation_wall_front_position, internal_foundation_wall_right_position, foundation_wall_height]
					for step in 0..3
						face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
						status = face.material = foundation_wall_texture
					end
					face = group_ents.add_face pts[1], pts[3], pts[5], pts[7], pts[9], pts[10]
					status = face.material = foundation_wall_texture
				end
				if foundation_wall_thickness - wall_thickness < beam_thickness * 3 + beam_width
					if hangar_left_extension > 0
						pts = []
						pts[0] = [internal_foundation_wall_back_position, internal_left_beam_position - beam_thickness, 0]
						pts[1] = [internal_foundation_wall_back_position, internal_left_beam_position - beam_thickness, foundation_wall_height]
						pts[2] = [internal_back_position + beam_thickness * 3 + beam_width, internal_left_beam_position - beam_thickness, 0]
						pts[3] = [internal_back_position + beam_thickness * 3 + beam_width, internal_left_beam_position - beam_thickness , foundation_wall_height]
						pts[4] = [internal_back_position + beam_thickness * 3 + beam_width, internal_left_beam_position + beam_thickness * 3 + beam_width, 0]
						pts[5] = [internal_back_position + beam_thickness * 3 + beam_width, internal_left_beam_position + beam_thickness * 3 + beam_width, foundation_wall_height]
						pts[6] = [internal_foundation_wall_back_position, internal_left_beam_position + beam_thickness * 3 + beam_width, 0]
						pts[7] = [internal_foundation_wall_back_position, internal_left_beam_position + beam_thickness * 3 + beam_width, foundation_wall_height]
						for step in 0..2
							face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
							if step == 0
								status = face.reverse!
							end
							status = face.material = foundation_wall_texture
						end
						face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
						status = face.material = foundation_wall_texture
						pts = []
						pts[0] = [internal_foundation_wall_front_position, internal_left_beam_position - beam_thickness, 0]
						pts[1] = [internal_foundation_wall_front_position, internal_left_beam_position - beam_thickness, foundation_wall_height]
						pts[2] = [internal_front_position - beam_thickness * 3 - beam_width, internal_left_beam_position - beam_thickness, 0]
						pts[3] = [internal_front_position - beam_thickness * 3 - beam_width, internal_left_beam_position - beam_thickness , foundation_wall_height]
						pts[4] = [internal_front_position - beam_thickness * 3 - beam_width, internal_left_beam_position + beam_thickness * 3 + beam_width, 0]
						pts[5] = [internal_front_position - beam_thickness * 3 - beam_width, internal_left_beam_position + beam_thickness * 3 + beam_width, foundation_wall_height]
						pts[6] = [internal_foundation_wall_front_position, internal_left_beam_position + beam_thickness * 3 + beam_width, 0]
						pts[7] = [internal_foundation_wall_front_position, internal_left_beam_position + beam_thickness * 3 + beam_width, foundation_wall_height]
						for step in 0..2
							face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
							status = face.material = foundation_wall_texture
						end
						face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
						status = face.material = foundation_wall_texture
					else
						for beam_step in 2..beams - 1

							pts = []
							pts[0] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) - beam_width, internal_foundation_wall_left_position, 0]
							pts[1] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) - beam_width, internal_foundation_wall_left_position, foundation_wall_height]
							pts[2] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) - beam_width, internal_left_beam_position + beam_thickness * 3 + beam_width, 0]
							pts[3] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) - beam_width, internal_left_beam_position + beam_thickness * 3 + beam_width, foundation_wall_height]
							pts[4] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) + beam_width + beam_thickness * 3, internal_left_beam_position + beam_thickness * 3 + beam_width, 0]
							pts[5] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) + beam_width + beam_thickness * 3, internal_left_beam_position + beam_thickness * 3 + beam_width, foundation_wall_height]
							pts[6] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) + beam_width + beam_thickness * 3, internal_foundation_wall_left_position, 0]
							pts[7] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) + beam_width + beam_thickness * 3, internal_foundation_wall_left_position, foundation_wall_height]
						
							for step in 0..2
								face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
								status = face.material = foundation_wall_texture
							end
							face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
							status = face.material = foundation_wall_texture
						end
					end	
					if hangar_right_extension > 0
						pts = []
						pts[0] = [internal_foundation_wall_back_position, internal_right_beam_position + beam_thickness, 0]
						pts[1] = [internal_foundation_wall_back_position, internal_right_beam_position + beam_thickness, foundation_wall_height]
						pts[2] = [internal_back_position + beam_thickness * 3 + beam_width, internal_right_beam_position + beam_thickness, 0]
						pts[3] = [internal_back_position + beam_thickness * 3 + beam_width, internal_right_beam_position + beam_thickness , foundation_wall_height]
						pts[4] = [internal_back_position + beam_thickness * 3 + beam_width, internal_right_beam_position - beam_thickness * 3 - beam_width, 0]
						pts[5] = [internal_back_position + beam_thickness * 3 + beam_width, internal_right_beam_position - beam_thickness * 3 - beam_width, foundation_wall_height]
						pts[6] = [internal_foundation_wall_back_position, internal_right_beam_position - beam_thickness * 3 - beam_width, 0]
						pts[7] = [internal_foundation_wall_back_position, internal_right_beam_position - beam_thickness * 3 - beam_width, foundation_wall_height]
						for step in 0..2
							face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
							status = face.material = foundation_wall_texture
						end
						face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
						status = face.material = foundation_wall_texture
						pts = []
						pts[0] = [internal_foundation_wall_front_position, internal_right_beam_position + beam_thickness, 0]
						pts[1] = [internal_foundation_wall_front_position, internal_right_beam_position + beam_thickness, foundation_wall_height]
						pts[2] = [internal_front_position - beam_thickness * 3 - beam_width, internal_right_beam_position + beam_thickness, 0]
						pts[3] = [internal_front_position - beam_thickness * 3 - beam_width, internal_right_beam_position + beam_thickness , foundation_wall_height]
						pts[4] = [internal_front_position - beam_thickness * 3 - beam_width, internal_right_beam_position - beam_thickness * 3 - beam_width, 0]
						pts[5] = [internal_front_position - beam_thickness * 3 - beam_width, internal_right_beam_position - beam_thickness * 3 - beam_width, foundation_wall_height]
						pts[6] = [internal_foundation_wall_front_position, internal_right_beam_position - beam_thickness * 3 - beam_width, 0]
						pts[7] = [internal_foundation_wall_front_position, internal_right_beam_position - beam_thickness * 3 - beam_width, foundation_wall_height]
						for step in 0..2
							face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
							if step == 0
								status = face.reverse!
							end
							status = face.material = foundation_wall_texture
						end
						face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
						status = face.material = foundation_wall_texture
					else
						for beam_step in 2..beams - 1
							pts = []
							pts[0] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) - beam_width, internal_foundation_wall_right_position, 0]
							pts[1] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) - beam_width, internal_foundation_wall_right_position, foundation_wall_height]
							pts[2] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) - beam_width, internal_right_beam_position - beam_thickness * 3 - beam_width, 0]
							pts[3] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) - beam_width, internal_right_beam_position - beam_thickness * 3 - beam_width, foundation_wall_height]
							pts[4] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) + beam_width + beam_thickness * 3, internal_right_beam_position - beam_thickness * 3 - beam_width, 0]
							pts[5] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) + beam_width + beam_thickness * 3, internal_right_beam_position - beam_thickness * 3 - beam_width, foundation_wall_height]
							pts[6] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) + beam_width + beam_thickness * 3, internal_foundation_wall_right_position, 0]
							pts[7] = [internal_back_position +((spacing +((beam_width * 2) + beam_thickness)) *(beam_step - 1)) + beam_width + beam_thickness * 3, internal_foundation_wall_right_position, foundation_wall_height]
						
							for step in 0..2
								face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
								if step == 0
									status = face.reverse!
								end
								status = face.material = foundation_wall_texture
							end
							face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
							status = face.material = foundation_wall_texture
						end
					end	
				end
			else # All other beam profiles
				if foundation_wall_thickness - wall_thickness < beam_thickness * 2 + beam_depth
					pts = []
					pts[0] = [internal_foundation_wall_back_position, internal_left_position + beam_thickness * 2 + beam_depth, 0]
					pts[1] = [internal_foundation_wall_back_position, internal_left_position + beam_thickness * 2 + beam_depth, foundation_wall_height]
					pts[2] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_left_position + beam_thickness * 2 + beam_depth, 0]
					pts[3] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_left_position + beam_thickness * 2 + beam_depth , foundation_wall_height]
					pts[4] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_foundation_wall_left_position, 0]
					pts[5] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_foundation_wall_left_position, foundation_wall_height]
					pts[6] = [internal_foundation_wall_back_position, internal_foundation_wall_left_position, foundation_wall_height]
						
					face = group_ents.add_face pts[0], pts[1], pts[3], pts[2]
					status = face.material = foundation_wall_texture
					face = group_ents.add_face pts[2], pts[3], pts[5], pts[4]
					status = face.material = foundation_wall_texture
					face = group_ents.add_face pts[1], pts[3], pts[5], pts[6]
					status = face.material = foundation_wall_texture
				
					pts = []
					pts[0] = [internal_foundation_wall_front_position, internal_left_position + beam_thickness * 2 + beam_depth, 0]
					pts[1] = [internal_foundation_wall_front_position, internal_left_position + beam_thickness * 2 + beam_depth, foundation_wall_height]
					pts[2] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_left_position + beam_thickness * 2 + beam_depth, 0]
					pts[3] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_left_position + beam_thickness * 2 + beam_depth , foundation_wall_height]
					pts[4] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_foundation_wall_left_position, 0]
					pts[5] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_foundation_wall_left_position, foundation_wall_height]
					pts[6] = [internal_foundation_wall_front_position, internal_foundation_wall_left_position, foundation_wall_height]
						
					face = group_ents.add_face pts[0], pts[1], pts[3], pts[2]
					if face.normal[1] < 0
						status = face.reverse!
					end
					status = face.material = foundation_wall_texture
					face = group_ents.add_face pts[2], pts[3], pts[5], pts[4]
					status = face.material = foundation_wall_texture
					face = group_ents.add_face pts[1], pts[3], pts[5], pts[6]
					status = face.material = foundation_wall_texture
				
					pts = []
					pts[0] = [internal_foundation_wall_back_position, internal_right_position - beam_thickness * 2 - beam_depth, 0]
					pts[1] = [internal_foundation_wall_back_position, internal_right_position - beam_thickness * 2 - beam_depth, foundation_wall_height]
					pts[2] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_right_position - beam_thickness * 2 - beam_depth, 0]
					pts[3] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_right_position - beam_thickness * 2 - beam_depth, foundation_wall_height]
					pts[4] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_foundation_wall_right_position, 0]
					pts[5] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_foundation_wall_right_position, foundation_wall_height]
					pts[6] = [internal_foundation_wall_back_position, internal_foundation_wall_right_position, foundation_wall_height]
						
					face = group_ents.add_face pts[0], pts[1], pts[3], pts[2]
					if face.normal[1] > 0
						status = face.reverse!
					end
					status = face.material = foundation_wall_texture
					face = group_ents.add_face pts[2], pts[3], pts[5], pts[4]
					status = face.material = foundation_wall_texture
					face = group_ents.add_face pts[1], pts[3], pts[5], pts[6]
					status = face.material = foundation_wall_texture
				
					pts = []
					pts[0] = [internal_foundation_wall_front_position, internal_right_position - beam_thickness * 2 - beam_depth, 0]
					pts[1] = [internal_foundation_wall_front_position, internal_right_position - beam_thickness * 2 - beam_depth, foundation_wall_height]
					pts[2] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_right_position - beam_thickness * 2 - beam_depth, 0]
					pts[3] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_right_position - beam_thickness * 2 - beam_depth, foundation_wall_height]
					pts[4] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_foundation_wall_right_position, 0]
					pts[5] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_foundation_wall_right_position, foundation_wall_height]
					pts[6] = [internal_foundation_wall_front_position, internal_foundation_wall_right_position, foundation_wall_height]
						
					face = group_ents.add_face pts[0], pts[1], pts[3], pts[2]
					status = face.material = foundation_wall_texture
					face = group_ents.add_face pts[2], pts[3], pts[5], pts[4]
					status = face.material = foundation_wall_texture
					face = group_ents.add_face pts[1], pts[3], pts[5], pts[6]
					status = face.material = foundation_wall_texture

					if hangar_left_extension == 0 or beam_type == "New H"
						for beam_step in 2..beams - 1
							pts = []
							pts[0] = [internal_back_position +((spacing + fullbeam_size) *(beam_step - 1)), internal_foundation_wall_left_position, 0]
							pts[1] = [internal_back_position +((spacing + fullbeam_size) *(beam_step - 1)), internal_foundation_wall_left_position, foundation_wall_height]
							pts[2] = [internal_back_position +((spacing + fullbeam_size) *(beam_step - 1)), internal_left_position + beam_thickness * 2 + beam_depth, 0]
							pts[3] = [internal_back_position +((spacing + fullbeam_size) *(beam_step - 1)), internal_left_position + beam_thickness * 2 + beam_depth, foundation_wall_height]
							pts[4] = [internal_back_position +((spacing + fullbeam_size) *(beam_step - 1)) + fullbeam_size + beam_thickness * 2, internal_left_position + beam_thickness * 2 + beam_depth, 0]
							pts[5] = [internal_back_position +((spacing + fullbeam_size) *(beam_step - 1)) + fullbeam_size + beam_thickness * 2, internal_left_position + beam_thickness * 2 + beam_depth, foundation_wall_height]
							pts[6] = [internal_back_position +((spacing + fullbeam_size) *(beam_step - 1)) + fullbeam_size + beam_thickness * 2, internal_foundation_wall_left_position, 0]
							pts[7] = [internal_back_position +((spacing + fullbeam_size) *(beam_step - 1)) + fullbeam_size + beam_thickness * 2, internal_foundation_wall_left_position, foundation_wall_height]
						
							for step in 0..2
								face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
								status = face.material = foundation_wall_texture
							end
							face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
							status = face.material = foundation_wall_texture

						end				
					end
					if hangar_left_extension > 0
						pts = []
						pts[0] = [internal_foundation_wall_back_position, internal_left_beam_position + beam_thickness * 2 + beam_depth, 0]
						pts[1] = [internal_foundation_wall_back_position, internal_left_beam_position + beam_thickness * 2 + beam_depth, foundation_wall_height]
						pts[2] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_left_beam_position + beam_thickness * 2 + beam_depth, 0]
						pts[3] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_left_beam_position + beam_thickness * 2 + beam_depth , foundation_wall_height]
						pts[4] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_left_beam_position, 0]
						pts[5] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_left_beam_position, foundation_wall_height]
						pts[6] = [internal_foundation_wall_back_position, internal_left_beam_position, 0]
						pts[7] = [internal_foundation_wall_back_position, internal_left_beam_position, foundation_wall_height]
						
						face = group_ents.add_face pts[0], pts[1], pts[3], pts[2]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[2], pts[3], pts[5], pts[4]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[4], pts[5], pts[7], pts[6]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
						status = face.material = foundation_wall_texture
				
						pts = []
						pts[0] = [internal_foundation_wall_front_position, internal_left_beam_position + beam_thickness * 2 + beam_depth, 0]
						pts[1] = [internal_foundation_wall_front_position, internal_left_beam_position + beam_thickness * 2 + beam_depth, foundation_wall_height]
						pts[2] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_left_beam_position + beam_thickness * 2 + beam_depth, 0]
						pts[3] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_left_beam_position + beam_thickness * 2 + beam_depth , foundation_wall_height]
						pts[4] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_left_beam_position, 0]
						pts[5] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_left_beam_position, foundation_wall_height]
						pts[6] = [internal_foundation_wall_front_position, internal_left_beam_position, 0]
						pts[7] = [internal_foundation_wall_front_position, internal_left_beam_position, foundation_wall_height]
							
						face = group_ents.add_face pts[0], pts[1], pts[3], pts[2]
						if face.normal[1] < 0
							status = face.reverse!
						end
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[2], pts[3], pts[5], pts[4]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[4], pts[5], pts[7], pts[6]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
						status = face.material = foundation_wall_texture
					end
					if hangar_right_extension > 0
						pts = []
						pts[0] = [internal_foundation_wall_back_position, internal_right_beam_position - beam_thickness * 2 - beam_depth, 0]
						pts[1] = [internal_foundation_wall_back_position, internal_right_beam_position - beam_thickness * 2 - beam_depth, foundation_wall_height]
						pts[2] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_right_beam_position - beam_thickness * 2 - beam_depth, 0]
						pts[3] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_right_beam_position - beam_thickness * 2 - beam_depth , foundation_wall_height]
						pts[4] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_right_beam_position, 0]
						pts[5] = [internal_back_position + beam_thickness * 2 + fullbeam_size, internal_right_beam_position, foundation_wall_height]
						pts[6] = [internal_foundation_wall_back_position, internal_right_beam_position, 0]
						pts[7] = [internal_foundation_wall_back_position, internal_right_beam_position, foundation_wall_height]
						
						face = group_ents.add_face pts[0], pts[1], pts[3], pts[2]
						if face.normal[1] > 0
							status = face.reverse!
						end
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[2], pts[3], pts[5], pts[4]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[4], pts[5], pts[7], pts[6]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
						status = face.material = foundation_wall_texture
				
						pts = []
						pts[0] = [internal_foundation_wall_front_position, internal_right_beam_position - beam_thickness * 2 - beam_depth, 0]
						pts[1] = [internal_foundation_wall_front_position, internal_right_beam_position - beam_thickness * 2 - beam_depth, foundation_wall_height]
						pts[2] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_right_beam_position - beam_thickness * 2 - beam_depth, 0]
						pts[3] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_right_beam_position - beam_thickness * 2 - beam_depth , foundation_wall_height]
						pts[4] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_right_beam_position, 0]
						pts[5] = [internal_front_position - beam_thickness * 2 - fullbeam_size, internal_right_beam_position, foundation_wall_height]
						pts[6] = [internal_foundation_wall_front_position, internal_right_beam_position, 0]
						pts[7] = [internal_foundation_wall_front_position, internal_right_beam_position, foundation_wall_height]
							
						face = group_ents.add_face pts[0], pts[1], pts[3], pts[2]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[2], pts[3], pts[5], pts[4]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[4], pts[5], pts[7], pts[6]
						status = face.material = foundation_wall_texture
						face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
						status = face.material = foundation_wall_texture
					end
					if hangar_right_extension == 0 or beam_type == "New H"
						for beam_step in 2..beams - 1
							pts = []
							pts[0] = [internal_back_position + ((spacing + fullbeam_size) *(beam_step - 1)), internal_foundation_wall_right_position, 0]
							pts[1] = [internal_back_position + ((spacing + fullbeam_size) *(beam_step - 1)), internal_foundation_wall_right_position, foundation_wall_height]
							pts[2] = [internal_back_position + ((spacing + fullbeam_size) *(beam_step - 1)), internal_right_position - beam_thickness * 2 - beam_depth, 0]
							pts[3] = [internal_back_position + ((spacing + fullbeam_size) *(beam_step - 1)), internal_right_position - beam_thickness * 2 - beam_depth, foundation_wall_height]
							pts[4] = [internal_back_position + ((spacing + fullbeam_size) *(beam_step - 1)) + fullbeam_size + beam_thickness * 2, internal_right_position - beam_thickness * 2 - beam_depth, 0]
							pts[5] = [internal_back_position + ((spacing + fullbeam_size) *(beam_step - 1)) + fullbeam_size + beam_thickness * 2, internal_right_position - beam_thickness * 2 - beam_depth, foundation_wall_height]
							pts[6] = [internal_back_position + ((spacing + fullbeam_size) *(beam_step - 1)) + fullbeam_size + beam_thickness * 2, internal_foundation_wall_right_position, 0]
							pts[7] = [internal_back_position + ((spacing + fullbeam_size) *(beam_step - 1)) + fullbeam_size + beam_thickness * 2, internal_foundation_wall_right_position, foundation_wall_height]
						
							for step in 0..2
								face = group_ents.add_face pts[step * 2], pts[step * 2 + 1], pts[step * 2 + 3], pts[step * 2 + 2]
								if step == 0 and face.normal[0] > 0
									status = face.reverse!
								end
								status = face.material = foundation_wall_texture
							end
							face = group_ents.add_face pts[1], pts[3], pts[5], pts[7]
							status = face.material = foundation_wall_texture

						end				
					end
				end
			end
		end
	end
end

####################
#### Draw signs ####
####################
	
	if sign_count > 0
		for step in 0..sign_count - 1
			sign_group = draw_signs(sign_type[step], sign_texture[step], door_frame_texture, sign_wall[step], sign_x_pos[step], sign_y_pos[step], sign_x_size[step], sign_y_size[step], sign_thickness[step], sign_filled[step], sign_double_sided[step], external_front_position, external_back_position, external_left_position, external_right_position)
			group = group.parent.entities.add_group([group, sign_group])
		end
	end


######################
#### Draw windows ####
######################

	if window_count > 0
		for step in 0..window_count - 1
			if window_y_pos[step] < foundation_wall_height
				window_y_pos[step] = foundation_wall_height
			end
			if window_wall[step] == "L"
				if window_y_size[step] + window_y_pos[step] > internal_height - roof_left_offset
					window_y_size[step] = internal_height - window_y_pos[step] - hangar_left_extension * roof_slope - beam_thickness
				end

				for window_step in 0..window_repeat[step] - 1
					do_not_draw = 0
					if external_front_position - window_x_pos[step] - ((window_x_size[step] + window_gap[step]) * window_step) - window_x_size[step] < internal_back_position
							do_not_draw = 1
					end
					if do_not_draw == 0
						window_group = draw_window(window_x_pos[step] + ((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step], window_x_size[step], window_y_size[step], window_wall[step], window_texture[step], window_back_texture[step], window_transparency[step], wall_thickness, external_left_position, external_right_position, external_front_position, external_back_position)
						group = group.parent.entities.add_group([group, window_group])
					end
				end
			elsif window_wall[step] == "R"
				if window_y_size[step] + window_y_pos[step] > internal_height - roof_right_offset
					window_y_size[step] = internal_height - window_y_pos[step] - roof_right_offset
				end
				for window_step in 0..window_repeat[step] - 1
					do_not_draw = 0
					if external_front_position - window_x_pos[step] -((window_x_size[step] + window_gap[step]) * window_step) - window_x_size[step] < internal_back_position
							do_not_draw = 1
					end
					if do_not_draw == 0
						pts = []
						if uv_map_right_wall == 0
							pts[0] = [external_front_position - window_x_pos[step] -((window_x_size[step] + window_gap[step]) * window_step), external_right_position, window_y_pos[step]]
							pts[1] = [external_front_position - window_x_pos[step] - window_x_size[step] -((window_x_size[step] + window_gap[step]) * window_step), external_right_position, window_y_pos[step]]
							pts[2] = [external_front_position - window_x_pos[step] - window_x_size[step] -((window_x_size[step] + window_gap[step]) * window_step), external_right_position, window_y_pos[step] + window_y_size[step]]
							pts[3] = [external_front_position - window_x_pos[step] -((window_x_size[step] + window_gap[step]) * window_step), external_right_position, window_y_pos[step] + window_y_size[step]]
							face = group_ents.add_face pts
							status = face.erase!
						else
							pts[0] = [external_back_position + window_x_pos[step] +((window_x_size[step] - window_gap[step]) * window_step), external_right_position, window_y_pos[step]]
							pts[1] = [external_back_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] - window_gap[step]) * window_step), external_right_position, window_y_pos[step]]
							pts[2] = [external_back_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] - window_gap[step]) * window_step), external_right_position, window_y_pos[step] + window_y_size[step]]
							pts[3] = [external_back_position + window_x_pos[step] +((window_x_size[step] - window_gap[step]) * window_step), external_right_position, window_y_pos[step] + window_y_size[step]]
							for pts_step in 0..3
								pts[pts_step][0] = pts[pts_step][0] - uv_map_right_offsets[0]
								pts[pts_step][1] = pts[pts_step][1] - uv_map_right_offsets[1]
								pts[pts_step][2] = pts[pts_step][2] - uv_map_right_offsets[2]
							end
							face = uv_map_group_ents[uv_map_right_wall - 1].add_face pts
							
							status = face.erase!
						end
						if wall_thickness > 0
							pts[4] = [external_front_position - window_x_pos[step] -((window_x_size[step] + window_gap[step]) * window_step), internal_right_position, window_y_pos[step]]
							pts[5] = [external_front_position - window_x_pos[step] - window_x_size[step] -((window_x_size[step] + window_gap[step]) * window_step), internal_right_position, window_y_pos[step]]
							pts[6] = [external_front_position - window_x_pos[step] - window_x_size[step] -((window_x_size[step] + window_gap[step]) * window_step), internal_right_position, window_y_pos[step] + window_y_size[step]]
							pts[7] = [external_front_position - window_x_pos[step] -((window_x_size[step] + window_gap[step]) * window_step), internal_right_position, window_y_pos[step] + window_y_size[step]]
							face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
							status = face.erase!
							if uv_map_right_wall > 0
								pts[0] = [external_front_position - window_x_pos[step] -((window_x_size[step] + window_gap[step]) * window_step), external_right_position, window_y_pos[step]]
								pts[1] = [external_front_position - window_x_pos[step] - window_x_size[step] -((window_x_size[step] + window_gap[step]) * window_step), external_right_position, window_y_pos[step]]
								pts[2] = [external_front_position - window_x_pos[step] - window_x_size[step] -((window_x_size[step] + window_gap[step]) * window_step), external_right_position, window_y_pos[step] + window_y_size[step]]
								pts[3] = [external_front_position - window_x_pos[step] -((window_x_size[step] + window_gap[step]) * window_step), external_right_position, window_y_pos[step] + window_y_size[step]]
							end
	
							face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
							if face.normal[0] < 0
								status = face.reverse!
							end
							status = face.material = wall_texture
							face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
							status = face.material = wall_texture
							face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
							status = face.material = wall_texture
							face = group_ents.add_face pts[3], pts[0], pts[4], pts[7]
							status = face.material = wall_texture
						end
	
						window_group = draw_window(window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step], window_x_size[step], window_y_size[step], window_wall[step], window_texture[step], window_back_texture[step], window_transparency[step], wall_thickness, external_left_position, external_right_position, external_front_position, external_back_position)
						group = group.parent.entities.add_group([group, window_group])
					end
				end
			elsif window_wall[step] == "B"
				for window_step in 0..window_repeat[step] - 1

					do_not_draw = 0
		#			if back_door == 1
			#			if(external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) > door_middle - door_width / 2 and external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) < door_middle + door_width / 2 and window_y_pos[step] < door_height) or(external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) + window_x_size[step] > door_middle - door_width / 2 and external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) + window_x_size[step] < door_middle + door_width / 2 and window_y_pos[step] < door_height) or external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) + window_x_size[step] > internal_right_position
				#			do_not_draw = 1
					#	end
				#	els
					if external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) + window_x_size[step] > internal_right_position
							do_not_draw = 1
					end
					if do_not_draw == 0
						pts = []
						if uv_map_back_wall == 0
							pts[0] = [external_back_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
							pts[1] = [external_back_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
							pts[2] = [external_back_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							pts[3] = [external_back_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							face = group_ents.add_face pts
							status = face.erase!
						else
							pts[0] = [external_back_position, external_right_position - window_x_pos[step] -((window_x_size[step] - window_gap[step]) * window_step), window_y_pos[step]]
							pts[1] = [external_back_position, external_right_position - window_x_pos[step] - window_x_size[step] -((window_x_size[step] - window_gap[step]) * window_step), window_y_pos[step]]
							pts[2] = [external_back_position, external_right_position - window_x_pos[step] - window_x_size[step] -((window_x_size[step] - window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							pts[3] = [external_back_position, external_right_position - window_x_pos[step] -((window_x_size[step] - window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							for pts_step in 0..3
								temp_pts = pts[pts_step][0]
								pts[pts_step][0] = pts[pts_step][1] - uv_map_back_offsets[1]
								pts[pts_step][1] = temp_pts - uv_map_back_offsets[0]
								pts[pts_step][2] = pts[pts_step][2] - uv_map_back_offsets[2]
							end
							face = uv_map_group_ents[uv_map_back_wall - 1].add_face pts
							
							status = face.erase!
						end
						if wall_thickness > 0
							if uv_map_back_wall > 0
								pts[0] = [external_back_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
								pts[1] = [external_back_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
								pts[2] = [external_back_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
								pts[3] = [external_back_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							end
							pts[4] = [internal_back_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
							pts[5] = [internal_back_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
							pts[6] = [internal_back_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							pts[7] = [internal_back_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
							status = face.erase!
							face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
							if face.normal[0] < 0
								status = face.reverse!
							end
							status = face.material = wall_texture
							face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
							status = face.material = wall_texture
							face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
							status = face.material = wall_texture
							face = group_ents.add_face pts[3], pts[0], pts[4], pts[7]
							status = face.material = wall_texture
						end
	
						window_group = draw_window(window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step], window_x_size[step], window_y_size[step], window_wall[step], window_texture[step], window_back_texture[step], window_transparency[step], wall_thickness, external_left_position, external_right_position, external_front_position, external_back_position)
						group = group.parent.entities.add_group([group, window_group])
					end
				end
			elsif window_wall[step] == "F"
				for window_step in 0..window_repeat[step] - 1
					do_not_draw = 0
					
					if(external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) > door_middle - door_width / 2 and external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) < door_middle + door_width / 2 and window_y_pos[step] < door_height) or(external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) + window_x_size[step] > door_middle - door_width / 2 and external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) + window_x_size[step] < door_middle + door_width / 2 and window_y_pos[step] < door_height) or external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step) + window_x_size[step] > internal_right_position
						do_not_draw = 1
					end
					
					if do_not_draw == 0
					
						pts = []
						pts[0] = [external_front_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
						pts[1] = [external_front_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
						pts[2] = [external_front_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
						pts[3] = [external_front_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
						if uv_map_front_wall == 0
							face = group_ents.add_face pts
							status = face.erase!
						else
							for pts_step in 0..3
								temp_pts = pts[pts_step][0]
								pts[pts_step][0] = pts[pts_step][1] - uv_map_front_offsets[1]
								pts[pts_step][1] = temp_pts - uv_map_front_offsets[0]
								pts[pts_step][2] = pts[pts_step][2] - uv_map_front_offsets[2]
							end
							face = uv_map_group_ents[uv_map_front_wall - 1].add_face pts
							status = face.erase!
						end
						if wall_thickness > 0
							if uv_map_front_wall > 0
								pts[0] = [external_front_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
								pts[1] = [external_front_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
								pts[2] = [external_front_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
								pts[3] = [external_front_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							end
							pts[4] = [internal_front_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
							pts[5] = [internal_front_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step]]
							pts[6] = [internal_front_position, external_left_position + window_x_pos[step] + window_x_size[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							pts[7] = [internal_front_position, external_left_position + window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step] + window_y_size[step]]
							face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
							status = face.erase!
							face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
							if face.normal[0] < 0
								status = face.reverse!
							end
							status = face.material = wall_texture
							face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
							status = face.material = wall_texture
							face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
							status = face.material = wall_texture
							face = group_ents.add_face pts[3], pts[0], pts[4], pts[7]
							status = face.material = wall_texture
						end
	
						window_group = draw_window(window_x_pos[step] +((window_x_size[step] + window_gap[step]) * window_step), window_y_pos[step], window_x_size[step], window_y_size[step], window_wall[step], window_texture[step], window_back_texture[step], window_transparency[step], wall_thickness, external_left_position, external_right_position, external_front_position, external_back_position)
						group = group.parent.entities.add_group([group, window_group])
					end
				end
			
			
			
			elsif window_wall[step][0..0] == "T"   # for window testing purposes - First letter to indicate testing, next characters to indicate window type.
				if window_wall[step][1..1] == "0" 

					frame_x_size = window_x_size[step] + wall_thickness * 2
					frame_y_size = window_y_size[step] + wall_thickness * 2
					frame_width = wall_thickness
					frame_thickness = 2 / $inch
					window_thickness = wall_thickness + frame_thickness * 2
					window_frame_thickness = wall_thickness / 2
					window_pane_position = window_frame_thickness / 2
					window_pane_middle = frame_y_size / 2

					pts = []
					pts[0] = [external_front_position - window_x_pos[step] + frame_width, external_left_position, window_y_pos[step] - frame_width]
					pts[1] = [external_front_position - window_x_pos[step] - window_x_size[step] - frame_width, external_left_position, window_y_pos[step] - frame_width]
					pts[2] = [external_front_position - window_x_pos[step] - window_x_size[step] - frame_width, external_left_position, window_y_pos[step] + window_y_size[step] + frame_width]
					pts[3] = [external_front_position - window_x_pos[step] + frame_width, external_left_position, window_y_pos[step] + window_y_size[step] + frame_width]
					face = group_ents.add_face pts
					status = face.erase!
					if wall_thickness > 0
						pts[4] = [external_front_position - window_x_pos[step] + frame_width, internal_left_position, window_y_pos[step] - frame_width]
						pts[5] = [external_front_position - window_x_pos[step] - window_x_size[step] - frame_width, internal_left_position, window_y_pos[step] - frame_width]
						pts[6] = [external_front_position - window_x_pos[step] - window_x_size[step] - frame_width, internal_left_position, window_y_pos[step] + window_y_size[step] + frame_width]
						pts[7] = [external_front_position - window_x_pos[step] + frame_width, internal_left_position, window_y_pos[step] + window_y_size[step] + frame_width]
						face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
						status = face.erase!
					end


					window_group = Sketchup.active_model.entities.add_group
					window_group_ents = window_group.entities
					texture_id = window_group.to_s
					for texture_step in 0..$texture_name.length - 1
						if window_texture[step] == $texture_name[texture_step]
							texture = materials.add $texture_name[texture_step] + " window " + texture_id
              if $texture_filename[texture_step].count(":") === 0
                texture.texture = $texture_files + $texture_filename[texture_step]
              else
                texture.texture = $texture_filename[texture_step]
              end
							texture.texture.size = [$texture_x_size[texture_step].to_f / $inch, $texture_y_size[texture_step].to_f / $inch]
						end
					end

					
					# Draw frame
					pts = []
					pts[0] = [0, 0, 0]
					pts[1] = [frame_x_size, 0, 0]
					pts[2] = [frame_x_size, 0, frame_y_size]
					pts[3] = [0, 0, frame_y_size]
					face = window_group_ents.add_face pts
					status = face.material = door_frame_texture

					pts[4] = [0, frame_thickness, 0]
					pts[5] = [frame_x_size, frame_thickness, 0]
					pts[6] = [frame_x_size, frame_thickness, frame_y_size]
					pts[7] = [0, frame_thickness, frame_y_size]

					pts[8] = [frame_width, 0, frame_width]
					pts[9] = [frame_x_size - frame_width, 0, frame_width]
					pts[10] = [frame_x_size - frame_width, 0, frame_y_size - frame_width]
					pts[11] = [frame_width, 0, frame_y_size - frame_width]

					pts[12] = [frame_width, window_thickness, frame_width]
					pts[13] = [frame_x_size - frame_width, window_thickness, frame_width]
					pts[14] = [frame_x_size -frame_width, window_thickness, frame_y_size - frame_width]
					pts[15] = [frame_width, window_thickness, frame_y_size - frame_width]

					pts[16] = [0, window_thickness, 0]
					pts[17] = [frame_x_size, window_thickness, 0]
					pts[18] = [frame_x_size, window_thickness, frame_y_size]
					pts[19] = [0, window_thickness, frame_y_size]

					pts[20] = [0, window_thickness - frame_thickness, 0]
					pts[21] = [frame_x_size, window_thickness - frame_thickness, 0]
					pts[22] = [frame_x_size, window_thickness - frame_thickness, frame_y_size]
					pts[23] = [0, window_thickness - frame_thickness, frame_y_size]
 
					face = window_group_ents.add_face pts[8], pts[9], pts[10], pts[11]
					status = face.erase!
					for window_frame_step in 0..2
						face = window_group_ents.add_face pts[window_frame_step], pts[window_frame_step + 1], pts[window_frame_step + 5], pts[window_frame_step + 4]
						status = face.material = door_frame_texture
					end
					face = window_group_ents.add_face pts[3], pts[0], pts[4], pts[7]
					status = face.material = door_frame_texture
					
					for window_frame_step in 0..2
						face = window_group_ents.add_face pts[window_frame_step + 8], pts[window_frame_step + 9], pts[window_frame_step + 13], pts[window_frame_step + 12]
						status = face.material = door_frame_texture
					end
					face = window_group_ents.add_face pts[11], pts[8], pts[12], pts[15]
					status = face.material = door_frame_texture

					face = window_group_ents.add_face pts[16], pts[17], pts[18], pts[19]
					status = face.reverse!
					status = face.material = door_frame_texture
					
					face = window_group_ents.add_face pts[12], pts[13], pts[14], pts[15]
					status = face.erase!
					for window_frame_step in 0..2
						face = window_group_ents.add_face pts[window_frame_step + 16], pts[window_frame_step + 17], pts[window_frame_step + 21], pts[window_frame_step + 20]
						status = face.material = door_frame_texture
					end
					face = window_group_ents.add_face pts[19], pts[16], pts[20], pts[23]
					status = face.material = door_frame_texture
						
						
					#Draw window pane structure
					for pane_step in 0..1
						pane_step_index = 1 - pane_step * 2
						pts = []
						pts[0] = [frame_width, frame_thickness +(frame_thickness * pane_step), frame_width +(window_y_size[step] * pane_step)]
						pts[1] = [frame_x_size - frame_width, frame_thickness +(frame_thickness * pane_step), frame_width +(window_y_size[step] * pane_step)]
						pts[2] = [frame_x_size - frame_width, frame_thickness +(frame_thickness * pane_step), window_pane_middle]
						pts[3] = [frame_width, frame_thickness +(frame_thickness * pane_step), window_pane_middle]
						face = window_group_ents.add_face pts
						if pane_step == 1
							status = face.reverse!
						end
						status = face.material = door_frame_texture
				
						pts[4] = [frame_width + frame_thickness, frame_thickness +(frame_thickness * pane_step), frame_width + frame_thickness * pane_step_index +(window_y_size[step] * pane_step)]
						pts[5] = [frame_x_size - frame_width - frame_thickness, frame_thickness +(frame_thickness * pane_step), frame_width + frame_thickness * pane_step_index +(window_y_size[step] * pane_step)]
						pts[6] = [frame_x_size - frame_width - frame_thickness, frame_thickness +(frame_thickness * pane_step), window_pane_middle - frame_thickness * pane_step_index]
						pts[7] = [frame_width + frame_thickness, frame_thickness +(frame_thickness * pane_step), window_pane_middle - frame_thickness * pane_step_index]
						
						pts[8] = [frame_width, frame_thickness * 2 +(frame_thickness * pane_step), frame_width +(window_y_size[step] * pane_step)]
						pts[9] = [frame_x_size - frame_width, frame_thickness * 2 +(frame_thickness * pane_step), frame_width +(window_y_size[step] * pane_step)]
						pts[10] = [frame_x_size - frame_width, frame_thickness * 2 +(frame_thickness * pane_step), window_pane_middle]
						pts[11] = [frame_width, frame_thickness * 2 +(frame_thickness * pane_step), window_pane_middle]
						
						pts[12] = [frame_width + frame_thickness, frame_thickness * 2 +(frame_thickness * pane_step), frame_width + frame_thickness * pane_step_index +(window_y_size[step] * pane_step)]
						pts[13] = [frame_x_size - frame_width - frame_thickness, frame_thickness * 2 +(frame_thickness * pane_step), frame_width + frame_thickness * pane_step_index +(window_y_size[step] * pane_step)]
						pts[14] = [frame_x_size - frame_width - frame_thickness, frame_thickness * 2 +(frame_thickness * pane_step), window_pane_middle - frame_thickness * pane_step_index]
						pts[15] = [frame_width + frame_thickness, frame_thickness * 2 +(frame_thickness * pane_step), window_pane_middle - frame_thickness * pane_step_index]
	
						face = window_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
						status = face.erase!
						face = window_group_ents.add_face pts[2], pts[3], pts[11], pts[10]
						if pane_step == 1
							status = face.reverse!
						end
						status = face.material = door_frame_texture
	
						for window_frame_step in 0..2
							face = window_group_ents.add_face pts[window_frame_step + 4], pts[window_frame_step + 5], pts[window_frame_step + 13], pts[window_frame_step + 12]
							status = face.material = door_frame_texture
						end
						face = window_group_ents.add_face pts[7], pts[4], pts[12], pts[15]
						status = face.material = door_frame_texture
						face = window_group_ents.add_face pts[8], pts[9], pts[10], pts[11]
						status = face.material = door_frame_texture
						face = window_group_ents.add_face pts[12], pts[13], pts[14], pts[15]
						status = face.erase!
						
						pts = []
						pts[0] = [frame_width + frame_thickness, frame_thickness * 1.5 +(frame_thickness * pane_step), frame_width + frame_thickness * pane_step_index +(window_y_size[step] * pane_step)]
						pts[1] = [frame_x_size - frame_width - frame_thickness, frame_thickness * 1.5 +(frame_thickness * pane_step), frame_width + frame_thickness * pane_step_index +(window_y_size[step] * pane_step)]
						pts[2] = [frame_x_size - frame_width - frame_thickness, frame_thickness * 1.5 +(frame_thickness * pane_step), window_pane_middle - frame_thickness * pane_step_index]
						pts[3] = [frame_width + frame_thickness, frame_thickness * 1.5 +(frame_thickness * pane_step), window_pane_middle - frame_thickness * pane_step_index]
						face = window_group_ents.add_face pts
						status = face.material = window_texture[step] + " window " + texture_id
						status = face.back_material = window_texture[step] + " window " + texture_id
						status = face.material.alpha = window_transparency[step].to_f / 100
						
					end
					point = Geom::Point3d.new(external_front_position - frame_width - window_x_pos[step] - window_x_size[step], external_left_position - frame_thickness, window_y_pos[step] - frame_width)
					t = Geom::Transformation.new point
					window_group.move! t

					group_text = group.description
					group = group.parent.entities.add_group([group, window_group])
					group.description = group_text
		
				elsif window_wall[step][1..1] == "1" 
				
				
				
				end
				
			end
			
		end
	end


#############################
#### Draw entrance doors ####
#############################
	
	for step in 0..entrance_door_count - 1
	  if entrance_doors_allowed[step] == 1
  		door_group = draw_entrance_door(entrance_doors[step][1], entrance_doors[step][2], entrance_doors[step][3], entrance_doors[step][4], entrance_doors[step][0], entrance_doors[step][6], entrance_doors[step][5], entrance_doors[step][7], entrance_doors[step][8], wall_thickness, external_left_position, external_right_position, external_front_position, external_back_position)
  	 	group_text = group.description
      group = group.parent.entities.add_group([group, door_group])
		  group.description = group_text
		end
	end
		

################################
####	Draw roof and ceiling	####
################################

	eaves_height_offset = eaves_overhang * (arc / (wall_thickness +(full_width / 2)))

		if eaves_overhang > 0
			pts = []
			pts[0] = [external_front_position, external_left_position, outside_height - wall_thickness - hangar_left_extension * roof_slope]
			pts[1] = [external_front_position, internal_arc_position, outside_height - wall_thickness + internal_arc_position * roof_slope]
			pts[2] = [external_front_position + eaves_overhang, internal_arc_position, outside_height - wall_thickness + internal_arc_position * roof_slope]
			pts[3] = [external_front_position + eaves_overhang, external_left_position - eaves_overhang, outside_height - wall_thickness -(hangar_left_extension + eaves_overhang) * roof_slope]
			pts[4] = [external_back_position - eaves_overhang, external_left_position - eaves_overhang, outside_height - wall_thickness -(hangar_left_extension + eaves_overhang) * roof_slope]
			pts[5] = [external_back_position - eaves_overhang, internal_arc_position, outside_height - wall_thickness + internal_arc_position * roof_slope]
			pts[6] = [external_back_position, internal_arc_position, outside_height - wall_thickness + internal_arc_position * roof_slope]
			pts[7] = [external_back_position, external_left_position, outside_height - wall_thickness - hangar_left_extension * roof_slope]
		#	edges = group_ents.add_edges pts
			#face = group_ents.add_face pts[0], pts[1], pts[2]
			#status = face.material = roof_texture
	
			face = group_ents.add_face pts
			status = face.material = roof_texture
	
			pts[8] = [external_front_position, external_right_position , outside_height - wall_thickness - hangar_right_extension * roof_slope]
			pts[9] = [external_front_position + eaves_overhang, external_right_position + eaves_overhang, outside_height - wall_thickness -(hangar_right_extension + eaves_overhang) * roof_slope]
			pts[10] = [external_back_position - eaves_overhang, external_right_position + eaves_overhang, outside_height - wall_thickness -(hangar_right_extension + eaves_overhang) * roof_slope]
			pts[11] = [external_back_position, external_right_position , outside_height - wall_thickness - hangar_right_extension * roof_slope]
			face = group_ents.add_face pts[8], pts[1], pts[2], pts[9], pts[10], pts[5], pts[6], pts[11]
			status = face.material = roof_texture
		end
	
	if uv_map_right_roof == 0
		ptsx = []
		ptsx[0] = [external_front_position + eaves_overhang, external_right_position + eaves_overhang, outside_height - eaves_height_offset - roof_right_offset]
	#	ptsx[1] = [external_front_position + eaves_overhang, internal_arc_position, outside_height + arc]
	#	ptsx[2] = [external_back_position - eaves_overhang, internal_arc_position, outside_height + arc]
		ptsx[1] = [external_front_position + eaves_overhang, internal_arc_position, internal_height + arc + wall_thickness]
		ptsx[2] = [external_back_position - eaves_overhang, internal_arc_position, internal_height + arc + wall_thickness]
		ptsx[3] = [external_back_position - eaves_overhang, external_right_position + eaves_overhang, outside_height - eaves_height_offset - roof_right_offset]
		if eaves_overhang > 0
			face = group_ents.add_face ptsx[0], ptsx[3], pts[10], pts[9]
			status = face.material = roof_texture
		end

		face = group_ents.add_face ptsx
		if face.normal[2] < 0
			status = face.reverse!
		end
		status = face.material = roof_texture
		if wall_thickness == 0
			status = face.back_material = ceiling_texture
		end
	end
		
	if uv_map_left_roof == 0
		ptsy = []
	#	ptsy[0] = [external_back_position - eaves_overhang, internal_arc_position, outside_height + arc]
		ptsy[1] = [external_back_position - eaves_overhang, external_left_position - eaves_overhang, outside_height - eaves_height_offset - roof_left_offset]
		ptsy[2] = [external_front_position + eaves_overhang, external_left_position - eaves_overhang, outside_height - eaves_height_offset - roof_left_offset]
		#	ptsy[3] = [external_front_position + eaves_overhang, internal_arc_position, outside_height + arc]
		ptsy[3] = [external_front_position + eaves_overhang, internal_arc_position, internal_height + arc + wall_thickness]
		ptsy[0] = [external_back_position - eaves_overhang, internal_arc_position, internal_height + arc + wall_thickness]
		if eaves_overhang > 0
			face = group_ents.add_face ptsy[1], ptsy[2], pts[3], pts[4]
			status = face.material = roof_texture
			face = group_ents.add_face ptsy[0], ptsy[1], pts[4], pts[5], pts[10], ptsx[3]
			status = face.material = roof_texture
			face = group_ents.add_face ptsy[3], ptsy[2], pts[3], pts[2], pts[9], ptsx[0]
			status = face.material = roof_texture
		end
		face = group_ents.add_face ptsy
		status = face.material = roof_texture
		if wall_thickness == 0
			status = face.back_material = ceiling_texture
		end
	end

	if wall_thickness > 0
		pts = []
		pts[0] = [internal_back_position, internal_arc_position, height + arc]
		pts[1] = [internal_front_position, internal_arc_position, height + arc]
		pts[2] = [internal_front_position, internal_left_position, height - roof_left_offset]
		pts[3] = [internal_back_position, internal_left_position, height - roof_left_offset]
		face = group_ents.add_face pts
		status = face.material = ceiling_texture

		pts = []
		pts[0] = [internal_back_position, internal_arc_position, height + arc]
		pts[1] = [internal_front_position, internal_arc_position, height + arc]
		pts[2] = [internal_front_position, internal_right_position, height - roof_right_offset]
		pts[3] = [internal_back_position, internal_right_position, height - roof_right_offset]
		face = group_ents.add_face pts
		status = face.material = ceiling_texture
	end	

############################
####	Draw roof windows	####
############################
	
	if roof_window_count > 0
		for step in 0..roof_window_count - 1
			if roof_window_side[step] == "L"
				side_index = 1
				window_start_position = internal_left_position
				roof_offset = roof_left_offset
			else
				side_index = -1
				window_start_position = internal_right_position
				roof_offset = roof_right_offset
			end
			ceiling_window_start_height = internal_height - roof_offset + roof_window_y_pos[step] * roof_slope
			ceiling_window_end_height = internal_height - roof_offset +(roof_window_y_pos[step] + roof_window_y_size[step]) * roof_slope
			roof_window_start_height = outside_height - roof_offset +(wall_thickness + roof_window_y_pos[step]) * roof_slope
			roof_window_end_height = outside_height - roof_offset +(wall_thickness + roof_window_y_pos[step] + roof_window_y_size[step]) * roof_slope
			pts = []
				pts[0] = [external_front_position - roof_window_x_pos[step], window_start_position + roof_window_y_pos[step] * side_index, ceiling_window_start_height]
				pts[1] = [external_front_position - roof_window_x_pos[step] - roof_window_x_size[step], window_start_position + roof_window_y_pos[step] * side_index, ceiling_window_start_height]
				pts[2] = [external_front_position - roof_window_x_pos[step] - roof_window_x_size[step], window_start_position +(roof_window_y_pos[step] + roof_window_y_size[step]) * side_index, ceiling_window_end_height]
				pts[3] = [external_front_position - roof_window_x_pos[step], window_start_position +(roof_window_y_pos[step] + roof_window_y_size[step]) * side_index, ceiling_window_end_height]
				face = group_ents.add_face pts
				status  = face.erase!
			if(uv_map_left_roof == 0 and roof_window_side[step] == "L") or(uv_map_right_roof == 0 and roof_window_side[step] == "R") 
				pts[4] = [external_front_position - roof_window_x_pos[step], window_start_position + roof_window_y_pos[step] * side_index, roof_window_start_height]
				pts[5] = [external_front_position - roof_window_x_pos[step] - roof_window_x_size[step], window_start_position + roof_window_y_pos[step] * side_index, roof_window_start_height]
				pts[6] = [external_front_position - roof_window_x_pos[step] - roof_window_x_size[step], window_start_position +(roof_window_y_pos[step] + roof_window_y_size[step]) * side_index, roof_window_end_height]
				pts[7] = [external_front_position - roof_window_x_pos[step], window_start_position +(roof_window_y_pos[step] + roof_window_y_size[step]) * side_index, roof_window_end_height]
				face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
				status  = face.erase!
			elsif roof_window_side[step] == "L"
				external_roof_ratio =(internal_arc_position - external_left_position) / left_roof_length
				roof_ratio =(internal_arc_position - internal_left_position) /(left_roof_length - wall_thickness / external_roof_ratio)
				window_bottom = roof_window_y_pos[step] / roof_ratio
				window_top = window_bottom + roof_window_y_size[step] / roof_ratio
				pts[4] = [external_front_position - roof_window_x_pos[step], 0, window_bottom]
				pts[5] = [external_front_position - roof_window_x_pos[step] - roof_window_x_size[step], 0, window_bottom]
				pts[6] = [external_front_position - roof_window_x_pos[step] - roof_window_x_size[step], 0, window_top]
				pts[7] = [external_front_position - roof_window_x_pos[step], 0, window_top]
				for pts_step in 4..7
					pts[pts_step][0] = pts[pts_step][0] - uv_map_left_roof_offsets[0]
					pts[pts_step][1] = pts[pts_step][1] - uv_map_left_roof_offsets[1]
					pts[pts_step][2] = pts[pts_step][2] - uv_map_left_roof_offsets[2] + wall_thickness / roof_ratio
				end
				face = uv_map_group_ents[uv_map_left_roof - 1].add_face pts[4], pts[5], pts[6], pts[7]
				status = face.erase!
			else
				external_roof_ratio =(external_right_position - internal_arc_position) / right_roof_length
				roof_ratio =(internal_right_position - internal_arc_position) /(right_roof_length - wall_thickness / external_roof_ratio)
				window_bottom = roof_window_y_pos[step] / roof_ratio
				window_top = window_bottom + roof_window_y_size[step] / roof_ratio
				pts[4] = [external_back_position + roof_window_x_pos[step], external_right_position, window_bottom]
				pts[5] = [external_back_position + roof_window_x_pos[step] + roof_window_x_size[step], external_right_position, window_bottom]
				pts[6] = [external_back_position + roof_window_x_pos[step] + roof_window_x_size[step], external_right_position, window_top]
				pts[7] = [external_back_position + roof_window_x_pos[step], external_right_position, window_top]
				for pts_step in 4..7
					pts[pts_step][0] = pts[pts_step][0] - uv_map_right_roof_offsets[0]
					pts[pts_step][1] = pts[pts_step][1] - uv_map_right_roof_offsets[1]
					pts[pts_step][2] = pts[pts_step][2] - uv_map_right_roof_offsets[2] + wall_thickness / roof_ratio
				end
				face = uv_map_group_ents[uv_map_right_roof - 1].add_face pts[4], pts[5], pts[6], pts[7]
				status = face.erase!
			end
			pts[4] = [external_front_position - roof_window_x_pos[step], window_start_position + roof_window_y_pos[step] * side_index, roof_window_start_height]
			pts[5] = [external_front_position - roof_window_x_pos[step] - roof_window_x_size[step], window_start_position + roof_window_y_pos[step] * side_index, roof_window_start_height]
			pts[6] = [external_front_position - roof_window_x_pos[step] - roof_window_x_size[step], window_start_position +(roof_window_y_pos[step] + roof_window_y_size[step]) * side_index, roof_window_end_height]
			pts[7] = [external_front_position - roof_window_x_pos[step], window_start_position +(roof_window_y_pos[step] + roof_window_y_size[step]) * side_index, roof_window_end_height]
			face = group_ents.add_face pts[4], pts[5], pts[6], pts[7]
			status  = face.erase!
			face = group_ents.add_face pts[0], pts[1], pts[5], pts[4]
			status = face.material = roof_texture
			face = group_ents.add_face pts[1], pts[2], pts[6], pts[5]
			status = face.material = roof_texture
			face = group_ents.add_face pts[2], pts[3], pts[7], pts[6]
			status = face.material = roof_texture
			face = group_ents.add_face pts[3], pts[0], pts[4], pts[7]
			status = face.material = roof_texture

			roof_window_group = Sketchup.active_model.entities.add_group
			roof_window_group_ents = roof_window_group.entities
			texture_id = roof_window_group.to_s
			for texture_step in 0..$texture_name.length - 1
				if roof_window_texture[step] == $texture_name[texture_step] or roof_window_back_texture[step] == $texture_name[texture_step] 
					texture = materials.add $texture_name[texture_step] + " roof window " + texture_id
          if $texture_filename[texture_step].count(":") === 0
            texture.texture = $texture_files + $texture_filename[texture_step]
          else
            texture.texture = $texture_filename[texture_step]
          end
					if roof_window_texture[step] != roof_window_back_texture[step] and roof_window_texture[step] == $texture_name[texture_step]
						texture.texture.size = [roof_window_x_size[step], roof_window_y_size[step]]
					else
					texture.texture.size = [$texture_x_size[texture_step].to_f / $inch, $texture_y_size[texture_step].to_f / $inch]
					end
				end
			end
			face = roof_window_group_ents.add_face pts[0], pts[1], pts[2], pts[3]
			if face.normal[2] > 0
				status = face.reverse!
			end
			status = face.material = roof_window_texture[step] + " roof window " + texture_id
			status = face.back_material = roof_window_back_texture[step] + " roof window " + texture_id
			if roof_window_texture[step] == roof_window_back_texture[step]
				status = face.material.alpha = roof_window_transparency[step].to_f / 100
			else
				status = face.back_material.alpha = roof_window_transparency[step].to_f / 100
			end
			face = roof_window_group_ents.add_face pts[4], pts[5], pts[6], pts[7]
			if face.normal[2] < 0
				status = face.reverse!
			end
			status = face.material = roof_window_texture[step] + " roof window " + texture_id
			status = face.back_material = roof_window_back_texture[step] + " roof window " + texture_id
			if roof_window_texture[step] == roof_window_back_texture[step]
				status = face.material.alpha = roof_window_transparency[step].to_f / 100
			else
				status = face.back_material.alpha = roof_window_transparency[step].to_f / 100
			end
			group = group.parent.entities.add_group([group, roof_window_group])
			
		end
	end


####################################################
####	Draw extensions				####
####################################################

	combined_extension_group = Sketchup.active_model.entities.add_group

	if extensions.length > 0		
 		for step in 0..extensions.length - 1
			before_y_pos = group.local_bounds.center[1]
			extension_type = extensions[step][0..extensions[step].index("(") - 1]
			if extension_type != "D" and extension_type != "CB" and extension_type != "W" and extension_type != "DB" and extension_type != "S" and extension_type != "X" and extension_type != "LH" and extension_type != "RH" and extension_type != "ED" and extension_type != "RW"
		 		ext_group = add_extensions(extensions[step], "Standard",full_length + wall_thickness * 2, full_width + wall_thickness * 2, outside_height, arc, wall_thickness, door_type, wall_texture, roof_texture, internal_wall_texture)
				combined_extension_group = combined_extension_group.parent.entities.add_group([combined_extension_group, ext_group])
	 		end
 	
		end
	end

	group_text = group.description
	group = group.parent.entities.add_group([group, combined_extension_group])
	group.description = group_text


########################
#### Draw back door ####
########################

  for step in 0..back_door_count - 1
    if back_door_allowed[step] == 1
      back_door_sections = door_sections
      door_group = Sketchup.active_model.entities.add_group
      door_group_ents = door_group.entities
      door_group = insert_door(back_door_type[step], back_door_height[step], back_door_folding_level.to_i, back_door_sections, back_door_width[step], external_left_position + back_door_position[step] + back_door_width[step] / 2, 0 - wall_thickness, wall_thickness, door_frame_thickness, door_skin_thickness, outside_height, arc, door_frame_texture, door_texture, wall_texture, roof_texture, beam_texture, floor_texture, "Y", "Standard", 0, back_door_extension[step].to_s)
	    point = Geom::Point3d.new(0, back_door_position[step] + back_door_width[step] / 2, 0)
      t = Geom::Transformation.scaling(point, -1, 1, 1)
      door_group.transform! t
      group_text = group.description
      group = group.parent.entities.add_group([group, door_group])
      group.description = group_text
  	end		
  end

	for step in 0..uv_map_count - 1
		group_text = group.description
		group = group.parent.entities.add_group([group, uv_map_group[step]])
		group.description = group_text
	end

#####################
####	Draw floor ####
#####################

	if floor_texture != "None" and floor_texture != "No floor"
		pts = []
		pts[0] = [external_back_position, internal_left_position, 0]
		pts[1] = [external_front_position, internal_left_position, 0]
		pts[2] = [external_front_position, internal_right_position, 0]
		pts[3] = [external_back_position, internal_right_position, 0]
		face = group_ents.add_face pts
		if face.normal[2] < 0
			status = face.reverse!
		end
		status = face.material = floor_texture 
	end
		

####################
#### Draw doors ####
####################
	
	if door_type != "Do not draw door"
		if multiple_doors == 0
  		door_group = Sketchup.active_model.entities.add_group
    	door_group_ents = door_group.entities
		  door_group = insert_door(door_type, door_height, door_folding_level.to_i, door_sections, door_width, door_middle, internal_front_position, wall_thickness, door_frame_thickness, door_skin_thickness, outside_height, arc, door_frame_texture, door_texture, wall_texture, roof_texture, beam_texture, floor_texture, "Y", "Standard", 0, hangar_door_extension[0].to_s)
  		if afcad_read == 1
	   		group.description = "Standard:" +(hangar_x -(full_roof_length / 2)).to_s + ":" +(hangar_y -(full_width / 2)).to_s + ":" + hangar_angle.to_s + ":" + hangar_x.to_s + ":" + hangar_y.to_s
  		end
	   	group_text = group.description + " with " + door_group.description
  		group = group.parent.entities.add_group([group, door_group])
	   	group.description = group_text
  	else
	   	for step in 1..multiple_doors
  			door_middle_position = (step * door_distance) + ((step - 1) * door_width) + (door_width / 2)
	   		door_group = Sketchup.active_model.entities.add_group
        door_group_ents = door_group.entities
  			if multiple_door_folding_level.count == 0 or multiple_door_folding_level.count < step
	   			door_group = insert_door(door_type, door_height, door_folding_level.to_i, door_sections, door_width, door_middle_position, internal_front_position, wall_thickness, door_frame_thickness, door_skin_thickness, outside_height, arc, door_frame_texture, door_texture, wall_texture, roof_texture, beam_texture, floor_texture, "Y", "Standard", 0, hangar_door_extension[0].to_s)
        else
				  door_group = insert_door(door_type, door_height, multiple_door_folding_level[step].to_i, door_sections, door_width, door_middle_position, internal_front_position, wall_thickness, door_frame_thickness, door_skin_thickness, outside_height, arc, door_frame_texture, door_texture, wall_texture, roof_texture, beam_texture, floor_texture, "Y", "Standard", 0, hangar_door_extension[0].to_s)
			  end
        if afcad_read == 1
				  group.description = "Standard:" +(hangar_x -(full_roof_length / 2)).to_s + ":" +(hangar_y -(full_width / 2)).to_s + ":" + hangar_angle.to_s + ":" + hangar_x.to_s + ":" + hangar_y.to_s
        end
        group_text = group.description + " with " + door_group.description
        group = group.parent.entities.add_group([group, door_group])
        group.description = group_text
      end
    end
  end
  
  
#####################################
####	Position and rotate hangar ####
#####################################

	if afcad_read == 1 or (midlat == 999 and midlong == 999)
		pt1 = [(full_roof_length / 2),(full_width / 2), 0]
		vector = Geom::Vector3d.new 0,0,1
		vector2 = vector.normalize!				
	#	circle = group_ents.add_circle pt1, vector2, parking_radius

		trans = group.transformation
		point = Geom::Point3d.new(hangar_x - (full_roof_length / 2) + trans.origin[0], hangar_y - (full_width / 2) + trans.origin[1], trans.origin[2])
		t = Geom::Transformation.new point
		group.move! t
		t = Geom::Transformation.rotation [hangar_x, hangar_y, 0], Z_AXIS, radians
		group.transform! t
	else
		trans = group.transformation
		point = Geom::Point3d.new(hangar_x + trans.origin[0], hangar_y + trans.origin[1], trans.origin[2])
		t = Geom::Transformation.new point
		group.move! t
		t = Geom::Transformation.rotation [hangar_x,hangar_y,0], Z_AXIS, radians
		group.transform! t
		group.name = "Standard:" + input[0].to_s + ":" + input[1].to_s + ":" + input[2].to_s + ":" + input[3].to_s + ":" + input[4].to_s + ":" + input[5].to_s + ":" + input[6].to_s + ":" + input[7].to_s + ":" + input[8].to_s + ":" + input[9].to_s + ":" + input[10].to_s + ":" + input[11].to_s + ":" + input[12].to_s + ":" + input[13].to_s + ":" + input[14].to_s + ":" + input[15].to_s + ":" + input[16].to_s
	end
end

